#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <time.h>
#include <errno.h> 


#define info info_
#define printwd printwd_
#define printdf printdf_
#define copyhistory copyhistory_
#define sendmessage sendmessage_
#define infouser infouser_
#define rmstorage rmstorage_
#define rmeditfile rmeditfile_
#define viewdvi viewdvi_
#define openeditor openeditor_
#define benson benson_
#define BUFL  512
#define FALSE 0
#define TRUE 1
#define STRL 80

extern struct info{
      char  user[STRL],logname[STRL],date[STRL],hostid[STRL],
            host[STRL],net[STRL],disksize[STRL],
            hepath[STRL],utpath[STRL],term[STRL],editor[STRL],
            shell[STRL],colfile[STRL],workdir[132];
} info;

static int sockfd,iconnect;
/* struct tm{*/
/*                      int     tm_sec;     seconds */
/*                      int     tm_min;     minutes */
/*                      int     tm_hour;    hours */
/*                      int     tm_mday;    day of the month */
/*                      int     tm_mon;     month */
/*                      int     tm_year;    year */
/*                      int     tm_wday;    day of the week */
/*                      int     tm_yday;    day in the year */
/*                      int     tm_isdst;   daylight saving time */
/*              };*/


char  recs[BUFL];

static int read_file(char filename[]){
  /* Read all 132-Byte-Records from the OMD-File into "feld" */
   FILE *dfile;
   dfile = fopen(filename,"rb");
   if (dfile==0){
      return FALSE;
   }
   fread(recs,1,sizeof(recs),dfile);
   fclose(dfile);
   if(recs[0]=='\0') {return FALSE;}
   else {return TRUE;}
}


void infouser(char *cinet) 
{
char name[STRL],envname[STRL];
 struct tm *tim;
 
  struct hostent *h;
  int i,in,il;
  long int j;
  char *datum;
  time_t zeit;

  /*getdomainname(name, STRL);
  do{info.domain[i]=name[i];i++;}while(name[i] != '\0'&& i<STRL);
  info.domain[STRL-1]='\0';*/

gethostname(name,STRL);
/*printf("gethostname %s\n",name);*/


  if((datum=getenv("USER"))!=NULL){
    i=0;do{info.user[i]=datum[i];i++;} while(datum[i] != '\0');}  

  if((datum=getenv("LOGNAME"))!=NULL){
    i=0;do{info.logname[i]=datum[i];i++;} while(datum[i] != '\0');}  

  if((datum=getenv("ALLPLOHEPATH"))!=NULL){
    i=0;do{info.hepath[i]=datum[i];i++;} while(datum[i] != '\0');}  

  if((datum=getenv("ALLPLOUTPATH"))!=NULL){
    i=0;do{info.utpath[i]=datum[i];i++;} while(datum[i] != '\0');}  

 if((datum=getenv("TERM"))!=NULL){
      i=0;do{info.term[i]=datum[i];i++;} while(datum[i] != '\0');} 

 if((datum=getenv("EDITOR")) !=NULL){
    i=0;do{info.editor[i]=datum[i];i++;} while(datum[i] != '\0');}

 if((datum=getenv("SHELL")) !=NULL){
    i=0;do{info.shell[i]=datum[i];i++;} while(datum[i] != '\0');}

 if((datum=getenv("COLORFILE")) !=NULL){
    i=0;do{info.colfile[i]=datum[i];i++;} while(datum[i] != '\0');}
 
 if((datum=getenv("PWD")) !=NULL){
    i=0;do{info.workdir[i]=datum[i];i++;} while(datum[i] != '\0');}

  zeit = time(NULL); 
  datum= ctime(&zeit); 
  i=0;do{info.date[i+10]=datum[i];i++;}while(datum[i] !='\0');
  /*printf("datum  %s\n",datum);*/
  tim=localtime(&zeit);
  in=strftime(name,STRL,"%m %d %y",tim);
  /*printf("date: %s\n",name);*/
  for(i=0;i<in;i++) info.date[i]=name[i]; 
  /*printf("strftime  %s\n",info.date);*/
}

void copyhistory(){
 char ma[80];
 strcpy(ma,"cp history.lst  history.err");
 system(ma);
}
void sendmessage(){
 char ma[80];
 strcpy(ma,"mail -s effi spiering@iacgu7.chemie.uni-mainz.de < history.lst");
 system(ma);
}

void printwd(){
 char ma[80];
 strcpy(ma,"pwd > storage.am");
 system(ma);
}
void printdf(){
 char ma[80];
 strcpy(ma,"df -l -xcifs -k > storage.am");
 system(ma);
}
void rmstorage(){
 char ma[80];
 strcpy(ma,"rm storage.am");
 system(ma);
}
void benson(){
 char ma[80];
 strcpy(ma,"rm allplo.ben");
 system(ma);
}

void rmbencom(){
 if(fopen("common.dat","r"))system("rm common.dat");
 if(fopen("allplo.ben","r"))system("rm allplo.ben");
 if(fopen("allplo.log","r"))system("rm allplo.log");
 }

void rmeditfile(char *ma){
 system(ma);
}
void viewdvi(char *dvifile){
    char ma[132];
     strcpy(ma,"xdvi ");strcat(ma,dvifile);
  printf(" %s\n",ma);
 system(ma);
}
void openeditor(int *k, char *posz){
    char *datum;
    char ma[132];
    int i;
    if (*k > 30){
     if((datum=getenv("EDITOR"))!=NULL){
	 i=0;do{ma[i]=datum[i];i++;} while(datum[i] != '\0'); ma[i]='\0';
         } else {*k=*k-20;};
    } else if(*k > 20 && *k < 30 ){
     strcpy(ma,"emacs ");strcat(ma,posz);
     if((datum=getenv("EMACSFONT"))!=NULL){
     strcat(ma," -fn '");strcat(ma,datum);strcat(ma,"'");}
    }
    switch(*k){
	case 11:strcpy(ma,"joe -overwrite -nonotice editor.pa"); 
	    break;
	case 12:strcpy(ma,"joe -overwrite -nonotice editor.co"); 
	    break;
	case 13:strcpy(ma,"joe -overwrite -nonotice editor.pa editor.co");
	    break;

	case 21:strcat(ma," editor.pa");	    
	    break;				    
	case 22:strcat(ma," editor.co");	    
	    break;				    
	case 23:strcat(ma," editor.pa editor.co");
	    break;

	case 31:strcat(ma," editor.pa");	    
	    break;				    
	case 32:strcat(ma," editor.co");	    
	    break;				    
	case 33:strcat(ma," editor.pa editor.co");
	    break;
    }; 
/* printf(" ma= %s NULL=%s\n",ma,NULL);*/
 system(ma);
}









