      subroutine instruction
      implicit none
c     M. Alflen 12.9.89
c
c     modifiziert fuer variablen Offset zwischen Rahmen und Plot
c
c	M. Alflen 15.12.89
      include 'comalp.for'
      integer       IX,IY,ixt,iyt,nx,ny,ixscp10,iyscp10,ixmode
      real          xtop,ytop,xbot,ybot,xanfsc,xendsc,xstep,
     &              xanflg,xendlg,xanflgsc,xendlgsc,xlgstep,
     &              yanfsc,yendsc,ystep,zxtext,zytext,
     &              yanflg,yendlg,yanflgsc,yendlgsc,ylgstep
       common/top/  xtop,ytop,xbot,ybot,xanfsc,xendsc,xstep,
     &              xanflg,xendlg,xanflgsc,xendlgsc,xlgstep,
     &              yanfsc,yendsc,ystep,zxtext,zytext, 
     &              yanflg,yendlg,yanflgsc,yendlgsc,ylgstep,
     &              IX,IY,ixt,iyt,nx,ny,ixscp10,iyscp10,ixmode 

      character     cxanf(24),cxend(24),cxstep(24),
     &              cyanf(24),cyend(24),cystep(24)
      integer       NAXFOR,nform,nxanf,nxend,nxstep,nyanf,nyend,nystep

      logical       l_ask
      character*132 querytype(2),chcom,chstr(2),wrb*1, 
     &              canf*10,cend*10,cstep*10,cf*1,
     &              form*7,chr*24,chl*24,chkblk*48 
      integer       idum,nn,im,le,i,j,jj,ii,ls,iout
      real          dum,dif,h,out
      dimension     out(32)
   
      chkblk=' '
      chkblk(1:1)=')'
c      write(6,'(a,10L3)')
c     & '##### subroutine datplo ',l_inter,l_def,l_scal
c     l_new = true  :  neuer Datensatz
c     l_scal = true :  neu Skalieren
c     l_def = true   : default-Werte uebernehmen
c      write(6,'(a,i6)')' datplo ncount=',ncount

      l_ask = .not. ( l_def .and. l_inter)
      if (.not.l_inter.and.l_ask)wrb='r' 
      if (l_inter.and.l_ask)wrb='w'
      if (l_inter.and..not.l_ask)wrb='d' 

c**************************************************************************
c      
      if (l_scal ) then       !  input

c**************************************************************************
c    x-range (-3.82,3.81)  [-4.00,4.00]           scale(lin,log) [li]
       chstr(1)=' '
       querytype(1)=
     & 'x-data                        (x ,log(x),10**x:  /lgx/pwx) ['
       chcom='log/power10'
       call ask1string(querytype,chstr,chcom,NPL,NRD,NWR,NBA,wrb)
       l_logxd=.false.
       l_10pxd=.false.
       if(chstr(1)(1:3).eq.'lgx')then
        l_logxd=.true.
        l_logx=.true.       
        if(xmin.lt.0.)then
         write(NWR,'(a,g12.4)')
     &  ' Log(x-data) not possible: 0>X_min=',xmin        
         l_logxd=.false.
         l_logx=.false.
        end if
       else if(chstr(1)(1:3).eq.'pwx')then
        l_10pxd=.true.
        if(xmax.gt.32.)then
         write(NWR,'(a,g12.4)')
     &   ' 10**(x-data) not possible: 32<X_max=',xmax        
         l_10pxd=.false.
        end if
       end if

       if(l_logxd)then
        xmin=log10(xmin)
        xmax=log10(xmax)
       else if(l_10pxd) then
        xmin=10**xmin
        xmax=10**xmax   
       end if
       call scaling(xmin,xmax,0,xanf,xend,dum,idum)  ! x-plot Bereich
       if(abs((xend-xmax)/dum).gt.0.5)xend=xmax+0.1*dum

       querytype(1)='    x-range('
       form='f12.2'
       h=abs(xmin)
       if(h.lt.0.01.and.h.ne.0..or.h.gt.1.e4)form='e12.2'
       call trlnu(form,xmin,chr,nn,chl,im)
       querytype(1)(13:)=chl(1:im)//','
c       le=44-im
       le=13-im
       j=14+im
       form='f12.2'
       if(abs(xmax).lt.0.01.or.abs(xmax).gt.1.e4)form='e12.2'
       call trlnu(form,xmax,chr,nn,chl,im)
       querytype(1)(j:)=chl(1:im)//chkblk(:le-im)//'  ['
       le=j+le+1
c       write(6,'(a,i4)')' le=',le
       form='f12.2'
       h=abs(xanf)
       if(h.lt.0.01.and.h.ne.0..or.h.gt.1.e4)form='e12.2'
       call trlnu(form,xanf,chr,nn,chl,im)
       chstr(1)(1:)=chl(1:im)//','
       j=2+im
       form='f12.2'
       if(abs(xend).lt.0.01.or.abs(xend).gt.1.e4)form='e12.3'
       call trlnu(form,xend,chr,nn,chl,im)
       chstr(1)(j:)=chl(1:im)
       j=j+im
       le=62-(le+j+20)
c       write(6,'(a,3i4)')' j,im,le=',j,im,le

       call stringlength(chstr(1),ls)

       querytype(2)=chkblk(2:le)//'(log scale y/n) ['
       chstr(2)='n'
       chcom='log/scale'
c    x-range(0.00,1.08)    [0.00,1.20]             (log,ln;d,s,B) []
       call ask2strings(querytype,chstr,chcom,NPL,NRD,NWR,NBA,wrb)
       call trlch(20,chstr(1),iout,out)
       if(iout.ge.1) xanf=out(1)
       if(iout.eq.2) xend=out(2)
       l_logx=.false.       
       if(chstr(2)(1:1).eq.'y')l_logx=.true.


       if (xanf .eq. xend) then
        xanf=xmin
        xend=xmax
       end if

c
c**********************input of x-scaling range****************************
c        scale (l,r,stepw,tics)  [0         20        2         5]
       call scaling(xanf,xend,1,xanfsc,xendsc,xstep,ixt)  ! x-Skala
       NX=NAXFOR(XANFSC,XENDSC,XSTEP)
       call numero(xanfsc,nx,cxanf,nxanf,0,0)
       call numero(xendsc,nx,cxend,nxend,0,0)
       call numero(xstep,nx,cxstep,nxstep,0,0)

         do i=1,10
          canf(i:i)=cxanf(i)
          cend(i:i)=cxend(i)
          cstep(i:i)=cxstep(i)
         end do
         cf=char(ixt+ichar('0'))
         chstr(1)=canf//cend//cstep//cf//' 0'
         querytype(1)='    scale(l,r,step,tics,pw)['
         chcom='l,r,step,tics,pw'
         call ask1string(querytype(1),chstr(1),chcom,
     &                                NPL,NRD,NWR,NBA,wrb)
         nx=nform(chstr(1))
         call trlch(80,chstr(1),nn,out)


         ixscp10=0
         if(nn.eq.5) ixscp10=out(5)
         if ( nn .ge. 3 ) then
          dif =abs(out(1)-out(2))*1.0001
          if (dif .gt. 0. and. dif .ge. abs(out(3)) 
     &        .and.out(1) .ge. xanf .and.out(2) .le. xend 
     &    ) then
           xanfsc=out(1)
           xendsc=out(2)
           if ( xanfsc .lt. xendsc ) then
            xstep=abs(out(3))
           else
            xstep=-abs(out(3))
           end if
           call numero(xanfsc,nx,cxanf,nxanf,0,ixscp10)
           call numero(xendsc,nx,cxend,nxend,0,ixscp10)
           call numero(xstep,nx,cxstep,nxstep,0,ixscp10)
          end if
         end if
         if ( nn .ge. 4 .and. out(4) .ge. 0.) ixt=out(4)
c*******************************************************************
c    y-range (-3.82,3.81)                                [-4.00,4.00]
       chstr(1)=' '
       querytype(1)=
     & 'y-data                        (y ,log(y),10**y:  /lgy/pwy) ['
       chcom='log/power10'
       call ask1string(querytype,chstr,chcom,NPL,NRD,NWR,NBA,wrb)
       l_logyd=.false.
       l_10pyd=.false.
       if(chstr(1)(1:3).eq.'lgy')then
        l_logyd=.true.        
        if(ymin.le.0.)then
         write(NWR,'(a,g12.4)')
     &  ' Log(y-data) not possible: 0>Y_min=',ymin        
         l_logyd=.false.
        end if
       else if(chstr(1)(1:3).eq.'pwx')then
        l_10pyd=.true.
        if(ymax.gt.32.)then
         write(NWR,'(a,g12.4)')
     &   ' 10**(y-data) not possible: 32<Y_max=',ymax        
         l_10pyd=.false.
        end if
       end if

       if(l_logyd)then
        ymin=log10(ymin)
        ymax=log10(ymax)
       else if(l_10pyd) then
        ymin=10**ymin
        ymax=10**ymax
       end if
       call scaling(ymin,ymax,0,yanf,yend,dum,idum)  ! y-plot Bereich
       if(abs((yend-ymax)/dum).gt.0.5)yend=ymax+0.1*dum
       if(abs((yanf-ymin)/dum).gt.0.5)yanf=ymin-0.1*dum

       querytype(1)='    y-range('
       form='f12.2'
       h=abs(ymin)
       if(h.lt.0.01.and.h.ne.0..or.h.gt.1.e4)form='e12.2'
       call trlnu(form,ymin,chr,nn,chl,im)
       querytype(1)(13:)=chl(1:im)//','
       le=13-im
       j=14+im
       form='f12.2'
       if(abs(ymax).lt.0.01.or.abs(ymax).gt.1.e4)form='e12.2'
       call trlnu(form,ymax,chr,nn,chl,im)
       querytype(1)(j:)=chl(1:im)//chkblk(:le-im)//'  ['
       le=j+le+1
       form='f12.2'
       h=abs(yanf)
       if(h.lt.0.01.and.h.ne.0..or.h.gt.1.e4)form='e12.2'
       call trlnu(form,yanf,chr,nn,chl,im)
       chstr(1)(1:)=chl(1:im)//','
       j=2+im
       form='f12.2'
       if(abs(yend).lt.0.01.or.abs(yend).gt.1.e4)form='e12.2'
       call trlnu(form,yend,chr,nn,chl,im)
       chstr(1)(j:)=chl(1:im)
       j=j+im
       le=62-(le+j+20)
c       write(6,'(a,3i4)')' j,im,le=',j,im,le

       call stringlength(chstr(1),ls)

       querytype(2)=chkblk(2:le)//'(log scale y/n) ['
       chstr(2)='n'
       if(l_logyd) chstr(2)='y'
       chcom='log/scale'
       call ask2strings(querytype(1),chstr(1),chcom,NPL,NRD,NWR,NBA,wrb)
       call trlch(20,chstr(1),iout,out)
       if(iout.ge.1) yanf=out(1)
       if(iout.eq.2) yend=out(2)
       l_logy=.false.       
       if(chstr(2)(1:1).eq.'y')l_logy=.true.

c**********************input of y-scaling range************************
c        scale (l,r,step,tics) [-4,4,1,5]
         call scaling(yanf,yend,1,yanfsc,yendsc,ystep,iyt)  ! y-Skala   
         ny=NAXFOR(yanfsc,yendsc,ystep)
         call numero(yanfsc,ny,cyanf,nyanf,0,0)
         call numero(yendsc,ny,cyend,nyend,0,0)
         call numero(ystep,ny,cystep,nystep,0,0)
 
         do i=1,10
          canf(i:i)=cyanf(i)
          cend(i:i)=cyend(i)
          cstep(i:i)=cystep(i)
         end do
         cf=char(iyt+ichar('0'))
         chstr(1)=canf//cend//cstep//cf//' 0'
         querytype(1)='    scale(l,r,step,tics,pw)['
         chcom='l,r,step,tics,pw'
         call ask1string(querytype(1),chstr(1),chcom,
     &                                NPL,NRD,NWR,NBA,wrb)
         ny=nform(chstr(1))

         call trlch(80,chstr(1),nn,out)

         iyscp10=0
         if(nn.eq.5) iyscp10=out(5)
         if ( nn .ge. 3 ) then
          dif =abs(out(1)-out(2))*1.0001
          if (dif .gt. 0. and. dif .ge. abs(out(3)) .and.
     &        out(1) .ge. yanf  .and.
     &        out(2) .le. yend                  ) then
           yanfsc=out(1)
           yendsc=out(2)
           if ( yanfsc .lt. yendsc ) then
            ystep=abs(out(3))
           else
            ystep=-abs(out(3))
           end if
           call numero(yanfsc,ny,cyanf,nyanf,0,iyscp10)
           call numero(yendsc,ny,cyend,nyend,0,iyscp10)
           call numero(ystep,ny,cystep,nystep,0,iyscp10)
          end if
         end if
         if ( nn .ge. 4 .and. out(4) .ge. 0.) iyt=out(4)
c**************************************************************************
c
      END IF       !  end of input section

      return
      end

       subroutine plotthedata
      implicit none
c     plottet Datenpunkte fuer ALLPLO
c     
c     M. Alflen 12.9.89
c
c     modifiziert fuer variablen Offset zwischen Rahmen und Plot
c
c	M. Alflen 15.12.89

      include 'comalp.for'


      logical       l_ini,l_remove

      integer       k,i,isym,iloop,nold_pen,ipen,infra   
      real          genau,G1,G2,G3,G4,G5,G6,gg1,gg2,gg3,gg4,
     &              xscal,xl,xu,xlow,xup,yscal,yl,yu,ylow,yup

      genau=1.e-4                  ! accuracy for real comparison
c      do i=1,NCOUNT
c        write(6,'(i4,2f10.2)')NSYM(i),XX(1,i),YY(1,i)
c      end do

      g1=xrand+gx+xoff_r
      g3=yrand+yoff_b
      call traa(g3,g1,0)           ! go to start
c
      xscal=gx/(xend-xanf)         ! x-scaling
      yscal=gy/(yend-yanf)         ! y-scaling
      xl=amin1(xanf,xend)           ! x-plot range ( user coo's )
      xu=amax1(xanf,xend)
      yl=amin1(yanf,yend)           ! y-plot range ( user coo's )
      yu=amax1(yanf,yend)

      xlow=gx+xrand+xoff_r+genau       ! x-plot range ( plot coo's )
      xup=xrand+xoff_r-genau
      ylow=gy+yrand+yoff_b+genau       ! y-plot range ( plot coo's )
      yup=yrand+yoff_b-genau

c

c
      nold_pen=-1                 
      call pluma(nold_pen)         ! ask for old pen
c      write(6,'(a,i4)')' datplo nold_pen=',nold_pen
      l_ini=.true.                 ! initialize

      infra=0
      i=0
      do while (i .lt. ncount )
        i=i+1
        if(l_remove) then
         if(xx(2,i).lt.0. .or.yy(2,i).lt.0.)goto 1000
        end if
        if(nsym(i).gt.900) then
          isym=nsym(i)/1000
          isym=nsym(i)-1000*isym
          if(isym.eq.0)nsym(i)=-nsym(i)
        end if
c        write(6,'(i5,a,i6)')i,' nsym(i)=',nsym(i)
        if(nsym(i).le.0) then
         ipen=1
         isym=-nsym(i)
        else
         ipen=0
         isym=nsym(i)
        end if
        npen=isym/1000
        isym=isym-npen*1000
        if(isym.gt.0)ipen=0

        iloop= isym/100
        isym=isym-iloop*100
        if (iloop.gt. 0) then                    ! =0 no filled symbol
          g1=amin1(sw,sh)          
         iloop=ifix(g1/pen)+1                    ! plot iloop times
        else
         iloop=1
        end if

        if(npen.eq.nbackgr)then
         npen=nbackgr+1
         if(nbackgr.eq.1)npen=0         !  npen different from nbackgr
c         write(6,'(i5,a,2i4)')i,' datplo nbackgr,npen=',nbackgr,npen
        end if

c        write(6,'(i5,a,5i4)')i,' ipen,isym,npen,iloop=',
c     &                           ipen,isym,npen,iloop

        if(isym.eq.34.and.iloop.gt.1) then
          call pfuma(npen)                          ! choose pen=fillcolor 
        else
         call pluma(npen)                           ! choose pen=color
        end if
        
         if(l_logyd) then
         gg3=log10(YY(1,i))         
        else if(l_10pyd) then
         gg3=10**YY(1,i)
        else
         gg3=YY(1,i)
        end if
        if(l_logxd) then
         gg1=log10(XX(1,i))         
        else if(l_10pxd) then
         gg1=10**XX(1,i)
        else
         gg1=XX(1,i)
        end if
        
        if ( l_error ) then                      ! plot error bars
         if(l_logxd) then
          gg2=XX(2,i)/XX(1,i)         
         else if(l_10pxd) then
          gg2=gg1*(10**XX(2,i)-1.)
         else
          gg2=XX(2,i)
         end if
         g1=gg1+abs(gg2)
         g2=gg1-abs(gg2)

         if(l_logyd) then
         gg4=YY(2,i)/YY(1,i)         
        else if(l_10pyd) then
         gg4=gg3*(10**YY(2,i)-1.)
        else
         gg4=YY(2,i)
        end if
         g3=gg3+abs(gg4)
         g4=gg3-abs(gg4)
        else
         g1=gg1
         g2=g1
         g3=gg3
         g4=g3
        end if
c
        if ( ( .not. l_clip ) .or.                           ! no clipping
     &      ( ( g1 .le. xu .and. g2 .ge. xl ) .and.
     &        ( g3 .le. yu .and. g4 .ge. yl )      )) then  ! point in frame

c         infra=infra+1
         gg1= xlow - ( gg1-xanf ) * xscal            ! plot coordinate
         gg3= yup + ( gg3-yanf) * yscal
          if ( l_error ) then
          g1= xlow - ( g1-xanf ) * xscal             ! plot coordinate
          g2= xlow - ( g2-xanf ) * xscal  
          g3= yup + ( g3-yanf ) * yscal  
          g4= yup + ( g4-yanf ) * yscal  
         end if
c     
         if ( l_ini ) then
           call traa(gg3,gg1,0)           ! go to start point        
            l_ini=.false.
         end if

         if ( isym .eq. 33 ) then
          call traa(gg3,gg1,ipen)
         end if
c     
         if(isym.eq.0)then
          call TRAA(gg3,gg1,ipen)
         else
          do k=1,iloop                    ! fill up symbol  
           g5=sw-(k-1)*pen
           if ( g5 .gt. 0 ) then
            g6=sh-(k-1)*pen
            if ( g6 .gt. 0 ) then
             if ( isym .ne. 33 ) then 
              call becena (gg3,gg1,ipen,isym,g5,g6,0.,-1.)    ! plot symbol
             else                        
              g5=(g5+g6)/4.
              CALL BCERCA (gg3,gg1,IPEN,G5,90.,360.)         ! plot circle
             end if
            end if
           end if
          end do
         end if

         if ( isym .eq. 33 ) then
          call traa(gg3,gg1,0)
         end if
c
         if ( l_error )     then            ! plot error bars
          if ( g1 .ne. g2 ) then            ! plot x-error
           call traa(gg3,g1,0)
           call traa(gg3,g2,1)
           call traa(gg3,gg1,0)
          end if
          if ( g3 .ne. g4 ) then            ! plot y-error
           call traa(g3,gg1,0)
           call traa(g4,gg1,1)
           call traa(gg3,gg1,0)
          end if
         end if
c
        else                                ! point out of frame
         l_ini=.true.                       ! break line
        end if                              ! end of point within frame
 1000  continue
      end do                               ! end of plot
c      write(6,'(a,3i6)')' datplo i,ncount=',i,ncount,infra

      isym=0
      call pluma(nold_pen)                 ! choose old pen

      return
      end

 
      subroutine scaling(xanf0,xend0,ityp,xfirst,xlast,delta,itck)
C
C     scale berechnet Werte fuer Plotbereich und Achsenbeschriftung
c
C
c     M. Alflen   8.9.89
c
C     ityp = 0 : Plotbereich ( d.h. xfirst<xanf , xlast>xend )
c            1 : Achsen      ( d.h. xfirst>xanf , xlast<xend )
c
c     xanf , xend  : Eingabewerte Bereich
c     xfirst,xlast : geglaettete Ausgabewerte
c     delta        : Achsen-Unterteilung
c     itck         : Anzahl der Ticks zwischen zwei Unterteilungen
c
      real xmant (4)
      DATA xmant /1.,2.,5.,10./
c
      if(ityp.eq.1)then
       xanf=xanf0*0.999999
       xend=xend0*1.000001
      else 
       xanf=xanf0
       xend=xend0
      end if
      XFIRST = AMIN1(xanf,xend)
      XLAST = AMAX1(xanf,xend)
      xf=xfirst
      xl=xlast
      IF(XLAST-XFIRST .LT. 0.001) GOTO 999
c
      DELTA = (XLAST-XFIRST)/10.
      TENPOW = 10. ** (INT(ALOG10(DELTA)+1000.)-1000)
      DELTA = DELTA/TENPOW - 0.01
C
C     NOW DELTA CONTAINS MANTISSA, TENPOW THE TENPOWER OF DELTA
C
      DO 301 I=1,4
       IS = I
       IF(XMANT(I).GE.DELTA) GOTO 302
301   CONTINUE
C
C     SMOOTH MANTISSA
C
302   CONTINUE
      DELTA = XMANT(IS)*TENPOW
C
C     SMOOTH XFIRST,XLAST
C
      ROUND = 0.001
      IF(XFIRST.LT.0.) ROUND = ROUND - 1.
      XFIRST = DELTA * AINT(XFIRST/DELTA + ROUND)
      XLAST = AINT((XLAST-XFIRST)/DELTA + 0.99999)*DELTA + XFIRST
c
      if ( ityp .eq. 1) then
       if ( abs(xfirst) .lt. abs(xf)*(1.-1.e-4) )
     &     xfirst=xfirst+delta
       if ( abs(xlast) .gt. abs(xl)*(1.+1.e-4) ) 
     &     xlast=xlast-delta
      end if
      if ( xanf .gt. xend ) then
       xd=xfirst
       xfirst=xlast
       xlast=xd
       delta=-delta
      end if
c
      itck=min(ifix(xmant(is)),5)
      
c
      return
c
 999  continue     ! keine sinnvolle Skalierung moeglich
      if (xanf .eq. xend) then
       xanf=0
       xend=1
       delta=1
      else
       xfirst=xanf
       xlast=xend
       delta=xend-xanf
      end if
      itck=1      
      RETURN
c
      end

      function nform(in)
      
c     nform analysiert Eingabestring (ASCII) und
c     bestimmt Skalierungs-Format fuer BATPLO
c     Im Eingabestring stehen mindestens 3 Zahlen.
c     Die 3. Zahl ( d.h. step ) bestimmt das Format.
c
c     nform <0 : e-Format
c           =0 : i-Format
c           >0 : f-Format ( nform Nachkommastellen )
c
c     in        : Integer -String ( A1 beschrieben )
c
c
c     M. Alflen   15.9.89
c
c 
      implicit none
c
      character*1 in(81),nbl,nko,npk,nE,nle
      integer     izahl,i,k,nform
c
      data nbl/' '/,nko/','/,npk/'.'/,nE/'E'/,nle/'e'/
c
      izahl=0
      i=1
c
      do while ( izahl .lt. 2 )  ! vorspulen
c
       do while ( in(i) .eq. nbl  .and. i .lt. 80 )      ! Zahlenanfang suchen
        i=i+1
       end do
c 
       if (in(i) .eq. nko ) then
       i=i+1
        do while (i .lt. 80 .and. in(i) .eq. nbl )
         i=i+1
        end do       
       end if
c 
       i=i+1
c
       do while ( i .lt. 80 .and.
     &            in(i) .ne. nbl .and. in(i) .ne. nko )  ! Zahl ueberspringen
        i=i+1
       end do
c
       izahl=izahl+1                                     ! Zahl gefunden
c
      end do
c
      if (in(i) .eq. nko) i=i+1
      do while (i .lt. 80 .and. ( in(i) .eq. nbl .or. in(i) .eq. nko ) )
       i=i+1
      end do
c
      do while (i .lt. 80 .and.
     &          in(i) .ne. npk .and.                       ! Punkt suchen
     &          in(i) .ne. nE  .and. in(i) .ne. nle .and.  ! e suchen
     &          in(i) .ne. nbl .and. in(i) .ne. nko )      ! Ende suchen
       i=i+1
      end do
c
      if (in(i) .eq. nbl .or. in(i) .eq. nko ) then        ! Ende gefunden
       nform=0                                             ! i-Format
      else if ( in(i) .eq. nE .or. in(i) .eq. nle ) then   ! e gefunden
       nform=-1                                            ! e-Format
      else if ( in(i) .eq. npk ) then                      ! Punkt gefunden
       k=0
       do while ( i .lt. 80 .and.
     &           k .le. 5 .and.                            ! max. 5 Stellen
     &           in(i) .ne. nE  .and. in(i) .ne. nle .and. ! e suchen
     &           in(i) .ne. nbl .and. in(i) .ne. nko )     ! Ende suchen
        i=i+1
        k=k+1
       end do
       k=k-1
       if (in(i) .eq. nE .or. in(i) .eq. nle ) then        ! e gefunden
        if (k.gt.1) then
         nform=-k                                           ! e-Format 03.07
        else
         nform=-1
        end if  
       else
        nform=k
       end if
c
      end if
c
      return
c
      end

