      subroutine plotframe
      implicit none
      include 'comalp.for'

      logical     l_x_br_bo_l,l_x_br_bo_r,l_x_br_to_l,l_x_br_to_r,
     &            l_y_br_le_b,l_y_br_le_t,l_y_br_ri_b,l_y_br_ri_t
      real        pos_x,pos_y,wid_x,xd,b_wid,b_x,yd,b_y,b_off,heig_y
      common/plfr/l_x_br_bo_l,l_x_br_bo_r,l_x_br_to_l,l_x_br_to_r,
     &            l_y_br_le_b,l_y_br_le_t,l_y_br_ri_b,l_y_br_ri_t,
     &            pos_x,pos_y,wid_x,xd,b_wid,b_x,yd,b_y,b_off,heig_y

      call pluma(npen)         ! choose pen
c      write(6,'(a,6L5)')'l_xaxb,l_xaxt,l_yaxl,l_yaxr=',
c     &                   l_xaxb,l_xaxt,l_yaxl,l_yaxr

      if (l_xaxb .or. l_xaxt .or. l_yaxl .or. l_yaxr) then
       if ( l_xaxb) then 	   ! bottom x-axis
        pos_x=xrand
	pos_y=yrand
	wid_x=gx+xoff_l+xoff_r
	call traa(pos_y,pos_x,0)
        if ( l_x_br_bo_l .or. l_x_br_bo_r) then    ! break bottom x-axis
         b_wid=xd/3.
	 b_x=xd*.15
         b_y=yd*.7
	 if ( l_x_br_bo_r ) b_off=xd    	 ! break right side
         if ( l_x_br_bo_l ) b_off=wid_x-(1.+1/3.)*xd ! break left side
         call traa(pos_y,pos_x+b_off,1)
         call traa(pos_y-b_y,pos_x+b_off+b_x,0)
         call traa(pos_y+b_y,pos_x+b_off-b_x,1)
	 b_off=b_off+b_wid
         call traa(pos_y-b_y,pos_x+b_off+b_x,0)
         call traa(pos_y+b_y,pos_x+b_off-b_x,1)
         call traa(pos_y,pos_x+b_off,0)
         call traa(pos_y,pos_x+wid_x,1)
	else
c        write(6,'(a,2f10.2)')'     bottom x-axis ',pos_x,pos_y			                   ! no break
         call traa(pos_y,pos_x+wid_x,1)
	end if
       end if 
       if ( l_yaxl ) then		! plot left y-axis
        pos_x=xrand+gx+xoff_r+xoff_l
        pos_y=yrand
c       write(6,'(a,2f10.2)')'left-axis px,py=',pos_x,pos_y
        heig_y=gy+yoff_t+yoff_b
        call traa(pos_y,pos_x,0)
        if ( l_y_br_le_b .or. l_y_br_le_t) then    ! break left y-axis
c         write(6,'(a,2f10.2)')' break left y-axis ',pos_x,pos_y
         b_wid=yd/3.
	 b_x=xd*.7
         b_y=yd*.15
	 if ( l_y_br_le_b ) b_off=yoff_b/2.
         if ( l_y_br_le_t ) b_off=heig_y-yoff_t/2.-b_wid
         call traa(pos_y+b_off,pos_x,1)
         call traa(pos_y+b_off-b_y,pos_x+b_x,0)
         call traa(pos_y+b_off+b_y,pos_x-b_x,1)
	 b_off=b_off+b_wid
         call traa(pos_y+b_off-b_y,pos_x+b_x,0)
         call traa(pos_y+b_off+b_y,pos_x-b_x,1)
         call traa(pos_y+b_off,pos_x,0)
         call traa(pos_y+heig_y,pos_x,1)
	else			                   ! no break
         call traa(pos_y+heig_y,pos_x,1)
	end if
       end if 
       if ( l_xaxt) then 	   ! top x-axis
        pos_x=xrand+gx+xoff_l+xoff_r
        pos_y=yrand+gy+yoff_b+yoff_t
c       write(6,'(a,2f10.2)')'top x-axis px,py=',pos_x,pos_y
        wid_x=-(gx+xoff_l+xoff_r)
        call traa(pos_y,pos_x,0)
        if ( l_x_br_to_r .or. l_x_br_to_l) then    ! break top x-axis
c         write(6,'(a,2f10.2)')' break top x-axis ',pos_x,pos_y
         b_wid=-xd/3.
	 b_x=xd*.15
         b_y=yd*.7
	 if ( l_x_br_to_l ) b_off=-xoff_l/2.	   ! break left side
         if ( l_x_br_to_r ) b_off=wid_x+0.5*xoff_r-b_wid ! break right side
         call traa(pos_y,pos_x+b_off,1)
         call traa(pos_y-b_y,pos_x+b_off+b_x,0)
         call traa(pos_y+b_y,pos_x+b_off-b_x,1)
	 b_off=b_off+b_wid
         call traa(pos_y-b_y,pos_x+b_off+b_x,0)
         call traa(pos_y+b_y,pos_x+b_off-b_x,1)
         call traa(pos_y,pos_x+b_off,0)
         call traa(pos_y,pos_x+wid_x,1)
	else
c         write(6,'(a,2f10.2)')'       top x-axis ',pos_x,pos_y
			                   ! no break
         call traa(pos_y,pos_x+wid_x,1)
	end if
       end if 
       if ( l_yaxr ) then		! plot right y-axis
        pos_x=xrand
        pos_y=yrand+gy+yoff_t+yoff_b
        heig_y=-(gy+yoff_t+yoff_b)
c       write(6,'(a,2f10.2)')'right y-axis px,py=',pos_x,pos_y
	call traa(pos_y,pos_x,0)
        if ( l_y_br_ri_b .or. l_y_br_ri_t) then    ! break right y-axis
c         write(6,'(a,2f10.2)')' break right y-axis ',pos_x,pos_y
         b_wid=-yd/3.
	 b_x=xd*.7
         b_y=yd*.15
	 if ( l_y_br_ri_t ) b_off=-yoff_t/2	  ! top break
         if ( l_y_br_ri_b ) b_off=heig_y+yoff_b/2.-b_wid ! bottom break
         call traa(pos_y+b_off,pos_x,1)
         call traa(pos_y+b_off-b_y,pos_x+b_x,0)
         call traa(pos_y+b_off+b_y,pos_x-b_x,1)
	 b_off=b_off+b_wid
         call traa(pos_y+b_off-b_y,pos_x+b_x,0)
         call traa(pos_y+b_off+b_y,pos_x-b_x,1)
         call traa(pos_y+b_off,pos_x,0)
         call traa(pos_y+heig_y,pos_x,1)
	else			                   ! no break
         call traa(pos_y+heig_y,pos_x,1)
	end if
       end if 
      end if  ! l_frame
      return 
      end


      subroutine plotfrm1(xbot,ybot,xtop,ytop)
      implicit none
      include 'comalp.for'
      real          xbot,ybot,xtop,ytop

      logical     l_x_br_bo_l,l_x_br_bo_r,l_x_br_to_l,l_x_br_to_r,
     &            l_y_br_le_b,l_y_br_le_t,l_y_br_ri_b,l_y_br_ri_t
      real        pos_x,pos_y,wid_x,xd,b_wid,b_x,yd,b_y,b_off,heig_y
      common/plfr/l_x_br_bo_l,l_x_br_bo_r,l_x_br_to_l,l_x_br_to_r,
     &            l_y_br_le_b,l_y_br_le_t,l_y_br_ri_b,l_y_br_ri_t,
     &            pos_x,pos_y,wid_x,xd,b_wid,b_x,yd,b_y,b_off,heig_y

      ybot=yrand
      xbot=xrand
      ytop=yrand+gy+yoff_b+yoff_t
      xtop=xrand+gx+xoff_l+xoff_r

      if (l_xaxb .or. l_xaxt .or. l_yaxl .or. l_yaxr) then
       if ( l_xaxb) then 	   ! bottom x-axis
        if ( l_x_br_bo_l .or. l_x_br_bo_r) then    ! break bottom x-axis
         b_y=yd*.7
         ybot=ybot-b_y
	end if
       end if 
       if ( l_yaxl ) then		! plot left y-axis
        if ( l_y_br_le_b .or. l_y_br_le_t) then    ! break left y-axis
	 b_x=xd*.7
         xtop=xtop+b_x
	end if
       end if 
       if ( l_xaxt) then 	   ! top x-axis
        if ( l_x_br_to_r .or. l_x_br_to_l) then    ! break top x-axis
         b_y=yd*.7
         ytop=ytop+b_y
	end if
       end if 
       if ( l_yaxr ) then		! plot right y-axis
        if ( l_y_br_ri_b .or. l_y_br_ri_t) then    ! break right y-axis
	 b_x=xd*.7
         xbot=xbot-b_x
	end if
       end if 
      end if  ! l_frame
      return 
      end


