      subroutine frstr_stroboscopy(l_nfrtheo,lstruct1,lstruct2,
     &                                           cmch,property)

      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'

      character*132 ch132,property,cmch*4,chth*8


      if(enwr(14)(1:1).eq.'y') write(nwr,'(2(a,a8),a,i2,a,/,a,2(a,i2))')
     & ' cmch=',cmch,' thstruct:',chth,' l_nfrtheo=',l_nfrtheo,
     & ' subr= frstr_stroboscopy  nameth_as=',nameth_as(:40),
     & ' lstruct1=',lstruct1,' lstruct2=',lstruct2

      if(cmch.eq.'name') then
       l_nfrtheo=1         
c####################################################
       property='Mossbauer stroboscopy'                                  !name
       ntheory(1)='Mossbauer synchrotron stroboscopy'
c####################################################
       return
      end if

      chth='fr'//property(1:6)
      nstruct=' '

      goto(100,200,300)lstruct1+1
c------------------------------------------------------------------------
 100  continue

      if(cmch.eq.'hdbk') then
       nstruct='handbook=nucleus.hdb '//
     & ' list=4 seq=2  chth='//chth  
       return
      end if


c------------------------------------------------------------------------
c     variables of frame theory: sample, reference absorber
c      common block is compatible with subroutine drive
c      common/avstrf/avsp,
c     &                  dum1,base,dum2,v_max,channel_v0,               5
c     &                  v_max2,channel_v02,v_max3,channel_v03,geo,     10  
c     &                  ang_shift,Pxsi,Peta,Pzeta                        14

c     dum1=f_factor, dum2=bg_fraction 
c     geo is used in subroutine drive. geo=0 for synchrotron radiation
c     is defined in fr_syncrotron.

      k=1
      do while(strtm(k,1)(:5).ne.'#beg#')
       k=k+1
      end do
      jm=k-1
      jmb=k
      k=1
      do while(strth(k,1)(:5).ne.' ')
       k=k+1
      end do
      jh=k-1
c     trans-Matrix   name                       dimension                    
      strtm(jm+1,1)='baseline                   1 1'
      strtm(jm+1,2)='(1) parameter base line '
      strth(1,1)='base            , 100000.0  0.0 0.0 10.0'     ! para baseline
c                 name                  pos     matrix
      strth(1,2)='base                    2    , 1 '            ! variable
c     variable have a position in the common block

c                 1        0         012345
      jm=jm+1
      jh=jh+1
      strtm(jm+1,1)='calibration                ,## 2 2'
      strtm(jm+1,2)='(2) parameters for calibration v_max,channel_v0'
      strth(jh+1,1)='v_max             ,  16.0   0.0 0.0 0.05 '  !
      strth(jh+2,1)='channel_v0        ,  128.0  0.0 0.0 0.1 '   ! channel_v0
      strth(jh+1,2)='v_max                   4     , 1 0'
      strth(jh+2,2)='channel_v0              5     , 0 1 '

      jm=jm+1
      jh=jh+2
      strtm(jm+1,1)='non_linearity                ,## y 4 4'
      strtm(jm+1,2)='(4) non linearity parameters for calibration'
      strth(jh+1,1)='vmax2            , 0.0   0.0 0.0 0.05 '   !
      strth(jh+2,1)='vphase2          , 128.0  0.0 0.0 0.1 '   ! phase shift2
      strth(jh+3,1)='vmax3            , 0.0   0.0 0.0 0.05 '  !
      strth(jh+4,1)='vphase3          , 128.0  0.0 0.0 0.1 '   ! phase shift3
      strth(jh+1,2)='vmax2                    6     1 0 0 0 '
      strth(jh+2,2)='vphase2                  7     0 1 0 0 '
      strth(jh+3,2)='vmax3                    8     0 0 1 0 '
      strth(jh+4,2)='vphase3                  9     0 0 0 1 '
      jm=jm+1
      jh=jh+4
      strtm(jm+1,1)='Poincare_vector           ## 3 3'
      strtm(jm+1,2)='(3) Poincare vector of the Synchrotron beam'
      strth(jh+1,1)='P_xsi             , -1.0  0.0 1.0  0.05'
      strth(jh+2,1)='P_eta             , 0.0  0.0 0.0   0.05'
      strth(jh+3,1)='P_zeta            , 0.0  0.0 0.0   0.05'
      strth(jh+1,2)='P_xsi                    12     1 0 0 '
      strth(jh+2,2)='P_eta                    13     0 1 0 '
      strth(jh+3,2)='P_zeta                   14     0 0 1 '
      jm=jm+1
      jh=jh+3

      strtm(jm+1,1)='calibration               ,## y 1 1'
      strtm(jm+1,2)='(1) frame parameter ang_shift'
      strth(jh+1,1)='ang_shift         , 0.0 0.0 0.0 0.1'
      strth(jh+1,2)='ang_shift                11     1  '
      jm=jm+1
      jh=jh+1
  
      strtm(jm+1,1)='#end#  14 '
      strtm(jm+2,1)='#beg#'

      do k=jmb,jm
       ch132=strtm(k,1)
       call stringlength(ch132,l)
       strtm(k,1)=ch132(:l)//'/'//chth
      end do


      if(l_nfrtheo.eq.1) then
      strcmt(0)=' 6  7'
      strcmt(1)=
     &' sample, reference absorber  are considered as layers, '
      strcmt(2)=' sample, ref-absorber may consist of several layers'
      strcmt(3)=
     &'  each layer n contains 0-N inequivalent lattice sites:'
      strcmt(4)=
     &'    \\  layer 1       ___________________     '
      strcmt(5)=
     &'                              ...                      '
      strcmt(6)=
     &'    /_ layer  n        ___________________    '

      strcmt(7)='absorber_reference        fs          ,##n    2 ' ! mstruct1
      strcmt(8)=' '
      strcmt(9)='number of incoherent parts '
      strcmt(10)='theory/'//chth//'/sample/layer/structure'
      end if

      if(l_nfrtheo.eq.2) then
      strcmt(0)=' 6  7'
      strcmt(1)=
     &' scatterer and reference absorber are considered as layers, '
      strcmt(2)=' they may consist of several layers and '
      strcmt(3)=
     &'  each layer n contains 0-N inequivalent lattice sites:'
      strcmt(4)=
     &'    \\  layer 1       ___________________     '
      strcmt(5)=
     &' n_period                    ...                      '
      strcmt(6)=
     &'    /_ layer  n        ___________________    '

      strcmt(7)='scatterer_reference       gr          ,##n     2 '
      strcmt(8)=' '
      strcmt(9)='number of incoherent parts '
      strcmt(10)='theory/'//chth//'/scatterer/layer/structure'
      end if
      return
c-----------------------------------------------------------------------------
c      sample 

c      common/cfr1trf/pfr1,Hext,thetaHe,phiHe,phi,theta,psi
 300  continue

      if(cmch.eq.'hdbk') then
       nstruct=' '
       return
      end if

      if(lstruct2.gt.0) goto 310

      k=1
      do while(strtm(k,1)(:5).ne.'#beg#')
       k=k+1
      end do
      jm=k-1
      jmb=k
      k=1
      do while(strth(k,1)(:5).ne.' ')
       k=k+1
      end do
      jh=k-1

      strtm(jm+1,1)='H_extern                ,# 3 3'
      strtm(jm+1,2)='external magnetic field (lab) at the sample'
      strth(jh+1,1)='Hext             , 0.0  0.0 0.0  1.0'
      strth(jh+2,1)='thetaHe          , 0.0 0.0 0.0   1.0'
      strth(jh+3,1)='phiHe            , 0.0 0.0 0.0   1.0 '
      strth(jh+1,2)='Hext                     2    1 0 0  '
      strth(jh+2,2)='thetaHe                  3    0 1 0 '
      strth(jh+3,2)='phiHe                    4    0 0 1'

      jm=jm+1
      jh=jh+3
      if(l_nfrtheo.eq.2) then

       strcmt(1)='scatterer_layer  sr  l l1=co li=sw ln=su #  1 1'
       strcmt(2)='name of layer (cover,sandwich,substrate)'
       strcmt(3)='number of layers of the scatterer '
       strcmt(4)='theory/'//chth//'/scatterer/layer/structure'
       strcmt(5)='distribution of parameters at sites of the layer'
      else
       strtm(jm+1,1)='orientation             , # 3 3'
       strtm(jm+1,2)='orientation of the sample in the LAB'
       strth(jh+1,1)='phi              , 0.0  0.0 0.0  1.0'
       strth(jh+2,1)='theta            , 0.0 0.0 0.0   1.0'
       strth(jh+3,1)='psi              , 0.0 0.0 0.0   1.0 '
       strth(jh+1,2)='phi                     5    1 0 0'
       strth(jh+2,2)='theta                   6    0 1 0'
       strth(jh+3,2)='psi                     7    0 0 1'
       jm=jm+1
       jh=jh+3

       strcmt(1)='sample_layer  ab  l  l1=po ln=an      #  1  1'
       strcmt(2)='name of layer (polarizer,analyser)'
       strcmt(3)='number of layers of the sample'
       strcmt(4)='theory/'//chth//'/sample/layer/structure'
       strcmt(5)='distribution of parameters at sites of the layer'
      end if
      strtm(jm+1,1)='#end# 7'
      strtm(jm+2,1)='#beg#'

      do k=jmb,jm
       ch132=strtm(k,1)
       call stringlength(ch132,l)
       strtm(k,1)=ch132(:l)//'/'//chth
      end do

      return
c                ---------------------------------------------
 310  continue
c     first variable is not counted in the definition
c     it containes the number of variable in the common block

c      common/acfr2trf/acfr2,
c                      rep_grp
c      common/avfr2trf/avfr2,
c                      thicklay,re_chilay,ai_chilay,roughness,


      k=1
      do while(strco(k)(:5).ne.'#beg#')
       k=k+1
      end do
      jc=k-1
      jcb=k

      k=1
      do while(strtm(k,1)(:5).ne.'#beg#')
       k=k+1
      end do
      jm=k-1
      jmb=k
      k=1
      do while(strth(k,1)(:5).ne.' ')
       k=k+1
      end do
      jh=k-1

      if(l_nfrtheo.eq.2) then
c      if(index(namefr,'reflection').gt.0) then
c                   1        0         012345
       strco(jc+1)='rep.grp                 1      1.1 '
                ! layer belongs to a group which repeat with period
       strco(jc+2)='iset_powder                2 #n   0 '
                ! iset=1-6 for 4-128 points on 1/48 of the sphere
       strco(jc+3)='isymmetry                  3 #n   10 '
                ! isymmetry =11-15 (z||C_4) and 21-25 (z||C_3)
       jc=jc+3
       strco(jc+1)='#end#  4  seq'
       strco(jc+2)='#beg#'

       do k=jcb,jc
        ch132=strco(k)
        call stringlength(ch132,l)
        strco(k)=ch132(:l)//'/'//chth
       end do



       strtm(jm+1,1)='thickn_lay              , 1 1'
       strtm(jm+1,2)='thickness of the layer'
       strth(jh+1,1)='thicklay        , 1.0  0.0 0.0  0.1'
       strth(jh+1,2)='thicklay                1    1  '
c                     1        0         012345

       strtm(jm+2,1) ='chi_electronic         , 2 2'
       strtm(jm+2,2) ='chi_electronic of the layer  '
       strth(jh+2,1)='r_chilay        , -14.5 0.0 0.0  0.1'
       strth(jh+3,1)='i_chilay        ,   0.7 0.0 0.0  0.1'
       strth(jh+2,2)='r_chilay                2    1 0'
       strth(jh+3,2)='i_chilay                3    0 1'

       strtm(jm+3,1)='roughness                ,# 1 1'
       strtm(jm+3,2)='roughness of the layer  '
       strth(jh+4,1)='roughness        , 0.0  0.0 0.0  0.1'
       strth(jh+4,2)='roughness               4    1 '
       jm=jm+3

       strtm(jm+1,1)='#end#    4'
       strtm(jm+2,1)='#beg#'

       strcmt(1)='scatterer_layer   s       #  1  0'
       strcmt(2)='li=(1 0)  '
       strcmt(3)='number of inequivalent sites of the scatterer layer'
       strcmt(4)='theory/'//chth//'/scatterer/layer/sites'
       strcmt(5)='distribution of parameters of site number'
      else if(l_nfrtheo.eq.1) then
       strtm(jm+1,1)='thickn_lay              , 1 1'
       strtm(jm+1,2)='thickness of the layer'
       strth(jh+1,1)='thicklay        , 1.0  0.0 0.0  0.1'
       strth(jh+1,2)='thicklay                1    1  '
       jm=jm+1
c 
       strtm(jm+1,1)='#end#    1'
       strtm(jm+2,1)='#beg#'

       strcmt(1)='sample_layer      s       #  1  1'
       strcmt(2)=' '
       strcmt(3)='number of inequivalent sites of the sample layer'
       strcmt(4)='theory/'//chth//'/sample/layer/sites'
       strcmt(5)='distribution of parameters of site number'
      end if

      do k=jmb,jm
       ch132=strtm(k,1)
       call stringlength(ch132,l)
       strtm(k,1)=ch132(:l)//'/'//chth
      end do

      return
c-----------------------------------------------------------------------
c     reference-absorber
c      common/cfr1trf/afr1,
c                     pfr1,Hext,thetaHe,phiHe,phi,theta,psi
 200  continue

      if(cmch.eq.'hdbk') then
       nstruct=' '
       return
      end if

      if(lstruct2.gt.0) goto 210

      k=1
      do while(strtm(k,1)(:5).ne.'#beg#')
       k=k+1
      end do
      jm=k-1
      jmb=k
      k=1
      do while(strth(k,1)(:5).ne.' ')
       k=k+1
      end do
      jh=k-1

      strtm(jm+1,1)='H_extern                ,# 3 3'
      strtm(jm+1,2)='external magnetic field (lab) at the ref-absorber'
      strth(jh+1,1)='Hext             , 0.0  0.0 0.0  1.0'
      strth(jh+2,1)='thetaHe          , 0.0 0.0 0.0   1.0'
      strth(jh+3,1)='phiHe            , 0.0 0.0 0.0   1.0 '
      strth(jh+1,2)='Hext                     2    1 0 0  '
      strth(jh+2,2)='thetaHe                  3    0 1 0 '
      strth(jh+3,2)='phiHe                    4    0 0 1'

      strtm(jm+2,1)='orientation               ,# 3 3'
      strtm(jm+2,2)='orientation of the ref-absorber in the LAB'
      strth(jh+4,1)='phi             , 0.0  0.0 0.0  1.0'
      strth(jh+5,1)='theta           , 0.0 0.0 0.0   1.0'
      strth(jh+6,1)='psi             , 0.0 0.0 0.0   1.0 '
      strth(jh+4,2)='phi                      5     1 0 0'
      strth(jh+5,2)='theta                    6     0 1 0'
      strth(jh+6,2)='psi                      7     0 0 1'
      jm=jm+2
      strtm(jm+1,1)='#end#  7  '
      strtm(jm+2,1)='#beg#'

      do k=jmb,jm
       ch132=strtm(k,1)
       call stringlength(ch132,l)
       strtm(k,1)=ch132(:l)//'/'//chth
      end do

      strcmt(1)='reference_layer       RF              #   1 1'
      strcmt(2)='name of  reference_layer'
      strcmt(3)='number of layers of the reference absorber '
      strcmt(4)='theory/'//chth//'/layer/ref-absorber'
      strcmt(5)='distribution of parameters at sites of the layer'
      return

 210  continue
c     first variable is not counted in the definition
c     it containes the number of variable in the common block

c      common/avfr2trf/avfr2,
c                      thicklay
 
      k=1
      do while(strtm(k,1)(:5).ne.'#beg#')
       k=k+1
      end do
      jm=k-1
      jmb=k
      k=1
      do while(strth(k,1)(:5).ne.' ')
       k=k+1
      end do
      jh=k-1

       strtm(jm+1,1)='thickn_lay              , 1 1'
       strtm(jm+1,2)='thickness of the layer'
       strth(jh+1,1)='thicklay        , 1.0  0.0 0.0  0.1'
       strth(jh+1,2)='thicklay                1    1  '
       jm=jm+1
c 
       strtm(jm+1,1)='#end#    1'
       strtm(jm+2,1)='#beg#'

      do k=jmb,jm
       ch132=strtm(k,1)
       call stringlength(ch132,l)
       strtm(k,1)=ch132(:l)//'/'//chth
      end do

      strcmt(1)='reference_absorber       s       #  1  1'
      strcmt(2)=' '
      strcmt(3)='number of inequivalent sites of the ref-layer'
      strcmt(4)='theory/'//chth//'/reference/layer/sites'
      strcmt(5)='distribution of parameters of site number'
      return
      end


