      subroutine replace_helpfile(helpfile)     
c     the user may collect help information in files of his choice
      character*132 chin,chcom,helpfile
      
      call stringlength(helpfile,j)
c      write(6,'(a)')helpfile(:j)
      if(helpfile(:j).eq.'Mossbauer_radioactive_source.help'.or.
     &   helpfile(:j).eq.'Mossbauer_geometry.help')then
       helpfile='Mossbauer_spectrum.help'
       return
      end if

      if(helpfile(:j).eq.'scalar_ref.index(stat)-Hi,DEQ.help'.or.
     &   helpfile(:j).eq.'scalar_ref.index(stat)-l1_l2_l6.help'.or.
     &   helpfile(:j).eq.'22ref.index(stat)-H_DEQ.help'.or.
     &   helpfile(:j).eq.'22ref.index(stat)-H_DEQ_f.help'.or.
     &   helpfile(:j).eq.'2x2_index_f_spinham.help' ) then
       helpfile='theory_nucleus.help'
       return
      end if

      if(helpfile(:j).eq.'scalar_refraction_index_(sad).help'.or.
     &   helpfile(:j).eq.'scalar_refraction_index_MB.help'.or.
     &   helpfile(:j).eq.'2x2_refraction_index_(sad).help'.or.
     &   helpfile(:j).eq.'2x2_refraction_index_MB.help'.or.
     &   helpfile(:j).eq.'2x2_refraction_index_f_(sad).help'.or.
     &   helpfile(:j).eq.'2x2_refraction_index_reflection.help'.or.
     &   helpfile(:j).eq.'2x2_refraction_index_transmission.help')then
       helpfile='refraction_index.help'
       return
      end if

      if(helpfile(:j).eq.'offspecular_correlation_function.help'.or.
     &   helpfile(:j).eq.'offspecular_correlation_matrix.help'.or.
     &   helpfile(:j).eq.'offspecular_scanmodes.help'.or.
     &   helpfile(:j).eq.'X-ray_offspecular_reflection.help'.or.
     &   helpfile(:j).eq.'offspecular_omegascan.help') then
       helpfile='Synchrotron_offspecular.help'
       return
      end if

      if(helpfile(:j).eq.'scalar_ref.index(dyn)-halfint.help'.or.
     &   helpfile(:j).eq.'scalar_ref.index(dyn)-twostate.help') then
       helpfile='Mossbauer_relaxation.help'
       return
      end if

      if(helpfile(:j).eq.'spin_Hamiltonian_one_field.help'.or.
     &   helpfile(:j).eq.'spin_Hamiltonian_two_fields.help') then
       helpfile='spin_Hamiltonian.help'
       return
      end if

      return
      end

      subroutine gethdb(ihdb,nhandbook)
      character nhandbook*32

      if(ihdb.eq.0) then
       if(nhandbook.eq.'nucleus.hdb') then
         ihdb=1
       else if(nhandbook.eq.'material.hdb') then
         ihdb=2
       end if
      else
       if(ihdb.eq.1) then
         nhandbook='nucleus.hdb'
       else if(ihdb.eq.2) then
        nhandbook='material.hdb'
       end if
      end if 
      return
      end



      subroutine getfrstring(nfrtheo,l_nfrtheo,lstruct1,lstruct2,
     &                                              cmch,property)
      character cmch*4,property*132

c       write(6,'(a,i2,3(a,i2),/,2a)')'getfrstring  nfrtheo=',nfrtheo,
c     &  ' l_nfrtheo=',l_nfrtheo,' lstruct1=',lstruct1,
c     &   ' lstruct2=',lstruct2,' property=',property(1:60)   

       i0=ichar('0')
       i10=nfrtheo/10
       i1=nfrtheo-10*i10
       property(1:2)=char(i10+i0)//char(i1+i0)
       i10=l_nfrtheo/10
       i1=l_nfrtheo-10*i10
       property(3:6)=char(i10+i0)//char(i1+i0)//'  '

       if(nfrtheo.eq.3) then
        call frstr_stroboscopy(l_nfrtheo,lstruct1,lstruct2,
     &                                          cmch,property)
       else if(nfrtheo.eq.2) then
        call frstr_synchrotron(l_nfrtheo,lstruct1,lstruct2,
     &                                          cmch,property)
       else if(nfrtheo.eq.1) then
        call frstr_mossbauer(l_nfrtheo,lstruct1,lstruct2,
     &                                          cmch,property)
       else if(nfrtheo.eq.4) then
        call frstr_neutron(l_nfrtheo,lstruct1,lstruct2,
     &                                          cmch,property)
      end if
      nfrtheo=4            ! loop nfrtheo will end at nfrtheo instead 
c                          ! at maxs=16
      return
      end

      subroutine distribthfr(iframe,cmch,iss,info)
      character cmch*4
c      write(6,'(a,i4)') ' distribthfr iframe=',iframe     
c       write(6,'(a,i2,a,a4,a,i2)')'distribthfr   iframe=',iframe,
c     &  ' cmch=',cmch,' iss=',iss

      if(iframe.eq.1) then
       call fr_stroboscopy(cmch,iss,info)
      else if(iframe.eq.2) then
       call fr_synchrotron(cmch,iss,info)
      else if(iframe.eq.3) then
       call fr_mossbauer(cmch,iss,info)
      else if(iframe.eq.4) then
       call fr_neutron(cmch,iss,info)
      end if
      iframe=4
      return
      end



      subroutine getthstring(jth,l_jth,cmch,property)
      character property*132,cmch*4

c      write(6,'(2(a,i4),2a)') ' getthstring jth=',jth,' l_jth=',l_jth,
c     &                        ' cmch=',cmch
       i0=ichar('0')
       i10=jth/10
       i1=jth-10*i10
       property(1:2)=char(i10+i0)//char(i1+i0)
       i10=l_jth/10
       i1=l_jth-10*i10
       property(3:6)=char(i10+i0)//char(i1+i0)//'  '

       if(jth.eq.1) then 
        call thstr_11indexmoss(l_jth,cmch,property)
       else if(jth.eq.2) then
        call thstr_11index(l_jth,cmch,property)
       else if(jth.eq.3) then
        call thstr_relaxhalfintegral(l_jth,cmch,property)
       else if(jth.eq.4) then
        call thstr_lines126(l_jth,cmch,property)
       else if(jth.eq.5) then
        call thstr_hdeqmiscil(l_jth,cmch,property)
       else if(jth.eq.6) then
        call thstr_22indexmoss(l_jth,cmch,property)
       else if(jth.eq.7) then
        call thstr_22indexfmoss(l_jth,cmch,property)
       else if(jth.eq.8) then
        call thstr_22indexrefl(l_jth,cmch,property)
       else if(jth.eq.9) then
        call thstr_hdeq(l_jth,cmch,property)
       else if(jth.eq.10) then
        call thstr_hdeqf(l_jth,cmch,property)
       else if(jth.eq.11) then
        call thstr_mossbauer(l_jth,cmch,property)
       else if(jth.eq.12) then
        call thstr_sampleorient(l_jth,cmch,property)
       else if(jth.eq.13) then
        call thstr_synstrob(l_jth,cmch,property)
       else if(jth.eq.14) then
        call thstr_synstrobtrans(l_jth,cmch,property)
       else if(jth.eq.15) then
        call thstr_strobwindow(l_jth,cmch,property)
       else if(jth.eq.16) then
        call thstr_synstrobrefl(l_jth,cmch,property)
       else if(jth.eq.17) then
        call thstr_synsource(l_jth,cmch,property)
       else if(jth.eq.18) then
        call thstr_syntransmission(l_jth,cmch,property)
       else if(jth.eq.19) then
        call thstr_synreflection(l_jth,cmch,property)
       else if(jth.eq.20) then
        call thstr_neutron(l_jth,cmch,property)
       else if(jth.eq.21) then
        call thstr_neutronspec(l_jth,cmch,property)
       else if(jth.eq.22) then
        call thstr_neutronoffspec(l_jth,cmch,property)
       else if(jth.eq.23) then
        call thstr_22indextrm(l_jth,cmch,property)
       else if(jth.eq.24) then
        call thstr_synoffspec(l_jth,cmch,property)
       else if(jth.eq.25) then
        call thstr_offspeccorrelation(l_jth,cmch,property)
       else if(jth.eq.26) then
        call thstr_offspeccorrelfunc(l_jth,cmch,property)
       else if(jth.eq.27) then
        call thstr_22indexreflnosampl(l_jth,cmch,property)
       else if(jth.eq.28) then
        call thstr_scanmode(l_jth,cmch,property)
       else if(jth.eq.29) then
        call thstr_relaxtwostate(l_jth,cmch,property)
       else if(jth.eq.30) then
        call thstr_aperture(l_jth,cmch,property)
       else if(jth.eq.31) then
        call thstr_hyperfineft(l_jth,cmch,property)
       else if(jth.eq.32) then
        call thstr_hyperfield(l_jth,cmch,property)
       else if(jth.eq.33) then
        call thstr_hyperfield2(l_jth,cmch,property)
       else if(jth.eq.34) then
        call thstr_11indexMB(l_jth,cmch,property)
       else if(jth.eq.35) then
        call thstr_22indexMB(l_jth,cmch,property)
      end if
       jth=35               ! neccessary
      return
      end

      subroutine distribth(isubthe_n,ntheo,icase,iput,iget,nath,info)
      integer isubthe_n,ntheo,icase,iput,iget,info
      character nath*80
c      write(6,'(a,5i8)') 'distribth isubthe_n,ntheo,icase=',
c     &                              isubthe_n,ntheo,icase
      if(ntheo.eq.1) then
       call th_22index(isubthe_n,icase,iput,iget,info)
       nath='th_22index'
      else if(ntheo.eq.2) then 
       call th_hdeq(isubthe_n,icase,iput,iget,info)
       nath='th_hdeq'
      else if(ntheo.eq.3) then
       call th_timewindows(isubthe_n,icase,iput,iget,info)      !
       nath='th_timewindows'
      else if(ntheo.eq.4) then
       call th_sampleorient(isubthe_n,icase,iput,iget,info)     !
       nath='th_sampleorient'
      else if(ntheo.eq.5) then
       call th_lines126(isubthe_n,icase,iput,iget,info)
       nath='th_lines126'
      else if(ntheo.eq.6) then
       call th_22indexsad(isubthe_n,icase,iput,iget,info)
       nath='th_22indexsad'
      else if(ntheo.eq.7) then
       call th_11indexsad(isubthe_n,icase,iput,iget,info)
       nath='th_11indexsad'
      else if(ntheo.eq.8) then
       call th_hdeqmiscellaneous(isubthe_n,icase,iput,iget,info)
       nath='th_hdeqmiscellaneous'
      else if(ntheo.eq.9) then
       call th_relaxglobalsad(isubthe_n,icase,iput,iget,info)
       nath='th_relaxglobalsad'
      else if(ntheo.eq.10) then
       call th_relaxspinhalfsad(isubthe_n,icase,iput,iget,info)
       nath='th_relaxspinhalfsad'
      else if(ntheo.eq.11) then
       call th_hdeqf(isubthe_n,icase,iput,iget,info)
       nath='th_hdeqf'
c      else if(ntheo.eq.12) then
c       call th_22indexfsad(isubthe_n,icase,iput,iget,info)
c       nath='th_22indexfsad'
      else if(ntheo.eq.12) then
       call th_11index(isubthe_n,icase,iput,iget,info)
       nath='th_11index'
      else if(ntheo.eq.13) then
       call th_offspeccorrelfunc(isubthe_n,icase,iput,iget,info)
       nath='th_offspeccorrelfunc'
      else if(ntheo.eq.14) then
       call th_offspeccorrelation(isubthe_n,icase,iput,iget,info)
       nath='th_offspeccorrelation'
      else if(ntheo.eq.15) then
       call th_scanmode(isubthe_n,icase,iput,iget,info)
       nath='th_scanmode'
      else if(ntheo.eq.16) then
       call th_relaxtwostatesad(isubthe_n,icase,iput,iget,info)
       nath='th_relaxtwostatesad'
      else if(ntheo.eq.17) then
       call th_hyperfineft(isubthe_n,icase,iput,iget,info)
       nath='th_hyperfineft'
      else if(ntheo.eq.18) then
       call th_spinham05(isubthe_n,icase,iput,iget,info)
       nath='th_spinham05'
c      else if(ntheo.eq.19) then
c       call th_sH05slowrelax(isubthe_n,icase,iput,iget,info)
c       nath='th_sH05slowrelax'
      else
       isubthe_n=-isubthe_n 
      end if
      ntheo=18
      return
      end


