      subroutine th_lines126(isubthe,icase,iput,iget,info)
      include 'comglb.for'
      include 'comthe.for'
      include 'comnuc.for'

      integer        isubthe,icase,iput,iget,info
      real           avm,w_Gauss,w_Lorentz,fr_int,pos,dumvm                           
      common/avmaps/ avm,w_Gauss(8),w_Lorentz(8),fr_int(8),pos(8),
     &               dumvm(ivstrf-33)
      logical        b_vm,b_dumvm      
      common/bvmaps/ b_vm,b_dumvm(ivstrf-1)
      real           c1,dumcm
      common/acmaps/ c1,dumcm(icstrf-1)

      real    rtr(maxjge)

      if(isubthe.lt.0) then
       theoryname='singlet_doublet_sextet           v=100'
       if(icase.eq.1) jge=1
       if(icase.eq.2) jge=2
       if(icase.eq.3) jge=6
       c1=2*jge+1
       return
      end if
      
c      write(6,'(a,2i6)')'th_lines126   iget,iput=',iget,iput       

c     write(6,'(a,4i6,a)')'th_lines126 isubthe,icase,iput,iget,info=',
c    &                isubthe,icase,iput,iget,info,' ###########'
      
      if(b_vm) then
       if(icase.eq.1) then
        jge=1
        rtr(1)=1.0
        Eagd(1)=0.0
       else
        if(icase.eq.2) jge=2
        if(icase.eq.3) jge=6
        do k=1,jge
         rtr(k)=fr_int(k)
         Eagd(k)=pos(k)
        end do
       end if
       i1=iput+1
       i2=i1+jge
c       write(6,'(a,i8)') 'th_lines126 i1=',i1
       array_fr(i1)=cmplx(float(jge),0.0)
       do i=1,jge
        array_fr(i1+i)=cmplx(Eagd(i),rtr(i))
        array_fr(i2+i)=cmplx(w_Gauss(i),w_Lorentz(i))          
       end do
      else
       isubthe=-abs(isubthe)
      end if 

      return
      end

      subroutine th_hdeqmiscellaneous(isubthe,icase,iput,iget,info)

      include 'comglb.for'
      include 'comthe.for'
      include 'comnuc.for' 
      
      integer isubthe,icase,iput,iget,info
      
      
      real           avm,w_Gauss,w_Lorentz,fr_int,
     &               aH,thetaH,phiH,DEq,eta,dumvm                           
      common/avmaps/ avm,w_Gauss(8),w_Lorentz(8),fr_int(8),
     &               aH,thetaH,phiH,DEq,eta,dumvm(ivstrf-30)
      logical        b_vm,b_dumvm      
      common/bvmaps/ b_vm,b_dumvm(ivstrf-1)

      integer       dumcm
      common/acmaps/c1,cTms,ajg,aje,amueg,amuee,QgdQe,r_E2M1,e1m1,
     &              offset,dumcm(icstrf-10)

c---------------------------------------------------------------------      
      complex efgPAS(-2:2),hvE(-1:1),hc1
      integer i8,indx
      dimension i8(8),indx(maxjge)
      real      rtr(maxjge),arrin(maxjge),
     &          gauss(maxjge),lorentz(maxjge)
c---------------------------------------------------------------------
      Integer   je,jg,Lp,jm,NN,ioffset
      logical b_integer

      jge=(2.*ajg+1)*(2.*aje+1)+0.01
       
       if(isubthe.lt.0) then
        theoryname='Hi_DEQ_miscellaneous'
        c1=1+2*jge
        return
       end if
      
c      write(6,'(a)')' th_hdeqmiscellaneous avsstrf ::'
c      write(6,'(10f10.3)')avss,fr_int,aH,thetaH,phiH,DEq,eta

      if(.not.b_vm) then
       isubthe=-abs(isubthe)
       return
      end if

       ioffset=offset
       if(icase.eq.1)ioffset=0
       lint=jge
       if(lint.gt.8)then
        lint=8
        if(ioffset+lint.gt.jge)then
         info=ioffset+lint
         infotext(1)='<theory_nucleus>/constant/offset'
         infotext(2)='**error** offset_line too large'
         infotext(3)=' '
         return         
        end if
       else
        if(ioffset.gt.0)then
         info=ioffset
         infotext(1)='<theory_nucleus>/constant/offset'
         infotext(2)=
     &   '**error** offset_line+8 is larger than number of lines'
         infotext(3)=' '
         return
        end if
       end if


      
c--------------------------------------------------------------------------
c      eQVzz=DEq/sqrt(1.+eta**2/3.)*2.
c       efgm are the spherical tensor
c       components of the EFG in the PAS
c       efg-2=efg2 , efg+1=efg-1=0
      
      pi=atan(1.)*4.
      rad=atan(1.)/45.
      
      eQVzz=DEq/sqrt(1.+eta**2/3.)*2.
      efg0=eQVzz/2.
      efg2=eta*efg0/sqrt(6.)
      
c     write(6,'(a,5f12.6)') '  efg=', eQVzz,eta,phiE,thetaE,psiE
c      write(6,'(a,5f12.6)') '    H=',aH,thetaH,phiH
c      write(6,'(a,5f12.6)') '    A=',phiAL,thetaAL,psiAL
      
      efgPAS(0)=cmplx(efg0,0.0)
      efgPAS(-1)=(0.,0.)
      efgPAS(1)=(0.,0.)
      efgPAS(-2)=cmplx(efg2,0.)
      efgPAS(2)=cmplx(efg2,0.)
      
c     magnetic field parameter
      
      hvE(1) =-cmplx(cos(phiH*rad),sin(phiH*rad))*
     &                  sin(thetaH*rad)/sqrt(2.0)*aH
      hvE(0) = cmplx(cos(thetaH*rad),0.0)*aH
      hvE(-1)=-conjg(hvE(1))

      ii=jge/2
      if(2*ii.eq.jge) then
       b_integer=.false.
       je=2*aje+0.01
       jg=2*ajg+0.01
       jm=je
       if(jg.gt.jm)jm=jg
       NN=jm+1
      else
       b_integer=.true.
       je=aje+0.01
       jg=ajg+0.01
       jm=je
       if(jg.gt.jm)jm=jg
       NN=2*jm+1
      end if
      if(abs(jg-jg_a)+abs(je-je_a).gt.0)then      
       jg_a=jg
       je_a=je
       call symbol3j(b_integer,je,jg,Vje_1_jg,Vje_2_jg,
     &                          wpje,wmje,wpjg,wmjg) 
      end if



c      call hamJgJe(amueg,amuee,QgdQe,cTms,hvE,efgPAS,arrin,Vm)
        call hamJgJe(b_integer,amueg,amuee,QgdQe,cTms,hvE,efgPAS,
     &    jge,arrin,V1m,V2m,jm,hma,je,Ee,Eve,jg,Eg,Evg,
     &    Vje_1_jg,Vje_2_jg,wpje,wmje,wpjg,wmjg,NN,AA,VV,DD)


      call INDEXX(jge,arrin,indx)
c     powder intensities      
      do ii=1,jge
       i=indx(ii)
       hc1=V1m(1,i)*conjg(V1m(1,i))+
     &       V1m(0,i)*conjg(V1m(0,i))+
     &       V1m(-1,i)*conjg(V1m(-1,i))
       rtr(ii)=real(hc1)/3.0
       Eagd(ii)=arrin(i)
       gauss(ii)=w_Gauss(1)
       lorentz(ii)=w_Lorentz(1)
      end do   ! i=1-jge
      if(icase.gt.1) then
       do i=1,lint
        ii=ioffset+i
        gauss(ii)=w_Gauss(i)
        lorentz(ii)=w_Lorentz(i)
       end do
      end if
      if(icase.eq.3) then
       do i=1,lint
        ii=ioffset+i
        rtr(ii)=fr_int(ii)
       end do
      end if

c      write(6,'(a)')'(Eagd(i),i=1,jge)'
c      write(6,'(8f8.4)')(Eagd(i),i=1,jge)
c       write(6,'(a,8i3)')'index=',(indx(i),i=1,jge)

      i1=iput+1
      i2=i1+jge
      array_fr(iput+1)=cmplx(float(jge),0.0)
      do i=1,jge
       array_fr(i1+i)=cmplx(Eagd(i),rtr(i))
       array_fr(i2+i)=cmplx(gauss(1),lorentz(1))
      end do
      if(icase.gt.1)then
       do i=1,lint
        ii=ioffset+i
        array_fr(i2+ii)=cmplx(gauss(i),lorentz(i))
       end do
      end if
      return
      end


