      subroutine th_hdeqf(isubthe,icase,iput,iget,info)
      implicit none
      include 'comglb.for'
      include 'comthe.for'
      include 'comnuc.for'

      integer isubthe,icase,iput,iget,info


c     transmission: fr2 defines external magnetic field, orientation 
c     of the sample by phi,theta,psi is calculated by the routine sample 
c     orientation tansferred by  array_fr to main and than passed to fr2.

      real            acfr2,rep_grp,aset,asymmetry,a_psi,dumcfr2
      common/acfr2trf/acfr2,rep_grp,aset,asymmetry,a_psi,
     &                dumcfr2(icfr2trf-5)
      logical         bcfr2,bumcfr2
      common/bcfr2trf/bcfr2,bumcfr2(icfr2trf-1)
      real            avfr2,dum5,Hext,thetaHe,phiHe,
     &                phi_ls,theta_ls,psi_ls,
     &                d_x2,eta_xx,phi_xx,theta_xx,psi_xx,
     &                t200,t400,dumvfr2
      common/avfr2trf/avfr2,dum5(5),Hext,thetaHe,phiHe,
     &                phi_ls,theta_ls,psi_ls,
     &                d_x2,eta_xx,phi_xx,theta_xx,psi_xx,
     &                t200,t400,dumvfr2(ivfr2trf-19)
c     b_phi is named b_laba (laboratory angles of the sample)
c     b_laba has got the value of b_phi.or.b_theta.or.b_psi 
c     in the routine th_sampleorient
c     b_dum5(5) is reserved place for the parameters thicklay,re_chilay,
c     ai_chilay,roughness,xxx  which are used in scattering theories, 
      logical         b_vfr2,b_dum5,b_Hext,b_thetaHe,b_phiHe,
     &                b_laba,b_thetals,b_psils,b_dx2,b_etaxx,
     &                b_phixx,b_thetaxx,b_psixx,b_t200,b_t400,b_dumvfr2
      common/bvfr2trf/b_vfr2,b_dum5(5),b_Hext,b_thetaHe,b_phiHe,
     &                b_laba,b_thetals,b_psils,b_dx2,b_etaxx,b_phixx,
     &                b_thetaxx,b_psixx,b_t200,b_t400,
     &                b_dumvfr2(ivfr2trf-19)

      real          c1,symcase,timeinvers,cTms,
     &              ajg,aje,amueg,amuee,QgdQe,r_E2M1,e1m1,dumc
      common/acmaps/c1,cTms,ajg,aje,amueg,amuee,QgdQe,r_E2M1,e1m1,
     &              symcase,timeinvers,dumc(icstrf-11)
      logical       b_c1,b_dum
      common/bcmaps/b_c1,b_dum(icstrf-1)
c     arrays derived from constants are calculated only once (transformation 
c     matrices for equivalent orientations, clebsch Gordan coefficients 
c     in the routine  hamJgJe, ...)
  
      real          avss,
     &              dsx2,eta_sx,phi_sx,theta_sx,psi_sx,
     &              aH,thetaH,phiH,DEq,eta,phi_CE,theta_CE,psi_CE,dumvss
      common/avmaps/avss,
     &              dsx2,eta_sx,phi_sx,theta_sx,psi_sx,
     &              aH,thetaH,phiH,DEq,eta,phi_CE,theta_CE,psi_CE,
     &              dumvss(ivstrf-14)
      logical       b_vss,
     &              b_dsx2,b_etasx,b_phisx,b_thetasx,b_psisx,
     &              b_aH,b_thetaH,b_phiH,
     &              b_DEq,b_eta,b_phiE,b_thetaE,b_psiE,b_dumvss
      common/bvmaps/b_vss,
     &              b_dsx2,b_etasx,b_phisx,b_thetasx,b_psisx,
     &              b_aH,b_thetaH,b_phiH,
     &              b_DEq,b_eta,b_phiE,b_thetaE,b_psiE,
     &              b_dumvss(ivstrf-14)

c     logical avssfr,avari,dumvssfr
c     common/avsstrf/avssfr,avari(17),dumvssfr(ivsstrf-18)
c     logical b_vssfr,b_vari,b_dumvssfr
c     common/bvsstrf/b_vssfr,b_vari(17),b_dumvssfr(ivsstrf-18)

      logical b_He,b_Hi,b_Hea,b_Hegt0,b_Higt0,b_Hgt0,
     &        b_eq,b_eqa,b_eqgt0,b_sx2,b_sx2a,b_sx2gt0,
     &        b_x2,b_x2a,b_x2gt0,b_xx,b_hf,b_laba0
      real    eagd_zz(2*maxjge),
     &        dj(-4:4,-4:4),
     &        phiH_r,thetaH_r,phi_r,theta_r,psi_r,phiE_r,thetaE_r,
     &        psiE_r,phiHe_r,thetaHe_r,h1,uveca(3,3),vik(3,3),vdd(3,3)

c     parameter(maxloop=5,..) has also to be changed in sym_equiv(...)
      integer ivv,iec,icl,iecv,id1,id2,istore,maxloop
      parameter(maxloop=11,ivv=90,iec=ivv+25,icl=iec+25,iecv=icl+9,
     &          id1=iecv+9,id2=id1+1+10*maxloop,istore=id2+25*maxloop)

      complex eagdzz(maxjge),
     &        efgPAS(-2:2),efgC(-2:2),efgC0(-2:2),efgL(-2:2),
     &        xxPAS(-2:2),sx2C(-2:2),sx2C0(-2:2),x2C(-2:2),
     &        hv(-1:1),hvL(-1:1),hvC(-1:1),hvC0(-1:1),hve(-1:1),
     &        Dect(-2:2,-2:2),Dsxct(-2:2,-2:2),Dxxct(-2:2,-2:2),
     &        Decv(-1:1,-1:1),Dslt(-2:2,-2:2),Dslv(-1:1,-1:1),
     &        d21(-1:1,-1:1),hc1,ctimeinv(maxloop),
     &        d1(-1:1,-1:1,maxloop),d2(-2:2,-2:2,maxloop),
     &        Dclv(-1:1,-1:1),Dclt(-2:2,-2:2),
     &        Dcpv(-1:1,-1:1),Dcpt(-2:2,-2:2)

      equivalence (eagdzz(1),eagd_zz(1))
      complex store(istore),caseloop
      equivalence (store(1),efgPAS(-2)),(store(6),efgC(-2)),
     &            (store(11),efgL(-2)),(store(16),xxPAS(-2)),
     &            (store(21),sx2C(-2)),(store(26),x2C(-2)),
     &            (store(31),hve(-1)),(store(34),hvC(-1)),
     &            (store(37),hvL(-1)),(store(40),Dect(-2,-2)),
     &            (store(65),Dsxct(-2,-2)),(store(ivv),Dxxct(-2,-2)),
     &            (store(iec),Dslt(-2,-2)),
     &            (store(icl),Decv(-1,-1)),(store(iecv),Dslv(-1,-1)),
     &            (store(id1),caseloop),(store(id1+1),ctimeinv(1)),
     &       (store(id1+1+maxloop),d1(-1,-1,1)),(store(id2),d2(-2,-2,1))

      logical b_integer
      integer i,j,k,l,m,n,ip,ii,iset,isymmetry,n_psi,jpsi,iOM,jOM,
     &        je,jg,jm,NN,ncase,
     &        nloop,nloop_b,nloop_e,jloop,nput,jljpjO,n_all,idumscrd
      real    a_mueg,a_muee,c_Tms,fn,fm,efg0,efg2,
     &        timeinv(maxloop),aszz,azz,texture,cost2,Stexture,
     &        q62,txx,tyy,tzz,txy,txz,tyz,sqrt2,sqrt3d2,pi,rad,
     &        pp,hmm,pp1,hmm1,pp2,hmm2,pp12,hmm12,rEM2,qEM2,
     &        h,hx,hy,hz,thetaOM,phiOM,psiOM,thetaC,phiC,sintC,
     &        gt0p,gt0m,lt0p,lt0m,hitl,hitr,
     &        psiOMa,arcos,eh,mat,dumscrd
      complex pm,pm1,pm2,pm12,x2Clab(-2:2),
     &        gt0o,lt0o
      parameter (idumscrd=maxscrd-6144*3-128*3-9*24)
      common/scrd/phiOM(6144),thetaOM(6144),psiOM(6144),
     &            eh(3,128),mat(3,3,24),dumscrd(idumscrd)      
c                 eh(3,128),mat(3,3,24) is used inside sphere()
c      complex ev(-1:1),evt(-1:1)
      parameter  (sqrt2=1.4142136,sqrt3d2=1.224745,
     &            rad=0.0174533,pi=3.14159) 
c      write(6,'(a)')' th_hdeqf avmaps ::'
c      write(6,'(6f12.3)')avss,
c     &              dsx2,eta_sx,phi_sx,theta_sx,psi_sx,
c     &              aH,thetaH,phiH,DEq,eta,phiE,thetaE,psiE
c      write(6,'(a,10f10.2)') ' acmaps:',c1,symcase,
c     &       timeinvers,cTms,ajg,aje,amueg,amuee


      jge=(2.*ajg+1)*(2.*aje+1)+0.01

      if(acfr2.lt.3.)aset=0.0
c     this way iset,... have not to be defined in frstr_..

      if(isubthe.lt.0) then
       theoryname='H_DEQ_f_equivalent_sites      v=102'
       if(isubthe.eq.-16) return 
c      routines only asking for the name (not values for storage space)
c      put isubthe to -16 (far away from -ntheory)
       ncase=symcase
       call sym_equiv(-ncase,timeinvers,nloop,ctimeinv,d1,d2)
       iset=aset
       if(nloop.eq.-1)nloop=0          ! only 1 rotation
       if(iset.gt.0) then
        isymmetry=asymmetry
        n_psi=a_psi
        call sphere(-iset,isymmetry,.false.,iOM,phiOM,thetaOM,psiOM,
     &                                                 eh,mat)
        if(iOM.eq.0) then
         info=1
         infotext(1)=' '
         infotext(2)(1:17)='*** error ***'
         infotext(3)='meaningless values of constants iset/isymmetry'
         infotext(4)=
     &      'help available: {co a}, {he cn} (n=number of constant)'
         infotext(5)=' '
         return
        end if
        i=1+istore+2+3*jge*(nloop+1)*iOM*(n_psi+1)+(iOM/2)*3
        if(iOM.eq.1)i=i+2
        c1=i
       else
        c1=1+istore+2+3*jge*(nloop+1)+2
       end if
       return
      end if

c      write(6,'(a)')'th_22nuclear avfr2...'
c      write(6,'(8f10.2)')avfr2,dum5(5),Hext,thetaHe,phiHe
c      write(6,'(20L3)')b_vfr2,b_dum5(5),b_Hext,b_thetaHe,b_phiHe
c     &                phi,theta,psi,d_x2,eta_xx,phi_xx,theta_xx,psi_xx,
c     &                axtexture
c      write(6,'(a)')'th_22nuclear avss...'
c      write(6,'(8f10.2)')avss,
c     &              dsx2,eta_sx,phi_sx,theta_sx,psi_sx,
c     &              aH,thetaH,phiH,DEq,eta,phiE,thetaE,psiE
c       write(6,'(20L3)')b_vss,
c     &              b_dsx2,b_etasx,b_phisx,b_thetasx,b_psisx,
c     &              b_aH,b_thetaH,b_phiH,
c     &              b_DEq,b_eta,b_phiE,b_thetaE,b_psiE

c       if(b_vssfr) then
c        write(6,'(2L2,3x,20L3)')b_vssfr,b_vss,b_vari
c        write(6,'(2f10.3,3x,20f10.3)')avssfr,avss,avari
c      write(6,'(8f10.2)')d_x2,eta_xx,phi_xx,theta_xx,psi_xx
c     any parameter changed ?

      if(.not.(b_vss.or.b_vfr2)) then
       isubthe=-abs(isubthe)             ! 24.10.07 theory not changed
c       write(6,'(a)') ' no change'
       return
      end if
c ----------------------------------------------------------------------
      j=iput+1
      nput=j+istore
      do i=1,istore
       store(i)=array_fr(j+i)
      end do
      array_fr(j)=cmplx(float(nput),float(istore))


c    bvfr2trf
c     external magnetic field
      b_Hea=b_thetaHe.or.b_phiHe
      b_He=b_Hext.or.b_Hea
c     orientation of the crystal/sample in the la. system
c     b_laba=b_phils.or.b_thetals.or.b_psils

c     <x2> of the crystal
      b_x2a =b_phixx.or.b_thetaxx.or.b_psixx
      b_x2  =b_dx2.or.b_etaxx.or.b_x2a

c    avmap 
c    <sx2> of the called site of the crystal
      b_sx2a=b_phisx.or.b_thetasx.or.b_psisx
      b_sx2 =b_dsx2.or.b_etasx.or.b_sx2a
c     internal magnetic field at the called site of the crystal
      b_Hi=b_aH.or.b_thetaH.or.b_phiH
c     electric field gradient at the called site of the crystal
      b_eqa=b_phiE.or.b_thetaE.or.b_psiE
      b_eq=b_DEq.or.b_eta.or.b_eqa
 
c     hyperfine parameter (He depends on angles phi,theta,psi)
      b_hf=b_He.or.b_Hi.or.b_eq.or.b_laba
c     <x2>+<sx2> (<x2> depends on angles phi,theta,psi)
      b_xx  =b_dsx2.or.b_sx2.or.b_dx2.or.b_x2.or.b_laba

      ii=jge/2
      if(2*ii.eq.jge) then
       b_integer=.false.
       je=2*aje+0.01
       jg=2*ajg+0.01
       jm=je
       if(jg.gt.jm)jm=jg
       NN=jm+1
      else
       b_integer=.true.
       je=aje+0.01
       jg=ajg+0.01
       jm=je
       if(jg.gt.jm)jm=jg
       NN=2*jm+1
      end if
      if(abs(jg-jg_a)+abs(je-je_a).gt.0)then      
       jg_a=jg
       je_a=je
       call symbol3j(b_integer,je,jg,Vje_1_jg,Vje_2_jg,
     &                          wpje,wmje,wpjg,wmjg) 
      end if

      a_mueg=amueg
      a_muee=amuee
      c_Tms=cTms
      rEM2=r_E2M1**2
      qEM2=1./(1.+rEM2)

      n_psi=a_psi
      iset=aset     
      ncase=symcase
      isymmetry=asymmetry

      nloop_b=0
      if(b_c1) then
       call sym_equiv(ncase,timeinvers,nloop,ctimeinv,d1,d2)
       nloop_e=nloop
       if(nloop.eq.-1)then
        nloop_b=1
        nloop_e=1
       end if 
      else
       nloop=real(caseloop)
c      write(6,'(a,i6)')'th_22nuclear nloop=',nloop
       nloop_e=nloop
       if(nloop.eq.-1)then
        nloop_b=1
        nloop_e=1
       end if 
      end if
      do k=1,nloop_e
       timeinv(k)=real(ctimeinv(k))
      end do

      if(bcfr2) then
       call sphere(iset,isymmetry,.false.,iOM,phiOM,thetaOM,psiOM,
     &                                                 eh,mat)
       caseloop=cmplx(float(nloop),float(iOM))
       if(nloop.eq.-1)then
        n_all=(n_psi+1)*iOM
       else       
        n_all=(n_psi+1)*iOM*(nloop+1)
       end if
       j=(nput+2+3*jge*n_all)*2
       do i=1,iOM
        k=(i-1)*3+j
        real_fr(k+1)=phiOM(i)
        real_fr(k+2)=thetaOM(i)
        real_fr(k+3)=psiOM(i)
       end do
      else 
       iOM=aimag(caseloop)
       if(nloop.eq.-1)then
        n_all=(n_psi+1)*iOM
       else       
        n_all=(n_psi+1)*iOM*(nloop+1)
       end if
       j=(nput+2+3*jge*n_all)*2
       do i=1,iOM
        k=(i-1)*3+j
        phiOM(i)=real_fr(k+1)
        thetaOM(i)=real_fr(k+2)
        psiOM(i)=real_fr(k+3)
       end do
      end if
      caseloop=cmplx(float(nloop),float(iOM))
     

c     <sx2> tensor
      b_sx2gt0=abs(dsx2).gt.0.
      if(b_sx2) then
       if(b_sx2a)then
c       The Euler angles rotate the crystal system S_C to the PAS S_sx2
c       of <sx2> tensor.The Euler angles are obtained with the 
c       program called by  {eu} [1 Euler angles from unit vectors]
c       ->[unit vectors eb(n) in system Sa].
c       Input are the unit vectors eb(x,y,z)=e_sx2 of S_sx2 with respect
c       to the crystal system S_C.
c       The transformation Dsxct(-gamma,-theta,-alpha) transforms 
c       the tensor components to the crystal system.
c       Symbolic:  e_sx2 in S_C  -> t_C=t_sx2*d^(-1)
        call dewigner(2,-theta_sx*rad,dj)
        do m=-2,2
        do n=-2,2
         fm=-float(n)*phi_sx*rad
         fn=-float(m)*psi_sx*rad
         Dsxct(m,n)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n)
        end do
        end do
       end if
      
c      xxPAS (-2..2) are the spherical tensor components of <sx2> in the 
c      S_sx2 system. The tensor is attached to site 1 (of nloop+1 
c      equivalent sites) of the crystal.
       xxPAS(0)=cmplx(sqrt3d2,0.0)
       xxPAS(-1)=(0.,0.)
       xxPAS(1)=(0.,0.)
       xxPAS(-2)=cmplx(eta_sx/2.,0.)
       xxPAS(2)=cmplx(eta_sx/2.,0.)

       do n=-2,2
        hc1=(0.,0.)
        do m=-2,2
         hc1=hc1+xxPAS(m)*Dsxct(m,n)
        end do
        sx2C(n)=hc1
       end do
c      sc2C(n) are the components of the tensor in the crystal system. 
c      Taking these components (the Cathesian one) to the program called 
c      by  {eu} [9 Euler angles of PAS of 2. rank tensor]
c      the PAS-values and Euler angles are obtained back.
      end if  ! b_sx2

c     <x2> tensor
c     see comment on the <sx2> tensor
      b_x2gt0=abs(d_x2).gt.0.
      if(b_x2) then
       if(b_x2a)then
        call dewigner(2,-theta_xx*rad,dj)
        do m=-2,2
        do n=-2,2
         fm=-float(n)*phi_xx*rad
         fn=-float(m)*psi_xx*rad
         Dxxct(m,n)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n)
        end do
        end do
       end if
       xxPAS(0)=cmplx(sqrt3d2,0.0)
       xxPAS(-1)=(0.,0.)
       xxPAS(1)=(0.,0.)
       xxPAS(-2)=cmplx(eta_xx/2.,0.)
       xxPAS(2)=cmplx(eta_xx/2.,0.)
      
       do n=-2,2
        hc1=(0.,0.)
        do m=-2,2
         hc1=hc1+xxPAS(m)*Dxxct(m,n)
        end do
        x2C(n)=hc1
       end do
      end if   ! b_x2

c     Transformation of the tensors sx2,x2 tensor given in the crystal
c     system  to the lab-system.
c     The gamma-direction is parallel to +z of the lab-system.
c     The orientation of the crystal in the laboratory is decribed by 
c     the Euler angles (phi,theta,psi). e_z(S_C) in the la. system S_L
c     determines phi,theta, which are the polar angle of e_z(S_C).
c     The Euler angles are obtained with the 
c     program euler in the directory effi/helproutines/euler:
c      [1 Euler angles from unit vectors]->[unit vectors eb(n) in system Sa].
c     Input are the unit vectors e_C=eb(x,y,z) of the crystal system S_C
c      with respect to the lab. system S_L.
c     The tensor components known in the system S_C are tranformed to the
c     Lab. system by the invers transformation Dsl(-psi,-theta,-phi).
c     Symbolic:  e_C in S_L  -> t_L=t_C*dlc^(-1) 
c     (see comment for sx2 above)
      b_laba0=abs(phi_ls)+abs(theta_ls)+abs(psi_ls).lt.0.001
      if(b_laba)then
c      write(6,'(a,3f10.2)')' phi,theta,psi_ls=',phi_ls,theta_ls,psi_ls

       phi_r=phi_ls*rad
       theta_r=theta_ls*rad
       psi_r=psi_ls*rad
c      1. rank tensor transformation matrix: crystal/sample to Lab
       call dewigner(1,-theta_r,dj)
       do m=-1,1
       do n=-1,1
        fm=-float(n)*phi_r
        fn=-float(m)*psi_r
        Dslv(m,n)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n)  
       end do
       end do
c      2. rank tensor transformation matrix: crstal/sample to Lab
       call dewigner(2,-theta_r,dj)
       do m=-2,2
       do n=-2,2
        fm=-float(n)*phi_r
        fn=-float(m)*psi_r
        Dslt(m,n)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n)  
       end do
       end do
      end if  ! b_laba (lab angle)
   
c     write(6,'(10f8.4)')Dslt
c     electric field gradient tensor  transformed to the crystal system
c     (see comment for sx2 above)
      phiE_r  =phi_CE*rad
      thetaE_r=theta_CE*rad
      psiE_r  =psi_CE*rad

      b_eqgt0=abs(DEq).gt.0.      
      if(b_eq)then
       if(b_eqa)then
        call dewigner(2,-thetaE_r,dj)
        do m=-2,2
        do n=-2,2
         fm=-float(n)*phiE_r
         fn=-float(m)*psiE_r
         Dect(m,n)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n)
        end do
        end do
       end if
c      efg (-2..2) are the spherical tensor components of the EFG in the PAS
       efg0=1.0/sqrt(1.+eta**2/3.)
       efg2=eta*efg0/sqrt(6.)
             
       efgPAS(0)=cmplx(efg0,0.0)
       efgPAS(-1)=(0.,0.)
       efgPAS(1)=(0.,0.)
       efgPAS(-2)=cmplx(efg2,0.)
       efgPAS(2)=cmplx(efg2,0.)
             
       do n=-2,2
        hc1=(0.,0.)
        do m=-2,2
         hc1=hc1+efgPAS(m)*Dect(m,n)
        end do
        efgC(n)=hc1
       end do
      end if  ! b_eq

c-----enable write-----EFG (site 1) in the crystal system --------------
        if(enwr(6)(1:2).eq.'t1') then
         q62=sqrt(6.0)/2.0
        if(enwr(6)(3:4).eq.'x2') then
         h=d_x2/2./sqrt3d2
         txx=real(-x2C(0)+q62*(x2C(2)+x2C(-2)))*h
         tyy=real(-x2C(0)-q62*(x2C(2)+x2C(-2)))*h
         tzz=2*real(x2C(0))*h
         txy=-real(q62*(x2C(2)-x2C(-2))*cmplx(0.,1.))*h
         txz=-real(q62*(x2C(1)-x2C(-1)))*h
         tyz=real(q62*(x2C(1)+x2C(-1))*cmplx(0.,1.))*h
         write(nwr,'(2x,a,2(f7.3,1x),f7.3,a1)')
     &    '            x ( ',txx,txy,txz,')'
         write(nwr,'(2x,a,8x,f7.3,1x,f7.3,a1)')
     &    '<i|T_C|k> = y ( ',tyy,tyz,')'
         write(nwr,'(2x,a,16x,f7.3,a1)')
     &    '            z ( ',tzz,')'

        else if(enwr(6)(3:4).eq.'sx') then
         h=dsx2/2./sqrt3d2
         txx=real(-sx2C(0)+q62*(sx2C(2)+sx2C(-2)))*h
         tyy=real(-sx2C(0)-q62*(sx2C(2)+sx2C(-2)))*h
         tzz=2*real(sx2C(0))*h
         txy=-real(q62*(sx2C(2)-sx2C(-2))*cmplx(0.,1.))*h
         txz=-real(q62*(sx2C(1)-sx2C(-1)))*h
         tyz=real(q62*(sx2C(1)+sx2C(-1))*cmplx(0.,1.))*h
         write(nwr,'(a,/)') '-- local <sx> in the S_C -- site 1'
         write(nwr,'(2x,a,2(f7.3,1x),f7.3,a1)')
     &    '            x ( ',txx,txy,txz,')'
         write(nwr,'(2x,a,8x,f7.3,1x,f7.3,a1)')
     &    '<i|T_C|k> = y ( ',tyy,tyz,')'
         write(nwr,'(2x,a,16x,f7.3,a1)')
     &    '            z ( ',tzz,')'
        else if(enwr(6)(3:4).eq.'ef') then
         txx=real(-efgC(0)+q62*(efgC(2)+efgC(-2)))
         tyy=real(-efgC(0)-q62*(efgC(2)+efgC(-2)))
         tzz=2*real(efgC(0))
         txy=-real(q62*(efgC(2)-efgC(-2))*cmplx(0.,1.))
         txz=-real(q62*(efgC(1)-efgC(-1)))
         tyz=real(q62*(efgC(1)+efgC(-1))*cmplx(0.,1.))
         write(nwr,'(a,/)') '-- EFG in the crystal system -- site 1'

        call dewigner(1,thetaE_r,dj)
         do m=-1,1
          do n=-1,1
           fm=float(m)*phiE_r
           fn=float(n)*psiE_r
           d21(m,n)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n)        
          end do
         end do

         uveca(1,1)=0.5*real(d21(1,1)-d21(-1,1)-d21(1,-1)+d21(-1,-1))
         uveca(1,2)=-0.5*aimag(d21(1,1)+d21(-1,1)-d21(1,-1)-d21(-1,-1))
         uveca(1,3)=-1./sqrt2*real(d21(0,1)-d21(0,-1))
    
         uveca(2,1)=0.5*aimag(d21(1,1)-d21(-1,1)+d21(1,-1)-d21(-1,-1))
         uveca(2,2)=0.5*real(d21(1,1)+d21(-1,1)+d21(1,-1)+d21(-1,-1))
         uveca(2,3)=-1./sqrt2*aimag(d21(0,1)+d21(0,-1))
    
         uveca(3,1)=-1./sqrt2*real(d21(1,0)-d21(-1,0))
         uveca(3,2)=1./sqrt2*aimag(d21(1,0)+d21(-1,0))
         uveca(3,3)=real(d21(0,0))
  

         vik(1,1)=txx
         vik(1,2)=txy
         vik(1,3)=txz
         vik(2,1)=txy
         vik(2,2)=tyy
         vik(2,3)=tyz
         vik(3,1)=txz
         vik(3,2)=tyz
         vik(3,3)=tzz
         
         do i=1,3
         do l=1,3
          h1=0.0
          do j=1,3
          do k=1,3
           h1=h1+uveca(i,k)*vik(k,j)*uveca(l,j)
          end do
          end do
          vdd(i,l)=h1
         end do
         end do
         write(nwr,'(10x,a,3(f7.3,a1))')
     &    '      ( ',vdd(1,1),',',vdd(1,2),',',vdd(1,3),')'
         write(nwr,'(a10,a,3(f7.3,a1))')'          ',
     &    'tik = ( ',vdd(2,1),',',vdd(2,2),',',vdd(2,3),')'
         write(nwr,'(10x,a,3(f7.3,a1),/)')
     &    '      ( ',vdd(3,1),',',vdd(3,2),',',vdd(3,3),')'

c         write(nwr,'(2(6x,a,3(f8.3,a1)))')
c     &    'eQx=(',uveca(1,1),',',uveca(1,2),',',uveca(1,3),')'
c         write(nwr,'(2(6x,a,3(f8.3,a1)))')
c     &    'eQy=(',uveca(2,1),',',uveca(2,2),',',uveca(2,3),')'
c         write(nwr,'(2(6x,a,3(f8.3,a1)))')
c     &    'eQz=(',uveca(3,1),',',uveca(3,2),',',uveca(3,3),')'

         write(nwr,'(2x,a,2(f7.3,1x),f7.3,a1,2(4x,a,3(f7.3,a1)))')
     &    '            x ( ',txx,txy,txz,')',
     &    ' u = x (',uveca(1,1),',',uveca(1,2),',',uveca(1,3),')' 

         write(nwr,'(2x,a,8x,f7.3,1x,f7.3,a1,2(4x,a,3(f7.3,a1)))')
     &    '<i|T_C|k> = y ( ',tyy,tyz,')',
     &    '   = y (',uveca(2,1),',',uveca(2,2),',',uveca(2,3),')'
         write(nwr,'(2x,a,16x,f7.3,a1,2(4x,a,3(f7.3,a1)))')
     &    '            z ( ',tzz,')',
     &    '   = z (',uveca(3,1),',',uveca(3,2),',',uveca(3,3),')'
        end if

        end if
c------end enable write---------------------------------------------

c     magnetic field 
      b_Hegt0=abs(Hext).gt.0.0
      b_Higt0=abs(aH).gt.0.0
      b_Hgt0=b_Higt0.or.b_Hegt0
      if(b_Hi) then
       phiH_r=phiH*rad
       thetaH_r=thetaH*rad
       hv(1) =-cmplx(cos(phiH_r),sin(phiH_r))*
     &                 sin(thetaH_r)/sqrt2
       hv(0) = cmplx(cos(thetaH_r),0.0)
       hv(-1)=-conjg(hv(1))
c      write(6,'(a,f10.1,a2,6f10.4)') 'hv  = ',aH,'*(',hv

       if(icase.eq.1) then
c       internal field with respect to the EFG system   
c       transformation of the magnetic field H from the  S_E to the 
c       crystal system S_C. hvC(n) in the crystal system  S_C. 
        if(b_eqa)then
         call dewigner(1,-thetaE_r,dj)
         do m=-1,1
         do n=-1,1
          fm=-float(n)*phiE_r
          fn=-float(m)*psiE_r
          Decv(m,n)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n)
         end do
         end do
        end if
        do n=-1,1
         hc1=(0.,0.)
         do m=-1,1
          hc1=hc1+hv(m)*Decv(m,n)
         end do
         hvC(n)=hc1
        end do
c        write(6,'(a,8f12.4)') 'hv    =',(hvC(i),i=-1,1)
       else
c       magnetic field given in the crystal system Sc
        do i=-1,1
         hvC(i)= hv(i)
        end do
       end if ! case 1
      end if  ! b_Hi

c-----enable write---H-field in the crystal system -----------------
       if(enwr(6).eq.'hfs1') then
        hx=-real(hvC(1)-hvC(-1))/sqrt2
        hy= real((hvC(1)+hvC(-1))*cmplx(0.,1.))/sqrt2
        hz= real(hvC(0))
        write(nwr,'(/,a,3f8.3,a1)')'        h_C =   (', hx,hy,hz,')'
       end if
c--------------------------------------------------------------------

c      external field defined in the LAB system S_L
       if(b_Hea)then         
        phiHe_r=phiHe*rad
        thetaHe_r=thetaHe*rad
        hve(1) =-cmplx(cos(phiHe_r),sin(phiHe_r))*
     &                  sin(thetaHe_r)/sqrt2
        hve(0) = cmplx(cos(thetaHe_r),0.0)
        hve(-1)=-conjg(hve(1))
       end if
       
c      storing the tensors of the 1. site if there are nloop+1 
c      equivalent sites (nloop >0) 
        do m=-2,2
         efgC0(m)=efgC(m)
        end do
        do m=-2,2
         sx2C0(m)=sx2C(m)
        end do
        do i=-1,1
         hvC0(i)=hvC(i)
        end do

c      ----------------------------------------------------
c       thetaOM(1)=54.7*rad
c       phiOM(1)=pi/4.
c       thetaOM(1)=0.
c      Omega loop in case of an average over different crystal
c      orientations: powder, texture 
c      ----------------------- loops-----------------------       
      psiOMa=2.*pi/(n_psi+1)
      jljpjO=0
      Stexture=0.0
      do jOM=1,iOM
       cost2=cos(thetaOM(jOM))**2
       texture=(1.+t200*(3.0*cost2-1.)/2.
     &           +t400*((35*cost2-30)*cost2+3.)/8.)/float(n_all)
c      loop over equivalent sites. In the routine sym_equiv(...,d1,d2)
c      the transformations d1 and d2 and timeinv() are defined 
       hitl=0.
       hitr=0.
       lt0p=0.
       do jloop=nloop_b,nloop_e

        if(jloop.gt.0) then
         if(b_Higt0) then
          do n=-1,1
           hc1=(0.,0.)
           do m=-1,1
            hc1=hc1+hvC0(m)*d1(m,n,jloop)
           end do
           hvC(n)=hc1*timeinv(jloop)
          end do
         end if
       
         if(b_eqgt0)then         
          do n=-2,2
           hc1=(0.,0.)
           do m=-2,2
            hc1=hc1+efgC0(m)*d2(m,n,jloop)
           end do
           efgC(n)=hc1
          end do
          
         end if
         if(b_sx2gt0)then         
          do n=-2,2
           hc1=(0.,0.)
           do m=-2,2
            hc1=hc1+sx2C0(m)*d2(m,n,jloop)
           end do
           sx2C(n)=hc1
          end do
         end if
        else
         do m=-2,2
          efgC(m)=efgC0(m)
         end do
         do m=-2,2
          sx2C(m)=sx2C0(m)
         end do
         do i=-1,1
          hvC(i)=hvC0(i)
         end do
        end if  ! jloop > 0

c------enable write--- of EFG_C ------------------------------------
        if(enwr(6)(1:2).eq.'ti') then
        q62=sqrt3d2
        if(enwr(6)(3:4).eq.'x2') then
         txx=real(-x2C(0)+q62*(x2C(2)+x2C(-2)))*d_x2
         tyy=real(-x2C(0)-q62*(x2C(2)+x2C(-2)))*d_x2
         tzz=2*real(x2C(0))*d_x2
         txy=-real(q62*(x2C(2)-x2C(-2))*cmplx(0.,1.))*d_x2
         txz=-real(q62*(x2C(1)-x2C(-1)))*d_x2
         tyz=real(q62*(x2C(1)+x2C(-1))*cmplx(0.,1.))*d_x2
         write(nwr,'(/,a,i2,/)') '--- equivalent <xx> ---- site',jloop+1
        else if(enwr(6)(3:4).eq.'sx') then
         txx=real(-sx2C(0)+q62*(sx2C(2)+sx2C(-2)))*dsx2
         tyy=real(-sx2C(0)-q62*(sx2C(2)+sx2C(-2)))*dsx2
         tzz=2*real(sx2C(0))*dsx2
         txy=-real(q62*(sx2C(2)-sx2C(-2))*cmplx(0.,1.))*dsx2
         txz=-real(q62*(sx2C(1)-sx2C(-1)))*dsx2
         tyz=real(q62*(sx2C(1)+sx2C(-1))*cmplx(0.,1.))*dsx2
         write(nwr,'(/,a,i2,/)') '--- equivalent <sx> ---- site',jloop+1
        else if(enwr(6)(3:4).eq.'ef') then
         txx=real(-efgC(0)+q62*(efgC(2)+efgC(-2)))
         tyy=real(-efgC(0)-q62*(efgC(2)+efgC(-2)))
         tzz=2*real(efgC(0))
         txy=-real(q62*(efgC(2)-efgC(-2))*cmplx(0.,1.))
         txz=-real(q62*(efgC(1)-efgC(-1)))
         tyz=real(q62*(efgC(1)+efgC(-1))*cmplx(0.,1.))
         write(nwr,'(/,a,i2,/)') '--- equivalent EFGs ---- site',jloop+1
        end if

        write(nwr,'(2x,a,2(f7.3,1x),f7.3,a1,2(4x,a,3(f7.3,a1)))')
     &  '            x ( ',txx,txy,txz,')',
     &  '   = x (',uveca(1,1),',',uveca(1,2),',',uveca(1,3),')' 
        write(nwr,'(2x,a,8x,f7.3,1x,f7.3,a1,2(4x,a,3(f7.3,a1)))')
     &  '<i|t_c|k> = y ( ',tyy,tyz,')',
     &  't  = y (',uveca(2,1),',',uveca(2,2),',',uveca(2,3),')'
        write(nwr,'(2x,a,16x,f7.3,a1,2(4x,a,3(f7.3,a1)))')
     &  '            z ( ',tzz,')',
     &  '   = z (',uveca(3,1),',',uveca(3,2),',',uveca(3,3),')'

        end if
c-------enable write------H-field in the crystal system --------------
        if(enwr(6).eq.'hfsi') then
         hx=-real(hvC(1)-hvC(-1))/sqrt2
         hy= real((hvC(1)+hvC(-1))*cmplx(0.,1.))/sqrt2
         hz= real(hvC(0))
         thetaC=arcos(hz)
         sintC=sin(thetaC)
         if(sintC.lt.0.001) then
          phiC=0.0
         else
          phic=arcos(hx/sintC)
          if(hy.lt.0.)phiC=2.*pi-phiC
         end if

         write(nwr,'(/,a,i2,a,3f8.3,a4,2f8.3,a1)')' site',jloop+1,
     &       ' ------  h_C = (',hx,hy,hz,'):=(',thetaC/rad,phiC/rad,')'
        end if
c---------------------------------------------------------------------

       do jpsi=0,n_psi
c       averaging over psiOM with n_psi+1 steps
        jljpjO=jljpjO+1
        Stexture= Stexture+ texture

        if(b_Hgt0) then
c        The grid point p(thetaOM,phiOM) defines z-axis of the system 
c        S_S of the sample. (If the sample is not rotated S_S coincides 
c        with the lab. system S_L, and the z_axis is the direction of 
c        observation).
c        The rotation around the z-axis starts with angle psiOM 
c        and has n_psi steps for averaging. The components in the 
C        S_OM system are 
c        Symbolic:  e_OM in S_C  -> t_C*dcs=t_OM   (t_S=t_OM)
c        If the sample system S_S  is rotated with respect to the Lab. system
c        -Dsl (=djsl)- the tensor components are
c        transformations are:
c         Symbolic:  e_S in S_L  -> t_L=t_S*dls^(-1) 
c                                   t_L= t_C*dcs*dls^(-1) 

c           write(6,'(i3,a,3f10.3,3x,3f9.3)')jOM,' phi,theta,psi=',
c     &                phiOM(jOM),thetaOM(jOM),psiOM(jOM)
         call dewigner(1,thetaOM(jOM),dj)
         do m=-1,1
         do n=-1,1
          fm=float(m)*phiOM(jOM)
          fn=float(n)*(psiOM(jOM)+jpsi*psiOMa)
          Dcpv(m,n)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n) 
         end do
         end do

         if(b_laba0)then
c         1. rank tensor transformation
          do m=-1,1
           do n=-1,1
            Dclv(m,n)=Dcpv(m,n)
           end do
          end do 
         else
          do m=-1,1
          do n=-1,1
           hc1=(0.,0.)
           do l=-1,1
           hc1=hc1+Dcpv(m,l)*Dslv(l,n)
           end do       
           Dclv(m,n)=hc1
          end do
          end do 
         end if

         do n=-1,1
          hc1=(0.,0.)
          do m=-1,1
           hc1=hc1+hvC(m)*Dclv(m,n)
          end do
          hvL(n)=hc1*aH+hve(n)*Hext
         end do
        else
         hc1=(0.,0.)
         do m=-1,1
          hvL(m)=hc1
         end do
        end if        ! b_Hgt0

        call dewigner(2,thetaOM(jOM),dj)
        do m=-2,2
        do n=-2,2
          fm=float(m)*phiOM(jOM)
          fn=float(n)*(psiOM(jOM)+jpsi*psiOMa)
         Dcpt(m,n)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n) 
        end do
        end do

        if(b_laba0)then
c        2. rank tensor transformation
         do m=-2,2
          do n=-2,2
           Dclt(m,n)=Dcpt(m,n)
          end do
         end do       
        else
         do m=-2,2
         do n=-2,2
          hc1=(0.,0.)
          do l=-2,2
            hc1=hc1+Dcpt(m,l)*Dslt(l,n)
          end do       
          Dclt(m,n)=hc1
         end do
         end do       
        end if

        if(b_eqgt0)then 
         do n=-2,2
          hc1=(0.,0.)
          do m=-2,2
           hc1=hc1+efgC(m)*Dclt(m,n)
          end do
          efgL(n)=hc1*DEq
         end do
        else
         hc1=(0.,0.)
         do m=-2,2
          efgL(m)=hc1
         end do
        end if   ! b_eqgt0

        if(b_sx2gt0)then         
         hc1=(0.,0.)
         do m=-2,2
          hc1=hc1+sx2C(m)*Dclt(m,0)
         end do
         aszz=real(hc1)/sqrt3d2
        else
         aszz=0.
        end if   ! b_sx2gt0

        if(b_x2gt0)then  
         do n=-2,2
          hc1=(0.,0.)
          do m=-2,2
           hc1=hc1+x2C(m)*Dclt(m,n)
          end do
          x2Clab(n)=hc1
         end do
         azz=real(x2Clab(0))/sqrt3d2
         h=d_x2/2./sqrt3d2
c         q62=sqrt3d2
c         txx=real(-x2Clab(0)+q62*(x2Clab(2)+x2Clab(-2)))*h
c         tyy=real(-x2Clab(0)-q62*(x2Clab(2)+x2Clab(-2)))*h
c         tzz=2*real(x2Clab(0))*h
c         txy=-real(q62*(x2Clab(2)-x2Clab(-2))*cmplx(0.,1.))*h
c         txz=-real(q62*(x2Clab(1)-x2Clab(-1)))*h
c         tyz=real(q62*(x2Clab(1)+x2Clab(-1))*cmplx(0.,1.))*h
c         write(nwr,'(2x,a,6f8.3,a1,3f10.3)')  
c     &   ' (',txx,tyy,tzz,txy,txz,tyz,')'
        else
         azz=0.
        end if   ! b_x2gt0

c-------enable write-------- EFG in the Lab system -------------------
        if(enwr(6).eq.'eflb') then
         q62=sqrt3d2
         txx=real(-efgL(0)+q62*(efgL(2)+efgL(-2)))
         tyy=real(-efgL(0)-q62*(efgL(2)+efgL(-2)))
         tzz=2*real(efgL(0))
         txy=-real(q62*(efgL(2)-efgL(-2))*cmplx(0.,1.))
         txz=-real(q62*(efgL(1)-efgL(-1)))
         tyz=real(q62*(efgL(1)+efgL(-1))*cmplx(0.,1.))

         write(nwr,'(2x,a,6f8.3,a1,3f10.3)')  
     &   ' (',txx,tyy,tzz,txy,txz,tyz,')'
c     &   sin(thetaOM(jOM))*cos(phiOM(jOM)),
c     &   sin(thetaOM(jOM))*sin(phiOM(jOM)),cos(thetaOM(jOM))
c         write(nwr,'(a)')
c         write(nwr,'(2x,a,3f8.3,a1)')  '            x (',txx,txy,txz,')'
c         write(nwr,'(2x,a,8x,2f8.3,a1)')'<i|V_L|k> = y (',tyy,tyz,')'
c         write(nwr,'(2x,a,16x,f8.3,a1)')'            z (',tzz,')'
        end if
c-------enable write---H-field in the Lab system ---------------------
        if(enwr(6).eq.'hflb') then
         hx=-real(hvL(1)-hvL(-1))/sqrt2
         hy= real((hvL(1)+hvL(-1))*cmplx(0.,1.))/sqrt2
         hz= real(hvL(0))
         write(nwr,'(a,i2,a,3f8.3,a1)')' site',jloop+1,
     &       ' ------  h_L = (',hx,hy,hz,')'
        end if
c--------------------------------------------------------------------
        call hamJgJe(b_integer,amueg,amuee,QgdQe,cTms,hvL,efgL,
     &    jge,Eagd,V1m,V2m,jm,hma,je,Ee,Eve,jg,Eg,Evg,
     &    Vje_1_jg,Vje_2_jg,wpje,wmje,wpjg,wmjg,NN,AA,VV,DD)

        eagd_zz(2)=aszz
        eagd_zz(4)=dsx2
        eagd_zz(6)=azz
        eagd_zz(8)=d_x2 
        eagd_zz(10)=aszz*dsx2+azz*d_x2
c        write(6,'(a,f12.4)')'aszz*dsx2+azz*d_x2=',aszz*dsx2+azz*d_x2
        do i=1,jge
         eagd_zz(2*i-1)=Eagd(i)
        end do
c       write(6,'(10f10.3)') (eagdzz(j),j=1,10)   ! trick with equivalence

        ip=nput+2+3*jge*(jljpjO-1)

        if(r_E2M1.eq.0.)then
         gt0p=0
         gt0m=0
         gt0o=(0.,0.)
c         lt0p=0
         lt0m=0
         lt0o=(0.,0.)
         do i=1,jge
          pp =real(conjg(V1m(1,i))*V1m(1,i))
          hmm=real(conjg(V1m(-1,i))*V1m(-1,i))
          if(Eagd(i).gt.0) then
           gt0p=gt0p+pp                       
           gt0m=gt0m+hmm                      
           gt0o=gt0o+conjg(V1m(1,i))*V1m(-1,i)
          else
           lt0p=lt0p+pp                       
           lt0m=lt0m+hmm                      
           lt0o=lt0o+conjg(V1m(1,i))*V1m(-1,i)
          end if

          ii=ip+3*(i-1)
          array_fr(ii+1)=eagdzz(i)
          array_fr(ii+2)=cmplx(pp-hmm,pp+hmm)/2.0*texture
          array_fr(ii+3)=conjg(V1m(1,i))*V1m(-1,i)*texture
         end do
c         if(jloop.eq.1)
c     &     write(6,'(i3,3f10.4,3x,3f10.4)')jloop+1,
c     &        aszz,azz,exp(-(aszz*dsx2+azz*d_x2)),lt0p,lt0o/2.
          hitl=hitl+exp(-(aszz*dsx2+azz*d_x2))*lt0p
          hitr=hitr+exp(-(aszz*dsx2+azz*d_x2))*(1.-lt0p)
        else 
         if(abs(r_E2M1).lt.9999.)then
c         mixed M1/E2 transition
          do i=1,jge
            pp1 =real(conjg(V1m(1,i))*V1m(1,i))
           hmm1=real(conjg(V1m(-1,i))*V1m(-1,i))
            pm1=conjg(V1m(1,i))*V1m(-1,i)
  
            pp2=real(conjg(V2m(1,i))*V2m(1,i))
           hmm2=real(conjg(V2m(-1,i))*V2m(-1,i))
            pm2=conjg(V2m(1,i))*V2m(-1,i)
  
            pp12= 2.*real(conjg(V2m(1,i))*V1m(1,i))
           hmm12=-2.*real(conjg(V2m(-1,i))*V1m(-1,i))
            pm12= conjg(V2m(1,i))*V1m(-1,i)-conjg(V1m(1,i))*V2m(-1,i)
  
             pp=(pp1 +rEM2*pp2  -r_E2M1*pp12)*qEM2
            hmm=(hmm1+rEM2*hmm2-r_E2M1*hmm12)*qEM2
             pm=(pm1 -rEM2*pm2  -r_E2M1*pm12)*qEM2

c           write(6,'(8f10.3)')eagdzz(i),pp,hmm,pm

           ii=ip+3*(i-1)
           array_fr(ii+1)=eagdzz(i)
           array_fr(ii+2)=cmplx(pp-hmm,pp+hmm)/2.0*texture
           array_fr(ii+3)=pm*texture
          end do
c           write(6,'(a)')
         else
c         E2 transition
          do i=1,jge
           pp =real(conjg(V2m(1,i))*V2m(1,i))
           hmm=real(conjg(V2m(-1,i))*V2m(-1,i))
           ii=ip+3*(i-1)
           array_fr(ii+1)=eagdzz(i)
           array_fr(ii+2)=cmplx(pp-hmm,pp+hmm)/2.0*texture
           array_fr(ii+3)=-conjg(V2m(1,i))*V2m(-1,i)*texture
          end do
         end if         
        end if 

       end do    ! n_psi   
       end do    ! nloop
c          write(6,'(3f10.4)')hitl,hitr
      end do    ! iOM
      if(enwr(7).eq.'tetu')write(nwr,'(a,f10.3)')'Sum texture=',Stexture
c     array_fr(nput+i):
c     (nput+1)=(n_all,jge)    (nput+2) = (b_xx,0)
c     (nput+3)=(Eagd(1),aszz) (nput+4) = (pp-hmm,hr+hmm)/2   (nput+5) =pm
c     (nput+6)=(Eagd(2),dsx2) (nput+7) = (pp-hmm,hr+hmm)/2   (nput+8) =pm
c     (nput+9)=(Eagd(3),dsx2) (nput+10)= (pp-hmm,hr+hmm)/2   (nput+11)=pm
c
c      ................................................................
c
c     (nput+j1)=(Eagd(2),dsx2) (nput+j2)= (pp-hmm,hr+hmm)/2   (nput+j3)=pm
c      j=2+3*(jge-1) j1=j+1,...,j3=j+3
c
c     for the case: b_xx=.false. the f-factor fd=exp(-azz*d_x2-aszz*dsx2) 
c     itself is stored  

      array_fr(nput+1)=cmplx(float(n_all),float(jge))
      if(b_xx) then
       array_fr(nput+2)=cmplx(1.0,0.)
      else
       array_fr(nput+2)=cmplx(0.,0.)
      end if
c     aimag of array_fr(nput+2) for further use


      if(nloop_e.gt.0) then
c      to be stored in array store() => array_fr()
       do m=-2,2
        efgC(m)=efgC0(m)
       end do
       do m=-2,2
        sx2C(m)=sx2C0(m)
       end do
       do i=-1,1
        hvC(i)=hvC0(i)
       end do
      end if
      j=iput+1
      do i=1,istore
       array_fr(j+i)=store(i)
      end do

      return
      end




      subroutine th_hdeq(isubthe,icase,iput,iget,info)
      implicit none

      include 'comglb.for'
      include 'comthe.for'
      include 'comnuc.for'

      integer         isubthe,icase,iput,iget,info

      real            acfr2,rep_grp,aset,asymmetry,dumcfr2
      common/acfr2trf/acfr2,rep_grp,aset,asymmetry,dumcfr2(icfr2trf-4)
      logical         bcfr2,bumcfr2
      common/bcfr2trf/bcfr2,bumcfr2(icfr2trf-1)

      real            avfr2,pvfr2,Hext,thetaHe,phiHe,
     &                phi_ls,theta_ls,psi_ls,dum,dumvfr2
      common/avfr2trf/avfr2,pvfr2,dum(4),Hext,thetaHe,phiHe,
     &                phi_ls,theta_ls,psi_ls,dumvfr2(ivfr2trf-12)
      logical         b_vfr2,b_Hext,b_thetaHe,b_phiHe,
     &                b_phils,b_thetals,b_psils,b_dum,b_dumvfr2
      common/bvfr2trf/b_vfr2,b_dum(5),b_Hext,b_thetaHe,b_phiHe,
     &                b_phils,b_thetals,b_psils,b_dumvfr2(ivfr2trf-12)
            
      real          c1,cTms,ajg,aje,amueg,amuee,QgdQe,r_E2M1,e1m1,
     &              symcase,timeinvers,dumc
      common/acmaps/c1,cTms,ajg,aje,amueg,amuee,QgdQe,r_E2M1,e1m1,
     &              symcase,timeinvers,dumc(icstrf-11)

      real          avm,aH,thetaH,phiH,
     &              DEq,eta,phi_CE,theta_CE,psi_CE,dumvm
      common/avmaps/avm,aH,thetaH,phiH,
     &              DEq,eta,phi_CE,theta_CE,psi_CE,dumvm(ivstrf-9)
      logical       b_vm,b_aH,b_thetaH,b_phiH,
     &              b_DEq,b_eta,b_phiE,b_thetaE,b_psiE,b_dumvm
      common/bvmaps/b_vm,b_aH,b_thetaH,b_phiH,
     &              b_DEq,b_eta,b_phiE,b_thetaE,b_psiE,b_dumvm(ivstrf-9)
      logical       b_c1,b_dumcm
      common/bcmaps/b_c1,b_dumcm(icstrf-1)

      logical  b_He,b_Hi,b_efg,b_eqgt0,b_Hegt0,b_Higt0,b_efgC,b_LS
      real     dj(-4:4,-4:4),
     &         phiH_r,thetaH_r,phiHe_r,thetaHe_r,phiE_r,thetaE_r,
     &         psiE_r

      integer  ivv,iec,icl,iecv,id1,id2,istore,maxloop
      parameter(maxloop=11,ivv=25,iec=ivv+25,icl=iec+25,iecv=icl+9,
     &         id1=iecv+9,id2=id1+1+10*maxloop,istore=id2+25*maxloop)
      complex  rtr(maxjge),rpm(maxjge),
     &         efgPAS(-2:2),efgC(-2:2),efgL(-2:2),
     &         hc1,hc2,
     &         hv(-1:1),hvL(-1:1),hvC(-1:1),
     &         Dslt(-2:2,-2:2),Dect(-2:2,-2:2),Decv(-1:1,-1:1),
     &         Dslv(-1:1,-1:1),hve(-1:1),Dcpv(-1:1,-1:1),
     &         Dcpt(-2:2,-2:2),ctimeinv(maxloop),
     &         d1(-1:1,-1:1,maxloop),d2(-2:2,-2:2,maxloop)
      complex     store(istore),caseloop
      equivalence (store(1),efgPAS(-2)),(store(6),efgC(-2)),
     &            (store(11),efgL(-2)),(store(16),hv(-1)),
     &            (store(19),hvC(-1)),(store(22),hvL(-1)),
     &            (store(ivv),Dect(-2,-2)),(store(iec),Dslt(-2,-2)),
     &            (store(icl),Decv(-1,-1)),(store(iecv),Dslv(-1,-1)),
     &            (store(id1),caseloop),(store(id1+1),ctimeinv(1)),
     &       (store(id1+1+maxloop),d1(-1,-1,1)),(store(id2),d2(-2,-2,1))

       logical b_integer,
     &         b_timeinv(0:maxloop)

       integer je,jg,jm,NN,i,ip,ii,k,j,m,n,nput,n_all,ncase,
     &         jloop,nloop,nloop_b,nloop_e,jOM,iOM,iset,isymmetry,
     &         jljO,idumscrd
       real    phils_r,thetals_r,psils_r,fm,fn,rEM2,qEM2,
     &         a_mueg,a_muee,efg0,efg2,c_Tms,
     &         eagd_zz(2*maxjge),pp,hmm,pp1,hmm1,pp2,hmm2,
     &         pp12,hmm12,h,hx,hy,hz,thetaC,phiC,sintC,arcos,
     &         q62,vxx,vyy,vzz,vxy,vxz,vyz,sqrt2,sqrt3d2,pi,rad,
     &         phiOM,thetaOM,psiOM,eh,mat,dumscrd

      complex  eagdzz(maxjge),TI12(-1:1),TI21(-1:1),V1mi(-1:1),
     &         V1hi(-1:1),V2mi(-2:2),V2hi(-2:2),
     &         hvC0(-1:1),efgC0(-2:2),pm,pm1,pm2,pm12
      real     dj1(-1:1,-1:1),DH1(-1:1,4),DH2(-2:2,4),
     &         TI1(-1:1),TI2(-2:2),DH12(-1:1,4),DH21(-1:1,4)
      integer  ipq(-1:1,-1:1)
      equivalence (eagdzz(1),eagd_zz(1))

      parameter (idumscrd=maxscrd-6144*3-128*3-9*24)
      common/scrd/phiOM(6144),thetaOM(6144),psiOM(6144),
     &            eh(3,128),mat(3,3,24),dumscrd(idumscrd)      
      parameter  (sqrt2=1.4142136,sqrt3d2=1.224745,
     &            rad=0.0174533,pi=3.14159) 

      jge=(2.*ajg+1)*(2.*aje+1)+0.01

      if(acfr2.lt.3.)aset=0.0
c     this way iset,... have not to be defined in frstr_..
      if(isubthe.lt.0) then
       theoryname='H_DEQ_equivalent_sites     v=102'
       if(isubthe.eq.-16) return 
       ncase=symcase
       call sym_equiv(-ncase,timeinvers,nloop,ctimeinv,d1,d2)
       if(nloop.eq.-1)nloop=0
       iset=aset
       if(iset.gt.0) then
        isymmetry=asymmetry       
       call sphere(-iset,isymmetry,.true.,iOM,phiOM,thetaOM,psiOM,
     &                                                 eh,mat)
        if(iOM.eq.0) then
         info=1
         infotext(1)=' '
         infotext(2)(1:17)='*** error ***'
         infotext(3)='meaningless values of constants iset/isymmetry'
         infotext(4)=
     &      'help available: {co a}, {he cn} (n=number of constant)'
         infotext(5)=' '
         return
        end if
        c1=1+istore+2+3*jge*(nloop+1)*iOM+iOM
       else
        c1=1+istore+2+3*jge*(nloop+1)+1
       end if
       return
      end if

      if(.not.(b_vm.or.b_vfr2)) then
       isubthe=-abs(isubthe)             ! 24.10.07 theory not changed
c       write(6,'(a)') ' no change'
       return
      end if
c ----------------------------------------------------------------------
      j=iput+1
      nput=j+istore
      do i=1,istore
       store(i)=array_fr(j+i)
      end do
      array_fr(j)=cmplx(float(nput),float(istore))
c      write(6,'(8f10.1)')store
c     logicals
      b_efg=b_DEq.or.b_eta
      b_eqgt0=abs(DEq).gt.0.
      b_Hegt0=abs(Hext).gt.0.0
      b_Higt0=abs(aH).gt.0.0

      b_He=b_Hext.or.b_thetaHe.or.b_phiHe
      b_Hi=b_aH.or.b_thetaH.or.b_phiH

      b_LS=b_phils.or.b_thetals.or.b_psils

      b_efgC=b_phiE.or.b_thetaE.or.b_psiE

      phils_r=phi_ls*rad
      thetals_r=theta_ls*rad
      psils_r=psi_ls*rad

      phiE_r=phi_CE*rad
      thetaE_r=theta_CE*rad
      psiE_r=psi_CE*rad

      a_mueg=amueg
      a_muee=amuee
      c_Tms=cTms
      rEM2=r_E2M1**2
      qEM2=1./(1.+rEM2)

      iset=aset     
      ncase=symcase
      isymmetry=asymmetry

      ii=jge/2
      if(2*ii.eq.jge) then
       b_integer=.false.
       je=2*aje+0.01
       jg=2*ajg+0.01
       jm=je
       if(jg.gt.jm)jm=jg
       NN=jm+1
      else
       b_integer=.true.
       je=aje+0.01
       jg=ajg+0.01
       jm=je
       if(jg.gt.jm)jm=jg
       NN=2*jm+1
      end if
      if(abs(jg-jg_a)+abs(je-je_a).gt.0)then      
       jg_a=jg
       je_a=je
       call symbol3j(b_integer,je,jg,Vje_1_jg,Vje_2_jg,
     &                          wpje,wmje,wpjg,wmjg) 
      end if


  
c     icase=1,2 magnetic field aH defined with respect to S_E,S_C
      nloop_b=0
      if(b_c1) then
       call sym_equiv(ncase,timeinvers,nloop,ctimeinv,d1,d2)
       nloop_e=nloop
       if(nloop.eq.-1)then
        nloop_b=1
        nloop_e=1
       end if 
      else
       nloop=real(caseloop)
c      write(6,'(a,i6)')'th_22nuclear nloop=',nloop
       nloop_e=nloop
       if(nloop.eq.-1)then
        nloop_b=1
        nloop_e=1
       end if 
      end if
      b_timeinv(0)=.false.
      do k=1,nloop_e
       b_timeinv(k)=real(ctimeinv(k)).lt.0.
      end do

      if(bcfr2) then
       call sphere(iset,isymmetry,.true.,iOM,phiOM,thetaOM,psiOM,
     &                                                 eh,mat)
       caseloop=cmplx(float(nloop),float(iOM))
c      write(6,'(a,i6)')'bcfr2 th_22nuclear nloop=',nloop
       if(nloop.eq.-1)then
        n_all=iOM
       else
        n_all=iOM*(nloop+1)
       end if
       j=nput+2+3*jge*n_all
       do i=1,iOM
        array_fr(j+i)=cmplx(thetaOM(i),phiOM(i))
       end do
      else 
       iOM=aimag(caseloop)
       if(nloop.eq.-1)then
        n_all=iOM
       else
        n_all=iOM*(nloop+1)
       end if
       j=nput+2+3*jge*n_all  
       do i=1,iOM
        thetaOM(i)=real(array_fr(j+i))
        phiOM(i) =aimag(array_fr(j+i))
       end do
      end if
      caseloop=cmplx(float(nloop),float(iOM))
     

        
       if(b_eqgt0)then
c       efg (-2..2) are the spherical tensor components of the EFG in the PAS
        efg0=1./sqrt(1.+eta**2/3.)
        efg2=eta*efg0/sqrt(6.)
 
        efgPAS(0)=cmplx(efg0,0.0)
        efgPAS(-1)=(0.,0.)
        efgPAS(1)=(0.,0.)
        efgPAS(-2)=cmplx(efg2,0.)
        efgPAS(2)=cmplx(efg2,0.)
       else
        do i=-2,2
         efgPAS(i)=cmplx(0.0,0.0)
        end do
        do i=-2,2
         efgL(i)=cmplx(0.0,0.0)
        end do
       end if

c       write(6,'(a,5f12.6)') '   efg=', eta,phi_CE,theta_CE,psi_CE
c        write(6,'(a,5f12.6)') '    H=',aH,phiH,thetaH
c        write(6,'(a,5f12.6)') '    A=',phi_ls,theta_ls,psi_ls
c        write(6,'(a,3i6)')'thmossub  sym=',inv_time,nconyi,nconzi

       if(b_Hegt0)then         
c       external field defined in the LAB system S_L
        phiHe_r=phiHe*rad
        thetaHe_r=thetaHe*rad
        hve(1) =-cmplx(cos(phiHe_r),sin(phiHe_r))*
     &                  sin(thetaHe_r)/sqrt2*Hext
        hve(0) = cmplx(cos(thetaHe_r),0.0)*Hext
        hve(-1)=-conjg(hve(1))
       else
        do i=-1,1
         hve(i)= cmplx(0.0,0.0)
        end do
       end if

       if(b_Higt0) then
c       internal field hv defined in the system S_E or S_C (case)

        phiH_r=phiH*rad
        thetaH_r=thetaH*rad
        hv(1) =-cmplx(cos(phiH_r),sin(phiH_r))*
     &                  sin(thetaH_r)/sqrt2*aH
        hv(0) = cmplx(cos(thetaH_r),0.0)*aH
        hv(-1)=-conjg(hv(1))
       else
        do i=-1,1
         hv(i)= cmplx(0.0,0.0)
        end do
       end if
c       write(6,'(a,8f12.4)') 'hv    =',(hv(i),i=-1,1)
c --------------------------------------------------------------------
      if(iset.eq.0) then
c      single crystal case,  EFG(efgL) in the S_L sytem
c      transformation:
c      Sum;n T(n)*Dnm(phi_CE,teta_CE,psi_CE) = T(m)
 
       if(b_efgC)then
        call dewigner(2,-thetaE_r,dj)
        do m=-2,2
        do n=-2,2
         fm=-float(n)*phiE_r
         fn=-float(m)*psiE_r
         Dect(m,n)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n)
        end do
        end do
       end if

       do n=-2,2
        hc1=(0.,0.)
        do m=-2,2
         hc1=hc1+efgPAS(m)*Dect(m,n)
        end do
        efgC(n)=hc1
       end do

c      q62=sqrt3d2
c      vxx=real(-efgC(0)+q62*(efgC(2)+efgC(-2)))
c      vyy=real(-efgC(0)-q62*(efgC(2)+efgC(-2)))
c      vzz=2*real(efgC(0))
c      vxy=aimag(q62*(efgC(2)-efgC(-2)))
c      vxz=-real(q62*(efgC(1)-efgC(-1)))
c      vyz=-aimag(q62*(efgC(1)+efgC(-1)))
c      write(6,'(8x,a,3f8.3,a1)')   '          x (',vxx,vxy,vxz,')'
c      write(6,'(8x,a,8x,2f8.3,a1)')'<i|V|k> = y (',vyy,vyz,')'
c      write(6,'(8x,a,16x,f8.3,a1)')'          z (',vzz,')'

c       absorber/crystal in the Lab system
c       efg transformed to the Lab. system
        call dewigner(2,-thetals_r,dj)       
        do m=-2,2
        do n=-2,2
         fm=-float(n)*phils_r
         fn=-float(m)*psils_r
         Dslt(m,n)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n)
        end do
        end do
       do n=-2,2
        hc1=(0.,0.)
        do m=-2,2
         hc1=hc1+efgC(m)*Dslt(m,n)
        end do
        efgL(n)=hc1*DEq
       end do

c      if(nfit(0).eq.0) then
c       q62=sqrt3d2
c       vxx=real(-efgL(0)+q62*(efgL(2)+efgL(-2)))
c       vyy=real(-efgL(0)-q62*(efgL(2)+efgL(-2)))
c       vzz=2*real(efgL(0))
c       vxy=aimag(q62*(efgL(2)-efgL(-2)))
c       vxz=-real(q62*(efgL(1)-efgL(-1)))
c       vyz=-aimag(q62*(efgL(1)+efgL(-1)))
c       write(nwr,'(8x,a,3f8.3,a1)')   '          x (',vxx,vxy,vxz,')'
c       write(nwr,'(8x,a,8x,2f8.3,a1)')'<i|V|k> = y (',vyy,vyz,')'
c       write(nwr,'(8x,a,16x,f8.3,a1)')'          z (',vzz,')'
c      end if

       if(icase.eq.1)then
c       transformation of the magnetic field H (hv) from the  S_E to 
c       the crystal system S_C  (hvC(n) in the crystal system  S_C) 
        if(b_efgC)then
         call dewigner(1,-thetaE_r,dj)
         do m=-1,1
         do n=-1,1
          fm=-float(n)*phiE_r
          fn=-float(m)*psiE_r
          Decv(m,n)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n)
         end do
         end do
        end if
        do n=-1,1
         hc1=(0.,0.)
         do m=-1,1
          hc1=hc1+hv(m)*Decv(m,n)
         end do
          hvC(n)=hc1
        end do
       else
c       magnetic field given in the crystal system Sc
        do i=-1,1
         hvC(i)= hv(i)
        end do
       end if ! case 1
c------enable write------H-field in the crystal system --------------
       if(enwr(6).eq.'hfsi') then
        hx=-real(hvC(1)-hvC(-1))/sqrt2
        hy= real((hvC(1)+hvC(-1))*cmplx(0.,1.))/sqrt2
        hz= real(hvC(0))
        h=sqrt(hx**2+hy**2+hz**2)
        thetaC=arcos(hz/h)
        sintC=sin(thetaC)
        if(sintC.lt.0.001) then
         phiC=0.0
        else
         phic=arcos(hx/h/sintC)
         if(hy.lt.0.)phiC=2.*pi-phiC
        end if

        write(nwr,'(/,a,3f8.3,a2,f7.2,a2,2f7.2,a1)')
     &      ' H_C = (',hx,hy,hz,')=',h,'*(',thetaC/rad,phiC/rad,')'
       end if
c--------------------------------------------------------------------

       if(b_LS)then
c       magnetic field transformed to the Lab system
        call dewigner(1,-thetals_r,dj)
        do m=-1,1
        do n=-1,1
         fm=-float(n)*phils_r
         fn=-float(m)*psils_r
         Dslv(m,n)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n)
        end do
        end do
c        write(6,'(a)') 'Dsl  b_LS=T'
c        write(6,'(10f10.3)') Dsl
       
        do n=-1,1
         hc1=(0.,0.)
         do m=-1,1
          hc1=hc1+hvC(m)*Dslv(m,n)
         end do
         hvL(n)=hc1+hve(n)
        end do
       else
        do n=-1,1
         hvL(n)=hvC(n)+hve(n)
        end do
       end if

c-------enable write-------- EFG in the Lab system -------------------
        if(enwr(6).eq.'eflb') then
         q62=sqrt3d2
         vxx=real(-efgL(0)+q62*(efgL(2)+efgL(-2)))
         vyy=real(-efgL(0)-q62*(efgL(2)+efgL(-2)))
         vzz=2*real(efgL(0))
         vxy=-real(q62*(efgL(2)-efgL(-2))*cmplx(0.,1.))
         vxz=-real(q62*(efgL(1)-efgL(-1)))
         vyz=real(q62*(efgL(1)+efgL(-1))*cmplx(0.,1.))

c         write(nwr,'(2x,a,6f8.3,a1,3f10.3)')  
c     &   ' (',vxx,vyy,vzz,vxy,vxz,vyz,')'
c     &   sin(thetaOM(jOM))*cos(phiOM(jOM)),
c     &   sin(thetaOM(jOM))*sin(phiOM(jOM)),cos(thetaOM(jOM))
         write(nwr,'(a)')
         write(nwr,'(2x,a,3f8.3,a1)')  '            x (',vxx,vxy,vxz,')'
         write(nwr,'(2x,a,8x,2f8.3,a1)')'<i|V_L|k> = y (',vyy,vyz,')'
         write(nwr,'(2x,a,16x,f8.3,a1)')'            z (',vzz,')'
        end if
c-------enable write---H-field in the Lab system ---------------------
        if(enwr(6).eq.'hflb') then
c         hx=-real(hvL(1)-hvL(-1))/sqrt2
c         hy= real((hvL(1)+hvL(-1))*cmplx(0.,1.))/sqrt2
c         hz= real(hvL(0))
         hx=-real(hvC(1)-hvC(-1))/sqrt2
         hy= real((hvC(1)+hvC(-1))*cmplx(0.,1.))/sqrt2
         hz= real(hvC(0))
         write(nwr,'(/,a,3f8.3,a1)')
     &       ' H_L = (',hx,hy,hz,')'
        end if
c--------------------------------------------------------------------
       call hamJgJe(b_integer,amueg,amuee,QgdQe,cTms,hvL,efgL,
     &    jge,Eagd,V1m,V2m,jm,hma,je,Ee,Eve,jg,Eg,Evg,
     &    Vje_1_jg,Vje_2_jg,wpje,wmje,wpjg,wmjg,NN,AA,VV,DD)

       do i=1,jge
        eagd_zz(2*i-1)=Eagd(i)
       end do

       n_all=nloop_e-nloop_b+1
       do i=1,jge
c       transformation (rotation and time inversion) of V1m,V2m
c       calculation of r_pq and averaging  
        pp=0.
        hmm=0.
        pm=(0.,0.)
        
        do jloop=nloop_b,nloop_e 

          if(b_timeinv(jloop))then
           do m=-1,1
            V1mi(m)=-(-1)**m*conjg(V1m(-m,i))
           end do
           do m=-1,1
            V2mi(m)=(-1)**m*conjg(V1m(-m,i))
           end do
          else
           do m=-1,1
            V1mi(m)=V1m(m,i)
           end do
           do m=-2,2
            V2mi(m)=V2m(m,i)
           end do
          end if

         if(jloop.gt.0) then
          do n=-1,1
           hc1=(0.,0.)
           do m=-1,1
            hc1=hc1+V1mi(m)*d1(m,n,jloop)
           end do
           V1hi(n)=hc1
          end do
          do n=-1,1
           V1mi(n)= V1hi(n)
          end do         

          do n=-2,2
           hc1=(0.,0.)
           do m=-2,2
            hc1=hc1+V2mi(m)*d2(m,n,jloop)
           end do
           V2hi(n)=hc1
          end do
          do n=-2,2
           V2mi(n)=V2hi(n)
          end do
         end if
c         if(jloop.gt.0)write(6,'(9f9.3)') (V1mi(m),m=-1,1)
c         if(jloop.gt.0)write(6,'(9f10.5)')real(conjg(V1mi(1))*V1mi(1)),
c     &   real(conjg(V1mi(-1))*V1mi(-1)),conjg(V1mi(1))*V1mi(-1),Eagd(i)

         if(r_E2M1.eq.0.)then
          pp =pp+real(conjg(V1mi(1))*V1mi(1))
          hmm=hmm+real(conjg(V1mi(-1))*V1mi(-1))
          pm =pm+conjg(V1mi(1))*V1mi(-1)
         else 
          if(abs(r_E2M1).lt.9999.)then
c          mixed M1/E2 transition
           pp1 =real(conjg(V1mi(1))*V1mi(1))
           hmm1=real(conjg(V1mi(-1))*V1mi(-1))
            pm1=conjg(V1mi(1))*V1mi(-1)
  
            pp2=real(conjg(V2mi(1))*V2mi(1))
           hmm2=real(conjg(V2mi(-1))*V2mi(-1))
            pm2=conjg(V2mi(1))*V2mi(-1)
  
            pp12= 2.*real(conjg(V2mi(1))*V1mi(1))
           hmm12=-2.*real(conjg(V2mi(-1))*V1mi(-1))
            pm12= conjg(V2mi(1))*V1mi(-1)-conjg(V1mi(1))*V2mi(-1)
  
             pp=pp+(pp1 +rEM2*pp2  -r_E2M1*pp12)*qEM2
            hmm=hmm+(hmm1+rEM2*hmm2-r_E2M1*hmm12)*qEM2
             pm=pm+(pm1 -rEM2*pm2  -r_E2M1*pm12)*qEM2
          else
c          E2 transition
           pp =pp+real(conjg(V2mi(1))*V2mi(1))
           hmm=hmm+real(conjg(V2mi(-1))*V2mi(-1))
          end if         
         end if 
c        write(6,'(2i3,a,2f10.3,3x,2f10.3)')
c     &       i,jloop,' pp,hmm,pm=',real(conjg(V1mi(1))*V1mi(1)),
c     &  real(conjg(V1mi(-1))*V1mi(-1)),conjg(V1mi(1))*V1mi(-1)
        end do    ! nloop

        rtr(i)=cmplx(pp-hmm,pp+hmm)/2.0/float(n_all)
        rpm(i)=pm/float(n_all)
       end do   ! i=1-jge

      else  
c      ----------------------powder case  iset>0 ------------------------
c      phi_ls,theta_ls,psi_ls would  rotate a powder (no effect)
       if(b_Hegt0)then
c        The polar angles  thetaOM,phiOM define the direction of
c        the z-axis of one of the crystals of the powder with system S_C 
c        rotated with respect to the sample system S_S. (If the sample
c        is not rotated S_S coincides with the lab. system S_L).
c        The Euler angles of the rotation are alpha=phiOM and beta=thetaOM 
c        and the angle psiOM which is averaged analytically (off diagonal 
c        elements of r_pq vanish). The components in the S_OM system are 
c        (symbolic):  e_OM in S_C  -> t_OM=t_C*d   (t_S=t_OM)

        array_fr(nput+1)=cmplx(float(n_all),float(jge))
        array_fr(nput+2)=cmplx(0.,0.)
        ipq(1,1)=1
        ipq(-1,-1)=2
        ipq(1,-1)=3
        ipq(-1,1)=4
        call dewigner(1,thetaHe_r,dj)
        do m=-1,1
         do n=-1,1
           dj1(m,n)=dj(m,n)
         end do
        end do
        do m=-1,1
         do i=-1,1,2
         do k=-1,1,2
           j=ipq(i,k)
           DH1(m,j)=dj1(m,i)*dj(m,k) 
         end do
         end do
        end do

        call dewigner(2,thetaHe_r,dj)
        do m=-2,2
         do i=-1,1,2
         do k=-1,1,2
           j=ipq(i,k)
           DH2(m,j)=dj(m,i)*dj(m,k) 
         end do
         end do
        end do

        do m=-1,1
         do i=-1,1,2
         do k=-1,1,2
           j=ipq(i,k)
           DH12(m,j)=dj1(m,i)*dj(m,k) 
           DH21(m,j)=dj(m,i)*dj1(m,k) 
         end do
         end do
        end do



        hve(0)=cmplx(Hext,0.)
        hve(1)=cmplx(0.,0.)
        hve(-1)=cmplx(0.,0.)
        do i=-2,2
         efgC(i)=efgPAS(i)
        end do
        eagd_zz(2)=0.
        eagd_zz(4)=0.
        eagd_zz(6)=0.
        eagd_zz(8)=0. 
        eagd_zz(10)=0.

        if(icase.eq.2) then
c        H internal defined with respect to the crystal system
         if(b_efgC)then
          call dewigner(1,thetaE_r,dj)
c         write(6,'(a,5f12.6)') 'rad,efg=', rad,phiE_r,psiE_r
          do m=-1,1
           do n=-1,1
            fm=float(m)*phiE_r
            fn=float(n)*psiE_r
            Decv(m,n)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n)
           end do
          end do
          do n=-1,1
           hc1=(0.,0.)
           do m=-1,1
            hc1=hc1+hv(m)*Decv(m,n)
           end do
           hvC(n)=hc1
          end do
         end if
        else
         do n=-1,1
          hvC(n)=hv(n)
         end do
        end if

        do n=-1,1
         hvC0(n)=hvC(n)
        end do
        do n=-2,2
         efgC0(n)=efgC(n)
        end do

        jljO=0
        do jOM=1,iOM                    !------------------------------

         call dewigner(1,thetaOM(jOM),dj)
         do m=-1,1
         do n=-1,1
          fm=float(m)*phiOM(jOM)
          fn=0.0
          Dcpv(m,n)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n) 
         end do
         end do

         call dewigner(2,thetaOM(jOM),dj)
         do m=-2,2
         do n=-2,2
          fm=float(m)*phiOM(jOM)
          fn=0.0
          Dcpt(m,n)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n) 
         end do
         end do

c        loop for isymmetry and timeinvers could be inserted here
c        hvC(n)=hvC0(m)*d1(m,n,jloop)   efgC(n)=efgC0(m)*d2(m,n,jloop)
c        if(b_timeinv(jloop)) hvC(n)=-hvC(n)
         do jloop=nloop_b,nloop_e
         jljO=jljO+1
         if(jloop.gt.0) then
          do n=-1,1
           hc1=(0.,0.)
           do m=-1,1
            hc1=hc1+hvC0(m)*d1(m,n,jloop)
           end do
           hvC(n)=hc1
          end do
          if(b_timeinv(jloop))then
           do n=-1,1
           hvC(n)=-hvC(n)
           end do
          end if

          do n=-2,2
           hc1=(0.,0.)
           do m=-2,2
            hc1=hc1+efgC0(m)*d2(m,n,jloop)
           end do
           efgC(n)=hc1
          end do
         else
          do n=-1,1
           hvC(n)=hvC0(n)
          end do
          do n=-2,2
           efgC(n)=efgC0(n)
          end do
         end if

c         1. rank tensor transformation
         do n=-1,1
          hc1=(0.,0.)
          do m=-1,1
           hc1=hc1+hvC(m)*Dcpv(m,n)
          end do
          hvL(n)=hc1+hve(n)
         end do

         if(b_eqgt0)then         
          do n=-2,2
           hc1=(0.,0.)
           do m=-2,2
            hc1=hc1+efgC(m)*Dcpt(m,n)
           end do
           efgL(n)=hc1*DEq
          end do
         end if   ! b_eqgt0

c-------enable write-------- EFG in the Lab system -------------------
        if(enwr(6).eq.'eflb') then
         q62=sqrt3d2
         vxx=real(-efgL(0)+q62*(efgL(2)+efgL(-2)))
         vyy=real(-efgL(0)-q62*(efgL(2)+efgL(-2)))
         vzz=2*real(efgL(0))
         vxy=-real(q62*(efgL(2)-efgL(-2))*cmplx(0.,1.))
         vxz=-real(q62*(efgL(1)-efgL(-1)))
         vyz=real(q62*(efgL(1)+efgL(-1))*cmplx(0.,1.))

         write(nwr,'(2x,a,6f8.3,a1,3f10.3)')  
     &   ' (',vxx,vyy,vzz,vxy,vxz,vyz,')'
c     &   sin(thetaOM(jOM))*cos(phiOM(jOM)),
c     &   sin(thetaOM(jOM))*sin(phiOM(jOM)),cos(thetaOM(jOM))
c         write(nwr,'(a)')
c         write(nwr,'(2x,a,3f8.3,a1)')  '            x (',vxx,vxy,vxz,')'
c         write(nwr,'(2x,a,8x,2f8.3,a1)')'<i|V_L|k> = y (',vyy,vyz,')'
c         write(nwr,'(2x,a,16x,f8.3,a1)')'            z (',vzz,')'
        end if
c-------enable write---H-field in the Lab system ---------------------
        if(enwr(6).eq.'hflb') then
         hx=-real(hvL(1)-hvL(-1))/sqrt2
         hy= real((hvL(1)+hvL(-1))*cmplx(0.,1.))/sqrt2
         hz= real(hvL(0))
         write(nwr,'(/,a,3f8.3,a1)')
     &       ' H_L = (',hx,hy,hz,')'
        end if
c--------------------------------------------------------------------


         call hamJgJe(b_integer,amueg,amuee,QgdQe,cTms,hvL,efgL,
     &    jge,Eagd,V1m,V2m,jm,hma,je,Ee,Eve,jg,Eg,Evg,
     &    Vje_1_jg,Vje_2_jg,wpje,wmje,wpjg,wmjg,NN,AA,VV,DD)
c        transformation to the direction of observation 
 
         do i=1,jge
          eagd_zz(2*i-1)=Eagd(i)
         end do

c        write(6,'(10f10.3)') (eagdzz(j),j=1,10)   ! trick with equivalence
c        if(jOM.eq.1)
c     &  write(6,'(a,i4,f12.3)')' iOM,thetaHe=',iOM,thetaHe_r/rad

         ip=nput+2+3*jge*(jljO-1)
         do i=1,jge

          if(r_E2M1.eq.0.)then
           do m=-1,1
            TI1(m)=real(conjg(V1m(m,i))*V1m(m,i))
           end do
           pp=0.
           do m=-1,1
            pp=pp+TI1(m)*DH1(m,1)
           end do
           hmm=0.
           do m=-1,1
            hmm=hmm+TI1(m)*DH1(m,2)
           end do
           pm=(0.,0.)
           do m=-1,1
            pm=pm+cmplx(0.,TI1(m)*DH1(m,3))
           end do
          else
           if(abs(r_E2M1).lt.1000.)then 
c           mixed M1/E2 transition  
            do m=-1,1
             TI1(m)=real(conjg(V1m(m,i))*V1m(m,i))
            end do        
            do m=-2,2
             TI2(m)=real(conjg(V2m(m,i))*V2m(m,i))
            end do
            do m=-1,1
             TI12(m)=conjg(V1m(m,i))*V2m(m,i)
             TI21(m)=conjg(V2m(m,i))*V1m(m,i)
            end do        
            pp=0.
            do m=-1,1
             pp=pp+TI1(m)*DH1(m,1)-
     &          r_E2M1*real(TI21(m)*DH21(m,1)+TI12(m)*DH12(m,1))
            end do
            do m=-2,2
             pp=pp+rEM2*TI2(m)*DH2(m,1)
            end do
            pp=pp*qEM2
            hmm=0.
            do m=-1,1
             hmm=hmm+TI1(m)*DH1(m,2)-
     &          r_E2M1*real(TI21(m)*DH21(m,2)+TI12(m)*DH12(m,2))
            end do
            do m=-2,2
             hmm=hmm+rEM2*TI2(m)*DH2(m,2)
            end do
            hmm=hmm*qEM2
            pm=0.
            do m=-1,1
             pm=pm+cmplx(0,TI1(m)*DH1(m,3))-
     &          r_E2M1*(TI21(m)*DH21(m,3)-TI12(m)*DH12(m,3))
            end do
            do m=-2,2
             pm=pm-rEM2*cmplx(0.,TI2(m)*DH2(m,3))
            end do
            pm=pm*qEM2
           else
c           E2 transition
            do m=-1,1
             TI2(m)=real(conjg(V2m(m,i))*V2m(m,i))
            end do
            pp=0.
            do m=-2,2
             pp=pp+TI2(m)*DH2(m,1)
            end do
            hmm=0.
            do m=-2,2
             hmm=hmm+TI2(m)*DH2(m,2)
            end do
            pm=(0.,0.)
            do m=-2,2
             pm=pm+cmplx(0.,TI2(m)*DH2(m,3))
            end do
           end if
          end if

          ii=ip+3*(i-1)
          array_fr(ii+1)=eagdzz(i)
          array_fr(ii+2)=cmplx(pp-hmm,pp+hmm)/2.0/float(n_all)
          array_fr(ii+3)=pm/float(n_all)
         end do
         end do   ! nloop
        end do    ! iOM
        goto 100       
c       end of powder average (Collins etc)
       else
c       average intensities of efg with only Hi (no external H)
        if(icase.eq.2) then
c        H internal defined with respect to the crystal system
         if(b_efgC)then
          call dewigner(2,-thetaE_r,dj)
c         write(6,'(a,5f12.6)') 'rad,efg=', rad,phiE_r,psiE_r
          do m=-2,2
           do n=-2,2
            fm=-float(n)*phiE_r
            fn=-float(m)*psiE_r
            Dect(m,n)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n)
           end do
          end do
         end if
         do n=-2,2
          hc1=(0.,0.)
          do m=-2,2
           hc1=hc1+efgPAS(m)*Dect(m,n)
          end do
          efgC(n)=hc1*DEq
         end do
        else
         do m=-2,2
          efgC(m)=efgPAS(m)*DEq
         end do
        end if
  
        do m=-1,1
         hvC(m)=hv(m)
        end do
c        write(6,'(a,8f9.1)') 'hv =',hv
c        write(6,'(a,L5,8f9.3)')'... =',b_integer,amueg,amuee,QgdQe,cTms
        call hamJgJe(b_integer,amueg,amuee,QgdQe,cTms,hvC,efgC,
     &    jge,Eagd,V1m,V2m,jm,hma,je,Ee,Eve,jg,Eg,Evg,
     &    Vje_1_jg,Vje_2_jg,wpje,wmje,wpjg,wmjg,NN,AA,VV,DD)

        if(r_E2M1.eq.0.)then
         do i=1,jge
          hc1=V1m(1,i)*conjg(V1m(1,i))+V1m(0,i)*conjg(V1m(0,i))+
     &      V1m(-1,i)*conjg(V1m(-1,i))
          rtr(i)=cmplx(0.,real(hc1)/3.)
          rpm(i)=cmplx(0.,0.)
         end do
        else 
         if(abs(r_E2M1).lt.1000.)then
c         mixed M1/E2 transition
          do i=1,jge
           hc1=V1m(1,i)*conjg(V1m(1,i))+V1m(0,i)*conjg(V1m(0,i))+
     &         V1m(-1,i)*conjg(V1m(-1,i))
           hc2=V2m(2,i)*conjg(V2m(2,i))+V2m(1,i)*conjg(V2m(1,i))+
     &         V2m(0,i)*conjg(V2m(0,i))+V2m(-1,i)*conjg(V2m(-1,i))+
     &         V2m(-2,i)*conjg(V2m(-2,i))
           rtr(i)=cmplx(0.,(real(hc1)/3.+rEM2*real(hc2)/5.)*qEM2)
           rpm(i)=cmplx(0.,0.)
          end do
         else
c         E2 transition
          do i=1,jge
           hc2=V2m(2,i)*conjg(V2m(2,i))+V2m(1,i)*conjg(V2m(1,i))+
     &         V2m(0,i)*conjg(V2m(0,i))+V2m(-1,i)*conjg(V2m(-1,i))+
     &         V2m(-2,i)*conjg(V2m(-2,i))
           rtr(i)=cmplx(0.,real(hc2)/5.)
           rpm(i)=cmplx(0.,0.)
          end do
         end if         
        end if 

       end if
      end if  ! 

      ip=nput+2
      do i=1,jge
       ii=ip+3*(i-1)
       array_fr(ii+1)=cmplx(Eagd(i),0.0)
       array_fr(ii+2)=rtr(i)
       array_fr(ii+3)=rpm(i)
c       write(6,'(i8,a,8f10.4)')ii,' E=',Eagd(i),rtr(i),rpm(i)
      end do

      n_all=1
      array_fr(nput+1)=cmplx(float(n_all),float(jge))
      array_fr(nput+2)=cmplx(0.,0.)


 100  if(nloop_e.gt.0) then
c      to be stored in array store() => array_fr()
       do m=-2,2
        efgC(m)=efgC0(m)
       end do
       do i=-1,1
        hvC(i)=hvC0(i)
       end do
      end if
      j=iput+1
      do i=1,istore
       array_fr(j+i)=store(i)
      end do

      return
      end



