c     H. Spiering september 2004 Mainz
c     adapted to the beta version
c
      subroutine neutronOffspecRough(b_total,info)
      implicit none
      include 'comglb.for'
      include 'comthe.for'

      logical     b_total      
      integer     info,mstruct1,istruct1,istruct2,
     &            l1_get,l2_get,l3_get,l1_put,l2_put,l3_put,
     &            nstorTH,nstorRM,nstorTHyy,istorTH,idum
      character*4 c1_prp,c2_prp,c3_prp,cfill,frthname*64
      common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),
     &              l1_get(0:maxfr1),l2_get(maxfr2),l3_get(maxthss),
     &              l1_put(0:maxfr1),l2_put(maxfr2),l3_put(maxthss),
     &              c1_prp(0:maxfr1),c2_prp(maxfr2),c3_prp(maxthss),
     &              frthname(2),nstorTH,nstorRM,nstorTHyy,idum(5),
     &              istorTH,cfill(23)


      real           acsp,dwba,channels,scale,unit_sclB,unit_sclN,
     &               ch_theta2,theta2_beg,theta2_end,
     &               theta1,lambda,dtheta1,dtheta2,dlambda,
     &               aver_points,dumcs
       common/acstrf/acsp,dwba,channels,scale,unit_sclB,unit_sclN,
     &               ch_theta2,theta2_beg,theta2_end,
     &               theta1,lambda,dtheta1,dtheta2,dlambda,
     &               aver_points,dumcs(icstrf-15)
      
      real           avs,aintensity,background,Pxsi_b,Peta_b,Pzeta_b,
     &               Pxsi_a,Peta_a,Pzeta_a,theta2_shift,fr_offspec,xi,
     &               Ao,dumvsp
      common/avstrf/avs,aintensity,background,Pxsi_b,Peta_b,Pzeta_b,
     &               Pxsi_a,Peta_a,Pzeta_a,theta2_shift,fr_offspec,xi,
     &               Ao,dumvsp(ivstrf-13)
      logical        b_vs,b_aintensity,b_background,
     &               b_Pxsi_b,b_Peta_b,b_Pzeta_b,
     &               b_Pxsi_a,b_Peta_a,b_Pzeta_a,
     &               b_theta2_shift,b_fr_offspec,b_xi,b_Ao,b_dumvsp
      common/bvstrf/b_vs,b_aintensity,b_background,
     &               b_Pxsi_b,b_Peta_b,b_Pzeta_b,
     &               b_Pxsi_a,b_Peta_a,b_Pzeta_a,
     &               b_theta2_shift,b_fr_offspec,b_xi,b_Ao,
     &               b_dumvsp(ivstrf-13)
      
      real            avfr1,pvfr1,Hext,theta_He,phi_He,dumvfr1
      common/avfr1trf/avfr1,pvfr1,Hext,theta_He,phi_He,
     &                dumvfr1(ivfr1trf-5)
      logical         b_vfr1,b_pvfr1,b_Hext,b_theta_He,b_phi_He,
     &                b_dumvfr1
      common/bvfr1trf/b_vfr1,b_pvfr1,b_Hext,b_theta_He,b_phi_He,
     &                b_dumvfr1(ivfr1trf-5)

      real            acfr2,dum,rep_grp,dumcfr2
      common/acfr2trf/acfr2,dum,rep_grp,dumcfr2(icfr2trf-3)

      real            avfr2,thicklay,B_eff,theta_B,phi_B,
     &                ar_scatldens,ai_scatldens,roughness,dumvfr2
      common/avfr2trf/avfr2,thicklay,B_eff,theta_B,phi_B,
     &                ar_scatldens,ai_scatldens,roughness,
     &                dumvfr2(ivfr2trf-8)
      logical         b_vfr2,b_thicklay,b_B_eff,b_theta_B,b_phi_B,
     &                b_ar_scatldens,b_ai_scatldens,b_roughness,
     &                b_dumvfr2
      common/bvfr2trf/b_vfr2,b_thicklay,b_B_eff,b_theta_B,b_phi_B,
     &                b_ar_scatldens,b_ai_scatldens,b_roughness,
     &                b_dumvfr2(ivfr2trf-8)
      
      logical  b_scatl_lay,b_Beff,b_analyser
      
      integer issp,i,nn,lstruct1,lstruct2,
     &        lay,nch_theta2,nchtheta2,nyout,laystr
C*************************************************************
C
C Variables defined by L. Deak (20.12.2000)      
C
      real      theta2_scat,theta_inc,rd_theta2,h,h1,h2,Hext_z,
     &          k_wave,SQz,pi,rad,thicklayer,roughlayer,I_specular,
     &          d_theta1,d_theta2,sum_off,sum_spec
      real*4    sin_theta_B,cos_theta_B,sin_phi_B,cos_phi_B
      real*4    sin_theta_H,cos_theta_H,sin_phi_H,cos_phi_H
      real*4    sin_B_H,cos_B_H,B_a,B_b,B_c
      logical   b_up,b_down
C
C ************************************************************     
      dimension thicklayer(maxfr2),roughlayer(maxfr2),
     &          laystr(2*maxfr2+2),b_Beff(maxfr2)

      complex aa(4),bb(4),dd(4),rho_a(4),rho_b(4),
     &        K_mag_lay(2,2,maxfr2),scatl_lay,Rmatrix(2,2),
     &        Imatrix(2,2),Incmatrix(2,2,maxn),Difmatrix(2,2,maxn)
      real*8  Dper(maxfr2),Dgrp(maxfr2)

      real choffspecular,chspecular
c          ,choffspecular2,dumscrd
      dimension choffspecular(maxn),chspecular(maxn)
c               ,choffspecular2(maxn)
c      common/scrd/dumscrd(maxscrd/2)
c      equivalence (dumscrd(1),choffspecular(1)),
c     &             (dumscrd(maxn+1),choffspecular2(1)),
c     &             (dumscrd(2*maxn+1),chspecular(1)),
c     &             (dumscrd(3*maxn+1),Incmatrix(1,1))
      
      logical b_scatterer
       
C **** Definitions of structure variables 
C Khaidukov 26.04.2003 & L. Deak 09.10.2002 ***
      integer POINTER,GRP,MAXGRP,GEOSTR(0:2*maxfr2),Kh
      logical b_first
      integer iaver_points
C ****                                       ***     

       iaver_points=aver_points      
      
       pi=atan(1.)*4.
       rad=pi/180.
c      write(6,'(a)')'synoffspecular ksp_m(0:maxthssp/2)='
c      write(6,'(10i7)')(iarray_sp+ksp_m(i),i=0,maxthssp/4)
c-------------------------------------------------------------------
      b_up  =.false.   ! initialization of '+' beam
      b_down=.false.   !                   '-'
      
      call mapsub(0)
      b_total=b_vs
      
c---------------------------------------------------------------------------
c     transformation matrix from spherical basis to (sigma,pi)-basis
      
c     orientation of the absorber with respect to the beam
      
      b_analyser=abs(Pxsi_a)+abs(Peta_a)+abs(Pzeta_a).gt.0.001
      if(b_analyser) then
C
C if Pzeta_a > 0. we measure the '+' beam
C if Pzeta_a < 0. we measure the '-' beam
       if(Pzeta_a.gt.0.)b_up  =.true.
       if(Pzeta_a.lt.0.)b_down=.true.
       rho_a(1)=cmplx(1.+Pzeta_a,0.)/2.
       rho_a(3)=cmplx(Pxsi_a,-Peta_a)/2.
       rho_a(2)=cmplx(Pxsi_a,Peta_a)/2.
       rho_a(4)=cmplx(1.-Pzeta_a,0.)/2.
      end if

      rho_b(1)=cmplx(1.+Pzeta_b,0.)/2.
      rho_b(3)=cmplx(Pxsi_b,-Peta_b)/2.
      rho_b(2)=cmplx(Pxsi_b,Peta_b)/2.
      rho_b(4)=cmplx(1.-Pzeta_b,0.)/2.

      nch_theta2=2*istorTH
      rd_theta2=(theta2_end-theta2_beg)/float(nch_theta2-1)
c     write(6,'(a,g15.5)')'neutronrok rd_theta2=',rd_theta2

c     write(6,'(a)')'++++++++++++++++++++++++++++++++++++'
      issp=1
      lstruct1=1
c       write(6,'(a,12i6)')'lstruct1 issp,ksp_m(issp)=',
c     & lstruct1,issp,ksp_m(issp)
      
       call mapsub(issp)
c      common/avfr1trf/avfr1,pvfr1,Hext
       b_total=b_total.or.b_vfr1
       Hext_z=Hext*unit_sclB      

       b_scatterer=b_vfr1
      
       issp=issp+1
       do lstruct2=istruct1(lstruct1-1)+1,istruct1(lstruct1)
c      ------------------------------------------------------------
c      layer lay1,2 ... mlay of scatterer
c      ---------------------------------------------------------------
c        write(6,'(a,12i6)')'lstruct2 issp,ksp_m(issp)=',
c     &  lstruct2,issp,ksp_m(issp)

        lay=lstruct2
         call mapsub(issp)
c       common/acfr2trf/ repeat_group
c       common/avfr2trf/ thicklay,B_eff,theta_B,phi_B,
c                      ar_scatldens,ai_scatldens,roughness
c        write(6,'(a,f10.1,L5)')'th_neutronoffspecular domain,b_domain=',
c     &    domainyn,b_domain(lay)
        thicklayer(lay)=thicklay

        scatl_lay=cmplx(ar_scatldens,ai_scatldens)*unit_sclN
 
        b_scatl_lay=b_vfr2.or.b_thicklay
        b_scatterer=b_scatterer.or.b_scatl_lay
c       write(6,'(a,l5)') '1------b_scatterer=',b_scatterer
        b_Beff(lay)=abs(B_eff*unit_sclB).gt.1.0e-6
        i=rep_grp
        laystr(2*lay-1)=i
        laystr(2*lay)=10*(rep_grp-float(i)+.01)
        roughlayer(lay)=roughness

C        hs=h*sin(theta_B*rad)
C************************************************************************
C
C transformation of B_eff from the sample system to the neutron system
C
C***********************************************************************

         h=B_eff*unit_sclB

         sin_theta_B=sin(theta_B*rad)
         cos_theta_B=cos(theta_B*rad)
         sin_phi_B  =sin(phi_B*rad)
         cos_phi_B  =cos(phi_B*rad)
C
        if(theta_He*rad.lt.1.e-8)then
         B_a=sin_theta_B*cos_phi_B
         B_b=sin_theta_B*sin_phi_B
         B_c=cos_theta_B
C        write(*,'(a)')'Mintarendszer ...'
C        write(*,*)B_a,B_b,B_c,B_a**2+B_b**2+B_c**2
        else
C        write(*,'(a)')'Trafo ...'
         sin_theta_H =sin(theta_He*rad)
         cos_theta_H =cos(theta_He*rad)
         sin_phi_H   =sin(phi_He*rad)
         cos_phi_H   =cos(phi_He*rad)
C
         sin_B_H =sin((phi_B-phi_He)*rad)
         cos_B_H =cos((phi_B-phi_He)*rad)
c        write(6,'(3f15.3)')phi_B,phi_He,cos_B_H
         B_a =-sin_theta_B*sin_theta_H*sin_B_H
         B_b = sin_theta_H*(sin_theta_B*cos_theta_H*cos_B_H+
     &         cos_theta_B*sin_theta_H)
         B_c = sin_theta_B*sin_theta_H*cos_B_H+
     &         cos_theta_B*cos_theta_H
c        write(*,'(3f15.3)')B_a,B_b,B_c
        endif        
         K_mag_lay(1,1,lay)=cmplx( h*B_c,0.0)-scatl_lay
         K_mag_lay(2,2,lay)=cmplx(-h*B_c,0.0)-scatl_lay
         K_mag_lay(1,2,lay)=cmplx(h*B_a,-h*B_b)
         K_mag_lay(2,1,lay)=conjg(K_mag_lay(1,2,lay))

c        write(6,'(3e15.5)')h*cos(theta_B*rad),real(scatl_lay),
c     &     real(K_mag_lay(1,1,lay))


C*****************************************************************

        issp=issp+1
       end do

       laystr(2*lay+2)=-1
       laystr(2*lay+1)=0
      
c      write(6,'(a,20i3)') 'laystr(1..lay)=',(laystr(i),i=1,2*lay)
       b_total=b_total.or.b_scatterer
       if(.not.b_total) return

c      write(6,'(a,l5)') ' ---------------b_scatterer,b_total=', b_total
c-----------------------------------------------------------------------
c     here the matrix R for the layers are given :
c     satrlay(n,lay)*1 +  (sapplay(n,lay)  sapmlay(n,lay))
c                         (samplay(n,lay) -sapplay(n,lay))
c
c     calculation of the transmittivity matrix T for all channels n
c     by   T = exp(iR)*rho*exp(-iR+)
      
      
c      if(.not.b_total) goto 1000

c----------------------------------------------------------------
C      ****************************************************************
C      We reconstarct the layer strucrure from the laystr variabale. 
c      GEOSTR(GRP) is the number of layers in group GRP.
c     Khaidukov Yu. 26.04.2003 & L. Deak, 09.10.2002                *** 
       GRP         =0
       GEOSTR(GRP) =0
       MAXGRP      =0
C       
	 b_first     =.true.
       POINTER=1
       do Kh=2,2*lay,2
        if(b_first)then
         if(GRP.eq.laystr(Kh))then
          GEOSTR(2*GRP)   =GEOSTR(2*GRP)+1
         else
          POINTER         =POINTER+GEOSTR(2*GRP)
          GRP             =GRP+1
          MAXGRP          =GRP
          GEOSTR(2*GRP)   =1
          GEOSTR(2*GRP-1) =laystr(Kh-1)
         end if
C
C    
          if(thicklayer(Kh/2).lt.0.) then
           b_first         =.false.
          thicklayer(Kh/2)      =1.e30
          GEOSTR(2*GRP-1) =1
         end if ! VKD < 0
        end if  ! b_first
       end do
C      ******************************************************************

       k_wave=2.0*pi/lambda
       theta_inc=theta1/1000.
       d_theta1=dtheta1/1000.0
       d_theta2=dtheta2/1000.0
       SQz=2.0*k_wave*sin(theta_inc)
       
       call n_optics(maxfr2,lay,b_Beff,MAXGRP,GEOSTR,SQz,Hext_z,
     &              K_mag_lay,thicklayer,roughlayer,b_up,b_down,Rmatrix)

       call n_depth(maxn,maxfr2,lay,b_Beff,MAXGRP,GEOSTR,SQz,K_mag_lay,
     &                  thicklayer,roughlayer,Rmatrix,Incmatrix)


       dd(1)=Rmatrix(1,1)
       dd(3)=Rmatrix(1,2)
       dd(2)=Rmatrix(2,1)
       dd(4)=Rmatrix(2,2)
c      trace (dd+*dd*rho) is the intensity
c      bb=cc+
       bb(1)=conjg(dd(1))
       bb(4)=conjg(dd(4))
       bb(2)=conjg(dd(3))
       bb(3)=conjg(dd(2))
       call matprof(dd,rho_b,aa)
       call matprof(aa,bb,dd)
       if(b_analyser) then
        call matprof(aa,rho_a,bb)
        h1=real(bb(1)+bb(4))
       else
        h1=real(dd(1)+dd(4))
       end if
       I_specular=h1
       
c      if(b_scatterer) then
       do nchtheta2=1,nch_theta2
        theta2_scat=(theta2_beg+rd_theta2*(nchtheta2-1))/1000.0
c       write(6,'(a,i3,a,f10.5)') 
c      &'neutronoffspecular nchtheta2=',nchtheta2,theta2_scat
c       subroutine  n_optics(maxl,NL,b_Cm,MAXGRP,GEOSTR,SQ,Hextz,Cmatrix,
c     &                              VKD,roughlay,b_up,b_down,Rmatrix)

        call n_diffuseRough(maxn,maxfr2,lay,b_Beff,MAXGRP,GEOSTR,
     &       theta_inc,theta2_scat,k_wave,K_mag_lay,thicklayer,
     &       roughlayer,Hext_z,xi,Ao,DWBA,
     &       Dper,Dgrp,Incmatrix,Difmatrix,b_up,Imatrix)

c         call n_diffuse(maxfr2,lay,b_Beff,MAXGRP,GEOSTR, K_mag_lay,
c     &        thicklayer,roughlayer,theta_inc,theta2_scat,
c     &                    b_up,Rmatrix,
c     &                 b_domain,k_wave,DWBA,xi,Imatrix)     
     
         
C        call n_optics(maxfr2,lay,b_Beff,laystr,theta2_scat,Hext_z,
C     &              K_mag_lay,thicklayer,roughlayer,b_up,b_down,Rmatrix)

        nn=nstorRM+(nchtheta2-1)*4
        array_fr(nn+1)=Imatrix(1,1)
        array_fr(nn+3)=Imatrix(1,2)
        array_fr(nn+2)=Imatrix(2,1)
        array_fr(nn+4)=Imatrix(2,2)
c       write(6,'(8g15.5)') Imatrix(1,1),Imatrix(2,2)
       end do  ! loop over theta2_values   
c      end if
c      write(6,'(a)')' neutronoffspecular do nchtheta2=1,nch_theta2'
      sum_spec=0.0
      sum_off=0.0
      do nchtheta2=1,nch_theta2
        theta2_scat=(theta2_beg+rd_theta2*(nchtheta2-1))/1000.0
       nn=nstorRM+4*(nchtheta2-1)
       do i=1,4
        dd(i)=array_fr(nn+i)
       end do
       call matprof(dd,rho_b,aa)
       if(b_analyser) then
        call matprof(aa,rho_a,bb)
        h1=real(bb(1)+bb(4))
       else
        h1=real(aa(1)+aa(4)) 
       end if
       h2=exp(-(theta2_scat-theta_inc)**2/(2.0*d_theta1**2))
       chspecular(nchtheta2)=h2
       sum_spec=sum_spec+h2
       choffspecular(nchtheta2)=h1
       sum_off=sum_off+h1
      end do  ! loop over theta2_values

      sum_spec=sum_spec/I_specular
      sum_off=sum_off/I_specular
      do nchtheta2=1,nch_theta2
       chspecular(nchtheta2)= chspecular(nchtheta2)/sum_spec
       choffspecular(nchtheta2)=choffspecular(nchtheta2)/sum_off
      end do
      
      
      do nchtheta2=1,nch_theta2
       choffspecular(nchtheta2)=
     & choffspecular(nchtheta2)*fr_offspec+chspecular(nchtheta2)
      end do

c      write(6,'(8g14.5)') (choffspecular(i),i=1,nch_theta2,4)
c--------------------------------------------------------

c      call integration(theta2_beg,theta2_end,nch_theta2,choffspecular,
c     &      choffspecular2,iaver_points,d_theta1,d_theta2,dlambda)

c      write(6,'(8g14.5)') (choffspecular(i),i=1,nch_theta2,4)
c      sum=0.
c      do nchtheta2=1,nch_theta2
c       sum=sum+choffspecular(nchtheta2)
c      end do

      nyout=nch_theta2/2
      do i=1,nyout
c       array_fr(nstorTH+i)=cmplx(choffspecular(i),choffspecular(nyout+i))/sum
      array_fr(nstorTH+i)=cmplx(choffspecular(i),choffspecular(nyout+i))
      end do
c      write(6,'(8g12.5)' ) (choffspecular(i),i=1,nch_theta2)
c     write(6,'(a)')' end of neutronoffspecularing'
      
c     end of calculation of absorber function
 1000 continue
      return
      end
C************************************************************************************************
      
      









