      subroutine thstr_synstrob(l_jth,cmch,property)

c     case time domain spectrum,
c          time integral - rocking curve
c          prompt - rocking curve
c     for  Synchrotron reflection

      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'

      character property*132,chth*8,cmch*4
      logical b_return

      chth='th'//property(1:6)


      if(enwr(14)(1:1).eq.'y') write(nwr,'(2(a,a8),a,i2,a,/,a)')
     & ' cmch=',cmch,' thstruct:',chth,' l_jth=',l_jth,
     & ' subr= thstr_synreflection  nameth_as=',nameth_as(:40)

      b_return=cmch.eq.'name'
      if(b_return)
     & property='Mossbauer synchrotron stroboscopy (distribute)'
      if(cmch.eq.'prop') then
       if(l_jth.eq.1)
     & property='prop=nocall       nono,0   nc_v_a_the=0,0,0'
       if(l_jth.eq.2)
     & property='prop=nocall       nono,0   nc_v_a_the=0,0,0'
      end if

c     name of this routine
      mthchild=2
      nameth(1)='Stroboscopy in transmission'
      nameth(2)='Stroboscopy in reflection'      
      nameth(3)=' '
      if(b_return) return

      if(l_jth.eq.0) then
c      asking for the number (mthchild) of theories fitting to ntheory
       mthparent=1     ! <=(max_nth
       ntheory(1)='Mossbauer synchrotron stroboscopy'
       do k= 1,mthparent
         if(nameth_as.eq.ntheory(k)) l_jth=mthchild
       end do
       return
      end if
      return
      end

      subroutine thstr_synstrobtrans(l_jth,cmch,property)
c     time domain spectrum for synchrotron transmission
c     level 0 theory

      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'

      character ch132*132,property*132,chth*8,cmch*4
      logical b_return

      chth='th'//property(1:6)

      if(enwr(14)(1:1).eq.'y') write(nwr,'(2(a,a8),a,i2,a,/,a)')
     & ' cmch=',cmch,' thstruct:',chth,' l_jth=',l_jth,
     & ' subr= thstr_synstrobtrans  nameth_as=',nameth_as(:40)

      b_return=cmch.eq.'name'
      if(b_return)
     & property='stroboscopic transmission'                             !name
      if(cmch.eq.'prop') then
       property='prop=nocall       nono,0   nc_v_a_the=13,0,0 '
       b_return=.true.
      end if

c     name of this routine
      mthchild=1
      nameth(1)='stroboscopic transmission spectrum'
      nameth(2)=' '
      if(b_return) return

      if(l_jth.eq.0) then
c      asking for the number (mthchild) of theories fitting to ntheory
       mthparent=1     ! <=max_nth
       ntheory(1)='Stroboscopy in transmission'
       do k= 1,mthparent
        if(nameth_as.eq.ntheory(k)) l_jth=mthchild
       end do
       return
      end if

      if(cmch.eq.'hdbk') then
       nstruct='handbook=nucleus.hdb '//
     &        'list=1  seq=2 chth='//chth
       return
      end if


      if(cmch.eq.'copa') then
c--------------------------------------------------------------------------
c       common/acstrf/acsp,
c                     wavelength,uthick_w,                           2
c      &              dum,unitchi,channels,v_range,
c      &              th_channels,th_sampling,drive_mode,channels_vmax,
c      &              Tbunch,flag_basis
c                     nStrobo,t1_window,t2_window 

c      uthick_A,unitchi are not used

       k=1
       do while(strco(k)(:5).ne.'#beg#')
        k=k+1
       end do
       j=k-1
c      write(6,'(a,4i4)') 'frtheory  j=',j
       jb=j+1
c-------------------------------------------------------
c           no ask (y)
c      #    ask [n]
c      #y   ask [y]
c      #i   intensity parameter no ask (y)
c      double ## := from data file
c      ##   from data file, ask [n]
c      ##y  from data file, ask [y]
c      ##n  from data file, no ask (y)
c--------------------------------------------------------
c                name                    pos  default
       strco(j+1)='th_channels             5     64'
                   ! velocity range of sample spectrum
       strco(j+2)='n_sampling              6     3 '
                   ! velocity range of sample spectrum
    
       strco(j+3)='v_range                 4     6.00 '
                   ! velocity range of sample spectrum
    
       strco(j+4)='nu_channels             3    ##n 512 '
                 ! channel number of the spectrum
       strco(j+5)='channels_vmax           8    ##y 128  '
                 ! period of the drive unit
       strco(j+6)='drive_mode              7    ##y 1 '
                 ! 1 triangular 
                 ! 2 sinus
                 ! determines function for channel to velocity scale
       strco(j+7)='T_bunch                 9    ##y 176 '
       strco(j+8)='flag_basis              10     1 '
                 ! switch for circular-linear basis 
       strco(j+9)='flag_phase              11    0 '
                 ! switch for normal(0), real part(1), imaginary part(-1) 
           j=j+9
       strco(j+1)='#end#  11   seq1'
       strco(j+2)='#beg#'
       do k=jb,j
        ch132=strco(k)
        call stringlength(ch132,l)
        strco(k)=ch132(:l)//'/'//chth
c        write(6,'(a)') strco(k)(:80)
       end do
    
      end if
      return
      end

      subroutine thstr_synstrobrefl(l_jth,cmch,property)


      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'

      character ch132*132,property*132,chth*8,cmch*4
      logical b_return

      chth='th'//property(1:6)


      if(enwr(14)(1:1).eq.'y') write(nwr,'(2(a,a8),a,i2,a,/,a)')
     & ' cmch=',cmch,' thstruct:',chth,' l_jth=',l_jth,
     & ' subr= thstr_synreflection  nameth_as=',nameth_as(:40)

      b_return=cmch.eq.'name'
      if(b_return)
     & property='stroboscopic reflection'                  !name
      if(cmch.eq.'prop') then
       if(l_jth.eq.1) 
     & property='prop=nocall       nono,0   nc_v_a_the=13,1,0'
       b_return=.true.
      end if

c     name of this routine
      mthchild=1
      nameth(1)='stroboscopic reflection spectrum'
      nameth(2)=' '
      if(b_return) return

      if(l_jth.eq.0) then
c      asking for the number (mthchild) of theories fitting to ntheory
       mthparent=1     ! <=(max_nth
       ntheory(1)='Stroboscopy in reflection'
       do k= 1,mthparent
         if(nameth_as.eq.ntheory(k)) l_jth=mthchild
       end do
       return
      end if

      if(cmch.eq.'hdbk') then
       nstruct='handbook=nucleus.hdb '//
     &        'list=1,2  seq=2 chth='//chth
       return
      end if 

      if(cmch.eq.'copa') then

c--------------------------------------------------------------------------
c       common/acstrf/acsp,wavelength,uthick_w,uthick_A,               ! hdb
c      &              unitchi,channels,v_range,
c      &              th_channels,th_sampling,drive_mode,channels_vmax,
c      &              Tbunch,flag_basis,flag_phase                       10
c                     nstrob_order

       k=1
       do while(strco(k)(:5).ne.'#beg#')
        k=k+1
       end do
       j=k-1
c      write(6,'(a,4i4)') 'frtheory  j=',j
       jb=j+1
c-------------------------------------------------------
c      #    ask [n]
c      ##   from data file, ask [n]
c      ## y from data file, ask [y]
c      ##n  from data file, no ask
c--------------------------------------------------------
c                 name                    pos  default
       strco(j+1)='th_channels             4     64'
                   ! velocity range of sample spectrum
       strco(j+2)='n_sampling              5     3 '
                   ! velocity range of sample spectrum
        
       strco(j+3)='v_range                 3     10.00 '
                   ! velocity range of sample spectrum
        
       strco(j+4)='nu_channels             2    ##n 512 '
                 ! channel number of the spectrum
       strco(j+5)='channels_vmax           7    ## y  128  '
                 ! period of the drive unit
       strco(j+6)='drive_mode              6    ## y 1 '
                 ! 1 triangular 
                 ! 2 sinus
                 ! determines function for channel to velocity scale
       strco(j+7)='T_bunch                 8    ## y 176 '
        
       strco(j+8)='unit_chi                1     1.0e-6 '
                 ! susceptibility multiplied by
       strco(j+9)='flag_basis              9     1 '
                 ! switch for circular-linear basis 
       strco(j+10)='flag_phase              10    0 '
                 ! switch for normal(0), real part(1), imaginary part(-1) 
       j=j+10
       strco(j+1)='#end#  10   seq1'
       strco(j+2)='#beg#'
       do k=jb,j
        ch132=strco(k)
        call stringlength(ch132,l)
        strco(k)=ch132(:l)//'/'//chth
c        write(6,'(a)') strco(k)(:80)
       end do


       k=1
       do while(strtm(k,1)(:5).ne.'#beg#')
        k=k+1
       end do
       jm=k-1
       jmb=k
       k=1
       do while(strth(k,1)(:5).ne.' ')
        k=k+1
       end do
       jh=k-1

       strtm(jm+1,1)='orientation                ## y 1 1'
       strtm(jm+1,2)='(1) grazing angle of the scatterer'
       strth(jh+1,1)='graz_angle        , 5.0 0.0 0.0   1.0'
       strth(jh+1,2)='graz_angle              1    1  '
       jm=jm+1

       strtm(jm+1,1)='#end#  1 '
       strtm(jm+2,1)='#beg#'
 
       do k=jmb,jm
        ch132=strtm(k,1)
        call stringlength(ch132,l)
        strtm(k,1)=ch132(:l)//'/'//chth
       end do


      end if
      return
      end

      subroutine thstr_strobwindow(l_jth,cmch,property)

      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'
 
      character ch132*132,property*132,chth*8,cmch*4
      logical b_return

      chth='th'//property(1:6)


      if(enwr(14)(1:1).eq.'y') write(nwr,'(2(a,a8),a,i2,a,/,a)')
     & ' cmch=',cmch,' thstruct:',chth,' l_jth=',l_jth,
     & ' subr= thstr_strobwindow  nameth_as=',nameth_as(:40)

      b_return=cmch.eq.'name'
      if(b_return) 
     & property='rectangular time windows'                               !name
      if(cmch.eq.'prop') then
       if(l_jth.eq.1) then
        property=
     &  'prop=rectangular_time_windows  nono,1   nc_v_a_the=3,0,t'
       else if(l_jth.eq.2)then
        property=
     &  'prop=rectangular_time_windows  nono,2   nc_v_a_the=7,0,t'
       end if
       b_return=.true.
      end if

c     names of this routine
      mthchild=2    ! <=max_nth
      nameth(1)='one rectangular time window'
      nameth(2)='two rectangular time windows'
      nameth(3)=' '
      if(b_return) return

      if(l_jth.eq.0) then
c      asking for the number (mthchild) of theories fitting to ntheory
       mthparent=4     ! <=max_nth
       ntheory(1)='stroboscopic transmission spectrum_0'
       ntheory(2)='stroboscopic reflection spectrum_0'
       ntheory(3)='time integral - rocking curve_0'
       ntheory(4)='time integral - rocking curve_fi_0'
       do k= 1,mthparent
        if(nameth_as.eq.ntheory(k)) l_jth=mthchild
       end do
       return
      end if


      if(cmch.ne.'copa') return
      i0=ichar('0')
      chth='th170'//char(l_jth+i0)//'  '

      k=1
      do while(strco(k)(:5).ne.'#beg#')
       k=k+1
      end do
      jb=k
      jc=k-1
     
      if(l_jth.eq.1) then
c                   standard time window
       strco(jc+1)='t1_window               2     0.25'
       strco(jc+2)='t2_window               3     0.75'
       strco(jc+3)='n_strob_order           1      10'
       strco(jc+4)='#end#     3  seq'
       strco(jc+5)='#beg#'
       je=jc+3 
      end if
      if(l_jth.eq.2) then
c                  double window with arbitrary amplitudes
       strco(jc+1)='t1_window               2     0.25'
       strco(jc+2)='t2_window               3     0.45'
       strco(jc+3)='amplitude_t12           4     1.0'
       strco(jc+4)='t3_window               5     0.55'
       strco(jc+5)='t4_window               6     0.75'
       strco(jc+6)='amplitude_t34           7     1.0'
       strco(jc+7)='n_strob_order           1      10'
       strco(jc+8)='#end#     7  seq'
       strco(jc+9)='#beg#'
       je=jc+7 
      end if

      do k=jb,je
       ch132=strco(k)
       call stringlength(ch132,l)
       strco(k)=ch132(:l)//'/'//chth
      end do

      return
      end

