c     ## effi defined quantities ##
c     ifrcase,ifrsubcase determines the branch of theory
c     ifrsto is used to communicate the storage requirement defined in 
c     frtheoryxx to communicate to effi
c     iarray_sp,nstorFR are an address and storage used by effi
c     the complex array: array_fr stores results of theories handled
c     by the user according a list of pointers
c     (array_fr is also handled by effi to provide the aktuell set)
      character theoryname*72,thfrcase*72
      integer iarray_sp,nstorFR,ifrcase,lstr1case,ifrsto
      common/thpt/iarray_sp,nstorFR,ifrcase,lstr1case,ifrsto,theoryname,
     &            thfrcase(8)
      complex array_fr
      common/store/array_fr(marray_sp)      
      real real_fr(2*marray_sp)
      equivalence (array_fr(1),real_fr(1))

c     ## user defined quantities ##
c     mLG and mGa determine the array size of Lorentz curves (convolution 
c     with a Gaussian distribution) needed in frame and theories       

      integer mGa,mLG
      parameter (mGa=maxn/2,mLG=6*maxn)

