c     author : h. spiering
c              Am Damsberg 86
c              D-55130 Mainz
c              last version september 2004
      
      subroutine fr_neutron(cmch,iss,info)
      implicit none
      include 'comglb.for' 
      include 'compar.for'
      include 'comdat.for'
      include 'comdas.for'
      include 'complt.for'
      include 'comthe.for'
      
      integer     iss,info,mstruct1,istruct1,istruct2,
     &            l1_get,l2_get,l3_get,l1_put,l2_put,l3_put,
     &            nstorTH,nstorRM,nstorTHyy,istorTH,idum
      character*4 cmch,c1_prp,c2_prp,c3_prp,cfill,frthname*64
      common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),
     &              l1_get(0:maxfr1),l2_get(maxfr2),l3_get(maxthss),
     &              l1_put(0:maxfr1),l2_put(maxfr2),l3_put(maxthss),
     &              c1_prp(0:maxfr1),c2_prp(maxfr2),c3_prp(maxthss),
     &              frthname(2),nstorTH,nstorRM,nstorTHyy,idum(5),
     &              istorTH,cfill(23)

      real          acsp,dwba,channels,scale,unit_sclB,unit_sclN,
     &              v_ch,v_beg,v_end,dumcsp
      common/acstrf/acsp,dwba,channels,scale,unit_sclB,unit_sclN,
     &              v_ch,v_beg,v_end,dumcsp(icstrf-9)
      real          avsp,aintensity,background,Pxsi_b,Peta_b,Pzeta_b,
     &              Pxsi_a,Peta_a,Pzeta_a,v_shift,dumvsp
      common/avstrf/avsp,aintensity,background,Pxsi_b,Peta_b,Pzeta_b,
     &              Pxsi_a,Peta_a,Pzeta_a,v_shift,dumvsp(ivstrf-10)
      logical       b_avsp,b_aintensity,b_background,
     &              b_Pxsi_b,b_Peta_b,b_Pzeta_b,
     &              b_Pxsi_a,b_Peta_a,b_Pzeta_a,b_v_shift,b_dumvsp
      common/bvstrf/b_avsp,b_aintensity,b_background,
     &              b_Pxsi_b,b_Peta_b,b_Pzeta_b,
     &              b_Pxsi_a,b_Peta_a,b_Pzeta_a,
     &              b_v_shift,b_dumvsp(ivstrf-10)
      
      
      integer nchansp,k1,k2,i,mscale
c*****************************************************************************
c
      if(cmch.eq.'thna') then
       theoryname= 'Neutron source'
       thfrcase(1)='Neutron rocking curve(11)'
       thfrcase(2)='Neutron offspecular (smooth)(21)'
       thfrcase(3)='Neutron offspecular (roughness)(22)'
       thfrcase(4)=' '
       return
      end if  
      if(cmch.eq.'dstr') goto 100               
c*****************************************************************************

      nchansp=channels  ! number of experimental data
      
      if(cmch.eq.'arr0') then      
        nstorTH=nuofdatas
c       nstorFR    is now added inside EFFI
c       the pointer information (nstorFR numbers, strings)
c       about the theory ist stored in array_fr. The absolute address of the 
c       set is added by effi entering the set for the first time.
c       The 8 interger numbers (here) nstorTH,nstorRM,nstorTHyy,idum(5)
c       appear to be chaned by effi calling commands like pl,te,ft,...
c       (8 is the maximum number of pointers which can be precalculated 
c        setting up the theory)
        do i=1,5
         idum(i)=0
        end do       
c       The dummies idum will have the value of the absolute address of the set

        istorTH=int(v_ch/4.)*2              

c       2*istorTH is the number of theoretical values (real)
c       to be stored in array_fr (complex) at nstorTH+1,nstorTH+2, ... 
c       8*istorTH is the number of Rmatrix values (complex)
c       to be stored in array_fr (complex) at nstorRM+1, ... 

        nstorRM=nstorTH+istorTH             
        nstorTHyy=nstorRM+8*istorTH
c       nchansp/2 is number of theoretical values (real) calculated at the
c       experimental channel points to be stored n array_fr (complex)
c       at nstorTHyy+1, ...

        ifrsto=istorTH+8*istorTH+nchansp/2
c       ifrsto is the total number of complex values requested by the 
c       frame of the theory with the subroutines: 
c       fr_neutronrock,neutronglobal,plotneutron,neutronrock   

c      write(6,'(a,4i5)')'nstorTH,nstorRM,nstorTHyy=',
c     &                   nstorTH,nstorRM,nstorTHyy
       return
      else if(cmch.eq.'arri') then 
       ifrsto=0
       return   
      else if(cmch.eq.'arre') then
       ifrsto=0
       return
      end if
       mscale=int(scale)     
c      write(6,'(a,4i5)')'nstorTH,nstorRM,nstorTHyy=',
c     &                   nstorTH,nstorRM,nstorTHyy

c      storag on real_fr(2*(iarraysp+nstorFR)+m) (array_f) 
c      corresponds to the i= drive_mode (label 100) 
       mfpt=2*(iarray_sp+nstorFR)  ! y data
       mdfpt=mfpt+nchansp         ! errors of y data (calculated by sqrt 
       mxpt=mfpt+2*nchansp        ! x data (angle) drive_mode=3



c*****************************************************************************
      if(cmch.eq.'data') then
       k1=1
      else if(cmch.eq.'ecic') then
       k1=2
      else if(cmch.eq.'test') then
       k1=3
      else if(cmch.eq.'dfdp') then
       k1=4
      else if(cmch.eq.'subs'.or.cmch.eq.'subt') then
       k1=5
      else if(cmch(1:3).eq.'ple') then
       k1=6
      else if(cmch.eq.'dmod'.or.cmch.eq.'plot') then
       k1=7
      else if(cmch.eq.'punc')then
       k1=8
      end if
      
      goto (110,120,200,300,400,500,600,700),k1
c**********************************************************************
 100  continue
c     k1 > 0 input unit (file is opened in main program)
      mscale=int(scale) 
      if(mscale.lt.1.or.mscale.gt.2) mscale=1  
      if(mscale.le.1) data_str='y,dy'
      if(mscale.ge.2) data_str='y,dy,x'
      call data2dread(0,info)
      return
 110  continue
      k1=iss
      call data2dread(k1,info)   
      return
 120  call excinc2d(info)
      return
c************************************************************************
c     'test': theory function is calculated ...
      
  200 continue
      k1=1
      call neutronglobal(k1,info)
      return
c************************************************************************
c     derivatives df
  300 continue
      k1=2

      call neutronglobal(k1,info)
      return
c**********************************************************************
c     subs, subt
  400 continue
      info=1
      infotext(1)='effi/structure/neutron/subspectra' 
      infotext(2)='subspectra command has no meaning'
      infotext(3)=' '
      return
c*************************************************************
c  call of subtract
 450  continue
      print *,' '
      print *,'          subtraction of subspectra'
      print *,'      has no meaning in the time domain'
      return
c**************************************************************************
c     plot execute
c     different plot programs may be called due to a flag constant 
c     to be introduced as global constant
  500 continue
       
       k1=0
       if(b_theory) k1=1
       if(cmch(4:4).eq.'2') k1=2   ! update test
       if(cmch(4:4).eq.'3') k1=3   ! update fit

       k2=1  ! 0: only 1 plot and return, 1: interactive plot
       call xmosplo(k1,k2)

       return
c**************************************************************************
c     display mode , filling of plotarray
 600  continue
      if(cmch.eq.'dmod') then
       call plotneutron(cmch)
      else  ! cmch='plot'
       if(b_theory) then
        k1=1
        call neutronglobal(k1,info)
       end if
       call plotneutron(cmch)
      end if
      return      
c**************************************************************************
c     punch data and theory
 700  continue
       k1=iss
       call punch2d(k1,info)
      return

      end
      
      
      
      subroutine neutronglobal(n1,info)
c *****************************************************************
c     n1 = 1 call of theory
c     n1 = 2 derivatives
c     n1 = 3 call of theory , calpl is not called
c *****************************************************************
      implicit none      
      include 'comglb.for'
      include 'comdat.for'
      include 'comthe.for'
      include 'complt.for'      
      
      integer     n1,info,idumst,ndumst,idum,
     &            nstorTH,nstorRM,nstorTHyy,istorTH
      character*4 cfill,frthname*64
      parameter(idumst=6+4*(maxfr1+maxfr2)+3*maxthss)
      common/struct/ndumst(idumst),frthname(2),
     &              nstorTH,nstorRM,nstorTHyy,idum(5),istorTH,cfill(23)

      real          acsp,dwba,channels,scale,unit_sclB,unit_sclN,
     &              v_ch,v_beg,v_end,dumcsp
      common/acstrf/acsp,dwba,channels,scale,unit_sclB,unit_sclN,
     &              v_ch,v_beg,v_end,dumcsp(icstrf-9)
      real          avsp,aintensity,background,Pxsi_b,Peta_b,Pzeta_b,
     &              Pxsi_a,Peta_a,Pzeta_a,v_shift,dumvsp
      common/avstrf/avsp,aintensity,background,Pxsi_b,Peta_b,Pzeta_b,
     &              Pxsi_a,Peta_a,Pzeta_a,v_shift,dumvsp(ivstrf-10)
      logical       b_avsp,b_aintensity,b_background,
     &              b_Pxsi_b,b_Peta_b,b_Pzeta_b,
     &              b_Pxsi_a,b_Peta_a,b_Pzeta_a,b_v_shift,b_dumvsp
      common/bvstrf/b_avsp,b_aintensity,b_background,
     &              b_Pxsi_b,b_Peta_b,b_Pzeta_b,
     &              b_Pxsi_a,b_Peta_a,b_Pzeta_a,
     &              b_v_shift,b_dumvsp(ivstrf-10)
      
      
      logical b_total,b_residual

      integer   ib_df,kana,ibmisfit
      real      thfk,dfdp,ddpk,yth
      common/fr2fi/thfk(max8),dfdp(max8),ddpk,ib_df,kana,ibmisfit
      dimension yth(-maxn:2*maxn)


      real x_exp,aintensityy,dx_the,dx_exp,xb_the,xb_exp,
     &     ff,hi
      common/ascale/x_exp(maxn)
      integer nexp,nexp2,nthe,nthe2,mscale,invers,jshift,k1,j,k,i,ji,
     &        nTHyy2,nstorTH2

c      aintensityy=aintensity-background*channels
      aintensityy=aintensity
      ibmisfit=0
c      integral 0-inf is normalized to 1
      nexp=channels
      nexp2=nexp/2
      nthe=istorTH*2
      nthe2=istorTH
      nTHyy2=2*nstorTHyy
      nstorTH2=nstorTH*2

c      aintensityy=aintensityy/channels*istorTH
      mscale=scale
      dx_the=abs(v_end-v_beg)/(v_ch-1.0)
      dx_exp=abs(v_end-v_beg)/(channels-1.0)
      xb_the=v_beg+v_shift
      xb_exp=v_beg
      invers=0
      if(dx_the.lt.0) then
       invers=nexp+1
       dx_the=-dx_the
      end if
c     warning** xb_exp is not correct if x-data are read from file
c     it is correct after calling x_scale()
      jshift=abs(xb_the/dx_the)+1

      if(ifrcase.eq.11) call neutronrock(b_total,info)
      if(ifrcase.eq.21) call neutronoffspecular(b_total,info)
      if(ifrcase.eq.22) call neutronOffspecRough(b_total,info)

c      write(6,'(a,L5,4i6)') 'neutronrock b_total=', b_total
      k1=n1
      goto (100,200,300),k1
      
      
 100  continue
c     calculation of thfk
     
      if(b_total.or.b_aintensity.or.b_background)then
       do j =1,nthe2
        yth(j)=real(array_fr(nstorTH+j))
        yth(j+nthe2)=aimag(array_fr(nstorTH+j))
       end do

       do k=0,jshift
        yth(-k)=yth(1)
        yth(nthe+k+1)=yth(nthe)
       end do

       call x_scale(mscale,nexp,dx_exp,xb_exp)
c       write(6,'(8g12.5)') (x_exp(i),i=1,nexp,4)      

       do j=1,nexp
        ji=abs(invers-j)
        hi=(x_exp(ji)-xb_the)/dx_the
        i=int(hi)
        if(i.le.0)i=i-1
        hi=hi-float(i)
        ff=yth(i+1)+hi*(yth(i+2)-yth(i+1))
        thfk(j)=ff*aintensityy+background
       end do
       do j=1,nexp
        real_fr(nTHyy2+j)=thfk(j)
       end do
      else
       do j=1,nexp
         thfk(j)=real_fr(nTHyy2+j)
       end do
      end if
      b_theory=.true.
      return
      
 200  continue
      ib_df=0

c     variable background
      if(b_background) then
       b_residual=b_total.or.b_aintensity
       if(.not.b_residual) then
c       write(6,'(a)')  '   derivative of background ------------'
        do j=1,nexp
         dfdp(j)=1.0
        end do
        kana=1
        ib_df=1
        goto 250
       end if
      end if
      
      do j=1,nexp
       thfk(j)=real_fr(nTHyy2+j)
      end do
c     variable aintensity
      if(b_aintensity) then
       b_residual=b_total.or.b_background
       if(.not.b_residual) then
c       write(6,'(a)')  '   derivative of aintensity ------------'
        do j=1,nexp
         dfdp(j)=(thfk(j)-background)/aintensityy
        end do
        kana=1
        ib_df=1
        goto 250
       end if
      end if
      
      
      call x_scale(mscale,nexp,dx_exp,xb_exp)
      kana=0
      b_residual=b_total.or.b_aintensity.or.b_background
      if(.not.b_residual) then
       do j =1,nthe
        yth(j)=real_fr(nstorTH2+j)
       end do
       do k=0,jshift
        yth(-k)=yth(1)
        yth(nthe+k)=yth(nthe)
       end do
       do j=1,nexp
        ji=abs(invers-j)
        hi=(x_exp(ji)-xb_the)/dx_the
        i=int(hi)
        if(i.le.0)i=i-1
        hi=hi-float(i)
        ff=yth(i+1)+hi*(yth(i+2)-yth(i+1))
        dfdp(j)=(ff*aintensityy+background-thfk(j))/ddpk
       end do   ! j=1,nexp
       ib_df=1
       goto 250
      end if
      
      kana=0
      if(ifrcase.eq.11) call neutronrock(b_total,info)
      if(ifrcase.eq.21) call neutronoffspecular(b_total,info)
      if(ifrcase.eq.22) call neutronOffspecRough(b_total,info)
     
      do j =1,nthe
       yth(j)=real_fr(nstorTH2+j)
      end do

      do k=0,jshift
       yth(-k)=yth(1)
       yth(nthe+k)=yth(nthe)
      end do
     
      do j=1,nexp
       ji=abs(invers-j)
       hi=(x_exp(ji)-xb_the)/dx_the
       i=int(hi)
       if(i.le.0)i=i-1
       hi=hi-float(i)
       ff=yth(i+1)+hi*(yth(i+2)-yth(i+1))
       dfdp(j)=(ff*aintensityy-thfk(j)+background)/ddpk
      end do   ! j=1,nexp
      ib_df=1
 250  continue
      return
      
 300  continue
c     calculation of thfk , not refreshing pl(j) by calpl
      if(.not.b_theory) goto 310 

      if(ifrcase.eq.11) call neutronrock(b_total,info)
      if(ifrcase.eq.21) call neutronoffspecular(b_total,info)
      if(ifrcase.eq.22) call neutronOffspecRough(b_total,info)
       call x_scale(mscale,nexp,dx_exp,xb_exp)

       do j =1,nthe
        yth(j)=real_fr(nstorTH2+j)
       end do
       do k=0,jshift
        yth(-k)=yth(1)
        yth(nthe+k+1)=yth(nthe)
       end do

      if(ndisplay_mode.gt.1) then      
       do j=1,nexp
        ji=abs(invers-j)
        hi=(x_exp(ji)-xb_the)/dx_the
        i=int(hi)
        if(i.le.0)i=i-1
        hi=hi-float(i)
        ff=yth(i+1)+hi*(yth(i+2)-yth(i+1))
        thfk(j)=ff*aintensityy+background
       end do
      else

       do j=1,nthe
        ji=abs(invers-j)
        thfk(j)=yth(ji)*aintensityy+background
       end do
      end if     
 310  return
      end
      
      subroutine plotneutron(cmch)
      implicit none      
      include 'comglb.for'
      include 'compar.for'
      include 'comdat.for'
      include 'complt.for'
      include 'comthe.for'      
      include 'comdas.for'  
  
      integer     idumst,ndumst,istorTH
      character*4 cfill,cmch
      parameter(idumst=46+4*(maxfr1+maxfr2)+3*maxthss)
      common/struct/ndumst(idumst),istorTH,cfill(23)

c v_plotstr.h defines the extern structure: 
c#define MAXSP 16
c#define MAXSUB 8
c#define MAXN   1024
c#define MAXSUBN (MAXSUB*MAXN*8)
c#define INFPLOT (MAXSUB+6)
c#define MDBPLFT (MAXN*72)

      integer      max8subn,n_subspectra,idumplot,logx,logy,logf,
     &             int3d,npnt3d,ifeder,ltext,npntplot,nchanplot,ncolor
      real         plotx,ploty,ploterry,plotres,plotxx,plotyy,plotsub,
     &             xyzdz,vtxt,vtxtp
      character*24 axesname,abscissa,ordinata,bgcolor,fgcolor,datacolor,
     &             thcolor,rescolor,auxcolor1,auxcolor2,auxcolor3,
     &             namechan*4,kform*8,chardum*4,axisformat*16,
     &             title*132,plotstrdef*80,plotstrpu*132
      parameter   (max8subn=maxsub*max8,
     &            idumplot=MDBPLFT*2-140*maxn-8*39-5*infplot-maxsub-168)
      common/plot/ plotx(max8),ploty(max8),ploterry(max8),plotres(max8),
     &             plotxx(max8),plotyy(max8),plotsub(max8subn),
     &             xyzdz(8),vtxt(2,maxn*4),vtxtp(8,32),
     &             int3d(maxn*16),npnt3d(16),ifeder(maxn*4),ltext(32),
     &             npntplot(infplot),nchanplot(infplot),ncolor(maxsub),
     &             n_subspectra,logx,logy,logf,
     &             namechan(infplot),kform(infplot),axisformat(3),
     &             axesname(3),title,plotstrdef,plotstrpu,
     &             bgcolor,fgcolor,datacolor,thcolor,rescolor,
     &             auxcolor1,auxcolor2,auxcolor3,chardum(idumplot)

      real          acsp,dwba,channels,scale,unit_sclB,unit_sclN,
     &              ch_v,v_beg,v_end,dumcsp
      common/acstrf/acsp,dwba,channels,scale,unit_sclB,unit_sclN,
     &              ch_v,v_beg,v_end,dumcsp(icstrf-9)
      real          avsp,aintensity,background,Pxsi_b,Peta_b,Pzeta_b,
     &              Pxsi_a,Peta_a,Pzeta_a,v_shift,dumvs
      common/avstrf/avsp,aintensity,background,Pxsi_b,Peta_b,Pzeta_b,
     &              Pxsi_a,Peta_a,Pzeta_a,v_shift,dumvs(ivstrf-10)
      

      integer   ib_df,kana,ibmisfit
      real      thfk,dfdp,ddpk
      common/fr2fi/thfk(max8),dfdp(max8),ddpk,ib_df,kana,ibmisfit

      integer     idumscrt
      logical     b_datf,b_12,b_34
      real        datx,errx,sym,subspectrum,daty,erry,dumsc
      parameter (idumscrt=maxscrt-6*maxn-maxn*maxsub)
      common/scrt/datx(maxn),errx(maxn),sym(maxn),
     &            subspectrum(maxn,maxsub),
     &            daty(maxn),erry(maxn),b_datf(maxn),dumsc(idumscrt)

      integer mscale,nexp,nthe,ii,i,k,j,ns,nyy,ny,nresidue
      real x_exp,dx_exp,xb_exp,dx_the,xb_the,h,x_multiplier,
     &     resmin,resmax,xmin,xmax,ymin,ymax,hd
      common/ascale/  x_exp(maxn)

      character       chsub*9
      logical         b_logx,b_logy
      character*1     chx,chbx,chlr,chy,chby,chbt
      character*80    CTEXT,CXTEXT,CYTEXT,frcolor*24,ch0*1 
      integer         nformx,nformy,i0
      real            chh,chw,syw,syh

      ch0=char(0)
      if(cmch.eq.'dmod') then
       namechan(1)='xd'
       namechan(2)='yd'
       namechan(3)='erry'
       namechan(4)='res'
       namechan(5)='xt'
       namechan(6)='yt'
       namechan(7)='su'
       namechan(8)='*'
       plotstrdef='(xd,yd,erry) (xt,yt)'
      
       display_mode(1)='q-scale ,log(count)'
       display_mode(2)='q-scale, residual aintensity'
       display_mode(3)='channel scale, aintensity'
       display_mode(4)='channel scale,residual aintensity'
       return
      end if
      
      b_logy=.false.
      b_logx=.false.     
      b_12=.false.
      b_34=.false.
      if(ndisplay_mode.gt.4) ndisplay_mode=4
      goto(1,2,3,4), ndisplay_mode
c      display_mode(1)='q scale, log(count)'
 1    continue
      b_12=.true.
      abscissa='Q[10^-2A^-1] .........'
      axisformat(1)='%6.2f '
      ordinata='log(count) '
      axisformat(2)='%6.2f '
      b_logy=.true.
      nformx=2
      nformy=2
      goto 5
c     display_mode(2)='q-scale, residual aintensity'
 2    continue
      b_12=.true.
      abscissa='Q[10-2A-1] .........'
      axisformat(1)='%6.2f '
      ordinata='log(intensity) '
      axisformat(2)='%6.2f '
      b_logy=.true.
      nformx=2
      nformy=2   
      goto 5
c     display_mode(3)='channel scale'
 3    b_34=.true.
      abscissa='channel '
      ordinata='intensity '
      axisformat(1)='%6.0f '
      axisformat(2)='%8.0f '
      nformx=0
      nformy=0   
      goto 5
c     display_mode(4)='-channel scale, residual aintensity'
 4    b_34=.true.
      abscissa='channel '
      ordinata='intensity '
      axisformat(1)='%6.0f '
      axisformat(2)='%8.0f '
      nformx=0
      nformy=0 
 5    continue
      

      if(b_12) then
       kform(1)='f7.2'
       kform(2)='f8.4'
       kform(3)='f8.6'
       kform(4)='f10.6'
       kform(5)='f7.2'
       kform(6)='f8.4'
       kform(7)='f8.4'
       nformy=2       
      end if
      if(b_34) then
       kform(1)='f6.0'
       kform(2)='f10.0'
       kform(3)='f8.1'
       kform(4)='f8.1'
       kform(5)='f6.0'
       kform(6)='f10.0'
       kform(7)='f10.0'
       nformy=0
      end if
      kform(8)=' '

      nexp=channels
      n_subspectra=n_subset

      bgcolor='LightYellow'//ch0
      fgcolor='black'//ch0
      datacolor=fgcolor
      thcolor=fgcolor
      rescolor='blue'//ch0
      do j=1,maxsub
       ncolor(j)=icolor_sub(j)
      end do
 
      axesname(1)=abscissa
      axesname(2)=ordinata
      axesname(3)=' '
      title=name_data
      if(.not.b_data) title=name_theory

      if(b_data) then
       do i=1,nexp
        daty(i)=real_fr(mfpt+i)
       end do
       do i=1,nexp
        erry(i)=real_fr(mdfpt+i)
       end do
      end if
      
      nresidue=0
      do ii=1,infplot
       nchanplot(ii)=0
      end do

c     if(b_theory) then
c      write(6,'(8g14.4)') (thfk(j),j=1,nexp,8)
c     else
c      write(6,'(8g15.4)') (daty(j),j=1,16)
c     end if
      mscale=scale
      if(ifrcase.eq.11) then
       x_multiplier=100.    
      else if(ifrcase.gt.20)then
       if(mscale.eq.1)then
        x_multiplier=1.    
       else
        x_multiplier=1000. 
       end if
      end if
      nthe=istorTH*2

      dx_the=abs(v_end-v_beg)/(ch_v-1.0)
      dx_exp=abs(v_end-v_beg)/(channels-1.0)
      xb_the=v_beg+v_shift
      xb_exp=v_beg

      nyy=0
      ny=0
      if(b_12) then
       call x_scale(mscale,nexp,dx_exp,xb_exp)

       if(b_data) then
        if(ndisplay_mode.eq.1)then
         do k=2,ichanks(0),2
          do j=ichanks(k-1),ichanks(k)
           ny=ny+1
           plotx(ny)=x_exp(j)
           h=abs(daty(j))
           if(h.lt.0.1) then
            ploty(ny)=0.
            ploterry(ny)=1.
            ny=ny-1
           else
            ploty(ny)=alog(h)
            ploterry(ny)=1./erry(j)
           end if
          end do
         end do
        else
         do k=2,ichanks(0),2
          do j=ichanks(k-1),ichanks(k)
           ny=ny+1
           plotx(ny)=x_exp(j)
           ploty(ny)=daty(j)
           ploterry(ny)=erry(j)
          end do
         end do
         if(b_theory)then
          nresidue=1
          ns=0
          do k=2,ichanks(0),2
           do j=ichanks(k-1),ichanks(k)
            ns=ns+1
            plotres(ns)=daty(j)-thfk(j)
           end do
          end do
         end if
        end if
       end if ! b_data


       if(b_theory) then

        if(ndisplay_mode.eq.1)then
         nyy=nthe
         do ii=1,nyy
          plotxx(ii)=xb_the+ (ii-1)*dx_the
          plotyy(ii)=alog(abs(thfk(ii)+0.1))
         end do
         if(n_subspectra.gt.0) then
          do j=1,n_subspectra
           ns=(j-1)*max8
           nchanplot(6+j)=nyy
           do ii=1,nyy
            ns=ns+1
            plotsub(ns)=alog(abs(subspectrum(ii,j)+0.1))
           end do
          end do
         end if
        else
         nyy=nexp
         do ii=1,nyy
          plotxx(ii)=x_exp(ii)
          plotyy(ii)=thfk(ii)
         end do
         if(n_subspectra.gt.0) then
          do j=1,n_subspectra
           ns=(j-1)*max8
           nchanplot(6+j)=nyy
           do ii=1,nyy
            ns=ns+1
            plotsub(ns)=subspectrum(ii,j)
           end do
          end do
         end if
        end if
       end if  ! b_theory
      end if ! log scale
      
      if(b_34) then
       call x_scale(mscale,nexp,dx_exp,xb_exp)
       if(b_data) then
        do k=2,ichanks(0),2
         do j=ichanks(k-1),ichanks(k)
          ny=ny+1
          plotx(ny)=j
          ploty(ny)=daty(j)
          ploterry(ny)=erry(j)
          if(daty(j).lt.0.1) ny=ny-1
         end do
        end do
        if(b_theory.and.ndisplay_mode.eq.4)then
         nresidue=1
         ns=0
         do k=2,ichanks(0),2
          do j=ichanks(k-1),ichanks(k)
           ns=ns+1
           plotres(ns)=daty(j)-thfk(j)
          end do
         end do
        end if
       end if ! b_data

       if(b_theory) then
        nyy=nexp
        do ii=1,nyy
         plotxx(ii)=x_exp(ii)
         plotyy(ii)=thfk(ii)
        end do
        if(n_subspectra.gt.0) then
         do j=1,n_subspectra
          ns=(j-1)*max8
          nchanplot(6+j)=nyy
          do i=1,nyy
            ns=ns+1
            plotsub(ns)=subspectrum(ii,j)
          end do
         end do
        end if
       end if  ! b_theory
      end if ! counts


      xmin=1.e30
      xmax=-xmin
      ymin=xmin
      ymax=-ymin                       ! counts > 0
      if(b_data) then
       do ii=1,3
        nchanplot(ii)=ny
       end do
       if(xmin.gt.plotx(1))xmin=plotx(1) 
       if(xmax.lt.plotx(ny))xmax=plotx(ny) 
       if(xmin.gt.plotx(ny))xmin=plotx(ny) 
       if(xmax.lt.plotx(1))xmax=plotx(1) 
       do i=1,ny
        if(ymin.gt.ploty(i)-ploterry(i))ymin=ploty(i)-ploterry(i)
       end do
       do i=1,ny
        if(ymax.lt.ploty(i)+ploterry(i))ymax=ploty(i)+ploterry(i)
       end do
      end if
      if(b_theory) then
       nchanplot(5)=nyy
       nchanplot(6)=nyy
       if(xmin.gt.plotxx(1))xmin=plotxx(1) 
       if(xmax.lt.plotxx(nyy))xmax=plotxx(nyy) 
       if(xmin.gt.plotxx(nyy))xmin=plotxx(nyy) 
       if(xmax.lt.plotxx(1))xmax=plotxx(1) 
       do i=1,nyy
        if(ymin.gt.plotyy(i))ymin=plotyy(i)
       end do
       do i=1,nyy
        if(ymax.lt.plotyy(i))ymax=plotyy(i)
       end do
      end if

      if(nresidue.eq.1) then
        nchanplot(4)=ny
        resmin=0.
        resmax=0.
        do i=1,ny
         hd= plotres(i)-ploterry(i)           
         if(resmin.gt.hd) resmin=hd
        end do
        do i=1,ny
         hd= plotres(i)+ploterry(i)           
         if(resmax.lt.hd) resmax=hd
        end do
         hd= resmax-2.0*resmin 
        do i=1,ny
         plotres(i)=plotres(i)+ymax-resmin
        end do
        ymax=ymax-resmin+resmax
      end if
       xyzdz(1)=xmin
       xyzdz(2)=xmax
       xyzdz(3)=ymin
       xyzdz(4)=ymax
c       write(6,'(a,4g12.6)')' min-max=',xmin,xmax,ymin,ymax

c      write(6,'(a,5i8)') 'nchanplot(ii)=',(nchanplot(ii),ii=1,6)
c      write(6,'(a,3i8)') 'plotx  nyy=',nyy
c      write(6,'(8g12.4)') (plotxx(ii),ii=1,nyy,8)
c      write(6,'(a,3i8)') 'plotyy  nyy=',nyy
c      write(6,'(8g12.4)') (ploty(ii),ii=1,nyy,8)
c      write(6,'(a,3i8)') 'ploterry ny=',ny
c      write(6,'(8g12.4)') (ploterry(ii),ii=1,ny,8)


       
c      definitions taken from allplo
       chx='b'                 ! (none,Both,bottom,top)  [B]
       chbx='n'                ! (none,bottom,top)  [n]
       chlr='l'                ! (left,right)  [r]
       chy='l'                 ! (none,Both,left,right)  [B]
       chby='l'                ! (none,left,right)  [r] 
       chbt='b'                ! (bottom,top)  [t]
       chh=0.3                 ! 
       chw=0.25                ! character cw,ch  [0.40,0.40]         
       syw=0.1                 !
       syh=0.1                 ! symbol sw,sh     [0.40,0.40]
       frcolor=fgcolor         ! color frame       [black]
       frcolor='blue'//ch0
       CTEXT=title
       CXTEXT=abscissa
       CYTEXT=ordinata
         
       call frame(chx,chbx,chlr,chy,chby,chbt,b_logx,b_logy,
     &            chh,chw,syw,syh,
     &          CTEXT,CXTEXT,CYTEXT,nformx,nformy,frcolor,bgcolor)
 
      
      return
      end
      
