      subroutine moss_plot(cmch)
      include 'comglb.for'
      include 'compar.for'
      include 'comdat.for'
      include 'comdas.for'
      include 'complt.for'
      include 'comthe.for'
      character    cmch*4

      integer      max8subn,n_subspectra,idumpl,logx,logy,logf,
     &             int3d,npnt3d,ifeder,ltext,npntplot,nchanplot,ncolor
      real         plotx,ploty,ploterry,plotres,plotxx,plotyy,plotsub,
     &             xyzdz,vtxt,vtxtp,parray
      character*24 axesname,abscissa,ordinata,bgcolor,fgcolor,datacolor,
     &             thcolor,rescolor,auxcolor1,auxcolor2,auxcolor3,
     &             namechan*4,kform*8,chardum*4,axisformat*16,
     &             title*132,datfile*80,plotstrdef*80,plotstrpu*132
      parameter   (max8subn=maxsub*max8,
     &            idumpl=MDBPLFT*2-140*maxn-8*39-5*infplot-maxsub-188)
      common/plot/parray(maxn*112),xyzdz(8),vtxt(2,maxn*4),vtxtp(8,32),
     &            int3d(maxn*16),npnt3d(16),ifeder(maxn*4),ltext(32),
     &            npntplot(infplot),nchanplot(infplot),ncolor(maxsub),
     &            n_subspectra,logx,logy,logf,
     &            namechan(infplot),kform(infplot),axisformat(3),
     &            axesname(3),title,plotstrdef,plotstrpu,
     &            bgcolor,fgcolor,datacolor,thcolor,rescolor,
     &            auxcolor1,auxcolor2,auxcolor3,datfile,chardum(idumpl)

      dimension   plotx(max8),ploty(max8),ploterry(max8),plotres(max8),
     &            plotxx(max8),plotyy(max8),plotsub(max8subn)
      equivalence (parray(1),plotx(1)),(parray(max8+1),ploty(1)),
     &            (parray(max8*2+1),ploterry(1)),
     &            (parray(max8*3+1),plotres(1)),
     &            (parray(max8*4+1),plotxx(1)),
     &            (parray(max8*5+1),plotyy(1)),
     &            (parray(max8*6+1),plotsub(1))
      common/acstrf/ dum1(5),
     &           channels,dum2(4),channels_vmax,dumcsp(icstrf-11)

      common/avstrf/avsp,f_factor,base,bg_fraction,v_max,channel_v0,
     &              dumvsp(ivstrf-6)

      integer   ib_df,kana,ibmisfit
      real      thfk,dfdp,ddpk
      common/fr2fi/thfk(max8),dfdp(max8),ddpk,ib_df,kana,ibmisfit

      logical b_vdarray,b_datf
      parameter (maxn0=maxn+2,maxnh=maxn/2,
     &           mscrplot=8*maxn0+4*maxnh,
     &           idumscrt=maxscrt-4*maxn-maxn*maxsub-mscrplot)
      common/scrt/datx(maxn),errx(maxn),sym(maxn),
     &            subspectrum(maxn,maxsub),
     &            varray(maxn0),yarray(maxn0),yyarray(maxn0),
     &            v1array(maxn0),v3array(maxn0),vrarray(maxn0),
     &            vdarray(maxn0),irarray(maxnh),i0array(maxnh),
     &            i1array(maxnh),i2array(maxnh),resarray(maxn0),
     &            b_datf(maxn),idumsc(idumscrt)
      real velocity,geof,dfdgeo
      common/adrive/  velocity(maxn),geof(maxn),dfdgeo(maxn)
      real hd,resmin,resmax 

      character       chsub*9
      logical         b_logx,b_logy
      character*1     chx,chbx,chlr,chy,chby,chbt
      character*80    CTEXT,CXTEXT,CYTEXT,frcolor*24,ch0*1 
      integer         nformx,nformy,i0
      real            chh,chw,syw,syh

      ch0=char(0)
      i0=ichar('0')
c      write(6,'(2a)')' moss_plot cmch=',cmch
      if(cmch.eq.'dmod') then
       display_mode(1)='channel scale, counts'
       display_mode(2)='channel scale, counts, residual spectrum'
       display_mode(3)='velocity scale'
       display_mode(4)='velocity scale, residual spectrum'
       display_mode(5)='velocity scale, counts'
       display_mode(6)='velocity scale, counts, residual spectrum' 
       display_mode(7)=' '
       display_mode(8)=' '
       namechan(1)='xd'
       namechan(2)='yd'
       namechan(3)='dy'
       namechan(4)='res'
       namechan(5)='xt'
       namechan(6)='yt'
       namechan(7)='su'
       namechan(8)=' '
       plotstrdef='(xd,yd,dy)'
       if(b_theory)then
        plotstrdef='(xd,yd,dy) (xt,yt)'
        j=21
        if(ndisplay_mode.eq.2.or.ndisplay_mode.eq.4
     &                         .or.ndisplay_mode.eq.6)then
         plotstrdef='(xd,yd,dy) (xt,yt) (xd,res)'
         j=30
        end if
        if(n_subset.gt.0)then
         do i=1,n_subset
          chsub=' (xt,su'//char(i+i0)//')'
          k=j+(i-1)*9
          plotstrdef(k:)=chsub
         end do
        end if
       end if
       return
      end if

      if(ndisplay_mode.eq.3.or.ndisplay_mode.eq.4) then
       kform(1)='f6.2'
       kform(2)='f10.6'
       kform(3)='f10.6'
       kform(4)='f10.6'
       kform(5)='f6.2'
       kform(6)='f10.6'
       kform(7)='f10.6'
       nformy=2
      else if(ndisplay_mode.le.2.or.ndisplay_mode.ge.5) then
       kform(1)='f8.2'
       kform(2)='f10.2'
       kform(3)='f8.1'
       kform(4)='f10.1'
       kform(5)='f6.0'
       kform(6)='f10.0'
       kform(7)='f10.0'
       nformy=0
      end if
      kform(8)=' '

      goto(3,4,1,2,5,5), ndisplay_mode
c       display_mode(1)='velocity scale'
 1     abscissa='mm/s'
       ordinata='relative transmission'
       axisformat(1)='%6.2f '
       axisformat(2)='%6.2f '
       nformx=1
       goto 6
c       display_mode(2)='-velocity scale, residual spectrum'
 2     abscissa='mm/s'
       ordinata='relative transmission'
       axisformat(1)='%6.2f '
       axisformat(2)='%6.2f '
       nformx=1
       goto 6
c       display_mode(3)='channel scale'
 3     abscissa='channel'
       ordinata='counts'
       axisformat(1)='%8.2f '
       axisformat(2)='%10.2f '
       nformx=0       
       goto 6
c       display_mode(4)='-channel scale, residual spectrum'
 4     abscissa='channel'
       ordinata='counts'
       axisformat(1)='%6.0f '
       axisformat(2)='%8.0f '
       nformx=0
       goto 6
c      display_mode(5)='-velocity scale, counts, residual spectrum'
 5     abscissa='mm/s'
       ordinata='counts'
       axisformat(1)='%8.2f '
       axisformat(2)='%10.2f '
       nformx=0
 6     continue

       n_subspectra=0
       if(b_theory) n_subspectra=n_subset
c      n_subset may be not defined

       nchansp=channels
       fold_point=channel_v0+channels_vmax
c      write(6,'(a,i4)') ' *****moss_plot*********'
c      write(6,'(3(a,i6))') ' idumscr=',idumscr,'  maxscrt=',maxscrt
c       write(6,'(2(a,l5),a,i5)') ' b_data=',b_data,
c     &  '  b_theory=',b_theory,' n_subspectra=',n_subspectra
c       write(6,'(4(a,f10.3))') ' base=',base,'  geo=',geo,
c     &         '  fold=',fold_point,'  fresonant=',fresonant


c     if(b_theory) then
c      write(6,'(4e15.6)') (thfk(i),i=1,nchansp,64)
c     else
c      write(6,'(20L4)') (b_datf(j),j=1,nchansp,16)
c     end if

      do j=1,nchansp
       b_datf(j)=.false.
      end do
      do k=2,ichanks(0),2
       do j=ichanks(k-1),ichanks(k)
        b_datf(j)=.true.
       end do
      end do

      bgcolor='LightYellow'//ch0
      fgcolor='black'//ch0
      datacolor=fgcolor
      thcolor=fgcolor
      rescolor='blue'//ch0
      do j=1,maxsub
       ncolor(j)=icolor_sub(j)
      end do

      axesname(1)=abscissa
      axesname(2)=ordinata
      axesname(3)=' '
      title=name_data
      ii=index(file_data,'.')
      if(ii.eq.0) then
       datfile='Ptheory_nodata.ps'//char(0)
      else
       datfile='P'//file_data(1:ii)//'ps'//char(0)
      end if
c      write(6,'(2a)')'datfile=',datfile(1:60) 

      if(.not.b_data) title=name_theory
      nresidue=0
      if(base.eq.0.) base=1.

c      write(6,'(a,3f10.3)') ' velo(1,512)=',velocity(1),
c     &                 velocity(256),velocity(512)
c      write(6,'(a,3f10.3)') ' geof(1,512)=',geof(1),geof(256),geof(512)
c        do j=240,250
c         write(6,'(i4,4x,f15.6)') j,thfk(j)
c       end do

 
       ny=0
       nyy=0
       do ii=1,infplot
        nchanplot(ii)=0
       end do
       basepl=base
       if(ndisplay_mode.ge.5) basepl=1

       if(b_data) then
        nbegin=0
        i=0
        do while(nbegin.eq.0.and.i.lt.nchansp)
         i=i+1
         if(b_datf(i)) nbegin=i
        end do
        nend=0
        i=nchansp+1
        do while(nend.eq.0.and.i.gt.1)
         i=i-1
         if(b_datf(i)) nend=i
        end do
        do i=1,nchansp
         varray(i)=velocity(i)
        end do
        varray(nchansp+1)=varray(1)
        varray(nchansp+2)=varray(2)

        is1=sign(1.,varray(nbegin+1)-varray(nbegin))
        do ii=nbegin+1,nend

         is2=sign(1.,varray(ii+1)-varray(ii))
c         write(6,'(i4,f10.4)')is2,varray(ii)
         if(is1*is2.lt.0) goto 9
        end do
 9      continue

        nsinglev=1                    ! double valued spectrum
        if(ii.gt.nend-2) nsinglev=-1  ! single valued  ''
        basepl=base
        if(ndisplay_mode.ge.5)then
         basepl=1
         if(nsinglev.eq.1)basepl=0.5
        end if

c        write(6,'(a,2i6)') ' ndisplay_mode=',ndisplay_mode,nchansp
c        write(6,'(3(a,i7))') ' mfpt=',mfpt,' mdfpt=',mdfpt,
c     & '  sigle_v=',nsinglev

        b_vdarray=.false.
        if(ndisplay_mode.ge.3) then

         if(nsinglev.lt.0) then
          do ii=nbegin,nend
           if(b_datf(ii)) then
            ny=ny+1
            plotx(ny)=velocity(ii)
            ploty(ny)=real_fr(mfpt+ii)/basepl
            ploterry(ny)=real_fr(mdfpt+ii)/basepl
           end if
          end do

          if(b_theory) then
           do ii=nbegin,nend
            nyy=nyy+1
            plotxx(nyy)=velocity(ii)
            plotyy(nyy)=thfk(ii)/basepl
           end do

           if(ndisplay_mode.ge.4) then
            nresidue=1
            ns=0
            do ii=nbegin,nend
             if(b_datf(ii)) then
              ns=ns+1
              plotres(ns)=ploty(ii)-plotyy(ii)
             end if
            end do
           end if

           if(n_subspectra.gt.0) then
            do j=1,n_subspectra
             ns=(j-1)*max8
             nchanplot(6+j)=nend-nbegin+1
             do ii=1,nchansp
              ns=ns+1
              plotsub(ns)=subspectrum(ii,j)/basepl
             end do
            end do
           end if
          end if   ! b_theory
          goto 200
         end if    !  nsinglev < 0

         sqrt2=sqrt(2.)
         base2=2*basepl

         l=3*int(log10(abs(v_max/nchansp*4.))*2.)
         glow=10**l
c        write(6,'(a,i4)') ' lower limit =',l
         if(b_theory) then
          do i=1,nchansp
           yyarray(i)=thfk(i)/geof(i)
          end do
          yyarray(nchansp+1)=thfk(1)/geof(1)
          yyarray(nchansp+2)=thfk(2)/geof(2)
         end if
         if(ndisplay_mode.eq.4.or.ndisplay_mode.eq.6) nresidue=1

         do i=1,nchansp
          resarray(i)=real_fr(mfpt+i)-thfk(i)
          yarray(i)=real_fr(mfpt+i)/geof(i)
         end do
         yarray(nchansp+1)=real_fr(mfpt+1)/geof(1)
         yarray(nchansp+2)=real_fr(mfpt+2)/geof(2)

         nh=nchansp/2.
         irh=int(fold_point)+1
         il=irh
         do ii=irh,irh+nh-1
          ir=ii
          if(ir.gt.nchansp) ir=ir-nchansp
          il=il+1
          vir=varray(ir)
          ivd=1
          il1=il+1
          vil1=varray(il+1)
          vil=varray(il)
          do while(ivd.gt.0)
           il2=il1
           il1=il
           vil2=vil1
           vil1=vil
           ivd=1

           if(vil2-vir.le.0)  ivd=-1
           if(vil2-vir.eq.0) goto 18

           if(vil1-vir.lt.0) then
            ivd=-ivd
           else if(vil1-vir.eq.0) then
            ivd=-1
           end if

   18      il=il-1
           if(il.lt.1) il=il+nchansp
           vil=varray(il)


          end do
          v1=vil-vil1
          v3=vil2-vil1
          vr=vir-vil1
          if(b_theory) then
           nyy=nyy+1
           irarray(nyy)=ir
           i0array(nyy)=il
           i1array(nyy)=il1
           i2array(nyy)=il2
           v1array(nyy)=v1
           v3array(nyy)=v3
           vrarray(nyy)=vr
           vdarray(nyy)=0.

           v1mv3=v1-v3
           det=v1*v3*v1mv3
           if(abs(det).gt.glow) then
            vdarray(nyy)=det
            b_vdarray=.true.
            y1=yyarray(il)
            y2=yyarray(il1)
            y3=yyarray(il2)
            y1=y1-y2
            y3=y3-y2
            y1=y1*v3
            y3=y3*v1
            aa=y1-y3
            bb=-y1*v3+y3*v1
            ff=vr*(vr*aa+bb)/det+y2
           else
            ff=yyarray(il1)
            b_vdarray=.false.
           end if
           plotxx(nyy)=vir
           plotyy(nyy)=(yyarray(ir)+ff)/base2
          else
           b_vdarray=.false.
          end if  ! b_theory

          if(b_datf(ir)) then
           y1=yarray(il)
           y2=yarray(il1)
           y3=yarray(il2)
           if(y1.ne.0..and.y2.ne.0..and.y3.ne.0.) then
            ny=ny+1
            iiii=ny/64
            if(b_vdarray) then
             y1=y1-y2
             y3=y3-y2
             y1=y1*v3
             y3=y3*v1
             aa=y1-y3
             bb=-y1*v3+y3*v1
             ff=vr*(vr*aa+bb)/det+y2
c            if(iiii*64.eq.ny) write(6,'(a,i4,f15.5)')
c    &       ' b_vdarray=true ny,ff=',ny,ff
            else
             ff=y2
c            if(iiii*64.eq.ny) write(6,'(a,i4,f15.5)')
c    &       ' b_vdarray=false ny,ff=',ny,ff
            end if
            plotx(ny)=vir
            ploty(ny)=(abs(yarray(ir))+abs(ff))/base2
            ploterry(ny)=sqrt2*real_fr(mdfpt+ir)/base2
            if(ndisplay_mode.eq.4.or.ndisplay_mode.eq.6) 
     &                         plotres(ny)=resarray(ir)/base2
c           if(iiii*64.eq.ny) write(6,'(2(a,i4,f15.5))')
c     & '   ny,plotres(ny)=',ny,plotres(ny),' ir,basepl=',ir,basepl
           end if
          end if
         end do
c        ny plot points for the data
c        nyy plot points for the theory

         if(b_theory.and.n_subspectra.gt.0) then
          do j=1,n_subspectra
           do i=1,nchansp
            yyarray(i)=subspectrum(i,j)
           end do
           yyarray(nchansp+1)=yyarray(1)
           yyarray(nchansp+2)=yyarray(2)

           ns=(j-1)*max8
           nchanplot(6+j)=nh
           do ii=1,nh
            v1=v1array(ii)
            v3=v3array(ii)
            vr=vrarray(ii)
            det=vdarray(ii)
            ir=irarray(ii)
            il0=i0array(ii)
            il1=i1array(ii)
            il2=i2array(ii)
            if(det.ne.0.) then
             y1=yyarray(il0)
             y2=yyarray(il1)
             y3=yyarray(il2)
             y1=y1-y2
             y3=y3-y2
             y1=y1*v3
             y3=y3*v1
             aa=y1-y3
             bb=-y1*v3+y3*v1
             ff=vr*(vr*aa+bb)/det+y2
            else
             ff=yyarray(il1)
            end if
            ns=ns+1
            plotsub(ns)=(subspectrum(ir,j)+ff)/base2
           end do
          end do
         end if
        else     ! ndisplay_mode.ge.3
         do i=nbegin,nend
          if(b_datf(i)) then
           ny=ny+1
           plotx(ny)=i
           ploty(ny)=real_fr(mfpt+i)
           ploterry(ny)=real_fr(mdfpt+i)
          end if
         end do

         if(b_theory) then
c          do i=nbegin,nend
          do i=1,nchansp
           nyy=nyy+1
           plotyy(nyy)=thfk(i)
           plotxx(nyy)=i
          end do
          if(ndisplay_mode.eq.2) then
           nresidue=1
           ns=0
           do ii=nbegin,nend
            if(b_datf(ii)) then
             ns=ns+1
             plotres(ns)=real_fr(mfpt+ii)-thfk(ii)
            end if
           end do
          end if
          if(n_subspectra.gt.0) then
           do j=1,n_subspectra
            ns=(j-1)*max8
            nchanplot(6+j)=nend-nbegin+1
            do ii=1,nchansp
             ns=ns+1
             plotsub(ns)=subspectrum(ii,j)
            end do
           end do
          end if
         end if  ! b_theory
        end if   ! ndisplay_mode.ge.3
       else  ! b_data

        if(ndisplay_mode.ge.3) then
         nyy=nchansp/2
         do i=1,nyy
          plotxx(i)=velocity(i)
          plotyy(i)=thfk(i)/basepl/geof(i)
         end do
         if(n_subspectra.gt.0) then
          do j=1,n_subspectra
           ns=(j-1)*max8
           nchanplot(6+j)=nyy
           do i=1,nyy
            plotsub(ns+i)=subspectrum(i,j)/basepl/geof(i)
           end do
          end do
         end if
        else
         nyy=nchansp
         do i=1,nchansp
          plotxx(i)=nyy-i+1
          plotyy(i)=thfk(i)
         end do
         if(n_subspectra.gt.0) then
          do j=1,n_subspectra
           ns=(j-1)*max8
           nchanplot(6+j)=nyy
           do i=1,nyy
            plotsub(ns+i)=subspectrum(i,j)
           end do
          end do
         end if
        end if
       end if ! b_data

 200  continue

      xmin=1.e30
      xmax=-xmin
      ymin=xmin
      ymax=0.                       ! counts > 0
      if(b_data) then
       do ii=1,3
        nchanplot(ii)=ny
       end do
       if(xmin.gt.plotx(1))xmin=plotx(1) 
       if(xmax.lt.plotx(ny))xmax=plotx(ny) 
       if(xmin.gt.plotx(ny))xmin=plotx(ny) 
       if(xmax.lt.plotx(1))xmax=plotx(1) 
       do i=1,ny
        if(ymin.gt.ploty(i)-ploterry(i))ymin=ploty(i)-ploterry(i)
       end do
       do i=1,ny
        if(ymax.lt.ploty(i)+ploterry(i))ymax=ploty(i)+ploterry(i)
       end do
      end if
      if(b_theory) then
       nchanplot(5)=nyy
       nchanplot(6)=nyy
       if(xmin.gt.plotxx(1))xmin=plotxx(1) 
       if(xmax.lt.plotxx(nyy))xmax=plotxx(nyy) 
       if(xmin.gt.plotxx(nyy))xmin=plotxx(nyy) 
       if(xmax.lt.plotxx(1))xmax=plotxx(1) 
       do i=1,nyy
        if(ymin.gt.plotyy(i))ymin=plotyy(i)
       end do
       do i=1,nyy
        if(ymax.lt.plotyy(i))ymax=plotyy(i)
       end do
      end if

      if(nresidue.eq.1.and.b_theory) then
        nchanplot(4)=ny
        resmin=0.
        resmax=0.
        do i=1,ny
         hd= plotres(i)-ploterry(i)           
         if(resmin.gt.hd) resmin=hd
        end do
        do i=1,ny
         hd= plotres(i)+ploterry(i)           
         if(resmax.lt.hd) resmax=hd
        end do
         hd= resmax-2.0*resmin 
        do i=1,ny
         plotres(i)=plotres(i)+ymax-resmin
        end do
        ymax=ymax-resmin+resmax

      end if
       xyzdz(1)=xmin
       xyzdz(2)=xmax
       xyzdz(3)=ymin
       xyzdz(4)=ymax

       b_logx=.false.
       b_logy=.false.
       logx=0
       logy=0
       if(b_logx)logx=1
       logf=0
       if(b_logy)logf=1

c      definitions taken from allplo
       chx='b'                 ! (none,Both,bottom,top)  [B]
       chbx='n'                ! (none,bottom,top)  [n]
       chlr='l'                ! (left,right)  [r]
       chy='l'                 ! (none,Both,left,right)  [B]
       chby='l'                ! (none,left,right)  [r] 
       chbt='b'                ! (bottom,top)  [t]
       chh=0.3                 ! 
       chw=0.25                ! character cw,ch  [0.40,0.40]         
       syw=0.1                 !
       syh=0.1                 ! symbol sw,sh     [0.40,0.40]
       frcolor=fgcolor         ! color frame       [black]
       frcolor='blue'//ch0
       CTEXT=title
       CXTEXT=abscissa
       CYTEXT=ordinata
         
       call frame(chx,chbx,chlr,chy,chby,chbt,b_logx,b_logy,
     &            chh,chw,syw,syh,
     &          CTEXT,CXTEXT,CYTEXT,nformx,nformy,frcolor,bgcolor)
 
c      write(6,'(a,4g12.6)')' min-max=',xmin,xmax,ymin,ymax
c      write(6,'(a,10i5)') ' nchanplot=',(nchanplot(ii),ii=1,8)
c      write(6,'(2(a,i4))')  ' ny=',ny,'    nyy=',nyy
c      write(6,'(a)')  ' j,plotx(j),ploty(j)'
c      write(6,'(3(2x,i4,1x,2g12.4))') (j,plotx(j),ploty(j),j=1,ny,16)
c      write(6,'(a)')  ' j,plotres(j),ploty(j)'
c      write(6,'(3(2x,i4,1x,2g10.2))') (j,plotres(j),ploty(j),j=1,ny,16)

      return
      end

      subroutine drive(mode_drive)

      include 'comglb.for'
      include 'comdat.for'
c      include 'comlc1.for'
      include 'comthe.for'
      logical mode_nlin

      common/acstrf/ dum1(5),
     &           channels,dum2(4),channels_vmax,dumcsp(icstrf-11)

      common/avstrf/avsp,f_factor,base,bg_fraction,v_max,
     &        channel_v0,v_max2,vphase2,v_max3,vphase3,geo,
     &        dumvsp(ivstrf-11)

      real velocity,geof,dfdgeo
      common/adrive/  velocity(maxn),geof(maxn),dfdgeo(maxn)

      nchansp=channels

c      write(6,'(a,f10.3)') ' ****--------*******drive v_max=',v_max
c      write(6,'(a,2f10.3)') ' drive_mode,channels_vmax=',
c     &                        drive_mode,channels_vmax
c     calculation  of velocity ,geo, dfdgeo
c     nchen mode = +1   triangular wave mode
c     nchen mode = +2   sine wave mode
c     nchen mode = +3   triangular wave mode with cosine correction :
c                   x = x - vmax2*cos(c2p*(x-fold_point2))-
c                           vmax3*cos(c2p*(x-fold_point3))-
c     nchen mode = +4   sine wave mode with cosine correction :
c                   x = x - vmax2*cos(c2p*(x-fold_point2))-
c                           vmax3*cos(c2p*(x-fold_point3))-
c
c      write(6,'(a,i4,5f10.3)') ' drive mode_drive,v_max=',
c     &                     mode_drive,v_max,channels_vmax,channel_v0


      iperiod=channels_vmax*2.0
      mode_nlin=.true.
      cp=3.141592/channels_vmax/2.0
      c2p=2.0*cp
      c3p=3.0*cp
      fold_point=channel_v0+channels_vmax
      fold_point2=vphase2+channels_vmax*2.0
      fold_point3=vphase3+channels_vmax*2.0

      goto (10,100,200,100,1000),mode_drive

c     triangular wave

   10 continue

      period2=channels_vmax*4.0
      fptmchpd=channel_v0-channels_vmax
      fptpchpd=channel_v0+channels_vmax*3.0
      fptmpdh =channel_v0
      fptppdh =channel_v0+channels_vmax*2.0
      vmax_chan=v_max/channels_vmax

c      a step in the function geof at v_max vanishes with the 
c      transformation of v_max 2007    
       v_max=v_max+v_max2*cos(c2p*(fold_point-fold_point2))+
     &             v_max3*cos(c3p*(fold_point-fold_point3))

      do ii=1,nchansp
       x=ii
       if(x-fold_point.gt.0.)goto 30
c      left side
       if(x.gt.fptmchpd) goto 22
       x=x+period2
       goto 32
   22  c1=fptmpdh-x
       s=1.
       goto 40
c      right side
   30  if(x.lt.fptpchpd) goto 32
       x=x-period2
       goto 22
   32  c1=fptppdh-x
       s=-1.
   40  c4=s*vmax_chan
       vh=c4*c1
       if(mode_nlin) vh=vh-v_max2*cos(c2p*(x-fold_point2))-
     &                     v_max3*cos(c3p*(x-fold_point3))
       velocity(ii)=vh
       cx=vh/v_max
       c2=s*(cx**2-1.)
       c5=1.+geo*c2
       geof(ii)=1./c5**2
       dfdgeo(ii)=-2.*geof(ii)/c5*c2
c       if(ii.gt.fold_point-2.and.ii.lt.fold_point+2)
c     & write(6,'(i5,a,3f12.4)')ii,' vh,v_max,geof=',vh,v_max,geof(ii)
      end do
      goto 1000
c
c     sine wave
c
  100 continue
      do ii=1,nchansp
       x=ii
       arg=cp*(x-fold_point)
       vh=-v_max*cos(arg)
       if(mode_nlin) vh=vh-v_max2*cos(c2p*(x-fold_point2))-
     &                   v_max3*cos(c3p*(x-fold_point3))
       velocity(ii)=vh

       sx=sin(arg)
       c5=1.+geo*sx
       geof(ii)=1./c5**2
       dfdgeo(ii)=-2.*geof(ii)/c5*sx
      end do
      goto 1000

 200  continue            !    mode_drive=3
      do ii=1,nchansp        
       vh=real_fr(mxpt+ii)
       if(mode_nlin) vh=vh-v_max2*cos(c2p*(x-fold_point2))-
     &                     v_max3*cos(c3p*(x-fold_point3))       
       velocity(ii)=vh
       cx=vh/v_max  
       c2=(cx**2-1.)
       c5=1.+geo*c2
       geof(ii)=1./c5**2
       dfdgeo(ii)=-2.*geof(ii)/c5*c2 
      end do    
 1000 continue
      return
      end



      subroutine geometry(ichansp,cosa,a_R,jt)
      implicit none
      include 'comglb.for'
      include 'comdat.for'

      integer ichansp,jt,icase,N_S,N_B
      real    r_B,r_S,sumi0,SoverF,AoverF,BoverF,DAoverF,DSoverF,HoverF
      common/geomet/icase,N_S,N_B,r_B,r_S,sumi0,
     &                SoverF,AoverF,BoverF,DAoverF,DSoverF,HoverF

      real       dum1,channels,dum2,channels_vmax,flag_basis,
     &           om_samp,Dsource,Dabsorber,
     &           sc2absorber,sc2aperture,dumcs
      common/acstrf/ dum1(5),
     &         channels,dum2(4),channels_vmax,flag_basis,
     &         om_samp,Dsource,Dabsorber,
     &         sc2absorber,sc2aperture,dumcs(icstrf-17)

      real    avsp,f_factor,base,bg_fraction,v_max,
     &        channel_v0,v_max2,vphase2,v_max3,vphase3,
     &        geo,Daperture,d_absorber,d_source,dumvs
      common/avstrf/avsp,f_factor,base,bg_fraction,v_max,
     &        channel_v0,v_max2,vphase2,v_max3,vphase3,geo,
     &        Daperture,d_absorber,d_source,dumvs(ivstrf-14)
c     d_absorber is the deviation from the axis: center of the source to
c     center aperture of the detector.     
c     d_source is the deviation from the axis: center of the absorber to
c     center aperture of the detector. 
      real   BoverFd,AoverFd,SoverFd,HoverFd,DAoverFd,DSoverFd,
     &       sc2apertured,gdetectord,geod
      common/geom/BoverFd,AoverFd,SoverFd,HoverFd,DAoverFd,DSoverFd,
     &            sc2apertured,gdetectord,geod
      integer i,j,nB,nR,nS,jR
      real velocity,geof,dfdgeo
      common/adrive/  velocity(maxn),geof(maxn),dfdgeo(maxn)

      real w_R,RR,RoverF,cc,h,hh,h0,h1,xi,xi2,yi,v2,kx,ky,k2,
     &     tau,tau2,maxtau,mintau,cyp_max,cym_min,gdetector

      real r4,r11,r20,r33,cosa,a_R,xy,wt
      dimension cosa(1320),a_R(1320),xy(66),wt(33)
      parameter (r4=3.0, r11=4.4641, r20=6.2915, r33=8.2111)

c     number 1,5,6,21,22 are of half weight
c     1-4 (r=3), 1-11 (2*sq3+1), 1-20 (2*sq7+1) 1-33 (2*sq13+1)  
      data xy/0.0, 0.000,1.0, 1.732,1.0,-1.732,2.0, 0.000,
     &        0.0, 3.464,0.0,-3.464,2.0, 3.464,2.0,-3.464,
     &        3.0, 1.732,3.0,-1.732,4.0, 0.000,
     &        1.0, 5.196,1.0,-5.196,3.0, 5.196,3.0,-5.196,
     &        4.0, 3.464,4.0,-3.464,5.0, 1.732,5.0,-1.732,
     &        6.0, 0.000,
     &        0.0, 6.928,0.0,-6.928,2.0, 6.928,2.0,-6.929,
     &        4.0, 6.928,4.0,-6.928,5.0, 5.196,5.0,-5.196,
     &        6.0, 3.464,6.0,-3.464,7.0, 1.732,7.0,-1.732,
     &        8.0, 0.000/
      data wt/0.5,1.,1.,1.,0.5,0.5,1. ,1. ,1.,1.,1.,1.,1.,1.,
     &        1., 1.,1.,1.,1. ,1. ,0.5,0.5,1.,1.,1.,1.,1.,1.,
     &        1., 1.,1.,1.,1./

c     om_samp             :    constant                 [0]
c     Dsource             :    constant                 [0.5]
c     Dabsorber           :    constant from experiment [1.6]
c     Daperture           :    constant from experiment [2.5]
c     F=sc2aperture       :    constant from experiment [10.0]
c     H=sc2absorber       :    parameter                [5.0]
c     d_absorber          :    parameter                [0.0]
c     d_source            :    parameter                [0.0]
c     geo                 :    parameter                [0.00000]


c     10 different cases of the geometry
c     uvwx   , 0 dynamically decided
c     u=1,2 point/extended source
c     v=1,2 intersection/full image or aperture
c     w=1,2 image of the absorber/ aperture
c     x=1,2 alignment/misalignment
      gdetector=6.
      if(icase.gt.0) goto 10
      N_B=om_samp+1

      SoverF=Dsource/sc2aperture 
      AoverF=Dabsorber/sc2aperture
      BoverF=Daperture/sc2aperture

      DAoverF=d_absorber/sc2aperture
      DSoverF=d_source/sc2aperture 
      HoverF=sc2absorber/sc2aperture
      

      BoverFd=BoverF
      AoverFd=AoverF
      SoverFd=SoverF
      HoverFd=HoverF
      DAoverFd=DAoverF
      DSoverFd=DSoverF
      sc2apertured=sc2aperture
      gdetectord=gdetector
      geod=abs(geo)
c        write(6,'(a,i3,2x,6f10.3)')' N_B,S,A,B,DA,H/F=',
c     &  N_B,SoverF,AoverF,BoverF,DAoverF,DSoverF,HoverF

      tau=1.0/(1.0-sqrt(geof(ichansp))*(1-HoverF))
      tau2=tau**2
      maxtau=(1-geo)/(HoverF-geo)
      mintau=(1+geo)/(HoverF+geo)
      if(SoverF.le.0.0001) then
c      case of point source
       if(abs(DAoverF)+abs(DSoverF).lt.0.0001) then
c       alignment
c       case=1001
        icase=1

        i=0
        RR=AoverF/2.0
        if(RR*tau.lt.BoverF/2.) then
         w_R=RR/N_B
        sumi0=1.
        jr=1.
        do nR=2,N_B
         RoverF=(nR-0.5)*w_R
         jr=jr+2
         h=1.0/(1.0+(RoverF/HoverF)**2)
         sumi0=sumi0+ h*sqrt(h)*jr
        end do
c           write(6,'(a,10f10.5)')
c     &  'a  sumi0,tau,AoverF,BoverF,w_R=',sumi0,tau,AoverF,BoverF,w_R
        else ! RR.gt.BoverF/2.
         w_R=BoverF/2./N_B
        sumi0=1.
        jr=1.
        do nR=2,N_B
         RoverF=(nR-0.5)*w_R
         jr=jr+2
         h=1.0/(1.0+RoverF**2)
         sumi0=sumi0+ h*sqrt(h)*jr
        end do
c           write(6,'(a,10f10.5)')
c     &  'b  sumi0,tau,AoverF,BoverF,w_R=',sumi0,tau,AoverF,BoverF,w_R
        end if
c         enwr(9)='plot'
        if(enwr(9).eq.'plot') then
         write(nwr,'(a)')'point source/alignment icase=1'
         if(RR*maxtau.le.BoverF/2) then
          write(nwr,'(a)')
     &            'image of absorber is smaller than/equal aperture'
         else if(RR*mintau.gt.BoverF/2) then
          write(nwr,'(a)')'image of absorber is larger than aperture'
         else if(RR*mintau.lt.BoverF/2.and.RR*maxtau.gt.BoverF/2) then 
          write(nwr,'(a,/a)')'**warning** absorber image/aperture <> 1',
     &    ' depends on the position of the source'
         end if
         call geompointsc 
         enwr(9)='nnnn'
        end if
       else  ! abs(DAoverF)+abs(DSoverF)> 0
c       misalignment
 
        h=DAoverF-DSoverF+AoverF/2.
        if(h.gt.0)then
         cyp_max=DSoverF+h*maxtau
        else
         cyp_max=DSoverF+h*mintau
        end if
        h=DAoverF-DSoverF-AoverF/2.
        if(h.gt.0)then
         cym_min=DSoverF+h*mintau
        else
         cym_min=DSoverF+h*maxtau
        end if

        sumi0=0.0
        if(cyp_max.le.BoverF/2..and.cym_min.ge.-BoverF/2.)then
c        Intersection is the full image of the absorber
c        case=1212
         if(enwr(9).eq.'plot') then
          write(nwr,'(a,2(/,a))')' point source/misalignment icase=2',
     &    ' image of the absorber inside aperture',
     &    ' integration over image by circles'
          call geompointsc 
          enwr(9)='nnnn'
         end if

         icase=2
         RR=AoverF/2.0
         if(N_B.le.4)then
          N_B=4
          r_B=RR/r4
         else if(N_B.le.11)then
          N_B=11
          r_B=RR/r11
         else if(N_B.le.20)then
          N_B=20
          r_B=RR/r20
         else if(N_B.gt.20)then
          N_B=33
          r_B=RR/r33
         end if

         i=-1
         do nB=1,N_B
          i=i+2 
          xi=xy(i)*r_B
          yi=DAoverF-DSoverF+xy(i+1)*r_B
          h=1.0/(1.0+(xi**2+yi**2)*tau2)
          sumi0=sumi0+h*sqrt(h)*wt(nB)  
         end do
c        write(6,'(a,10f10.3)')'sumi0,tau=',sumi0,tau
        else if(cyp_max.gt.BoverF/2..and.cym_min.lt.-BoverF/2.)then
c        Intersection is the full aperture
c        case=1222
         if(enwr(9).eq.'plot') then
          write(nwr,'(a,2(/,a))')' point source/misalignment icase=3',
     &  ' image of the absorber larger than aperture',
     &  ' integration over aperture by circles'
          call geompointsc 
          enwr(9)='nnnn'
         end if

         icase=3
c         write(6,'(a,5f12.3)')'mintau,maxtau,cyp_max,cym_min,BoverF/2=',
c     &                         mintau,maxtau,cyp_max,cym_min,BoverF/2 
         RR=BoverF/2.0
         if(N_B.le.4)then
          N_B=4
          r_B=RR/r4
         else if(N_B.le.11)then
          N_B=11
          r_B=RR/r11
         else if(N_B.le.20)then
          N_B=20
          r_B=RR/r20
         else if(N_B.gt.20)then
          N_B=33
          r_B=RR/r33
         end if
         i=-1
         do nB=1,N_B
          i=i+2 
          xi=xy(i)*r_B
          yi=-DSoverF+xy(i+1)*r_B
          h=1.0/(1.0+xi**2+yi**2)
          sumi0=sumi0+h*sqrt(h)*wt(nB)  
         end do
c        write(6,'(a,10f10.3)')'sumi0=',sumi0
        else 
c        Intersection; image of the absorber filled with cirles 
c        case=1112
         if(enwr(9).eq.'plot') then
          write(nwr,'(a,3(/,a))')' point source/misalignment icase=4',
     &  ' intersection of absorber image and aperture depends on the',
     &  ' position of the source; integration over aperture by circles',
     &  ' with smooth edge'
          BoverFd=-BoverFd
          call geompointsc 
          enwr(9)='plot'
         end if

         RR=AoverF/2.0
         icase=4 
         RR=AoverF/2.
         if(N_B.le.4)then
          N_B=20
          r_B=RR/r20
         else if(N_B.gt.4)then
          N_B=33
          r_B=RR/r33
         end if
 
         i=-1
         do nB=1,N_B
          i=i+2
          xi2=(xy(i)*r_B*tau)**2
          yi=(DAoverF-DSoverF+xy(i+1)*r_B)*tau
          h=1.0/(1.0+(xi2+yi**2))
          hh=h*sqrt(h)*wt(nB)
          cc=sqrt(xi2+(DSoverF+yi)**2)/BoverF*8.-3.
          if(cc.gt.0.) then
c         image out of aperture cirle (decreasing weight)
           hh=hh*exp(-(cc*gdetector)**2)
          end if
          sumi0=sumi0+hh
c         write(6,'(a,10f10.3)')'sumi0,tau=',sumi0,tau
         end do
        end if  
       end if
      else        ! Dsource > 0 
c      ################## extended source ############################
c     v=1,2 intersection/full image or aperture
c     w=1,2 image of the absorber/ aperture
c     x=1,2 alignment/misalignment

       sumi0=0.0
       tau=1.0/(1.0-sqrt(geof(ichansp))*(1-HoverF))
       tau2=tau**2

       if(abs(DAoverF)+abs(DSoverF).lt.0.0001) then
c       alignment
c       case=2001
        icase=5

        h=AoverF-SoverF
        if((h.gt.0.0.and.SoverF+h*mintau.gt.BoverF).or.
     &     (h.lt.0.0.and.SoverF+h*maxtau.gt.BoverF)) then
c        image covers aperture for all source points
c        integration over aperture (rings), source circles
c        2221       
         icase=5
         if(enwr(9).eq.'plot') then
          write(nwr,'(a,2(/,a))')' extended source/alignment icase=5',
     &    ' image covers aperture for all source points',
     &    ' integration over aperture by rings and source by circles'
          call geomextendsc
          enwr(9)='nnnn'
         end if

         RR=SoverF/2.
         if(N_B.le.4)then
          N_S=4
          r_S=RR/r4
         else if(N_B.le.11)then
          N_S=11
          r_S=RR/r11
         else if(N_B.gt.11)then
          N_S=20
          r_S=RR/r20
c         else if(N_B.gt.20)then
c         N_S=33
c         r_S=RR/r33
c         never more than 20 circles for the source=> less than 20*20 values
         end if

         w_R=BoverF/2.0/N_B       
         jR=-1
         do nR=1,N_B
          RoverF=(nR-0.5)*w_R
          jR=jR+2
          i=-1
          do nS=1,N_S 
           i=i+2 
           v2=(xy(i)*r_S)**2+(RoverF-xy(i+1)*r_S)**2
           h=1./(1.+v2)
           sumi0=sumi0+h*sqrt(h)*wt(nS)*jR
C           write(6,'(2i4,a,6f12.3)')nS,nR,' sqrt(h)=',
C     &        sqrt(h),wt(nS),RoverF*sc2aperture
          end do
         end do
C         write(6,'(a,10f10.3)')'sumi0,tau=',sumi0,tau
        else
         h=AoverF+SoverF
         if(-SoverF+(AoverF+SoverF)*maxtau.lt.BoverF) then
         if(enwr(9).eq.'plot') then
          write(nwr,'(a,2(/,a))')' extended source/alignment icase=6',
     &    ' image inside aperture for all source points',
     &    ' integration over image, source by rings/image by circles'
          call geomextendsc
          enwr(9)='nnnn'
         end if
c         2211
          icase=6

          RR=AoverF/2.
          if(N_B.le.4)then
           N_B=4
           r_B=RR/r4
          else if(N_B.le.11)then
           N_B=11
           r_B=RR/r11
          else if(N_B.le.20)then
           N_B=20
           r_B=RR/r20
          else if(N_B.gt.20)then
           N_B=33
           r_B=RR/r33
          end if

          tau2=tau**2
          w_R=SoverF/2.0/N_B       
          jR=-1
          do nS=1,N_B
           RoverF=(nS-0.5)*w_R
           jR=jR+2
           i=-1
           do nB=1,N_B 
            i=i+2 
            kx=xy(i)*r_B
            ky=-RoverF+xy(i+1)*r_B
            h=1.0/(1.0+(kx**2+ky**2)*tau2)
            sumi0=sumi0+h*sqrt(h)*wt(nB)*jR
           end do
          end do
         else ! general case of an alignment
          if(enwr(9).eq.'plot') then
           write(nwr,'(a,2(/,a))')' extended source/alignment icase=7',
     &    ' source source/aperture <> 1 dependent on source position',
     &    ' integration over aperture (by circles) with smooth edge'
          BoverFd=-BoverFd
          call geomextendsc
          enwr(9)='nnnn'
         end if
c         2111
          icase=7     

          w_R=SoverF/2.0/N_B       
          jR=-1
          do nS=1,N_B
           RoverF=(nS-0.5)*w_R
           jR=jR+2
           i=-1
           do nB=1,N_B 
            i=i+2 
            kx=xy(i)*r_B
            ky=-RoverF+xy(i+1)*r_B
            h=1.0/(1.0+(kx**2+ky**2)*tau2)
            hh=h*sqrt(h)*wt(nB)*jR
            cc=sqrt((tau*xy(i)*r_B)**2+
     &              (RoverF*(1.-tau)+tau*xy(i+1)*r_B)**2)/BoverF*8.-3.
            if(cc.gt.0.0) then 
             hh=hh*exp(-(cc*gdetector)**2)
            end if
            sumi0=sumi0+hh
           end do
          end do
c         write(6,'(a,10f10.3)')'sumi0,tau=',sumi0,tau
         end if
        end if

       else  ! abs(DAoverF)+abs(DSoverF)> 0
        if(enwr(9).eq.'plot') then
         write(nwr,'(a,2(/,a))')
     &    ' extended source/misalignment icase=8',
     &    ' integration by cirles (source and aperture)',
     &    ' aperture with smooth edge'
         BoverFd=-BoverFd
         call geomextendsc
         enwr(9)='nnnn'
        end if
c       2122
        icase=8
        RR=SoverF/2.
        if(N_B.le.4)then
         N_S=4
         r_S=RR/r4
        else if(N_B.le.11)then
         N_S=11
         r_S=RR/r11
        else if(N_B.gt.11)then
         N_S=20
         r_S=RR/r20
c        else if(N_B.gt.20)then
c        N_S=33
c        r_S=RR/r33
c        never more than 20 circles for the source=> less than 20*33 values
        end if

        RR=AoverF/2.
        if(N_B.le.4)then
         N_B=20
         r_B=RR/r20
        else if(N_B.gt.4)then
         N_B=33
         r_B=RR/r33
        end if
        jt=0
        j=-1
        do nS=1,N_S
         j=j+2
         xi=xy(j)*r_S
         yi=xy(j+1)*r_S+DSoverF
2200     i=-1
         do nB=1,N_B 
          i=i+2
          jt=jt+1
          k2=(xy(i)*r_B-xi)**2+(xy(i+1)*r_B+DAoverF-yi)**2
          h=1./(1.+k2*tau2)
          hh=h*sqrt(h)*wt(nS)
          h1=sqrt((xi*(1.-tau)+tau*xy(i)*r_B)**2
     &         +(yi*(1.-tau)+tau*(DAoverF+xy(i+1)*r_B))**2)
          cc=h1/BoverF*8.-3.
c     &       /BoverF*8.-3.
c     &         -BoverF/2.
          if(cc.ge.0.0) then 
           hh=hh*exp(-(cc*gdetector)**2)
c           write(6,'(3i4,a,4f12.3)')jt,nS,nB,' sqrt(h), exp=',
c     &      sqrt(h),exp(-(cc*gdetector)**2),h1*sc2aperture*sign(1.,xi)
c          else
c           write(6,'(3i4,a,4f12.3)')jt,nS,nB,' sqrt(h), exp=',
c     &      sqrt(h),1.0,h1*sc2aperture*sign(1.,xi)
          end if
          sumi0=sumi0+hh
         end do
         if(xi.gt.0)then
          xi=-xi
          goto 2200
         end if
        end do
       end if
      end if


 10   continue
      jt=0
      tau=1.0/(1.0-sqrt(geof(ichansp))*(1-HoverF))
      tau2=tau**2

      goto(1001,1212,1222,1112,2221,2211,2111,2122) icase

c     point source case=1, alignment
1001  continue
c     dynamical decission according to tau(v) 
c     normalization to effective efficiency at s=0 for all v.
c     at that point is geof(ichansp)=1
        
      jt=1
      cosa(jt)=1.0
      a_R(jt)=geof(ichansp)
      jr=1.
      RR=AoverF/2.0
      if(RR*tau.lt.BoverF/2.) then
       w_R=RR/N_B
      do nR=2,N_B
       RoverF=(nR-0.5)*w_R
       jt=jt+1
       jr=jr+2
       h=1.0/(1.0+geof(ichansp)*RoverF**2*tau2)
       cosa(jt)=sqrt(h)
       a_R(jt)=geof(ichansp)*jr*h*cosa(jt)
c         if(ichansp.eq.123)then
c           write(6,'(a,10f10.5)')
c     &  '1001  tau,AoverF,BoverF,w_R,a_R(jt),cosa(jt)=',
c     &            tau,AoverF,BoverF,w_R,a_R(jt),cosa(jt)
c         end if
      end do
      else ! RR.gt.BoverF/2.
       w_R=BoverF/2./N_B
      do nR=2,N_B
       RoverF=(nR-0.5)*w_R
       jt=jt+1
       jr=jr+2
       h=1.0/(1.0+geof(ichansp)*RoverF**2)
       cosa(jt)=sqrt(h)
       a_R(jt)=geof(ichansp)*jr*h*cosa(jt)
c         if(ichansp.eq.123)then
c           write(6,'(a,10f10.5)')
c     &  '1001  tau,AoverF,BoverF,w_R,a_R(jt),cosa(jt)=',
c     &            tau,AoverF,BoverF,w_R,a_R(jt),cosa(jt)
c         end if
      end do
      end if
      do i=1,jt
        a_R(i)=a_R(i)/sumi0
      end do
      return

c     parameter (r4=3.0, r11=4.4641, r20=6.2915, r33=8.2111)
c     number 1,5,6,21,22 are of single weight
c     1-4 (r=3), 1-11 (2*sq3+1), 1-20 (2*sq7+1) 1-33 (2*sq13+1)  
c     point source case=1, misalignment

c     else if(cyp_max.le.BoverF/2..and.cym_max.ge.-BoverF/2.)then
c     Intersection is the full image of the absorber
 1212 continue
c     number 1,5,6,21,22 are of single weight
      i=-1
      do nB=1,N_B
       i=i+2 
       jt=jt+1
       xi=xy(i)*r_B
       yi=DAoverF-DSoverF+xy(i+1)*r_B
       h=1.0/(1.0+geof(ichansp)*(xi**2+yi**2)*tau**2)
       cosa(jt)=sqrt(h)
       a_R(jt)=geof(ichansp)*h*cosa(jt)*wt(nB)
      end do
      do i=1,jt
        a_R(i)=a_R(i)/sumi0
      end do
      return

c     Intersection is the full image of the aperture
 1222 continue
c     number 1,5,6,21,22 are of single weight
      i=-1
      do nB=1,N_B
       i=i+2 
       xi=xy(i)*r_B
       yi=-DSoverF+xy(i+1)*r_B
       jt=jt+1
       h0=xi**2+yi**2
       h=1.0/(1.0+geof(ichansp)*h0)
       cosa(jt)=sqrt(h)
       a_R(jt)=geof(ichansp)*h*cosa(jt)*wt(nB)
      end do
      do i=1,jt
        a_R(i)=a_R(i)/sumi0
      end do
      return

c     else if(cym_min.lt.-BoverF/2.) then 
c     Intersection; image of the absorber filled with cirles 
1112  continue
c     number 1,5,6,21,22 are of single weight
      hh=BoverF/2
      i=-1
      do nB=1,N_B
       i=i+2
       jt=jt+1
       xi2=(xy(i)*r_B*tau)**2
       yi=(DAoverF-DSoverF+xy(i+1)*r_B)*tau
       h=1.0/(1.0+geof(ichansp)*(xi2+yi**2))
       a_R(jt)=geof(ichansp)*h*sqrt(h)*wt(nB)
       cc=sqrt(xi2+(DSoverF+yi)**2)/BoverF*8.-3.
       if(cc.gt.0.) then
c       image out of aperture cirle (decreasing weight)
        a_R(jt)=a_R(jt)*exp(-(cc*gdetector)**2)
       end if
      end do
      do i=1,jt
        a_R(i)=a_R(i)/sumi0
      end do
      return

c     ##################### extended source ##########################
c     if(abs(DAoverF)+abs(DSoverF).lt.0.0001) then
c     alignment
2221  continue

c     image covers aperture for all source points
c     integration over aperture (rings), source circles       
      hh=0.
      w_R=BoverF/2.0/N_B       
      jR=-1
      do nR=1,N_B
       RoverF=(nR-0.5)*w_R
       jR=jR+2
       i=-1
       do nS=1,N_S 
        jt=jt+1
        i=i+2 
        v2=(xy(i)*r_S)**2+(RoverF-xy(i+1)*r_S)**2
        h=1./(1.+geof(ichansp)*v2)
        cosa(jt)=sqrt(h)
        a_R(jt)=geof(ichansp)*h*cosa(jt)*wt(nS)*jR
c        if(ichansp.eq.1)then
c          write(6,'(2i4,a,6f12.3)')nS,nR,' sqrt(h)=',
c     &        sqrt(h),wt(nS),float(jR)
c        end if
       end do
      end do
      goto 2202

2211  continue
c     integration over image, source ring/image circles
c     image inside aperture for all source points
      w_R=SoverF/2.0/N_B       
      jR=-1
      do nS=1,N_B
       RoverF=(nS-0.5)*w_R
       jR=jR+2
       i=-1
       do nB=1,N_B 
        jt=jt+1
        i=i+2 
        kx=xy(i)*r_B
        ky=-RoverF+xy(i+1)*r_B
        h=1.0/(1.0+geof(ichansp)*(kx**2+ky**2)*tau2)
        cosa(jt)=sqrt(h)
        a_R(jt)=geof(ichansp)*h*cosa(jt)*wt(nB)*jR
       end do
      end do
      goto 2202

2111  continue
c     source rings and image circles; 
c     aperture simulated by smooth edge       
      w_R=SoverF/2.0/N_B       
      jR=-1
      do nS=1,N_B
       RoverF=(nS-0.5)*w_R
       jR=jR+2
       i=-1
       do nB=1,N_B 
        jt=jt+1
        i=i+2 
        kx=xy(i)*r_B
        ky=-RoverF+xy(i+1)*r_B
        h=1.0/(1.0+geof(ichansp)*(kx**2+ky**2)*tau2)
        cosa(jt)=sqrt(h)
        a_R(jt)=geof(ichansp)*h*cosa(jt)*wt(nB)*jR
        cc=sqrt((tau*xy(i)*r_B)**2+
     &          (RoverF*(1.-tau)+tau*xy(i+1)*r_B)**2)/BoverF*8.-3.
        if(cc.gt.0.0) then 
         a_R(jt)=a_R(jt)*exp(-(cc*gdetector)**2)
        end if
       end do
      end do
      goto 2202

c     Intersection; general case; image filled with circles
c     finite aperture simulated by a smooth edge
2122  continue
      j=-1
      do nS=1,N_S
       j=j+2
       xi=xy(j)*r_S
       yi=xy(j+1)*r_S+DSoverF
 2201  i=-1
       do nB=1,N_B 
        jt=jt+1
        i=i+2
        k2=(xy(i)*r_B-xi)**2+(xy(i+1)*r_B+DAoverF-yi)**2
        h=1./(1.+geof(ichansp)*k2*tau2)
        cosa(jt)=sqrt(h)
        a_R(jt)=geof(ichansp)*h*cosa(jt)*wt(nS)
        h1=sqrt((xi*(1.-tau)+tau*xy(i)*r_B)**2+
     &          (yi*(1.-tau)+tau*(DAoverF+xy(i+1)*r_B))**2)
          cc=h1/BoverF*8.-3.
        if(cc.ge.0.0) then 
         a_R(jt)=a_R(jt)*exp(-(cc*gdetector)**2)
c         if((ichansp.eq.256.or.ichansp.eq.768).and.a_R(jt).gt.0.01)
c     &     write(6,'(3i4,a,4f10.3)')jt,nS,nB,' sqrt(h), exp=',sqrt(h),
c     &      exp(-(cc*gdetector)**2),h1*sc2aperture*sign(1.,xi),a_R(jt)
c        else
c          if((ichansp.eq.256.or.ichansp.eq.768).and.a_R(jt).gt.0.01)
c     &       write(6,'(3i4,a,4f10.3)')jt,nS,nB,' sqrt(h), exp=',
c     &      sqrt(h),1.0,h1*sc2aperture*sign(1.,xi),a_R(jt)
        end if
       end do
       if(xi.gt.0)then
        xi=-xi
        goto 2201
       end if
      end do
 2202 do i=1,jt
        a_R(i)=a_R(i)/sumi0
      end do
      return
      end


      subroutine syn_plot(cmch)
      implicit none
      include 'comglb.for'
      include 'compar.for'
      include 'comdat.for'
      include 'complt.for'
      include 'comthe.for'
      include 'comdas.for'

      integer     ifrth,idex,dstr,istr,iaddr,
     &            idum1,nstorTH1,nTH1,nCP,idum2,nsrw,idum
      real       srw8
      parameter (istr=38+4*(maxfr1+maxfr2)+3*maxthss)
      common/struct/dstr(istr),idum1,nstorTH1,iaddr(6),                 !13.9.05
     &              nTH1,nCP,idum2,nsrw,ifrth(4),idum(8),srw8,idex(7)

      integer      max8subn,n_subspectra,idumpl,logx,logy,logf,
     &             int3d,npnt3d,ifeder,ltext,npntplot,nchanplot,ncolor
      real         plotx,ploty,ploterry,plotres,plotxx,plotyy,plotsub,
     &             xyzdz,vtxt,vtxtp
      character*24 axesname,abscissa,ordinata,bgcolor,fgcolor,datacolor,
     &             thcolor,rescolor,auxcolor1,auxcolor2,auxcolor3,
     &             cmch*4,namechan*4,kform*8,chardum*4,axisformat*16,
     &             title*132,datfile*80,plotstrdef*80,plotstrpu*132
      parameter   (max8subn=maxsub*max8,
     &            idumpl=MDBPLFT*2-140*maxn-8*39-5*infplot-maxsub-188)
      common/plot/plotx(max8),ploty(max8),ploterry(max8),plotres(max8),
     &            plotxx(max8),plotyy(max8),plotsub(max8subn),
     &            xyzdz(8),vtxt(2,maxn*4),vtxtp(8,32),
     &            int3d(maxn*16),npnt3d(16),ifeder(maxn*4),ltext(32),
     &            npntplot(infplot),nchanplot(infplot),ncolor(maxsub),
     &            n_subspectra,logx,logy,logf,
     &            namechan(infplot),kform(infplot),axisformat(3),
     &            axesname(3),title,plotstrdef,plotstrpu,
     &            bgcolor,fgcolor,datacolor,thcolor,rescolor,
     &            auxcolor1,auxcolor2,auxcolor3,datfile,chardum(idumpl)

      real          acsp,wavelength,uthick,
     &              unit_chi,aiT_max,v_max,
     &              ak_extension,T_bunch,scale,channels,
     &              ch_angle,graz_beg,graz_end,dumcsp
      common/acstrf/acsp,wavelength,uthick,
     &              unit_chi,aiT_max,v_max,
     &              ak_extension,T_bunch,scale,channels,
     &              ch_angle,graz_beg,graz_end,dumcsp(icstrf-13)

      real          avsp,counts,background,Pxsi,Peta,Pzeta,
     &              t_shift,dumvsp
      common/avstrf/avsp,counts,background,Pxsi,Peta,Pzeta,
     &              t_shift,dumvsp(ivstrf-7)

      integer    idumscrt,idumsc
      logical    b_12,b_34
      parameter(idumscrt=maxscrt-maxn*maxsub-5*maxn)
      real        datx,errx,sym,subspectrum,daty,erry
      common/scrt/datx(maxn),errx(maxn),sym(maxn),
     &            subspectrum(maxn,maxsub),
     &            daty(maxn),erry(maxn),idumsc(idumscrt)

      integer   ib_df,kana,ibmisfit
      real      thfk,dfdp,ddpk
      common/fr2fi/thfk(max8),dfdp(max8),ddpk,ib_df,kana,ibmisfit

      real x_exp
      common/ascale/  x_exp(maxn)
      integer   mscale,nexp,n_plotsub,nresidue,nthe,ny,nyy,ns,
     &          i,ii,j,jj,k
      real      h,hm,htr,dx_the,dx_exp,xb_the,xb_exp,schrw,
     &          resmin,resmax,xmin,xmax,ymin,ymax,hd

      character       chsub*9
      logical         b_logx,b_logy
      character*1     chx,chbx,chlr,chy,chby,chbt
      character*80    CTEXT,CXTEXT,CYTEXT,frcolor*24 
      integer         nformx,nformy,i0
      real            chh,chw,syw,syh

      i0=ichar('0')
      mscale=1                    ! if no data 
      if(b_data)mscale=scale

      if(cmch.eq.'dmod') then
       namechan(1)='x'
       namechan(2)='y'
       namechan(3)='dy'
       namechan(4)='res'
       namechan(5)='xt'
       namechan(6)='yt'
       namechan(7)='su'
       namechan(8)=' '
       plotstrdef='d(x,y,dy)'
c      if there is not the standard xd,yd,erry a d(...) identifies data 
       if(b_theory)then
        plotstrdef='d(x,y,dy) (xt,yt)'
        j=21
       end if
       if(ifrcase.ge.22) then
        display_mode(1)='angle scale, log(counts)'
        display_mode(2)='angle scale, residual counts'
        display_mode(3)='channel scale, counts'
        display_mode(4)='channel scale,residual counts'
        if(b_theory)then
         if(ndisplay_mode.eq.2.or.ndisplay_mode.eq.4)then
          plotstrdef='d(x,y,dy) (xt,yt) (x,res)'
          j=30
         end if
         if(n_subset.gt.0)then
          do i=1,n_subset
           chsub=' (xt,su'//char(i+i0)//')'
           k=j+(i-1)*9
           plotstrdef(k:)=chsub
          end do
         end if
        end if
       else
        display_mode(1)='time scale, log(counts)'
        display_mode(2)='time scale, residual counts'
        display_mode(3)='channel scale, counts'
        display_mode(4)='channel scale,residual counts'
        display_mode(5)='velocity scale, cross section'
        display_mode(6)='channel scale, cross section'
        if(b_theory)then
         if(ndisplay_mode.eq.2.or.ndisplay_mode.eq.4)then
          plotstrdef='d(x,y,dy) (xt,yt) (x,res)'
          j=30
         end if
         if(n_subset.gt.0)then
          do i=1,n_subset
           chsub=' (xt,su'//char(i+i0)//')'
           k=j+(i-1)*9
           plotstrdef(k:)=chsub
          end do
         end if
        end if
       end if

       return
      end if

      b_logy=.false.
      b_logx=.false.
      b_12=.false.
      b_34=.false.
      if(ifrcase.ge.22.and.ndisplay_mode.gt.4) ndisplay_mode=4
      goto(1,2,3,4,1,2,3,4,5,6), ndisplay_mode
c       display_mode(1)='angle, time scale'
 1     b_12=.true.
       if(ifrcase.ge.22) then
        abscissa='theta[mrad] '
        axisformat(1)='%6.2f '
       else
        abscissa='T[ns] '
        axisformat(1)='%6.1f '
       end if
       ordinata='log(count) '
       axisformat(2)='%6.2f '
       b_logy=.true.
       nformx=0
       nformy=2       
       goto 7
c       display_mode(2)='angle, time scale, residual counts'
 2      b_12=.true.
        if(ifrcase.ge.22) then
        abscissa='theta[mrad] '
        axisformat(1)='%6.2f '
       else
        abscissa='T[ns] '
        axisformat(1)='%6.1f '
       end if
       ordinata='log(counts) '
       axisformat(2)='%6.2f '
       b_logy=.true.
       nformx=0
       nformy=2     
       goto 7
c       display_mode(3)='channel scale'
 3     b_34=.true.
       abscissa='channel '
       ordinata='counts '
       axisformat(1)='%6.0f '
       axisformat(2)='%8.0f '
       nformx=0
       nformy=0     
       goto 7
c       display_mode(4)='-channel scale, residual counts'
 4      b_34=.true.
        abscissa='channel '
       ordinata='counts '
       axisformat(1)='%6.0f '
       axisformat(2)='%8.0f '
       b_logy=.false.
       nformx=0
       nformy=0    
       goto 7
c      display_mode(5)='velocity scale, cross section'
 5      abscissa='[mm/s] '
       ordinata='cross section '
       axisformat(1)='%6.1f '
       axisformat(2)='%10.2f '
       nformx=1
       nformy=2     
       goto 7
c      display_mode(6)='channel scale, cross section'
 6     abscissa='channels '
       ordinata='cross section '
       axisformat(1)='%6.0f '
       axisformat(2)='%10.2f '
       nformx=0
       nformy=2     
 7     continue



      if(b_12.or.ndisplay_mode.eq.5) then
       kform(1)='f7.2'
       kform(2)='f10.4'
       kform(3)='f12.6'
       kform(4)='f10.6'
       kform(5)='f7.2'
       kform(6)='f8.4'
       kform(7)='f8.4'
       nformy=2
      else
       kform(1)='f6.0'
       kform(2)='f12.0'
       kform(3)='f9.1'
       kform(4)='f9.1'
       kform(5)='f6.0'
       kform(6)='f12.0'
       kform(7)='f12.0'
       nformy=0
      end if
      kform(8)=' '

      bgcolor='LightYellow'//char(0)
      fgcolor='black'//char(0)
      datacolor=fgcolor
      thcolor=fgcolor
      rescolor='blue'//char(0)
      do j=1,maxsub
       ncolor(j)=icolor_sub(j)
      end do

      n_subspectra=n_subset
      nexp=channels
      
      n_plotsub=n_subspectra
      axesname(1)=abscissa
      axesname(2)=ordinata
      axesname(3)=' '
      title=name_data
      if(.not.b_data) title=name_theory

c      write(6,'(a,i4)')'frame02 plot nexp=',nexp
c       write(6,'(a,a4,4i6)')'syn_plot cmch,ifrcase,scale=',
c     &                                cmch,ifrcase,mscale

      if(b_data) then
       do i=1,nexp
        daty(i)=real_fr(mfpt+i)
       end do
       do i=1,nexp
        erry(i)=real_fr(mdfpt+i)
       end do   
      end if

      nresidue=0
      do ii=1,infplot
       nchanplot(ii)=0
      end do

c       write(6,'(4(a,f10.3))')'counts=',counts,
c     &   ' T_bunch=',T_bunch, '  background=',background
c       write(6,'(6g12.2)') (thfk(i),i=1,256)
c      do j=240,250
c      write(6,'(i4,4x,2f15.6)') j,daty(j),erry(j)
c      end do
c      do j=240,250
c      write(6,'(i4,4x,f15.6)') j,thfk(j)
c      end do
c       write(6,'(a,20i4)')' ichanks=',(ichanks(i),i=0,ichanks(0))

       nthe=nTH1*2

      if(ifrcase.ge.22) then
       dx_the=abs(graz_end-graz_beg)/(ch_angle-1.0)
       dx_exp=abs(graz_end-graz_beg)/(channels-1.0)
       xb_the=graz_beg+t_shift
       xb_exp=graz_beg
      else
       dx_the=abs( T_bunch)/nthe
       dx_exp=abs(T_bunch)/channels
       xb_the=t_shift
       xb_exp=0.0
      end if

      nyy=0
      ny=0
      if(b_12) then
       call x_scale(mscale,nexp,dx_exp,xb_exp)
       if(b_data) then
        if(ndisplay_mode.eq.1)then
         do k=2,ichanks(0),2
          do j=ichanks(k-1),ichanks(k)
           ny=ny+1
           plotx(ny)=x_exp(j)
           h=abs(daty(j))
           if(h.lt.0.1) then
            ploty(ny)=0.
            ploterry(ny)=1.
            ny=ny-1
           else
            ploty(ny)=LOG10(h)
            ploterry(ny)=1./erry(j)
           end if
          end do
         end do
        else
         do k=2,ichanks(0),2
          do j=ichanks(k-1),ichanks(k)
           ny=ny+1
           plotx(ny)=x_exp(j)
           ploty(ny)=daty(j)
           ploterry(ny)=erry(j)
          end do
         end do
         if(b_theory)then
          nresidue=1
          ns=0
          do k=2,ichanks(0),2
           do j=ichanks(k-1),ichanks(k)
            ns=ns+1
            plotres(ns)=daty(j)-thfk(j)
           end do
          end do
         end if
        end if
       end if ! b_data

       if(b_theory) then
        if(ndisplay_mode.eq.1)then
         nyy=nthe
         do ii=1,nyy
          plotxx(ii)=xb_the+(ii-1)*dx_the
          plotyy(ii)=LOG10(abs(thfk(ii)+0.1))
         end do
         if(n_subspectra.gt.0) then
          do j=1,n_subspectra
           ns=(j-1)*max8
           nchanplot(6+j)=nyy
           do ii=1,nyy
            ns=ns+1
            plotsub(ns)=LOG10(abs(subspectrum(ii,j)+0.1))
           end do
          end do
         end if
        else
         nyy=nexp
         do ii=1,nyy
          plotxx(ii)=x_exp(ii)
          plotyy(ii)=thfk(ii)
         end do
         if(n_subspectra.gt.0) then
          do j=1,n_subspectra
           ns=(j-1)*max8
           nchanplot(6+j)=nyy
           do ii=1,nyy
            ns=ns+1
            plotsub(ns)=subspectrum(ii,j)
           end do
          end do
         end if
        end if
       end if  ! b_theory
      end if ! log scale


      if(b_34) then
       call x_scale(mscale,nexp,dx_exp,xb_exp)
       if(b_data) then
        do k=2,ichanks(0),2
         do j=ichanks(k-1),ichanks(k)
          ny=ny+1
          plotx(ny)=j
          ploty(ny)=daty(j)
          ploterry(ny)=erry(j)
          if(daty(j).lt.0.1) ny=ny-1
         end do
        end do
        if(b_theory.and.ndisplay_mode.eq.4)then
         nresidue=1
         ns=0
         do k=2,ichanks(0),2
          do j=ichanks(k-1),ichanks(k)
           ns=ns+1
           plotres(ns)=daty(j)-thfk(j)
          end do
         end do
        end if
       end if ! b_data

       if(b_theory) then
        nyy=nthe
        if(b_data)nyy=ny
        do ii=1,nyy
         plotxx(ii)=ii
         plotyy(ii)=thfk(ii)
        end do
        if(n_subspectra.gt.0) then
         do j=1,n_subspectra
          ns=(j-1)*max8
          nchanplot(6+j)=nyy
          do i=1,nyy
            ns=ns+1
            plotsub(ns)=subspectrum(ii,j)
          end do
         end do
        end if
       end if  ! b_theory
      end if ! counts
c    &

c      display_mode(5)='velocity scale, cross section'
c      abscissa='[mm/s]'
c      ordinata='cross section'

c      display_mode(5)='channel scale, cross section'
c      abscissa='channels'
c       ordinata='cross section'

      if(ndisplay_mode.eq.5.or.ndisplay_mode.eq.6) then
       schrw=1.0
       nresidue=0
c       cv_ET=100.*wavelength
c       iT_max=aiT_max
c       iT_max2=2**iT_max

       if(ndisplay_mode.eq.5) schrw=8*srw8
c       if(ndisplay_mode.eq.9) schrw=cv_ET/abs(T_bunch*iT_max2)
       schrw=schrw*nsrw
c       write(6,'(a,2i8,f10.4)')
c     &   'array_fr( nn+),nCP,nsrw,schrw=',nCP,nsrw,schrw

       nyy=0
       hm=0.
       do ii=-nCP,nCP-1
        jj=nstorTH1+(nCP+ii)*4
        nyy=nyy+1
        plotxx(nyy)=schrw*ii
        htr=0.0
c        do k=1,4
c         htr=htr+array_fr(jj+k)*conjg(array_fr(jj+k))
        do k=1,4,3
         htr=htr+real(array_fr(jj+k))
        end do
        if(hm.lt.htr) hm=htr
        plotyy(nyy)=htr
       end do
       plotyy(nyy-1)=2.*hm
       plotyy(nyy)=-2.*hm


c      write(6,'(a,2i4,f10.4)') ' nyy,nCP,schrw=',nyy,nCP,schrw
       n_plotsub=8
       n_subspectra=n_plotsub
       do j=1,n_plotsub/2
        ns=2*(j-1)*nyy
        nchanplot(5+2*j)=nyy

        do ii=-nCP,nCP-1
         jj=nstorTH1+(nCP+ii)*4
         ns=ns+1
         plotsub(ns)=real(array_fr(jj+j))
c         if(abs(ii).lt.5) write(6,'(2i4,f15.3)') j,ns,plotsub(ns)
        end do
c        write(6,'(a,4i8)') ' real nstorTH1,j,nyy=',nstorTH1,j,nyy
c        write(6,'(8f10.4)')
c     &     (plotsub(ii),ii=2*(j-1)*nyy+1,(2*j-1)*nyy,32)
        ns=(2*j-1)*max8
        nchanplot(6+2*j)=nyy
        do ii=-nCP,nCP-1
         jj=nstorTH1+(nCP+ii)*4
         ns=ns+1
         plotsub(ns)=aimag(array_fr(jj+j))
c         if(abs(ii).lt.5) write(6,'(2i4,f15.3)') j,ns,plotsub(ns)
        end do
c       write(6,'(a,2i6)') ' aimag nstorTH1,j=',nstorTH1,j
c       write(6,'(8f10.4)') (plotsub(ii),ii=(2*j-1)*nyy+1,2*j*nyy)
       end do

      end if ! 5,6

      xmin=1.e30
      xmax=-xmin
      ymin=xmin
      ymax=0.                       ! counts > 0
      if(b_data.and.ndisplay_mode.lt.5) then
       do ii=1,3
        nchanplot(ii)=ny
       end do
       if(xmin.gt.plotx(1))xmin=plotx(1) 
       if(xmax.lt.plotx(ny))xmax=plotx(ny) 
       if(xmin.gt.plotx(ny))xmin=plotx(ny) 
       if(xmax.lt.plotx(1))xmax=plotx(1) 
       do i=1,ny
        if(ymin.gt.ploty(i)-ploterry(i))ymin=ploty(i)-ploterry(i)
       end do
       do i=1,ny
        if(ymax.lt.ploty(i)+ploterry(i))ymax=ploty(i)+ploterry(i)
       end do
      else
       do ii=1,4
        nchanplot(ii)=0
       end do
      end if
    
      if(b_theory) then
       nchanplot(5)=nyy
       nchanplot(6)=nyy
       if(xmin.gt.plotxx(1))xmin=plotxx(1) 
       if(xmax.lt.plotxx(nyy))xmax=plotxx(nyy) 
       if(xmin.gt.plotxx(nyy))xmin=plotxx(nyy) 
       if(xmax.lt.plotxx(1))xmax=plotxx(1) 
       do i=1,nyy-2
        if(ymin.gt.plotyy(i))ymin=plotyy(i)
       end do
       do i=1,nyy-2
        if(ymax.lt.plotyy(i))ymax=plotyy(i)
       end do
       if(n_subspectra.gt.0) then
         do j=1,n_subspectra
          ns=(j-1)*max8
          do i=1,nyy
           if(ymin.gt.plotsub(ns+i))ymin=plotsub(ns+i)
          end do
         end do
       end if
      end if

      if(nresidue.eq.1) then
        nchanplot(4)=ny
        resmin=0.
        resmax=0.
        do i=1,ny
         hd= plotres(i)-ploterry(i)           
         if(resmin.gt.hd) resmin=hd
        end do
        do i=1,ny
         hd= plotres(i)+ploterry(i)           
         if(resmax.lt.hd) resmax=hd
        end do
         hd= resmax-2.0*resmin 
        do i=1,ny
         plotres(i)=plotres(i)+ymax-resmin
        end do
        ymax=ymax-resmin+resmax
      end if
       xyzdz(1)=xmin
       xyzdz(2)=xmax
       xyzdz(3)=ymin
       xyzdz(4)=ymax

       bgcolor='Ivory'//char(0)     ! color background  (0...) [0]
       fgcolor='black'//char(0)
       datacolor=fgcolor
       thcolor=fgcolor
       rescolor='blue'//char(0)
       do j=1,maxsub
        ncolor(j)=icolor_sub(j)
       end do
       
       logx=0
       logy=0
       if(b_logx)logx=1
       logf=0
       if(b_logy)logf=1

c      definitions taken from allplo
c      x
       chx='b'                 ! (none,Both,bottom,top)  [B]
       chbx='n'                ! (none,bottom,top)  [n]
       chlr='l'                ! (left,right)  [r]
c      y
       chy='B'                 ! (none,Both,left,right)  [B]
       chby='r'                ! (none,left,right)  [r] 
       chbt='t'                ! (bottom,top)  [t]
       chh=0.3                 ! 
       chw=0.25                ! character cw,ch  [0.40,0.40]         
       syw=0.1                 !
       syh=0.1                 ! symbol sw,sh     [0.40,0.40]
       frcolor=fgcolor         ! color frame       [black]
       frcolor='blue'//char(0) 
       CTEXT=title
       CXTEXT=abscissa
       CYTEXT=ordinata
         
       call frame(chx,chbx,chlr,chy,chby,chbt,b_logx,b_logy,
     &            chh,chw,syw,syh,
     &          CTEXT,CXTEXT,CYTEXT,nformx,nformy,frcolor,bgcolor)

c       write(6,'(a,4g12.6)')' min-max=',xmin,xmax,ymin,ymax

c      write(6,'(a,f15.5)') ' in frame in plotf plotyy(2)=',plotyy(2)
c       write(6,'(8f10.4)') (plotx(ii),ii=1,ny,16)
c       write(6,'(8f10.4)') (ploty(ii),ii=1,ny,16)
c      write(6,'(a,3i8)') 'syn_plot xx nexp,nyy=',nexp,nyy
c      write(6,'(8f10.4)') (plotxx(ii),ii=1,nyy,16)
c      write(6,'(a,3i8)') 'syn_plot yy nexp,nyy=',nexp,nyy
c      write(6,'(8f10.4)') (plotyy(ii),ii=1,nyy)

      return
      end



      subroutine x_scale(mscale,nexp,dx_exp,xb_exp)
      implicit none
      include 'comglb.for'
      include 'comdat.for'
      include 'comthe.for' 
    
      real x_exp,xb_exp,dx_exp,x
      common/ascale/x_exp(maxn)
      integer mscale,nexp,k,i

      if(.not.b_data) then
       if(mscale.eq.2) then
        write(nwr,'(a)')' **warning** scale=2 requires data; set to 1'
        mscale=1
       end if
      end if

      goto (100,200,1000),mscale
      
 100  continue
c     scale of experimental points 
      x=xb_exp-dx_exp
      do k=1,nexp
       x=x+dx_exp
       x_exp(k)=x
      end do
      goto 1000
      
 200  continue
c     scale of experimental points 
c     data for time or angle array taken from data file
      do i=1,nexp
       x_exp(i)=real_fr(mxpt+i)
      end do

 1000  continue
      return
      end
      



      subroutine data2dread(n1,info)
      implicit none
      include 'comglb.for'
      include 'compar.for'
      include 'comdat.for'
      include 'comdas.for'
      include 'comthe.for'
c      include 'comscd.for'


      integer   n1,info,icdum
      character*132 chnext,chcom,ch132,cp132,querytype,chardata*80,
     &              carray*4,chl*24,chr*24,form*7,ch1*1,chf*4,
     &              ch6*6,ch2*2,dacom*4
      integer     ldacom,iplace,iextra,irow,ig
      real        out
      parameter   (icdum = i_stmp-24-5*33-8-80-48-32-16)
      common/stmp/ ldacom(8),iplace(8),iextra(8),
     &             chnext,chcom,ch132,cp132,querytype,dacom(8),
     &             chardata(4),chl,chr,form,ch1,chf(32),ch6,ch2,
     &             out(32),irow(16),carray(icdum)
c      logical     b_dat
c      dimension   b_dat(max8)
      real        array,h
      common/plot/array(MDBPLFT*2)
c      equivalence (array(1),b_dat(1))
      integer      i,ip,ipos,ir,ifound,ih,j,j1,jj1,jj2,k,nt,nj,irn

c     write(6,'(a,5i7)') '  iarray_sp,nstorFR=',iarray_sp,nstorFR
c     only even number of channels are handled
c      write(6,'(a,i4,2x,a)')'dataread n1,readform=',
c     &  n1,readform

      do k=1,8
       ldacom(k)=0
       iplace(k)=0
       iextra(k)=0
      end do

      ip=1
      ih=0
      nt=0
c      write(6,'(2a)')'cdata_str=', cdata_str    ! from data file
      ch132=cdata_str
      do while(ip.gt.0)
       call nextchar(ch132,ih,ipos,cp132,ip)
       ch132=cp132
       ih=ip
       nt=nt+1
c      write(6,'(i5,2x,a)') ip,cp132(1:24)

       if(nt.eq.8.or.ip.eq.0)then
        ip=0
        dacom(nt)=' '
        ldacom(nt)=ip
       else
        dacom(nt)=cp132(1:ip)
        ldacom(nt)=ip
        end if
       end do
       nt=nt-1
c      write(6,'(a,10a6)') ' dacom=',(dacom(i),i=1,nt)
c      write(6,'(a,10i5)') ' ldacom=',(ldacom(i),i=1,nt)

c      write(6,'(2a)') 'from th data_str=',data_str            ! from fr_theory
      ch132=data_str
      ip=1
      ih=0
      ir=0
      nj=0
      do while(ip.gt.0)
       call nextchar(ch132,ih,ipos,cp132,ip)
       ch132=cp132
       ih=ip
       nj=nj+1
       ifound=10
       if(nj.eq.8) ip=0
       if(ip.gt.0) then
        ifound=0
c       write(6,'(i5,2x,a)') ip,cp132(1:24)
        do k=1,nt
c        write(6,'(a,i2,a,a4,2x,a)') 'k=',k,' dacom(k)=',
c     &                   dacom(k),cp132(1:ip)
         if(cp132(1:ip).eq.dacom(k)) then
          ir=ir+1
          iplace(ir)=k
          ifound=1
         end if
        end do
       end if
       if(ifound.eq.0) then
        do k=1,nt
         if(cp132(1:1).eq.'d'.and.cp132(2:2).eq.dacom(k)) then
c         write(6,'(a,i2,a,a4,2x,a)') 'found=0 k=',k,
c     &   ' dacom(k)=',dacom(k),cp132(1:2)
          iextra(ir)=k
          ifound=1
         end if
c        write(6,'(a,2i5)') 'k,ifound=',k,ifound
        end do
       end if
       if(ifound.eq.0) then
        info=23
        infotext(1)='effi/data/read_data/format'
        infotext(3)='expected data format not on data file'
        infotext(4)='format: '//cdata_str(:12)//'expected format: '
     &    //data_str
        infotext(5)=' '
        goto 250
       end if
      end do
c      write(6,'(a,i4)')   ' return, ifound=',ifound
c      write(6,'(a,10i5)') ' ldacom=',(ldacom(i),i=1,8)
c      write(6,'(a,10i5)') ' iplace=',(iplace(i),i=1,8)
c      write(6,'(a,10i5)') ' iextra=',(iextra(i),i=1,8)

c     reading of data type n=1,2,...,8
c     storing data of type istortype=1...8
      ip=-1
      do k=1,ir
       j=nt-iplace(k)
       ip=ip+1
       jj1=j1+ip*nchannelsp
       if(iextra(k).gt.0) then
        ip=ip+1
       end if
      end do
c      write(6,'(a,6i6)') 'cc ip,nchannelsp=',ip,nchannelsp
      nuofdatas=(ip+1)*int((nchannelsp+1)/2)
c      write(6,'(a,6i6)') ' nuofdatas=',nuofdatas
      if(n1.eq.0) return

      k=nchannelsp*nt
c     write(6,'(a,6i6)') ' n1,nt,k,nchannelsp=',n1,nt,k,nchannelsp
      i=index(readform,'free')
      if(i.gt.0)then
       ch132=readform(2:i)
       call trlch(i+1,ch132,irn,out) 
       do i=1,irn
        irow(i)=out(i)
       end do
            
       j=0
       do while(j.lt.k) 
        read(n1,'(a)',end=50,err=240)ch132
        call trlch(80,ch132,ipos,out)
        do ip=1,irn
         array(ip+j)=out(irow(ip))
        end do
        j=j+irn
       end do
      else
c      write(6,'(a,a)') ' readform=',readform
       read(n1,readform,end=50,err=240) (array(i),i=1,k)
      end if
      goto 60
 50   info=25
      infotext(3)='read found EOF'
      infotext(4)=' '
      goto 250
 60   continue
 
      ip=-1
      j1=2*(iarray_sp+nstorFR)
      do k=1,ir
       j=nt-iplace(k)
       ip=ip+1
       jj1=j1+ip*nchannelsp
c       write(6,'(a,6i7)') ' ir,iplace(k),nt,j,jj1,iextra(k)=',
c     &                 ir,iplace(k),nt,j,jj1,iextra(k)
       do i=1,nchannelsp
        real_fr(jj1+i)=array(nt*i-j)
       end do
c       write(6,'(8f10.2)')(real_fr(jj1+i),i=1,nchannelsp,16)
       if(iextra(k).gt.0) then
        ip=ip+1
        jj2=j1+ip*nchannelsp
c       write(6,'(a,6i7)') ' ip,iplace(k),nt,j,jj2=',
c     &                 ip,iplace(k),nt,j,jj2
        do i=1,nchannelsp
         h=real_fr(jj1+i)
         if(h.gt.0) then
          real_fr(jj2+i)=sqrt(h)
         else
          real_fr(jj2+i)=1.
         end if
        end do
       end if
      end do
c      write(6,'(a,6i6)') 'cc ip,nchannelsp=',ip,nchannelsp

      goto 250
 240  continue
c     read error format?
      info=24
      infotext(3)='read error of data file, identified format:'
      infotext(4)=readform
      infotext(5)=' '
 250  continue
      return
      end

      subroutine punch2d(nout,info)

      include 'comglb.for'
      include 'compar.for'
      include 'comdat.for'
      include 'comdas.for'
      include 'comthe.for'
      include 'comscd.for'

      integer     icdum
      real        out
      character   carray*4,ch132*132,cp132*132,cpunch*132,
     &            iform*132,k2form*8,stringnumber*40,chl*24,chr*24,
     &            form*7,su*2
      parameter   (icdum =i_stmp-7*infplot-32-4*33-22)
      common/stmp/iplace(infplot),lname(infplot),jp(infplot),out(32),
     &            ch132,cp132,iform,cpunch,stringnumber,
     &            chl,chr,k2form(2*infplot),
     &            carray(icdum)

      integer     ifeder,ltext,idumpl,int3d,npnt3d,ncolor,
     &            npntplot,nchanplot,n_plotsub,maxn6,max8subn,
     &            logx,logy,logf
      character   axesname*24,
     &            namechan*4,kform*8,chdum*4,axisformat*16,
     &            title*132,plotstrdef*80,plotstrpu*132
      real        plotarray,xyzdz
      parameter   (max8subn=maxsub*max8,maxn6=max8*6,
     &            idumpl=MDBPLFT*2-140*maxn-8*39-maxsub-5*infplot-120)
      common/plot/plotarray(maxn6+max8subn),
     &            xyzdz(8),vtxt(2,maxn*4),vtxtp(8,32),
     &            int3d(maxn*16),npnt3d(16),ifeder(4*maxn),ltext(32),
     &            npntplot(infplot),nchanplot(infplot),ncolor(maxsub),
     &            n_subspectra,logx,logy,logf,
     &            namechan(infplot),kform(infplot),axisformat(3),
     &            axesname(3),title,plotstrdef,plotstrpu,
     &            chdum(idumpl)
c                 chardum[14964]
      character*132 cpunchsu,cpunchw,cpunchstrj


      k=1
      do while(kform(k).ne.' '.and.k.lt.infplot)
       k2form(k)=kform(k)
c       write(6,'(a)')kform(k)
       k=k+1
      end do
      k=k-1
      do i=1,k
       k2form(k+i)=kform(k)
      end do


c      do ii=1,infplotarray*2
c       scratch(ii)=plotarray(ii)
c      end do
      do k=1,infplot
       l=index(namechan(k),' ')
       lname(k)=l-1
       if(lname(k).le.0) lname(k)=4
      end do

      cpunch=plotstrpu
      call stringlength(cpunch,l)
      do k=1,l
       if(cpunch(k:k).eq.',')cpunch(k:k)=' '
      end do
      nsequence=1
 100  continue
c      write(6,'(2a)') 'print  100:',cpunch(1:60)
      jka=index(cpunch,'(')
      jkz=index(cpunch,')')
      cpunchstrj=' '
      if(jka.gt.0.and.jkz.gt.0) then
       cpunchstrj=cpunch(jka:jkz)
       if(jka.gt.1)then
        if(cpunch(jka-1:jka-1).eq.'d')cpunchstrj='d'//cpunch(jka:jkz)
       end if
       nsequence=0
       cpunchw=cpunch(jka+1:jkz-1)
       cp132=cpunch(jkz+1:)
       cpunch=cp132
      else
       cpunchstrj=cpunch
       cpunchw=cpunch
       cpunch=' '
      end if

      do k=1,8
       iplace(k)=0
      end do

      su=namechan(mplot+1) 
c      write(6,'(3a)')'namechan(mplot+1)=',namechan(mplot+1)  
      ir=0

 200  continue
c      write(6,'(3a)') ' 200: cpunchw=',cpunchw(1:30)
      isu=index(cpunchw,su)
      if(isu.gt.0) then
       ch132=cpunchw(1:isu-1)
       cp132=cpunchw(isu:)
       cpunchw=cp132
c       write(6,'(3a)') 'isu.gt.0: cpunchw=',cpunchw(1:30)
       ipw=0
       k=1
       do while(k.le.mplot.and.ipw.eq.0)
        ipw=index(cpunchw,namechan(k)(1:lname(k)))
c       write(6,'(i4,3a)') ipw,'=ipw: cpunchw,namechan(k)=',
c     &       cpunchw(1:30),namechan(k)(1:lname(k))
        k=k+1
       end do
       if(ipw.gt.0) then
        cp132=cpunchw(ipw:)
        cpunchsu=cpunchw(1:ipw-1)
        cpunchw=cp132
c       write(6,'(3a)') 'ipw.gt.0: cpunchw,cpunchsu=',
c    &    cpunchw(1:30),cpunchsu(1:30)
       else
        cpunchsu=cpunchw
        cpunchw=' '
c       write(6,'(3a)') 'ipw.eq.0: cpunchw,cpunchsu=',
c    &    cpunchw(1:30),cpunchsu(1:30)
       end if
      else
       ch132=cpunchw
c      write(6,'(3a)') 'isu.eq.0: cpunchw=',cpunchw(1:30)
       cpunchsu=' '
       cpunchw=' '
      end if

      ifound=0
      ip=1
      ih=0
 210  continue
      call nextchar(ch132,ih,ipos,cp132,ip)
      ch132=cp132
      ih=ip
c     write(6,'(a,i5,2x,a)') 'ip,cp132(1:24)=',ip,cp132(1:24)

      if(ip.gt.0) then
       do k=1,infplot
c       k=0
c       do while(ifound.eq.0.and.k.lt.infplot)
c        k=k+1
c        write(6,'(i4,a,i2,a,a4,2x,a)') ifound,' k=',k,' namechan(k)=',
c     &          namechan(k)(1:lname(k)),cp132(1:ip)
        if(namechan(k)(1:lname(k)).eq.cp132(1:ip)) then
c         write(6,'(a,i2,a,a4,2x,a)') 'k=',k,' namechan(k)=',
c     &                   namechan(k),cp132(1:ip)
c         write(6,'(a)') cpunchw(1:80)
         ir=ir+1
         iplace(ir)=k
         ifound=1
        end if
       end do
c       write(6,'(a,10i4)') ' ir,ifound=',ir,ifound
       if(ifound.eq.0) then
        write(nwr,'(3a)')
     &         '**error** ',cp132(1:ip),' is not a data type'
       end if
       goto 210
      end if
c      write(6,'(a)') cpunchsu(1:80)
      nch=132
      isu=index(cpunchsu,'su')
      if(isu.gt.0) cpunchsu(isu:isu+1)=' '
      call panum(cpunchsu,n_plotsub,1)
c      write(6,'(a,10i4)') ' npanum=',(npanum(i),i=1,10)
c      write(6,'(a,10i4)') ' ir,mplot=',ir,mplot
      do k=1,npanum(2)
       iplace(ir+k)=mplot+npanum(2+k)
      end do
      ir=ir+npanum(2)
c     write(6,'(2a)') 'cpunchw=',cpunchw(1:60)
      if(cpunchw.ne.' ') goto 200
c     write(6,'(a,8f8.3)') 'rsyco=',(rsyco(ipk),ipk=1,8)

      if(ir.eq.0) goto 1000
      write(nout,'(a)') title

c       write(6,'(a,20i3)') ' nseq=0,iplace=',(iplace(i),i=1,ir)
        ipk=iplace(1)
        ch132=k2form(ipk)
        call stringlength(ch132,il)
        iform='('//ch132(1:il)
        if=il+1
        do k=2,ir
         ipk=iplace(k)
         ch132=k2form(ipk)
c        write(6,'(a,2x,a)') 'ipk,k2form',ipk,k2form(ipk)
         call stringlength(ch132,il)
         iform(if+1:if+1+il)=','//ch132(1:il)
         if=if+1+il
        end do
        iform(if+1:if+1)=')'
        lfr=if+1
        call stringlength(cpunchstrj,lpw)
        write(nout,'(a,2x,a)') iform(:lfr),cpunchstrj(:lpw)
        write(nwr,'(17x,a,2x,a)') iform(:lfr),cpunchstrj(:lpw)
        form='i5'
        ip1=iplace(1)
        rn=nchanplot(ip1)
        call trlnu(form,rn,chr,ii,chl,il)
        stringnumber='nu_channels='//chl(1:il)
        write(nout,'(a)') stringnumber

        do k=1,ir
         jp(k)=(iplace(k)-1)*max8
c        write(6,'(a,3i5,2x,f15.6)') ' ir,iplace(k),j,plotarray(j+1)=',
c     &                 ir,iplace(k),jp(k),plotarray(jp(k)+1)-1.
        end do
        do i=1,nchanplot(iplace(1))
         write(nout,iform) (plotarray(jp(k)+i),k=1,ir)
        end do
        write(nout,'(a)') (axesname(i),i=1,3)
       if(cpunch.ne.' ') goto 100
 1000  continue
      return
      end

      subroutine testplot
      include 'comglb.for'
      integer  idum
      common/plot/ idum(MDBPLFT*2)
      return
      end
