      subroutine synoffspec_plot(cmch,info)
      implicit none
      include 'comglb.for'
      include 'compar.for'
      include 'comthe.for'
      include 'comdat.for'
      include 'complt.for'
      include 'comdas.for'

      integer     ifrth,idex,dstr,istr,iaddr,istruct1,istruct2,l1_get,
     &            info,mstruct1,idum1,nstorTH1,nTH1,nCP,idum2,nsrw,idum
      real       srw8
      parameter (istr=34+3*(maxfr1+maxfr2)-maxfr1+3*maxthss)
      common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),     !13.9.05 
     &              l1_get(0:maxfr1),dstr(istr),
     &              idum1,nstorTH1,iaddr(6),                 !13.9.05
     &              nTH1,nCP,idum2,nsrw,ifrth(4),
     &              idum(8),srw8,idex(7)

      
      integer      n_subspectra,idumpl,logx,logy,logf,
     &             int3d,npnt3d,ifeder,ltext,npntplot,nchanplot,ncolor
      real         parray,xyzdz,vtxt,vtxtp
      character*24 axesname,abscissa,ordinata,bgcolor,fgcolor,datacolor,
     &             thcolor,rescolor,auxcolor1,auxcolor2,auxcolor3,
     &             cmch*4,namechan*4,kform*8,chardum*4,axisformat*16,
     &             title*132,datfile*80,plotstrdef*80,plotstrpu*132
      parameter  (idumpl=MDBPLFT*2-140*maxn-8*39-5*infplot-maxsub-188)
      common/plot/ parray(maxn*112),xyzdz(8),vtxt(2,maxn*4),vtxtp(8,32),
     &             int3d(maxn*16),npnt3d(16),ifeder(4*maxn),ltext(32),
     &             npntplot(infplot),nchanplot(infplot),ncolor(maxsub),
     &             n_subspectra,logx,logy,logf,
     &             namechan(infplot),kform(infplot),axisformat(3),
     &             axesname(3),title,plotstrdef,plotstrpu,
     &             bgcolor,fgcolor,datacolor,thcolor,rescolor,
     &             auxcolor1,auxcolor2,auxcolor3,datfile,chardum(idumpl)

      real          acsp,wavelength,uthick_A,
     &              unitchi,aiT_max,v_max,
     &              ak_extension,T_bunch,scale,channels,columns,
     &              strob_order,t1_window,t2_window,flag_basis,  
     &              th_channels,Th_approx,angpairs,dumcsp
      common/acstrf/acsp,wavelength,uthick_A,
     &              unitchi,aiT_max,v_max,
     &              ak_extension,T_bunch,scale,channels,columns,
     &              strob_order,t1_window,t2_window,flag_basis,  
     &              th_channels,angpairs,Th_approx,dumcsp(icstrf-18)

c      real          acsp,wavelength,uthick,
c     &              unit_chi,aiT_max,v_max,
c     &              ak_extension,T_bunch,scale,channels,
c     &              ch_angle,graz_beg,graz_end,dumcsp
c      common/acstrf/acsp,wavelength,uthick,
c     &              unit_chi,aiT_max,v_max,
c     &              ak_extension,T_bunch,scale,channels,
c     &              ch_angle,graz_beg,graz_end,dumcsp(icstrf-13)

      real          avsp,counts,background,Pxsi,Peta,Pzeta,
     &              t_shift,dumvsp
      common/avstrf/avsp,counts,background,Pxsi,Peta,Pzeta,
     &              t_shift,dumvsp(ivstrf-7)


      integer    idumscrt,idumsc
      parameter(idumscrt=maxscrt-maxn*maxsub-5*maxn)
      real        datx,errx,sym,subspectrum,daty,erry
      common/scrt/datx(maxn),errx(maxn),sym(maxn),
     &            subspectrum(maxn,maxsub),
     &            daty(maxn),erry(maxn),idumsc(idumscrt)

      integer   ib_df,kana,ibmisfit
      real      thfk,dfdp,ddpk
      common/fr2fi/thfk(max8),dfdp(max8),ddpk,ib_df,kana,ibmisfit

      real x_exp,x_the
      common/scale3d/  x_exp(maxn),x_the(maxn)
      character TEXT*80,chl*24,chr*24,form*7,ch4*4,bsl*1,dbsl*2
      integer   i,i0,ii,j,jj,k,ISTEU,j6th,j9th,nchannel,ny,
     &          icase,n_omega,n_theta,nstorTH,i_angle,i_angp1,k_omega,
     &          nn,im,i_theta,ntxt
      real      h,h1,Xl,Yl,Zl,BREITE,HOEHE,alpha,rad,
     &          thmax,damax,damin,scmin,
     &          omega,omega_beg,domega,omega_end,omegaend,omegabeg,
     &          theta,dtheta,theta_beg,theta_end,thetaend,thetabeg,
     &          anglemax,grazinc,grazout,X0,Y0,
     &          xend,yend,xbeg,ybeg,vxend,vyend,vxbeg,vybeg
      logical   omgtheta,log_mode,b_showangles

      real         plotx,ploty,ploterry,plotres,plotxx,plotyy,OP
      dimension    plotx(max8),ploty(max8),ploterry(max8),plotres(max8),
     &             plotxx(max8),plotyy(max8),OP(0:8)
       equivalence (parray(1),plotx(1)),(parray(max8+1),ploty(1)),
     &             (parray(max8*2+1),ploterry(1)), 
     &             (parray(max8*3+1),plotres(1)), 
     &             (parray(max8*4+1),plotxx(1)),
     &             (parray(max8*5+1),plotyy(1))

      logical         b_logx,b_logy
      character*1     chx,chbx,chlr,chy,chby,chbt
      character*80    CTEXT,CXTEXT,CYTEXT,frcolor*24 
      integer         nformx,nformy
      real            chh,chw,syw,syh

      nchannel=channels
      j6th=max8*6
      j9th=max8*9
      b_showangles=angpairs.gt.0.
      do k=1,infplot
       nchanplot(k)=0 
      end do      
      icase=int(real(array_fr(l1_get(0)+1)))
      if(.not.b_theory) then
       info=10
       infotext(1)='effi/3dplot/notheory'
       infotext(2)=
     & '*** no theory calculated -> no dimensions of the plot'
       infotext(3)='calculate dummy (z=0) to obtaine x,y grid '       
       infotext(4)=' '
       return
      end if
      i0=ichar('0')
      if(cmch.eq.'dmod') then
       namechan(1)='xd'
       namechan(2)='yd'
       namechan(3)='zd'
       namechan(4)='dz'
       namechan(5)='res'
       namechan(6)='xt'
       namechan(7)='yt'
       namechan(8)='zt'
       namechan(9)='  '
       display_mode(1)='angle scale (linear scale)'
       display_mode(2)='angle scale-(log scale)'
       if(icase.lt.3.or.icase.eq.5)then
        display_mode(3)='channel scale (2d) (linear scale)'
        display_mode(4)='channel scale (2d) (log scale)'
       end if
       return
      end if
      nformx=1
      nformy=1
      b_logx=.false.
      b_logy=.false.
      log_mode=ndisplay_mode.eq.2.or.ndisplay_mode.eq.4
      if(log_mode) then
       kform(1)='f7.2'
       kform(2)='f8.4'
       kform(3)='f8.6'
       kform(4)='f10.6'
       kform(5)='f7.2'
       kform(6)='f8.4'
       kform(7)='f8.4'
       kform(8)='f8.4'
       b_logy=.true.
      else
       kform(1)='f10.3'
       kform(2)='f10.3'
       kform(3)='f8.1'
       kform(4)='f8.1'
       kform(5)='f6.0'
       kform(6)='f10.3'
       kform(7)='f10.3'
       kform(8)='f10.0'
      end if
      kform(9)=' '
      plotstrdef='(xd,yd,zd,dz) (xt,yt,zt)'

      ii=index(file_data,'.')
      datfile='P'//file_data(1:ii)//'ps'//char(0)

      bgcolor='Ivory'//char(0)
      fgcolor='black'//char(0)
      datacolor=fgcolor
      thcolor=fgcolor
      rescolor='blue'//char(0)
      do j=1,maxsub
       ncolor(j)=icolor_sub(j)
      end do

      rad=0.0174533
      do i=1,16
       ltext(i)=0
      end do


c      n_theta,theta_beg,dtheta,n_omega,omega_beg,domega
       n_omega=int(real(array_fr(l1_get(0)+2)))
       n_theta=int(aimag(array_fr(l1_get(0)+2)))
       omgtheta= n_omega.ge.n_theta 
       omega_beg=real(array_fr(l1_get(0)+3))
       domega=aimag(array_fr(l1_get(0)+3))
       theta_beg=real(array_fr(l1_get(0)+4))
       dtheta=aimag(array_fr(l1_get(0)+4))
       omega_end=real(array_fr(l1_get(0)+5))
       theta_end=aimag(array_fr(l1_get(0)+5))

       nstorTH=l1_get(0)+6               ! see th_scanmode()

c       write(6,'(a,i4,4x,3f10.4)')
c     &  'n_theta,theta_beg,dtheta,theta_end=',
c     &   n_theta,theta_beg,dtheta,theta_end
c       write(6,'(a,i4,4x,3f10.4)')
c     &   'n_omega,omega_beg,domega,omega_end=',
c     &   n_omega,omega_beg,domega,omega_end

       if(ndisplay_mode.ge.3) goto 1000         
c        display_mode(1)='angle scale (linear scale)'
c        display_mode(2)='angle scale-(log scale)'
c        display_mode(3)='channel scale (2d) (linear scale)'
c        display_mode(4)='channel scale (2d) (log scale)'
        if(icase.eq.1.or.icase.eq.4)then
         h=(omega_end-omega_beg)
         h1=(theta_end-theta_beg)
         if(h.lt.h1)h=h1 
         xyzdz(1)=omega_beg-1 
         xyzdz(2)=(h+2.)/2. 
         xyzdz(3)=theta_beg-1
         xyzdz(4)=xyzdz(2)
         anglemax=theta_end
         if(theta_end.lt.omega_end) anglemax=omega_end
         thetabeg=theta_beg
         omegabeg=omega_beg
         thetaend=theta_end*1.01
         omegaend=theta_end*1.01
        else if(icase.eq.2.or.icase.eq.3)then
         xyzdz(1)=omega_beg 
         xyzdz(2)=(theta_end-omega_beg)/2. 
         xyzdz(3)=omega_beg 
         xyzdz(4)=(theta_end-omega_beg)/2.
         anglemax=theta_end 
         thetaend=theta_end*1.01
         omegaend=theta_end*1.01
         thetabeg=omega_beg
         omegabeg=omega_beg
        else if(icase.eq.5)then
         h=omega_end
         xyzdz(1)=omega_beg-1 
         xyzdz(2)=(h+2.)/2. 
         xyzdz(3)=theta_beg-1
         xyzdz(4)=xyzdz(2)
         anglemax=theta_end
         if(theta_end.lt.omega_end) anglemax=omega_end
         thetabeg=theta_beg
         omegabeg=omega_beg
         thetaend=omega_end*1.01
         omegaend=omega_end*1.01
        end if

       i_angle=0
       i_angp1=0
       j=0
c      ------caculation of the specular angles (red line)-------
       omega=omega_beg-domega
       do while(omega.lt.anglemax)       
        omega=omega+domega
        i_angp1=i_angp1+1
        j=3*(i_angp1-1)+j6th
        parray(j+1)=omega
        parray(j+2)=omega
c        write(6,'(a,6f12.2)')'omega, omega_beg/end Theta_beg/end=',
c     &               omega,omegabeg,omegaend,thetabeg,thetaend
        if(omega.gt.thetaend.or.omega.lt.thetabeg .or.
     &     omega.gt.omegaend.or.omega.lt.omegabeg)i_angp1=i_angp1-1
        parray(j+3)=0.0
        if(log_mode) parray(j+3)=1.0 
       end do     ! n_omega
       i_angp1=i_angp1+1
       j=3*(i_angp1-1)+j6th
       parray(j+1)=i_angle
       parray(j+2)=0
       parray(j+3)=-1.
c      ------ end of caculation of the specular angles (red line)-------


      do i_theta=1,n_theta
       theta=theta_beg+dtheta*(i_theta-1)

       do k_omega=1,n_omega        
        omega=omega_beg+domega*(k_omega-1)

        if(icase.eq.1.or.icase.eq.4) then
          grazinc=omega
          grazout=theta
        else if(icase.eq.2.or.icase.eq.3) then
           grazinc=omega_beg+domega*(k_omega-1)+(i_theta-1)*dtheta
           grazout=2*omega_beg+domega*(n_omega-1)+
     &       (i_theta-1)*dtheta*2-grazinc
        else if(icase.eq.5) then
c        PHI_s=omega N_s=n_omega
         j=i_theta/2
         if(2*j.eq.i_theta) then
c         + dTheta_out
          grazinc=omega
          grazout=(omega+dtheta*j)
         else
c         + dTheta_out
          grazinc=(omega+dtheta*j)
          grazout=omega
         end if
         if(omega+dtheta*j.gt.omega_end)goto 77
        end if
        i_angle=i_angle+1   
        i_angp1=i_angp1+1
        j=3*(i_angp1-1)+j6th
        parray(j+1)=grazinc
        parray(j+2)=grazout


        if(b_showangles) then
         parray(j+3)=0.01
        else
         h=real_fr(2*nstorTH+i_angle)*counts+background
c         write(6,'(i8,2g12.3)')nstorTH+i_angle,
c     &                  real_fr(2*nstorTH+i_angle),h 
         if(log_mode)then
          parray(j+3)=alog10(h)
c         write(6,'(i8,2g12.3)')j,h, parray(j+3)
         else
          parray(j+3)=h
         end if
        end if
 77     continue
       end do     ! n_omega
        i_angp1=i_angp1+1
        j=3*(i_angp1-1)+j6th
        parray(j+1)=i_angle
        parray(j+2)=0
        parray(j+3)=-1.
       end do     ! n_theta

       i_angp1=i_angp1+1
       j=3*(i_angp1-1)+j6th
       parray(j+1)=-1.
       parray(j+2)=-1.
       parray(j+3)=-1.

c       write(6,'(3f10.3)')(parray(j6th+i),i=1,3*i_angp1+3) ! ####

       if(icase.eq.2.or.icase.eq.3) then
        xbeg =0.02
        vxbeg=omega_beg
        xend=1.02
        vxend=omega_end+dtheta*(n_theta-1)/1.4142
        ybeg =0.02
        vybeg=omega_beg
        yend =xend
        vyend=vxend
       else ! icase.eq.1 or 4 or 5
        ybeg=0.02
        vybeg=theta_beg
        yend=1.02
        xbeg=0.02
        vxbeg=omega_beg
        xend=1.02
        if(theta_end-theta_beg.lt.omega_end-omega_beg) then
         vyend=theta_beg+omega_end-omega_beg
         vxend=omega_end
        else
         vyend=theta_end
         vxend=omega_beg+theta_end-theta_beg
        end if
       end if

c      decission for points or line
       npnt3d(1)=1
       if(b_showangles) npnt3d(1)=0
c      
      if(log_mode)then
       abscissa='omega[mrad]'
       axisformat(1)='%5.1f '
       ordinata='log(counts)'
       axisformat(2)='%12.2f '
      else
       abscissa='omega [mrad]'
       axisformat(1)='%5.1f '
       ordinata='counts'
       axisformat(2)='%12.2f '
      end if

      xyzdz(5)=1.e10
      scmin=1.e10
      xyzdz(6)=0.
      if(b_showangles) then
       xyzdz(5)=-0.1
       xyzdz(6)=1.0
      end if

      if(b_theory)then
       j=j6th
       thmax=0.
       do k=1,i_angp1
        if(parray(j+3).gt.thmax)thmax=parray(j+3)
        j=j+3 
       end do
       nchanplot(6)=i_angp1
       if(thmax.gt.xyzdz(6))xyzdz(6)=thmax
       j=j6th
       do k=1,i_angp1
        if(parray(j+3).lt.thmax)thmax=parray(j+3)
        j=j+3 
       end do
       if(thmax.lt.xyzdz(5))xyzdz(5)=thmax
       scmin=thmax
      end if
c       write(6,'(a,f12.5)') ' th_min=',scmin

      if(b_data)then
       j=j9th
       if(log_mode)then
        ny=0
        do k=2,ichanks(0),2
         do jj=ichanks(k-1),ichanks(k)
         ny=ny+1
c        do k=1,nchannel
         parray(j+1)=real_fr(mxpt+jj)
         parray(j+2)=real_fr(mypt+jj)
         if(real_fr(mfpt+jj).le.0)then
          ny=ny-1
          j=j-5
         else
          parray(j+3)=alog10(real_fr(mfpt+jj))
          parray(j+4)=real_fr(mdfpt+jj)/(real_fr(mfpt+jj)+2)
c          write(6,'(a,5f10.3)') ' real_fr(mypt+jj)=',parray(j+1),
c     &    parray(j+2),real_fr(mfpt+jj),parray(j+3),parray(j+4)
         end if

         parray(j+5)=1.
         j=j+5
         end do
        end do
c       residual not yet implemented        
       else
        ny=0
        do k=2,ichanks(0),2
         do jj=ichanks(k-1),ichanks(k)
         ny=ny+1
c        do k=1,nchannel
         parray(j+1)=real_fr(mxpt+jj)
         parray(j+2)=real_fr(mypt+jj)
         parray(j+3)=real_fr(mfpt+jj)
         parray(j+4)=real_fr(mdfpt+jj)
         parray(j+5)=thfk(jj)-parray(j+3)
         j=j+5
         end do
        end do

        if(angpairs.gt.1.) then
         j=j9th
         do k=2,ichanks(0),2
          do jj=ichanks(k-1),ichanks(k)
           parray(j+3)=0.01
           j=j+5
          end do
         end do
         
        end if
       end if
 
       j=j9th
       damax=0.        
       do k=1,ny
c        write(6,'(i8,2f12.2)')j,parray(j+3),parray(j+4)
        if(parray(j+3)+parray(j+4).gt.damax)
     &            damax=parray(j+3)+parray(j+4)
        j=j+5 
       end do
       j=j9th
       damin=damax
       do k=1,ny
        if(parray(j+3)-parray(j+4).lt.damin)
     &            damin=parray(j+3)-parray(j+4)
        j=j+5 
       end do
       if(damax.gt.xyzdz(6)) xyzdz(6)=damax
       if(damin.lt.xyzdz(5)) xyzdz(5)=damin
       nchanplot(1)=ny

       j=j9th
       do k=1,ny
        if(parray(j+3).lt.scmin) scmin=parray(j+3)
         j=j+5 
       end do

      end if    ! b_data

      if(angpairs.gt.1.) then
        xyzdz(5)=0.
        xyzdz(6)=1.
      end if          

c      ------ begin of correction the specular angles (red line)-------
c      the z-component of the first point (used for all z-values i xmosplo.c)
       if(log_mode)parray(j6th+3)=xyzdz(4)
c      ------ end of correction of the specular angles (red line)-------

       i_angp1=i_angp1+1
       j=3*(i_angp1-1)+j6th
       parray(j+1)=i_angle
       parray(j+2)=0
       parray(j+3)=-1.
c      ------ end of caculation of the specular angles (red line)-------

       axesname(1)=abscissa
       axesname(2)='theta [mrad]'
       axesname(3)=ordinata
       auxcolor1='red'//char(0)
       auxcolor2='yellow'//char(0)

       title=name_data
       if(.not.b_data) then
        call stringlength(name_theory,i)
        if(icase.eq.1) title=name_theory(:i)//': @4 detector scan@ '
        if(icase.eq.2) title=name_theory(:i)//': omega scan'
        if(icase.eq.3) title=name_theory(:i)//': omega scan (3d)'
        if(icase.eq.4) title=name_theory(:i)//': theta1/theta2 (3d)'
        if(icase.eq.5) title=name_theory(:i)//': parallel scan'
       end if

       ISTEU=1
       BREITE=0.5
       HOEHE=0.6
       call stringlength(title,ntxt)
c       write(6,'(i4,a)')ntxt,title
       TEXT=title
       alpha=90.
       OP(0)=0.            ! no rotation around z-axis of inscription
       OP(1)=0.            ! phix
       OP(2)=0.            ! phiz
       OP(3)=0.            ! phiy
       OP(4)=10.            ! Xb
       OP(5)=10.            ! Yb
       OP(6)=0.0           ! Zb
       OP(7)=0.            ! strsx
       OP(8)=0.            ! strsy
       call TXTPLO(OP,ISTEU,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl)

c       -------- omega axis -------------------------------
       OP(0)=1
       bsl=char(92)
       dbsl='$'//bsl
       form='f5.2'
       alpha=0.
       BREITE=0.4
       HOEHE=0.4
       TEXT=bsl//'gW'
       ntxt=3
       if(icase.eq.4)then
          TEXT=bsl//'gq$_1$ '
          ntxt=8
       end if
       OP(1)=-90.*rad     ! phix
       OP(2)=-90.*rad     ! phiz
       OP(3)=0.           ! phiy
       OP(4)=1.           ! Xb
       OP(5)=0.           ! Yb
       OP(6)=0.           ! Zb
       OP(7)=0.           ! strsx
       OP(8)=-1.3*HOEHE   ! strsy
       call TXTPLO(OP,ISTEU,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl)

       BREITE=0.2
       HOEHE=0.25
       TEXT=bsl//'r   [mrad]'
       ntxt=11       
       OP(1)=-90.*rad     ! phix
       OP(2)=-90.*rad     ! phiz
       OP(3)=0.           ! phiy
       OP(4)=1.           ! Xb
       OP(5)=0.           ! Yb
       OP(6)=0.           ! Zb
       OP(7)=0.           ! strsx
       OP(8)=-2.6*HOEHE   ! strsy
       call TXTPLO(OP,ISTEU,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl)

       BREITE=0.3
       HOEHE=0.3
       call trlnu(form,vxbeg,chr,nn,chl,im)
       if(chr(nn:nn).eq.'0')nn=nn-1
       TEXT=chr(:nn)
       call TXTPLO(OP,-1,TEXT,nn,BREITE,HOEHE,alpha,Xl,Yl,Zl)
       OP(1)=-90.*rad     ! phix
       OP(2)=-90.*rad     ! phiz
       OP(3)=0.           ! phiy
       OP(4)=xbeg         ! Xb
       OP(5)=0.           ! Yb
       OP(6)=0.           ! Zb
       OP(7)=Xl           ! strsx
       OP(8)=-0.4*HOEHE   ! strsy      
       call TXTPLO(OP,ISTEU,TEXT,nn,BREITE,HOEHE,alpha,Xl,Yl,Zl)

       call trlnu(form,vxend,chr,nn,chl,im)
       if(chr(nn:nn).eq.'0')nn=nn-1
       TEXT=chr(:nn)
       OP(1)=-90.*rad     ! phix
       OP(2)=-90.*rad     ! phiz
       OP(3)=0.           ! phiy
       OP(4)=xend         ! Xb
       OP(5)=0.           ! Yb
       OP(6)=0.           ! Zb
       OP(7)=0.           ! strsx
       OP(8)=-0.4*HOEHE   ! strsy      
       call TXTPLO(OP,ISTEU,TEXT,nn,BREITE,HOEHE,alpha,Xl,Yl,Zl)

c      -------- theta axis -------------------------------

       ISTEU=1
       alpha=0.
       BREITE=0.4
       HOEHE=0.5
       TEXT=bsl//'gQ'
       ntxt=3
       if(icase.eq.4)then
         TEXT=bsl//'gq$_2$ '
         ntxt=8
       end if
       call TXTPLO(OP,-1,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl)
       OP(1)=0.           ! phix
       OP(2)=0.           ! phiz
       OP(3)=-90.*rad     ! phiy
       OP(4)=0            ! Xb
       OP(5)=0.87           ! Yb
       OP(6)=0.           ! Zb
       OP(7)=-1.6*HOEHE     ! strsx
       OP(8)=-Xl          ! strsy
       call TXTPLO(OP,ISTEU,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl)

    
       BREITE=0.2
       HOEHE=0.25
       TEXT=bsl//'r   [mrad]'
       ntxt=11
       call TXTPLO(OP,-1,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl)
       OP(1)=0.           ! phix
       OP(2)=0.           ! phiz
       OP(3)=-90.*rad     ! phiy
       OP(4)=0            ! Xb
       OP(5)=1.           ! Yb
       OP(6)=0.           ! Zb
       OP(7)=-3.5*HOEHE     ! strsx
       OP(8)=-Xl          ! strsy
       call TXTPLO(OP,ISTEU,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl)

       BREITE=0.3
       HOEHE=0.3
       call trlnu(form,vybeg,chr,nn,chl,im)
       if(chr(nn:nn).eq.'0')nn=nn-1
       TEXT=chr(:nn)
       OP(1)=0.           ! phix
       OP(2)=0.           ! phiz
       OP(3)=-90.*rad     ! phiy
       OP(4)=0            ! Xb
       OP(5)=ybeg          ! Yb
       OP(6)=0.           ! Zb
       OP(7)=-0.4*HOEHE   ! strsx
       OP(8)=0.0             ! strsy
       call TXTPLO(OP,ISTEU,TEXT,nn,BREITE,HOEHE,alpha,Xl,Yl,Zl)


       call trlnu(form,vyend,chr,nn,chl,im)
       if(chr(nn:nn).eq.'0')nn=nn-1
       TEXT=chr(:nn)
       call TXTPLO(OP,-1,TEXT,nn,BREITE,HOEHE,alpha,Xl,Yl,Zl)
       OP(1)=0.           ! phix
       OP(2)=0.           ! phiz
       OP(3)=-90.*rad     ! phiy
       OP(4)=0            ! Xb
       OP(5)=yend         ! Yb
       OP(6)=0.           ! Zb
       OP(7)=-0.4*HOEHE   ! strsx
       OP(8)=-Xl          ! strsy
       call TXTPLO(OP,ISTEU,TEXT,nn,BREITE,HOEHE,alpha,Xl,Yl,Zl)

c      -------- z axis -------------------------------
       BREITE=0.21
       HOEHE=0.25
       if(log_mode)then
        i=0.8*int(xyzdz(6)+1.)
        ii=i/10
        jj=i-10*ii
        ch4=' '//char(jj+i0)//'.0'
        if(ii.gt.0)ch4(1:1)=char(ii+i0)
        TEXT='lg(counts)'
        ntxt=10
       else
        i=int(alog(xyzdz(6)+1.)/alog(10.))
        TEXT='counts[10$^'//char(i+i0)//'$ ]'
        ntxt=16
        form='f4.1'
        h=0.8*xyzdz(6)/10**i
        call trlnu(form,h,chr,nn,chl,im)       
        ch4=chl
       end if
       alpha=90.
       OP(0)=0.           ! no rotation around z-axis of inscription
       OP(1)=0.           ! phix
       OP(2)=0.           ! phiz
       OP(3)=0.           ! phiy
       OP(4)=-0.05        ! Xb
       OP(5)=-0.05        ! Yb
       OP(6)=0.4         ! Zb
       OP(7)=0.           ! strsx
       OP(8)=0.           ! strsy
       call TXTPLO(OP,ISTEU,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl)

       TEXT=ch4
       ntxt=4
       alpha=0.
       call TXTPLO(OP,-1,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl)
       OP(0)=0.            ! no rotation around z-axis of inscription
       OP(1)=0.            ! phix
       OP(2)=0.            ! phiz
       OP(3)=0.            ! phiy
       OP(4)=0.            ! Xb
       OP(5)=0.            ! Yb
       OP(6)=0.75           ! Zb
       OP(7)=0.            ! strsx
       OP(8)=-Xl-0.4*HOEHE ! strsy
       call TXTPLO(OP,ISTEU,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl)

       if(log_mode)then
        i=int(scmin)
c        write(6,'(a,i4)')'  log mode i=',i
         jj=abs(i)
         ch4='-'//char(jj+i0)//'.0'
         ii=10*(abs(scmin)-jj)
         ch4(4:4)=char(ii+i0) 
        if(i.lt.0) then       
         TEXT=ch4
         ntxt=4
        else
         ch4(1:1)=' '
         TEXT=ch4(2:4)
         ntxt=3
        end if
       alpha=0.
       OP(0)=0.           ! no rotation around z-axis of inscription
       OP(1)=0.           ! phix
       OP(2)=0.           ! phiz
       OP(3)=0.           ! phiy
       OP(4)=0.           ! Xb
       OP(5)=0.           ! Yb
       OP(6)=0.02         ! Zb
       OP(7)=0.           ! strsx
       OP(8)=-XL-0.4*BREITE ! strsy
       call TXTPLO(OP,ISTEU,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl)
       end if



c       write(6,'(a,8g12.6)')' min-max=',
c     &       xyzdz(1),xyzdz(2),xyzdz(3),xyzdz(4),xyzdz(5),xyzdz(6)
     

c      write(6,'(8f10.3)')(vtxtx(i),i=1,ltext(2))
c      write(6,'(a,2f10.3)') ' X2,Y2=',X2,Y2
c     fill in test data
      return

 1000 continue

       i_angle=0
       i_angp1=0
       do i_theta=1,n_theta
        theta=theta_beg+dtheta*(i_theta-1)
        do k_omega=1,n_omega        
         omega=omega_beg+domega*(k_omega-1)
         
         if(icase.eq.2.or.icase.eq.3) then
            grazinc=omega_beg+domega*(k_omega-1)+(i_theta-1)*dtheta
            grazout=2*omega_beg+domega*(n_omega-1)+
     &        (i_theta-1)*dtheta*2-grazinc
         else if(icase.eq.5) then
c         PHI_s=omega N_s=n_omega
          j=i_theta/2
          if(2*j.eq.i_theta) then
c          + dTheta_out
           grazinc=omega
           grazout=(omega+dtheta*j)
          else
c          + dTheta_out
           grazinc=(omega+dtheta*j)
           grazout=omega
          end if
          if(omega+dtheta*j.gt.omega_end)goto 777
         end if
         i_angle=i_angle+1   
         i_angp1=i_angp1+1
              
         if(.not.b_showangles)then
          h=real_fr(2*nstorTH+i_angle)*counts+background
          if(log_mode)then
            plotyy(i_angp1)=alog10(h)
          else
           plotyy(i_angp1)=h
          end if
          plotxx(i_angp1)=i_angp1
         end if
 777     continue
        end do     ! n_omega
        i_angp1=i_angp1+1
        plotxx(i_angp1)=i_angp1
        plotyy(i_angp1)=-1.
        nchanplot(5)=i_angp1
       end do     ! n_theta


c      write(6,'(2f12.2)') (real_fr(mfpt+j),real_fr(2*nstorTH+j),j=1,12)
      if(log_mode)then
       abscissa='channel'
       axisformat(1)='%5.1f '
       ordinata='lg(counts)'
       axisformat(2)='%12.2f '
      else
       abscissa='channel'
       axisformat(1)='%5.1f '
       ordinata='counts'
       axisformat(2)='%12.2f '
      end if

      xyzdz(1)=1
      xyzdz(2)=0.
      xyzdz(3)=1.e10
      xyzdz(4)=0.

      if(b_data) then 
       if(log_mode)then
        ny=0     
        do k=2,ichanks(0),2
         do j=ichanks(k-1),ichanks(k)
          ny=ny+1
          plotx(ny)=j
          if(real_fr(mfpt+j).lt.1.0) then
           ny=ny-1
          else
           ploty(ny)=alog10(real_fr(mfpt+j))
           ploterry(ny)=real_fr(mdfpt+j)/(real_fr(mfpt+j)+1)
c          write(6,'(2i6,a,4g12.6)')ny,j,' ploty(ny)=',ploty(ny)
          end if
         end do
        end do
        nchanplot(1)=ny
       else
        ny=0     
        do k=2,ichanks(0),2
         do j=ichanks(k-1),ichanks(k)
          ny=ny+1
          plotx(ny)=j
          if(real_fr(mfpt+j).lt.0.0) then
           ny=ny-1
          else
           ploty(ny)=real_fr(mfpt+j)
           ploterry(ny)=real_fr(mdfpt+j)
c          write(6,'(2i6,a,4g12.6)')ny,j,' ploty(ny)=',ploty(ny)
          end if
         end do
        end do
        nchanplot(1)=ny
       end if
       xyzdz(1)=1
       xyzdz(2)=ny
       damax=0.
       do i=1,ny
        if(ploty(i)+ploterry(i).gt.damax)damax=ploty(i)+ploterry(i)
       end do
       if(damax.gt.xyzdz(4))xyzdz(4)=damax
       do i=1,ny
        if(ploty(i)-ploterry(i).lt.damax)damax=ploty(i)-ploterry(i)
       end do
       if(damax.lt.xyzdz(3))xyzdz(3)=damax
      end if   ! b_data


      if(b_showangles.and..not.b_data) then
       xyzdz(3)=-0.1
       xyzdz(4)=1.0
      end if


      thmax=-1.e10
      if(.not.b_showangles)then
       jj=nchanplot(5) 
       do i=1,jj
        if(plotyy(i).gt.thmax)thmax=plotyy(i)
       end do
       if(thmax.gt.xyzdz(4))xyzdz(4)=thmax
       xyzdz(2)=jj
       do i=1,jj
        if(plotyy(i).lt.thmax)thmax=plotyy(i)
       end do
       if(thmax.lt.xyzdz(3))xyzdz(3)=thmax
      end if
c       write(6,'(i6,a,8g12.6)')nchanplot(5),' min-max=',
c     &       xyzdz(1),xyzdz(2),xyzdz(3),xyzdz(4),xyzdz(5),xyzdz(6)


      axesname(1)=abscissa
      axesname(2)=ordinata
      axesname(3)=' '
      title=name_data
      if(.not.b_data) title=name_theory

       bgcolor='Ivory'//char(0)     ! color background  (0...) [0]
       fgcolor='black'//char(0)
       datacolor=fgcolor
       thcolor=fgcolor
       rescolor='blue'//char(0)
       do j=1,maxsub
        ncolor(j)=icolor_sub(j)
       end do

       logx=0
       logy=0
       if(b_logx)logx=1
       logf=0
       if(b_logy)logf=1

c      definitions taken from allplo
       chx='B'                 ! (none,Both,bottom,top)  [B]
       chbx='n'                ! (none,bottom,top)  [n]
       chlr='l'                ! (left,right)  [r]
       chy='r'                 ! (none,Both,left,right)  [B]
       chby='r'                ! (none,left,right)  [r] 
       chbt='b'                ! (bottom,top)  [t]
       chh=0.3                 ! 
       chw=0.25                ! character cw,ch  [0.40,0.40]         
       syw=0.1                 !
       syh=0.1                 ! symbol sw,sh     [0.40,0.40]
       frcolor=fgcolor         ! color frame       [black]
 
       CTEXT=title
       CXTEXT=abscissa
       CYTEXT=ordinata

       call frame(chx,chbx,chlr,chy,chby,chbt,b_logx,b_logy,
     &            chh,chw,syw,syh,
     &            CTEXT,CXTEXT,CYTEXT,nformx,nformy,frcolor,bgcolor)
 

c      write(6,'(a,i5)') ' rdplpu3d nchannel=',nchannel
c       write(6,'(a,4g12.6)')' b min-max=',
c     &       xyzdz(1),xyzdz(2),xyzdz(3),xyzdz(4)
c      write(6,'(8f10.4)') (plotxx(ii),ii=1,nchannel)
c      write(6,'(8f10.4)') (plotyy(ii),ii=1,nchanplot(5))
c      write(6,'(8f10.4)') (ploterry(ii),ii=1,nchannel,16)

      return
      end



      subroutine punch3d(nout,info)
c     not yet altered for 3d
      include 'comglb.for'
      include 'compar.for'
      include 'comdat.for'
      include 'comdas.for'
      include 'comthe.for'
      include 'comscd.for'
      include 'complt.for'

      integer   icdum
      real      out
      character carray*4,ch132*132,cp132*132,cpunch*132,
     &          iform*132,k2form*8,stringnumber*40,chl*24,chr*24
      parameter   (icdum = i_stmp-8*infplot-32-4*33-22)
      common/stmp/ iplace(infplot),lname(infplot),jp(infplot),out(32),
     &             ch132,cp132,iform,cpunch,stringnumber,
     &             chl,chr,k2form(2*infplot),iplact(infplot),
     &             carray(icdum)

      integer      n_subspectra,idumpl,j6th,logx,logy,logf,
     &             int3d,npnt3d,ifeder,ltext,npntplot,nchanplot,ncolor
      real         parray,xyzdz,vtxt,OP
      character*24 axesname,namechan*4,kform*8,
     &             chardum*4,axisformat*16,title*132,plotstrdef*80,
     &             plotstrpu*132
      parameter  (idumpl=MDBPLFT*2-140*maxn-8*39-5*infplot-maxsub-120)
      common/plot/ parray(maxn*112),xyzdz(8),vtxt(2,maxn*4),vtxtp(8,32),
     &             int3d(maxn*16),npnt3d(16),ifeder(4*maxn),ltext(32),
     &             npntplot(infplot),nchanplot(infplot),ncolor(maxsub),
     &             n_subspectra,logx,logy,logf,
     &             namechan(infplot),kform(infplot),axisformat(3),
     &             axesname(3),title,plotstrdef,plotstrpu,
     &             chardum(idumpl)

      real         plotx,ploty,ploterry,plotres,plotxx,plotyy
      dimension    plotx(max8),ploty(max8),ploterry(max8),plotres(max8),
     &             plotxx(max8),plotyy(max8)
       equivalence (parray(1),plotx(1)),(parray(max8+1),ploty(1)),
     &             (parray(max8*2+1),ploterry(1)), 
     &             (parray(max8*3+1),plotres(1)), 
     &             (parray(max8*4+1),plotxx(1)),
     &             (parray(max8*5+1),plotyy(1))

      character*132 cpunchw,cpunchstrj,form*7,su*2

c     structure on plot
c     xd,yd,zd,errz,res,  ...., xd,yd,zd,errz,res,....
c     from j6th+1 
c     xt,yt,zt,...., xt,yt,zt,...
      j9th=max8*9
      j6th=max8*6
      k=1
      do while(kform(k).ne.' '.and.k.lt.infplot)
       k2form(k)=kform(k)
c       write(6,'(a)')kform(k)
       k=k+1
      end do
      k=k-1
      do i=1,k
       k2form(k+i)=kform(k)
      end do

      do k=1,infplot
       l=index(namechan(k),' ')
       lname(k)=l-1
       if(l.eq.0) lname(k)=4
      end do

      cpunch=plotstrpu
      call stringlength(cpunch,l)
      do k=1,l
       if(cpunch(k:k).eq.',')cpunch(k:k)=' '
      end do
      nsequence=1
 100  continue
c      write(6,'(2a)') 'print  100:',cpunch(1:60)
      jka=index(cpunch,'(')
      jkz=index(cpunch,')')
      cpunchstrj=' '
      if(jka.gt.0.and.jkz.gt.0) then
       cpunchstrj=cpunch(jka:jkz)
       nsequence=0
       cpunchw=cpunch(jka+1:jkz-1)
       cp132=cpunch(jkz+1:)
       cpunch=cp132
      else
       cpunchstrj=cpunch
       cpunchw=cpunch
       cpunch=' '
      end if

      do k=1,8
       iplace(k)=0
      end do

      su=namechan(mplot+1)
      ir=0

 200  continue
c      write(6,'(3a)') ' 200: cpunchw=',cpunchw(1:30)
       ch132=cpunchw
       cpunchw=' '

      ifound=0
      ip=1
      ih=0
 210  continue
      call nextchar(ch132,ih,ipos,cp132,ip)
      ch132=cp132
      ih=ip
c     write(6,'(a,i5,2x,a)') 'ip,cp132(1:24)=',ip,cp132(1:24)

      if(ip.gt.0) then
       do k=1,infplot
c       k=0
c       do while(ifound.eq.0.and.k.lt.infplot)
c        k=k+1
c        write(6,'(i4,a,i2,a,a4,2x,a)') ifound,' k=',k,' namechan(k)=',
c     &          namechan(k)(1:lname(k)),cp132(1:ip)
        if(namechan(k)(1:lname(k)).eq.cp132(1:ip)) then
c         write(6,'(a,i2,a,a4,2x,a)') 'k=',k,' namechan(k)=',
c     &                   namechan(k),cp132(1:ip)
c         write(6,'(a)') cpunchw(1:80)
         ir=ir+1
         iplace(ir)=k
         ifound=1
        end if
       end do
c       write(6,'(a,10i4)') ' ir,ifound=',ir,ifound
       if(ifound.eq.0) then
        write(nwr,'(3a)')
     &         '**error** ',cp132(1:ip),' is not a data type'
       end if
       goto 210
      end if
c      write(6,'(a)') cpunchsu(1:80)
      nch=132

c      write(6,'(2a)') 'cpunchw=',cpunchw(1:60)
      if(cpunchw.ne.' ') goto 200
c     write(6,'(a,8f8.3)') 'rsyco=',(rsyco(ipk),ipk=1,8)

      if(ir.eq.0) goto 1000
      write(nout,'(a)') title

c       write(6,'(a,20i3)') ' nseq=0,iplace=',(iplace(i),i=1,ir)
        ipk=iplace(1)
        ch132=k2form(ipk)
        call stringlength(ch132,il)
        iform='('//ch132(1:il)
        if=il+1
        do k=2,ir
         ipk=iplace(k)
         ch132=k2form(ipk)
c        write(6,'(a,2x,a)') 'ipk,k2form',ipk,k2form(ipk)
         call stringlength(ch132,il)
         iform(if+1:if+1+il)=','//ch132(1:il)
         if=if+1+il
        end do
        iform(if+1:if+1)=')'
        lfr=if+1
        call stringlength(cpunchstrj,lpw)
        write(nout,'(a,2x,a)') iform(:lfr),cpunchstrj(:lpw)
        write(nwr,'(17x,a,2x,a)') iform(:lfr),cpunchstrj(:lpw)


c       constants from data file
        ch132=' '
        jj=1
        j=1
        do while(n_cdatas(j).ne.' ') 
         i=index(n_cdatas(j),')')
         form=n_cdatas(j)(19:i-1)
         if(j.eq.1) then
          if(iplace(1).lt.6) then
           rn=nchanplot(1)
          else
          jch=1
          do while(parray(j6th+(jch-1)*3+3).gt.-1.)
           jch=jch+1
          end do
           rn=nchanplot(6)-jch
           jch=jch+1
          end if
         else
          rn=cdatas(j)
         end if
         call trlnu(form,rn,chr,ii,chl,il)
         ch132(jj:jj+19+il)=n_cdatas(j)(:16)//'='//chl(1:il)
         jj=jj+19+il
         if(jj.gt.80) then
          write(nout,'(a)')ch132
          ch132=' '
          jj=1
         end if
         j=j+1
        end do
        if(jj.gt.16)write(nout,'(a)')ch132

c       variables from data file
        ch132=' '
        jj=1
        j=1
        do while(n_vdatas(j).ne.' ')
         i=index(n_vdatas(j),')')
         form=n_vdatas(j)(19:i-1)
         rn=vdatas(j)
         call trlnu(form,rn,chr,ii,chl,il)
         ch132(jj:jj+19+il)=n_vdatas(j)(:16)//'='//chl(1:il)
         jj=jj+19+il
         if(jj.gt.80) then
          write(nout,'(a)')ch132
          ch132=' '
          jj=1
         end if
         j=j+1
        end do
        if(jj.gt.16)write(nout,'(a)')ch132

         do k=1,ir
          if(iplace(k).gt.5)iplact(k)=iplace(k)-5
         end do
         if(iplace(1).lt.6) then
          do i=1,nchanplot(1)
           write(nout,iform) (parray(j9th+(i-1)*5+iplace(k)),k=1,ir)
          end do
         else
          do i=jch,nchanplot(6)
           write(nout,iform) (parray(j6th+(i-1)*3+iplact(k)),k=1,ir)
          end do
         end if
         write(nout,'(a)') (axesname(i),i=1,3)
       if(cpunch.ne.' ') goto 100
 1000  continue
      return
      end


 
      subroutine data3dread(n1,info)
      implicit none
      include 'comglb.for'
      include 'compar.for'
      include 'comdat.for'
      include 'comdas.for'
      include 'comthe.for'
      include 'comscd.for'

      integer   n1,info,icdum
      character*132 chnext,chcom,ch132,cp132,querytype,chardata*80,
     &              carray*4,chl*24,chr*24,form*7,ch1*1,chf*4,
     &              ch6*6,ch2*2,dacom*4
      integer     ldacom,iplace,iextra
      parameter   (icdum = i_stmp-24-5*33-8-80-48)
      common/stmp/ ldacom(8),iplace(8),iextra(8),
     &             chnext,chcom,ch132,cp132,querytype,dacom(8),
     &             chardata(4),chl,chr,form,ch1,chf(32),ch6,ch2,
     &             carray(icdum)
      logical     b_dat
      dimension   b_dat(max8)
      real        array,h
      common/plot/array(MDBPLFT*2)
      equivalence (array(1),b_dat(1))
      integer      i,ip,ipos,ir,ifound,ih,j,j1,jj1,jj2,k,nt,nj,ig

c     write(6,'(a,5i7)') '  iarray_sp,nstorFR=',iarray_sp,nstorFR
c     only even number of channels are handled
c      write(6,'(a,2i4,2x,a)')'dataread n1,ks,readform=',
c    &  n1,ks,readform

      do k=1,8
       ldacom(k)=0
       iplace(k)=0
       iextra(k)=0
      end do

      ip=1
      ih=0
      nt=0
c      write(6,'(2a)')'cdata_str=', cdata_str    ! from data file
      ch132=cdata_str
      do while(ip.gt.0)
       call nextchar(ch132,ih,ipos,cp132,ip)
       ch132=cp132
       ih=ip
       nt=nt+1
c      write(6,'(i5,2x,a)') ip,cp132(1:24)

       if(nt.eq.8.or.ip.eq.0)then
        ip=0
        dacom(nt)=' '
        ldacom(nt)=ip
       else
        dacom(nt)=cp132(1:ip)
        ldacom(nt)=ip
       end if
      end do
      nt=nt-1
c      write(6,'(a,10a6)') ' dacom=',(dacom(i),i=1,nt)
c      write(6,'(a,10i5)') ' ldacom=',(ldacom(i),i=1,nt)

c      write(6,'(2a)') 'from th data_str=',data_str            ! from fr_theory
      ch132=data_str
      ip=1
      ih=0
      ir=0
      nj=0
      do while(ip.gt.0)
       call nextchar(ch132,ih,ipos,cp132,ip)
       ch132=cp132
       ih=ip
       nj=nj+1
       ifound=10
       if(nj.eq.8) ip=0
       if(ip.gt.0) then 
        ifound=0
c       write(6,'(i5,2x,a)') ip,cp132(1:24)
        do k=1,nt
c        write(6,'(a,i2,a,a4,2x,a)') 'k=',k,' dacom(k)=',
c     &                   dacom(k),cp132(1:ip)
         if(cp132(1:ip).eq.dacom(k)) then
          ir=ir+1
          iplace(ir)=k
          ifound=1
         end if
        end do
       end if
       if(ifound.eq.0) then
        do k=1,nt
         if(cp132(1:1).eq.'d'.and.cp132(2:2).eq.dacom(k)) then
c         write(6,'(a,i2,a,a4,2x,a)') 'found=0 k=',k,
c     &   ' dacom(k)=',dacom(k),cp132(1:2)
          iextra(ir)=k
          ifound=1
         end if
c        write(6,'(a,2i5)') 'k,ifound=',k,ifound
        end do
       end if
       if(ifound.eq.0) then
        info=23
        infotext(1)='effi/data/read_data/format'
        infotext(3)='expected data format not on data file'
        infotext(4)='format: '//cdata_str(:12)//'expected format: '
     &    //data_str
        infotext(5)=' '
        goto 250
       end if
      end do
c      write(6,'(a,i4)')   ' return, ifound=',ifound
c      write(6,'(a,10i5)') ' ldacom=',(ldacom(i),i=1,8)
c      write(6,'(a,10i5)') ' iplace=',(iplace(i),i=1,8)
c      write(6,'(a,10i5)') ' iextra=',(iextra(i),i=1,8)

c     reading of data type n=1,2,...,8
c     storing data of type istortype=1...8
      nchannelsp=ichanks(ichanks(0))
      ip=-1
      do k=1,ir
       j=nt-iplace(k)
       ip=ip+1
       jj1=j1+ip*nchannelsp
       if(iextra(k).gt.0) then
        ip=ip+1
       end if
      end do
c      write(6,'(a,6i6)') 'cc ip,nchannelsp=',ip,nchannelsp
      nuofdatas=(ip+2)*int((nchannelsp+1)/2)
c      write(6,'(a,6i6)') ' nuofdatas=',nuofdatas
      if(n1.eq.0) return

      k=nchannelsp*nt
c      write(6,'(a,6i6)') ' n1,nt,k,nchannelsp=',n1,nt,k,nchannelsp
c      write(6,'(a,a)') ' readform=',readform
      read(n1,readform,end=50,err=240) (array(i),i=1,k)

      goto 60
 50   info=25
      infotext(3)='read found EOF'
      infotext(4)=' '
      goto 250
 60   continue
 
      ip=-1
      do k=1,ir
       j=nt-iplace(k)
       ip=ip+1
       jj1=mfpt+ip*nchannelsp
c       write(6,'(a,6i7)') ' ir,iplace(k),nt,j,jj1,iextra(k)=',
c     &                 ir,iplace(k),nt,j,jj1,iextra(k)
        do i=1,nchannelsp
         real_fr(jj1+i)=array(nt*i-j)
        end do
      
        if(iextra(k).gt.0) then
         ip=ip+1
         jj2=mfpt+ip*nchannelsp
c        write(6,'(a,6i7)') ' ip,iplace(k),nt,j,jj2=',
c     &                 ip,iplace(k),nt,j,jj2
         do i=1,nchannelsp
          h=real_fr(jj1+i)
          if(h.gt.0) then
           real_fr(jj2+i)=sqrt(h)
          else
           real_fr(jj2+i)=1.
          end if
         end do
        end if
      end do

      do i=1,nchannelsp
       b_dat(i)=.true.
      end do

      ig=1                  ! group number
      do i=1,nchannelsp
       real_fr(mgpt+i)=ig
       if(real_fr(mfpt+i).eq.-1)then
        ig=ig+1
        b_dat(i)=.false.
       end if
      end do


c        do i=1,ibadchan(0,iset)
c         b_dat(ibadchan(i,iset))=.false.
c        end do

        k=1
        i=1
        do while(i.lt.nchannelsp)
         if(b_dat(i))then
          ichanks(k)=i
          j=i+1                   
          do while(j.le.nchannelsp.and.b_dat(j))
           j=j+1
          end do
          ichanks(k+1)=j-1
          i=j-1
          if(i.lt.nchannelsp) k=k+2
         end if
         i=i+1
        end do 
        ichanks(0)=k+1
        if(ichanks(k).eq.0)ichanks(0)=k-1

c     write(6,'(a,6i6)') 'cc ip,nchannelsp=',ip,nchannelsp

      goto 250
 240  continue
c     read error format?
      info=24
      infotext(3)='read error of data file, identified format:'
      infotext(4)=readform
      infotext(5)=' '
 250  continue
      return
      end
