c     H. Spiering January,1995 Mainz
c                 oktober 2004 budapest, dezember Christcurch
c                 june Mainz 2005
c     moving absorber or moving source
c
      subroutine mossbauer_trm(b_total,info)
      
      implicit none
      include 'comglb.for'
      include 'comthe.for'

      logical     b_total
      integer     info,ifrth,iaddr,idex,mstruct1,istruct1,istruct2,
     &            l1_get,l2_get,l3_get,l1_put,l2_put,l3_put,
     &            nstorTH,idum,nAS,nSC
      character*4 c1_prp,c2_prp,c3_prp,frthname*64
      common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),     !13.9.05 
     &              l1_get(0:maxfr1),l2_get(maxfr2),l3_get(maxthss),
     &              l1_put(0:maxfr1),l2_put(maxfr2),l3_put(maxthss),
     &              c1_prp(0:maxfr1),c2_prp(maxfr2),c3_prp(maxthss),
     &              frthname(2),nstorTH,iaddr(7),             
     &              ifrth(8),idum(3),nAS,nSC,idex(11)
 
      real          acsp,uthick_w,unit_chi,channels,vm_SC,convol,
     &              th_dum,drive_mode,channels_vmax,dumcs,dum
      common/acstrf/acsp,uthick_w,dum(2),unit_chi,channels,vm_SC,convol,
     &              th_dum,drive_mode,channels_vmax,dumcs(icstrf-11)

      logical       b_vsp,b_v_max,b_dumvsp
      common/bvstrf/b_vsp(4),b_v_max,b_dumvsp(ivstrf-5)
      
      real            acfr1,dumcfr1
      common/acfr1trf/acfr1,dumcfr1(icfr1trf-1)
      real            acfr2,dumcfr2
      common/acfr2trf/acfr2,dumcfr2(icfr2trf-1)

c                     phi,theta,psi are not directly assigned
c                     but by arry_fr via the routine orientation 
      real            avfr2,th_factor,dumx,phi,theta,psi,dumvfr2
      common/avfr2trf/avfr2,th_factor,dumx(7),phi,theta,psi,
     &                dumvfr2(ivfr2trf-12)
      logical         b_vfr2,b_thfactor,b_dumx,b_phi,b_theta,b_psi,
     &                b_dumvfr2
      common/bvfr2trf/b_vfr2,b_thfactor,b_dumx(7),b_phi,b_theta,b_psi,
     &                b_dumvfr2(ivfr2trf-12)
       
      real             vsstrf,sftr
      common/avsstrf/ vsstrf(ivsstrf)
      logical          b_vsstrf,b_not_sftr
      common/bvsstrf/ b_vsstrf(ivsstrf)
      

      integer     km,mAS,idumscrd
      parameter  (km=256,mAS=4*maxn,idumscrd=maxscrd-9*(2*mAS+1)
     &                                       -2*(km+1))
      real        sP1,sP2,sP3,aP1,aP2,aP3,sTr,aTr,sa,dumscrd
      complex     yout
      common/scrd/sP1(-mAS:mAS),sP2(-mAS:mAS),sP3(-mAS:mAS),
     &            aP1(-mAS:mAS),aP2(-mAS:mAS),aP3(-mAS:mAS),
     &            sTr(-mAS:mAS),aTr(-mAS:mAS),sa(-mAS:mAS),
     &            yout(0:km),dumscrd(idumscrd)
      
      logical   b_source,b_absorber,b_detector,
     &          b_sites,b_lay,b_sourcesite,b_polisite,
     &          b_polabsorber,b_polsource,b_absdetector,
     &          b_reemission
      integer   issa,isse,iss,mss,idt,i,ii,j,n,nn,n8,n2,
     &          k,lay,mlay,layl,nabs0,nabs1,nabs2,nabs3,
     &          iscn_fr,iscn_nr,npolSCAS,iyout,isubthe,
     &          lstruct1,lstruct2,lstruct3,iget,isite,isource_sp
      real      wi,detector,satrexpr,factor_thickness,BESSI0
      dimension wi(maxthss),
     &          b_sites(maxfr2),
     &          detector(-km:km),b_polisite(0:maxthss)
      complex   hc,hc1,hci,app,apm,amp,satraceh,
     &          aam(4,maxfr2),aa(4),bb(4),dd(4)

      

      do i=1,maxthss
       wi(i)=0.
      end do
c     ch_case='source','absorber','detector',
c     ifrcase=3 transmission, 4 reemission
c     ifrcase=5   mosaic absorber

      b_reemission=.false.
      if(ifrcase.eq.2.or.ifrcase.eq.4) b_reemission=.true. 
      b_polsource  =.false.
      b_polabsorber=.false.
            
      hc1=cmplx(1.,0.)
      hci=cmplx(0.,1.)
      
      
       b_source =.false.
       b_absorber=.false.
       b_detector=.false.
       b_absdetector=.false.      
c------------------------------------------------------------------
c-------------------------------------------------------------------

      call mapsub(0) 

c     write(6,'(a,10L4)')'b_vsp(4),b_v_max=',b_vsp,b_v_max 
      b_total=b_v_max

      isubthe=1
      call get_theory(isubthe,info)
      if(info.gt.0) return
      b_total= b_total.or.(isubthe.gt.0) 

      iss=1
      do lstruct1=1,mstruct1

       call mapsub(iss) 

       isubthe=1                      ! frame
       call get_theory(isubthe,info)
       if(info.gt.0) return
       b_total= b_total.or.(isubthe.gt.0)     

       if(lstruct1.eq.1) then
c      -----------------------------------------------------------------
c      layer 1 = moving source
c      ------------------------------------------------------------------
c      Sums of source curves at the positions Eagd. For the convolution
c      integral the stepwidth is still srw2. The stepwidth srw8 of the
c      source function guarantees that the source line is exact
c      within 1/8 channel.
c
c      ----0--------------------------nLG
c       nLG--------------------------0-------------        srw8
c        nSC------------0------------nSC                    srw2
        lstr1case=1     ! entry for the source is transferred by the 
c                         common block  'common/struct/' to the 
c                         the routine called by get_theory

        iss=iss+1
        do lstruct2=istruct1(lstruct1-1)+1,istruct1(lstruct1)

         call mapsub(iss)
         isubthe=1
         call get_theory(isubthe,info)
         if(info.gt.0) return
         if(isubthe.eq.0) then
          b_phi=.false.
         else
c         write(6,'(a,i1,a2,i6)') 
c     &     'l2_get(',lstruct2,')=',l2_get(lstruct2)
           
          iget=l2_get(lstruct2)
          b_phi=aimag(array_fr(iget+2)).gt.0.0      !    
          phi  =real(array_fr(iget+2))
          theta=real(array_fr(iget+3))
          psi  =real(array_fr(iget+4))
         end if
c        write(6,'(a,3f12.4)')'moss phi,..psi=',phi,theta,psi      
         b_lay=(isubthe.gt.0).or.b_phi
         
         iss=iss+1
         do lstruct3=istruct2(lstruct2-1)+1,istruct2(lstruct2)

          call mapsub(iss)

          b_polisite(lstruct3)=c3_prp(lstruct3).eq.'plrs'
          if(b_polisite(lstruct3)) b_polsource=.true.

          wi(lstruct3)=vsstrf(2)

          isubthe=0
          call get_theory(isubthe,info)
          if(info.gt.0) return
c          write(6,'(a)')' th_mossbauer source 2'
c          write(6,'(10f10.3)')(vsstrf(i),i=1,10)
          b_source=b_source.or.b_lay.or.(isubthe.gt.0)

          iss=iss+1
         end do
        end do
       end if  ! lstruct1=1 source
       
     
       if(lstruct1.eq.2) then
c      ----------------------------------------------------------------
c      layer lay2,3 ... mlay of  absorber at rest
c      ----------------------------------------------------------------
c      The Lorentz curve of the absorber in npq is 1 at resonance so that
c      for a singl line the exponent at resonance is just -teff (effective
c      thickness). areaLor ~ pi*ga/2 ( area -+ infinity), ga/2=hga/2/srw8,
c      normalizes ( to area 1) the Lorentz curve.
      
c      Sums of absorber curves at the positions Eagd. For the convolution
c      integral the stepwidth is still srw4. The stepwidth srw8 of the
c      absorber function guarantees that the absorbtion line is exact
c      within 1/4 channel.
c
c      ----0--------------------------naLG
c       naLG--------------------------0-------------        srw8
c        nAS------------0------------nAS                    srw2
c
        lstr1case=2       ! absorber
      
        iss=iss+1
        do lstruct2=istruct1(lstruct1-1)+1,istruct1(lstruct1)
         lay=lstruct2
c        ifrcase=5 mosaic absorber stores each part=layer at l2_put(lstruct2)
     
         call mapsub(iss)
         isubthe=1
         call get_theory(isubthe,info)
         if(info.gt.0) return
         
         if(isubthe.eq.0) then
          b_phi=.false.
         else
c         write(6,'(a,i1,a2,i6)') 
c     &     'l2_get(',lstruct2,')=',l2_get(lstruct2)           
          iget=l2_get(lstruct2)
          b_phi=aimag(array_fr(iget+2)).gt.0.0      !    
          phi  =real(array_fr(iget+2))
          theta=real(array_fr(iget+3))
          psi  =real(array_fr(iget+4))
c          write(6,'(2i6,a,3f10.2)')lstruct2,iget,
c     &    '  mossbauer phi,theta,psi=',phi,theta,psi
         end if    

         b_absorber=b_absorber.or.b_phi.or.(isubthe.gt.0)
                
         iss=iss+1
         do lstruct3=istruct2(lstruct2-1)+1,istruct2(lstruct2)
          b_polisite(lstruct3)=c3_prp(lstruct3).eq.'plrs'
          if(b_polisite(lstruct3)) b_polabsorber=.true.

          b_sites(lay)=.true.
      
          call mapsub(iss)

          sftr=vsstrf(2) 
c         logical of the thickness sftr is at b_vsstrf(2)
          if(ifrcase.eq.3.or.ifrcase.eq.5) then
           factor_thickness=real(array_fr(iget+1))
           wi(lstruct3)=sftr*uthick_w*factor_thickness
c           write(6,'(a,2i6,2x,3f12.4)')'*absorber** sftr=',
c     &           lstruct3,iget,sftr,uthick_w,factor_thickness
          else
            wi(lstruct3)=sftr*uthick_w
c            write(6,'(a,3f12.4)')'th_mossbauer exp*bess0=',
c     &      exp(-wi(lstruct3)/2.)*BESSI0(wi(lstruct3)/2.)
           if(th_factor.gt.0.000001) then 
            wi(lstruct3)=wi(lstruct3)*th_factor
            b_absorber=b_absorber.or.b_thfactor
           end if
          end if
      
          isubthe=0
          call get_theory(isubthe,info)
          if(info.gt.0) return
c          write(6,'(a)')' th_mossbauer absorber 2'
c          write(6,'(10f10.3)')(vsstrf(i),i=1,10)

          b_absorber=b_absorber.or.b_vsstrf(2).or.(isubthe.gt.0)
          iss=iss+1
         end do
        end do
       end if  ! lstruct1=2 absorber
      
       if(lstruct1.eq.3) then
c      ----------------------------------------------------------------
c      layer lay=mlay of detector
c      ----------------------------------------------------------------
        lstr1case=3
        b_absdetector=.true.
        do n=-nSC,nSC
         detector(n)=0.
        end do
        iss=iss+1
        do lstruct2=istruct1(lstruct1-1)+1,istruct1(lstruct1)

         lay=lstruct2
      
         iss=iss+1
         do lstruct3=istruct2(lstruct2-1)+1,istruct2(lstruct2)

          call mapsub(iss)
          j=vsstrf(1)
          do k=3,j+1
           b_not_sftr=b_not_sftr.or.b_vsstrf(k)
          end do

          sftr=vsstrf(2)
          wi(lstruct3)=sftr*uthick_w
           
          isubthe=0
          call get_theory(isubthe,info)
          if(info.gt.0) return

          b_detector=b_not_sftr
     &                   .or.b_vsstrf(2).or.(isubthe.gt.0)

          idt=l3_get(lstruct3)+1
c         write(6,'(a,i6)') 'iget=idt=',idt
          do n=0,nSC
           detector(n)=detector(n)+real(array_fr(idt+n))*wi(lstruct3)
           detector(-n)=detector(-n)+aimag(array_fr(idt+n))*wi(lstruct3)
          end do ! n=0,nSC
          do n=-nSC,nSC
           detector(n)=exp(-2.*detector(n))
          end do  ! n=0,nSC

          iss=iss+1
         end do
        end do
       end if  ! lstruct1=3 detector
      end do
      mss=iss
      mlay=lay
      b_total=b_total.or.b_source.or.b_absorber.or.b_detector

c-----------------------------------------------------------------------
c      here the matrix R for the absorber are given :
c      satrace(n)*1 +  (sapp(n)  sapm(n))
c                      (samp(n) -sapp(n))
c
c      calculation of the transmittivity matrix T for all channels n
c      by   T = exp(iR)*rho*exp(-iR+)
c      exp(-2*Sum;lay sattrlay(lay)) is a common factor, which is the
c      only one for an unpolarized sample
      
c-----------------------------------------------------------------------
c      here the matrix R for the layers are given :
c      satrlay(n,lay)*1 +  (sapplay(n,lay)  sapmlay(n,lay))
c                          (samplay(n,lay) -sapplay(n,lay))
c
c      calculation of the transmittivity matrix T for all channels n
c      by   T = exp(iR)*rho*exp(-iR+)
c      exp(-2*Sum;lay sattrilay(lay)) is a common factor, which is the
c      only one for an unpolarized sample
c      if(mstrut1.eq.3) then the last layer (detector) does not move relative
c      to the source. The detector window is treated as an unpolarized absorber.
      
c       write(6,'(a,2l5)')'moss b_absorber,b_total=',b_absorber,b_total

      if(.not.b_total) goto 1000

      if(ifrcase.eq.5)then
c     --------------------ifrcase=5--------------------------------
       layl=mlay
       if(b_absdetector) layl=mlay-1

       do lay=2,layl
        issa=istruct2(lay-1)+1
        isse=istruct2(lay)

        do n=-nAS,nAS
         n2=2*abs(n)+1
         if(n.ge.0) n2=n2-1
         n8=4*n2
         satraceh=cmplx(0.,0.)
         app=cmplx(0.,0.)
         apm=cmplx(0.,0.)
         amp=cmplx(0.,0.)
         if(isse.gt.issa) then
          do isite=issa,isse
c          if(n.eq.0)write(6,'(a ,2i4,2x,f10.4)')
c     &    ' --1-lay,isite,wi(isite)=',lay,isite,wi(isite)
           if(b_polisite(isite)) then
            nn=l3_get(isite)+n8 
c            if(n.eq.0)write(6,'(a,i6)') 'iget=',l3_get(isite)
            app=app+array_fr(nn+2)*wi(isite)
            apm=apm+array_fr(nn+3)*wi(isite)
            amp=amp+array_fr(nn+4)*wi(isite)
           else
            nn=l3_get(isite)+n2
c            if(n.eq.0)write(6,'(a,i6)') 'iget=',l3_get(isite)
           end if
           satraceh=satraceh+array_fr(nn+1)*wi(isite)
          end do     ! isite loop
         else
          if(b_polisite(issa)) then
           nn=l3_get(issa)+n8
c           if(n.eq.0)write(6,'(a,i6)') 'iget=nn=',nn
           app   =  array_fr(nn+2)*wi(issa)
           apm   =  array_fr(nn+3)*wi(issa)
           amp   =  array_fr(nn+4)*wi(issa)
          else
           nn=l3_get(issa)+n2
c           if(n.eq.0)write(6,'(a,i6)') 'iget=',l3_get(issa)
          end if
          satraceh=satraceh+array_fr(nn+1)*wi(issa)
         end if  ! isse.gt.issa
         if(b_polabsorber) then
          if(b_reemission) then
           aa(1)=cmplx(1.0,0.0)+app
           aa(3)=apm
           aa(2)=amp
           aa(4)=cmplx(1.0,0.0)-app
          else
           call expo_22(app,apm,amp,aa)
          end if
         end if
         if(b_reemission) then
          satrexpr=1.0+2.*aimag(satraceh)
         else
          satrexpr=exp(-aimag(satraceh))
          satrexpr=satrexpr**2
         end if

         if(b_polabsorber) then
c         multiplication of the matrices exp(iR(layl))*...*exp(iR(2))
c         trace (dd+*dd*rho) is the intensity
c         bb=cc+
          do k=1,4
           dd(k)=aa(k)
          end do
          bb(1)=conjg(dd(1))
          bb(4)=conjg(dd(4))
          bb(2)=conjg(dd(3))
          bb(3)=conjg(dd(2))
          call matprof(bb,dd,aa)
       
c         aa=cc*cc+ is a Hermitian matrix
c         aa=1/2*trace(aa)*1 + aP*sv(Pauli)
          aa(1)=aa(1)*satrexpr
          aa(2)=aa(2)*satrexpr
          aa(4)=aa(4)*satrexpr
          aTr(n)= 0.5*real(aa(1)+aa(4))-1.
          aP1(n)=   real(aa(2))
          aP2(n)= -aimag(aa(2))
          aP3(n)= 0.5*real(aa(1)-aa(4))
         else
          aTr(n)= satrexpr-1.
          aP1(n)=0.0
          aP2(n)=0.0
          aP3(n)=0.0
         end if
        end do ! n

c       store l2_put
c        write(6,'(a,i1,a2,2i6)')'l2_put(',lay,')=',l2_put(lay)
        nabs0=l2_put(lay)+1              
        nabs1=nabs0+nAS+1
        nabs2=nabs1+nAS+1
        nabs3=nabs2+nAS+1
c       write(6,'(a,i6)') 'iput=nabs0=',nabs0
        do n=0,nAS
         array_fr(nabs0+n)=cmplx(aTr(n),aTr(-n))
         array_fr(nabs1+n)=cmplx(aP1(n),aP1(-n))
         array_fr(nabs2+n)=cmplx(aP2(n),aP2(-n))
         array_fr(nabs3+n)=cmplx(aP3(n),aP3(-n))
        end do          
       end do   ! lay=2,layl


       iyout=nstorTH+2 
       do k=0,km
        array_fr(iyout+k)=cmplx(1.,1.)
       end do

       lay=1
       issa=istruct2(lay-1)+1
       isse=istruct2(lay)
       b_polabsorber=.true.
       do lay=2,layl
        nabs0=l2_put(lay)
c       write(6,'(a,i6)') 'iget=nabs0=',nabs0
        nabs1=nabs0+nAS+1
        nabs2=nabs1+nAS+1
        nabs3=nabs2+nAS+1
        do n=0,nAS
         aTr(n) = real(array_fr(nabs0+n))
         aTr(-n)=aimag(array_fr(nabs0+n))
         aP1(n) = real(array_fr(nabs1+n))
         aP1(-n)=aimag(array_fr(nabs1+n))
         aP2(n) = real(array_fr(nabs2+n))
         aP2(-n)=aimag(array_fr(nabs2+n))
         aP3(n) = real(array_fr(nabs3+n))
         aP3(-n)=aimag(array_fr(nabs3+n))
        end do
    
        do isite=issa,isse
c        sum over all source sites
         isource_sp=l3_get(isite)                 
c        write(6,'(a,2i6)') 'isite,iget=isource_sp=',isite,isource_sp
      
         if(b_absdetector) then
c         ----------------------------------------------------------
c         b_absdetector=.true.  detector at rest relative to the source
c         -----------------------------------------------------------
          do n=0,nSC
           if(b_polisite(isite)) then
            nn=isource_sp+4*n
            sTr(n) =aimag(array_fr(nn+1))*detector(n)
            sTr(-n)=aimag(array_fr(nn+3))*detector(-n)
           else
            nn=isource_sp+2*n
            sTr(n) =aimag(array_fr(nn+1))*detector(n)
            sTr(-n)=aimag(array_fr(nn+2))*detector(-n)
           end if
          end do
          if(b_polabsorber.and.b_polsource) then
           do n=0,nSC
            nn=isource_sp+4*n
            sP1(n)=  real(array_fr(nn+2))*detector(n)
            sP2(n)=-aimag(array_fr(nn+2))*detector(n)
            sP3(n)=  real(array_fr(nn+1))*detector(n)
            sP1(-n)=  real(array_fr(nn+4))*detector(-n)
            sP2(-n)=-aimag(array_fr(nn+4))*detector(-n)
            sP3(-n)=  real(array_fr(nn+3))*detector(-n)
           end do
          end if  ! b_polabsorber.and.b_polsource
         else  ! b_absdetector=.true.
     
          do n=0,nSC
           if(b_polisite(isite)) then
            nn=isource_sp+4*n
            sTr(n) =aimag(array_fr(nn+1))
            sTr(-n)=aimag(array_fr(nn+3))
           else
            nn=isource_sp+2*n
            sTr(n) =aimag(array_fr(nn+1))
            sTr(-n)=aimag(array_fr(nn+2))
           end if
          end do
              
          if(b_polabsorber.and.b_polsource) then
           do n=0,nSC
            nn=isource_sp+4*n
            sP1(n)=  real(array_fr(nn+2))
            sP2(n)=-aimag(array_fr(nn+2))
            sP3(n)=  real(array_fr(nn+1))
            sP1(-n)=  real(array_fr(nn+4))
            sP2(-n)=-aimag(array_fr(nn+4))
            sP3(-n)=  real(array_fr(nn+3))
c           if(abs(n).le.5) write(6,'(a1,i4,4f15.6)')'x',n,sTr(n),sP3(n)
           end do
          end if   ! b_polabsorber.and.b_polsource
         end if   !  b_absdetector
     
         npolSCAS=0
         if (b_polsource.and.b_polabsorber) npolSCAS=1
         i=2
         if(b_polisite(isite))i=4
         iscn_nr=isource_sp+(nSC+1)*i+1
         if(nAS.gt.nSC) then
          call convolutionAS(iscn_nr,nSC,npolSCAS)
         else
          call convolutionSC(iscn_nr,nAS,npolSCAS)
         end if
         do k=0,km
          array_fr(iyout+k)=array_fr(iyout+k)+yout(k)
     &                                *wi(isite)/float(layl)
         end do
        end do     ! isite source loop
       end do      ! lay loop
      else
c     ------------------- standard -----------------------------
       if(b_absorber) then
        layl=mlay
        if(b_absdetector) layl=mlay-1
       
        do n=-nAS,nAS
         n2=2*abs(n)+1
         if(n.ge.0) n2=n2-1
         n8=4*n2
      
         satraceh=cmplx(0.,0.)
         do lay=2,layl
          issa=istruct2(lay-1)+1
          isse=istruct2(lay)
          app=cmplx(0.,0.)
          apm=cmplx(0.,0.)
          amp=cmplx(0.,0.)
          if(isse.gt.issa) then
           do isite=issa,isse
c           if(n.eq.0)write(6,'(a ,2i4,2x,f10.4)')
c     &     ' --1-lay,isite,wi(isite)=',lay,isite,wi(isite)
            if(b_polisite(isite)) then
             nn=l3_get(isite)+n8 
c             if(n.eq.0)write(6,'(a,i6)') 'iget=',l3_get(isite)
             app=app+array_fr(nn+2)*wi(isite)
             apm=apm+array_fr(nn+3)*wi(isite)
             amp=amp+array_fr(nn+4)*wi(isite)
            else
             nn=l3_get(isite)+n2
c             if(n.eq.0)write(6,'(a,i6)') 'iget=',l3_get(isite)
            end if
            satraceh=satraceh+array_fr(nn+1)*wi(isite)
c            if(abs(n).lt.2) write(6,'(i6,11f8.3)')
c     &        nn,wi(isite),satraceh*1000
           end do     ! isite loop
          else
c          if(n.eq.0)write(6,'(a ,2i4,2x,f10.4)')
c     &    ' --2-lay,issa,wi(issa)=',lay,issa,wi(issa)
           if(b_polisite(issa)) then
            nn=l3_get(issa)+n8
c            if(n.eq.0)write(6,'(a,i6)') 'iget=',l3_get(isite)
            app   =  array_fr(nn+2)*wi(issa)
            apm   =  array_fr(nn+3)*wi(issa)
            amp   =  array_fr(nn+4)*wi(issa)
           else
            nn=l3_get(issa)+n2
c            if(n.eq.0)write(6,'(a,i6)') 'iget=',l3_get(issa)
           end if
           satraceh=satraceh+array_fr(nn+1)*wi(issa)
c            if(abs(n).lt.8) write(6,'(i6,10f12.3)')
c     &        nn,wi(issa),satraceh*1000/wi(issa)
c          if(abs(n).le.5) write(6,'(i2,i6,10f7.2)') n,nn,
c     &    (array_fr(nn+i)*1000.,i=1,4),wi(issa),float(issa)
          end if  ! isse.gt.issa
          if(b_polabsorber) then
           if(b_reemission) then
            aa(1)=cmplx(1.0,0.0)+app
            aa(3)=apm
            aa(2)=amp
            aa(4)=cmplx(1.0,0.0)-app
           else
            call expo_22(app,apm,amp,aa)
           end if
           do k=1,4
            aam(k,lay)=aa(k)
           end do
c            if(n.eq.0) write(6,'(i2,a,11f8.3)')lay,'=lay, aa=',aa 
          end if

         end do   ! lay=2,layl

         
         if(b_reemission) then
          satrexpr=1.0+2.*aimag(satraceh)
c          satrexpr=1.0+2.*aimag(satraceh)/(2.*aimag(satraceh)+1.)
         else
          satrexpr=exp(-aimag(satraceh))
          satrexpr=satrexpr**2
         end if

c         if(abs(n).le.5) write(6,'(i2,2f12.6,5x,L5)') 
c     &            n,aimag(satraceh),satrexpr,b_polabsorber
      
         if(b_polabsorber) then
          do k=1,4
           dd(k)=aam(k,layl)
          end do
      
c         multiplication of the matrices exp(iR(layl))*...*exp(iR(2))
          if(layl.gt.2) then
           do lay=layl-1,2,-1
            do k=1,4
             aa(k)=dd(k)
             bb(k)=aam(k,lay)
            end do
            call matprof(aa,bb,dd)
           end do
          end if
c          if(n.eq.0) write(6,'(a,11f8.3)')' dd=',dd      
c         trace (dd+*dd*rho) is the intensity
c         bb=cc+
          bb(1)=conjg(dd(1))
          bb(4)=conjg(dd(4))
          bb(2)=conjg(dd(3))
          bb(3)=conjg(dd(2))
          call matprof(bb,dd,aa)
      
c         aa=cc*cc+ is a Hermitian matrix
c         aa=1/2*trace(aa)*1 + aP*sv(Pauli)
          aa(1)=aa(1)*satrexpr
          aa(2)=aa(2)*satrexpr
          aa(4)=aa(4)*satrexpr
          aTr(n)= 0.5*real(aa(1)+aa(4))-1.
          aP1(n)=   real(aa(2))
          aP2(n)= -aimag(aa(2))
          aP3(n)= 0.5*real(aa(1)-aa(4))
c          if(abs(n).le.5) write(6,'(a1,i4,4f15.6)')'x',n,aTr(n),aP3(n)
      
         else
          aTr(n)= satrexpr-1.
          aP1(n)=0.0
          aP2(n)=0.0
          aP3(n)=0.0
         end if
c        if(abs(n).le.5) write(6,'(i4,4f15.6)')
c     &                   n,aTr(n),aP1(n),aP2(n),aP3(n)
        end do ! n

c       write(6,'(a,i5)') ' A mossbau bef nAS=',nAS
c       write(6,'(8f10.3)') (aTr(n),n=0,nAS,32)
      
      
c        write(6,'(a,i1,a2,i6)') 
c     &     'l1_put(',mstruct1+1,')=',l1_put(mstruct1+1)

        if(b_polabsorber.and.b_polsource) then
         nabs0=l1_put(mstruct1+1)+1              ! 25.7.06
         nabs1=nabs0+nAS+1
         nabs2=nabs1+nAS+1
         nabs3=nabs2+nAS+1
c         write(6,'(a,i6)') 'iput=nabs0=',nabs0
         do n=0,nAS
          array_fr(nabs0+n)=cmplx(aTr(n),aTr(-n))
          array_fr(nabs1+n)=cmplx(aP1(n),aP1(-n))
          array_fr(nabs2+n)=cmplx(aP2(n),aP2(-n))
          array_fr(nabs3+n)=cmplx(aP3(n),aP3(-n))
         end do
        else
         nabs0=l1_put(mstruct1+1)+1              ! 25.7.06
c         write(6,'(a,i6)') '#iput=nabs0=',nabs0
c        write(6,'(a,i5)') ' mossbau iput=nabs3+nAS=',nabs3+nAS
c        write(6,'(8f10.3)') (aTr(n),n=-3,3)
      
         do n=0,nAS
          array_fr(nabs0+n)=cmplx(aTr(n),aTr(-n))
         end do
        end if

c       write(6,'(a,4f15.1)') 'th_mossbauer array_fr(1,2) =',
c    &  (array_fr(iarray_sp-1)),array_fr(iarray_sp)

       else  ! b_absorber
        if(b_polabsorber.and.b_polsource) then
         nabs0=l1_put(mstruct1+1)
c         write(6,'(a,i6)') 'iget=nabs0=',nabs0
         nabs1=nabs0+nAS+1
         nabs2=nabs1+nAS+1
         nabs3=nabs2+nAS+1
         do n=0,nAS
          aTr(n) = real(array_fr(nabs0+n))
          aTr(-n)=aimag(array_fr(nabs0+n))
          aP1(n) = real(array_fr(nabs1+n))
          aP1(-n)=aimag(array_fr(nabs1+n))
          aP2(n) = real(array_fr(nabs2+n))
          aP2(-n)=aimag(array_fr(nabs2+n))
          aP3(n) = real(array_fr(nabs3+n))
          aP3(-n)=aimag(array_fr(nabs3+n))
         end do
        else
         
         nabs0=l1_put(mstruct1+1)+1
c         write(6,'(a,i6)') 'iget=nabs0=',nabs0
         do n=0,nAS
          aTr(n) = real(array_fr(nabs0+n))
          aTr(-n)=aimag(array_fr(nabs0+n))
         end do
        end if
c        write(6,'(a,i5)') ' B mossbau after nAS=',nAS
c        write(6,'(8f10.3)') (aTr(n),n=0,nAS,32)
       end if  ! b_absorber


       iyout=nstorTH+2 
       do k=0,km
        array_fr(iyout+k)=cmplx(1.,1.)
       end do
    
       lay=1
       issa=istruct2(lay-1)+1
       isse=istruct2(lay)
c      write(6,'(a,8i3)')'istruct2=',(istruct2(isite),isite=0,7)

       do isite=issa,isse
c       sum over all source sites
        isource_sp=l3_get(isite)                 
c       write(6,'(a,2i6)') 'isite,iget=isource_sp=',isite,isource_sp
      
        if(b_absdetector) then
c        ----------------------------------------------------------
c        b_absdetector=.true.  detector at rest relative to the source
c        -----------------------------------------------------------
         do n=0,nSC
         if(b_polisite(isite)) then
          nn=isource_sp+4*n
          sTr(n) =aimag(array_fr(nn+1))*detector(n)
          sTr(-n)=aimag(array_fr(nn+3))*detector(-n)
         else
          nn=isource_sp+2*n
          sTr(n) =aimag(array_fr(nn+1))*detector(n)
          sTr(-n)=aimag(array_fr(nn+2))*detector(-n)
         end if
         end do
         if(b_polabsorber.and.b_polsource) then
          do n=0,nSC
           nn=isource_sp+4*n
           sP1(n)=  real(array_fr(nn+2))*detector(n)
           sP2(n)=-aimag(array_fr(nn+2))*detector(n)
           sP3(n)=  real(array_fr(nn+1))*detector(n)
           sP1(-n)=  real(array_fr(nn+4))*detector(-n)
           sP2(-n)=-aimag(array_fr(nn+4))*detector(-n)
           sP3(-n)=  real(array_fr(nn+3))*detector(-n)
c          if(abs(n).le.5) write(6,'(a1,i4,4f15.6)')'x',n,sTr(n),sP3(n)
          end do
         end if  ! b_polabsorber.and.b_polsource
        else  ! b_absdetector=.true.
     
         do n=0,nSC
          if(b_polisite(isite)) then
           nn=isource_sp+4*n
           sTr(n) =aimag(array_fr(nn+1))
           sTr(-n)=aimag(array_fr(nn+3))
          else
           nn=isource_sp+2*n
           sTr(n) =aimag(array_fr(nn+1))
           sTr(-n)=aimag(array_fr(nn+2))
          end if
         end do

c        write(6,'(a,2i6)')'mossbau nSC,isource_sp=',nSC,isource_sp
c        write(6,'(8f10.3)') (sTr(n),n=0,64)
     
         if(b_polabsorber.and.b_polsource) then
          do n=0,nSC
           nn=isource_sp+4*n
           sP1(n)=  real(array_fr(nn+2))
           sP2(n)=-aimag(array_fr(nn+2))
           sP3(n)=  real(array_fr(nn+1))
           sP1(-n)=  real(array_fr(nn+4))
           sP2(-n)=-aimag(array_fr(nn+4))
           sP3(-n)=  real(array_fr(nn+3))
c          if(abs(n).le.5) write(6,'(a1,i4,4f15.6)')'x',n,sTr(n),sP3(n)
          end do
         end if   ! b_polabsorber.and.b_polsource
        end if   !  b_absdetector
     
        npolSCAS=0
        if (b_polsource.and.b_polabsorber) npolSCAS=1
c       write(6,'(a,i5)') ' #########npolSCAS=',npolSCAS
        i=2
        if(b_polisite(isite))i=4
        iscn_nr=isource_sp+(nSC+1)*i+1
c        write(6,'(a,4i6)') '---------isource,iscn_nr,iput=',
c     &       isource_sp,iscn_nr,isite
     
        if(nAS.gt.nSC) then
         call convolutionAS(iscn_nr,nSC,npolSCAS)
        else
         call convolutionSC(iscn_nr,nAS,npolSCAS)
        end if
        do k=0,km
         array_fr(iyout+k)=array_fr(iyout+k)+yout(k)*wi(isite)
        end do
       end do     ! isite source loop
      end if       ! ifrcase
c-------------------------------------------------------------
c     end of calculation of absorber function
      
 1000  continue
      
      return
      end




c                 
c
c     moving scatterer  or moving source
c
      subroutine mossbauer_refl(b_total,info)
      
      implicit none
      include 'comglb.for'
      include 'comthe.for'

      logical     b_total
      integer     info,ifrth,iaddr,idex,mstruct1,istruct1,istruct2,
     &            l1_get,l2_get,l3_get,l1_put,l2_put,l3_put,
     &            nstorTH,iflag_basis,idum,nAS,nSC
      character*4 c1_prp,c2_prp,c3_prp,frthname*64
      common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),     !13.9.05 
     &              l1_get(0:maxfr1),l2_get(maxfr2),l3_get(maxthss),
     &              l1_put(0:maxfr1),l2_put(maxfr2),l3_put(maxthss),
     &              c1_prp(0:maxfr1),c2_prp(maxfr2),c3_prp(maxthss),
     &              frthname(2),nstorTH,iaddr(7),ifrth(8),
     &              iflag_basis,idum(2),nAS,nSC,idex(11)             

      real          acsp,wavelength,uthick_A,uthick_w,unit_chi,channels,
     &              vm_SC,convol,th_dum,drive_mode,channels_vmax,dumcs
      common/acstrf/acsp,wavelength,uthick_A,uthick_w,unit_chi,channels,
     &              vm_SC,convol,th_dum,drive_mode,channels_vmax,
     &              dumcs(icstrf-11)

      logical       b_vsp,b_v_max,b_dumvsp
      common/bvstrf/b_vsp(4),b_v_max,b_dumvsp(ivstrf-5)
      
      real             acfr1,dumcfr1
      common/acfr1trf/ acfr1,dumcfr1(icfr1trf-1)
      
      integer    idumvfr1
      parameter (idumvfr1=ivfr1trf-8)
      real          avfr1,pvfr1,Hext,thetaHe,phiHe,phi,theta,psi,dumvfr1
      common/avfr1trf/ avfr1,pvfr1,Hext,thetaHe,phiHe,phi,theta,psi,
     &                 dumvfr1(idumvfr1)
      logical          b_vfr1,b_pvfr1,b_Hext,b_thetaHe,b_phiHe,
     &                 b_phi,b_theta,b_psi,b_dumvfr1
      common/bvfr1trf/ b_vfr1,b_pvfr1,b_Hext,b_thetaHe,b_phiHe,
     &                 b_phi,b_theta,b_psi,b_dumvfr1(idumvfr1)
      
      integer    idumvfr2,idumcfr2
      parameter (idumvfr2=ivfr2trf-5,idumcfr2=icfr2trf-2)
      real            acfr2,rep_grp,dumcfr2
      common/acfr2trf/acfr2,rep_grp,dumcfr2(idumcfr2)

      real            avfr2,thicklay,re_chilay,ai_chilay,roughness,
     &                dumvfr2
      common/avfr2trf/avfr2,thicklay,re_chilay,ai_chilay,roughness,
     &                dumvfr2(idumvfr2)
      logical         b_vfr2,b_thicklay,b_re_chilay,b_ai_chilay,
     &                b_roughness,b_dumvfr2
      common/bvfr2trf/b_vfr2,b_thicklay,b_re_chilay,b_ai_chilay,
     &                b_roughness,b_dumvfr2(idumvfr2)
      
      
      real             vsstrf,sftr
      common/avsstrf/ vsstrf(ivsstrf)
      logical          b_vsstrf,b_not_sftr
      common/bvsstrf/ b_vsstrf(ivsstrf)
      
      integer     km,mAS,idumscrd
      parameter  (km=256,mAS=4*maxn,idumscrd=maxscrd-9*(2*mAS+1)
     &                                       -2*(km+1))
      real        sP1,sP2,sP3,aP1,aP2,aP3,sTr,aTr,sa,dumscrd
      complex     yout
      common/scrd/sP1(-mAS:mAS),sP2(-mAS:mAS),sP3(-mAS:mAS),
     &            aP1(-mAS:mAS),aP2(-mAS:mAS),aP3(-mAS:mAS),
     &            sTr(-mAS:mAS),aTr(-mAS:mAS),sa(-mAS:mAS),
     &            yout(0:km),dumscrd(idumscrd)

      logical   b_false,
     &          b_scatarr,b_sites,b_lay,
     &          b_source,b_absorber
      integer   issa,isse,iss,mss,idt,
     &          i,ii,j,n,nn,n8,n2,
     &          k,lay,mlay,layl,ly,laystr,nabs0,nabs1,nabs2,nabs3,
     &          iscn_fr,iscn_nr,npolSCAS,iyout,
     &          lstruct1,lstruct2,lstruct3,isite,isource_sp
      real      wi,vkd,detector,roughlay
      dimension wi(maxthss),roughlay(maxfr2),
     &          b_sites(maxfr2),
     &          vkd(maxfr2),detector(-km:km),laystr(2*maxfr2)
      
      real    pi,rad,grazing,cv_ET,sqrt2,wisp,vector_k,
     &        sing,baseline
      complex hc,hc1,hci,app,apm,amp,satraceh,
     &        aa(4),bb(4),dd(4),
     &        Cmatrix(2,2,maxfr2),chilay(maxfr2),
     &        Rmatrix(2,2),TSPCA(2,2)
      
      logical b_ew,b_polabsorber,b_polsource,b_detector,b_polisite
      integer isubthe

      dimension b_polisite(0:maxthss)

c     ifrcase=6                    !  reflection geometry
      call mapsub(0) 

      b_polsource  =.false.
      b_polabsorber=.false.
            
      hc1=cmplx(1.,0.)
      hci=cmplx(0.,1.)
      
      b_false=.false.
      b_total=.false.
      b_detector=.false.
      b_absorber=.false.      
c------------------------------------------------------------------
c-------------------------------------------------------------------
        vector_k=2*pi/wavelength    ! /Angstroem
c       cv_ET=2*pi*100./vector_k
        cv_ET=100.*wavelength
c      calculation of values,arrays depending on the constants
      
       pi=atan(1.)*4.
       rad=pi/180.
c      transformation matrix from spherical basis to (sigma,pi)-basis
       sqrt2=1./sqrt(2.)
       TSPCA(1,1)=cmplx( sqrt2,0.)
       TSPCA(1,2)=cmplx(-sqrt2,0.)
       TSPCA(2,1)=cmplx(0.,-sqrt2)
       TSPCA(2,2)=cmplx(0.,-sqrt2)
      
      
      iss=1
      do lstruct1=1,mstruct1


       call mapsub(iss)
       b_scatarr=b_v_max.or.b_vfr1
c       isubthe=1                      ! frame
c       call get_theory(isubthe,info)
       
       if(lstruct1.eq.1) then
c      -----------------------------------------------------------------
c      layer 1 = moving source
c      ------------------------------------------------------------------
c      Sums of source curves at the positions Eagd. For the convolution
c      integral the stepwidth is still srw2. The stepwidth srw8 of the
c      source function guarantees that the source line is exact
c      within 1/8 channel.
c
c      ----0--------------------------nLG
c       nLG--------------------------0-------------        srw8
c        nSC------------0------------nSC                    srw2
        lstr1case=1     ! source is transferred by a common block to the 
c                          the routine called by get_theory
        iss=iss+1
        do lstruct2=istruct1(lstruct1-1)+1,istruct1(lstruct1)

  
         b_lay=.false.
         iss=iss+1
         do lstruct3=istruct2(lstruct2-1)+1,istruct2(lstruct2)
          b_polisite(lstruct3)=c3_prp(lstruct3).eq.'plrs'
          if(b_polisite(lstruct3)) b_polsource=.true.
          call mapsub(iss)

          b_scatarr=b_scatarr.or.b_vsstrf(1)
          b_source=b_scatarr
          b_false=b_false.or.b_vsstrf(2)
          b_lay=b_lay.or.b_source
          b_false=b_false.or.b_lay
      
c         write(6,'(a,4l5)')
c     &   ' mossbau source b_lay,b_not_sftr,b_OHL,b_scatarr=',
c     &             b_lay,b_not_sftr,b_OHL,b_scatarr
      
          sftr=vsstrf(2)
          wi(lstruct3)=sftr
          isubthe=0
          call get_theory(isubthe,info)
          if(info.gt.0) return
          iss=iss+1
         end do
        end do
       end if  ! lstruct1=1 source
      
       if(lstruct1.eq.2) then
c      ----------------------------------------------------------------
c      layer lay2,3 ... mlay of  absorber at rest
c      ----------------------------------------------------------------
c      The Lorentz curve of the absorber in npq is 1 at resonance so that
c      for a singl line the exponent at resonance is just -teff (effective
c      thickness). areaLor ~ pi*ga/2 ( area -+ infinity), ga/2=hga/2/srw8,
c      normalizes ( to area 1) the Lorentz curve.
      
c      Sums of absorber curves at the positions Eagd. For the convolution
c      integral the stepwidth is still srw4. The stepwidth srw8 of the
c      absorber function guarantees that the absorbtion line is exact
c      within 1/4 channel.
c
c      ----0--------------------------naLG
c       naLG--------------------------0-------------        srw8
c        nAS------------0------------nAS                    srw2
c
        lstr1case=2       ! absorber
      
         grazing=0.001*abs(theta)
         theta=(pi/2.-grazing)/rad
         sing=sin(grazing)
      
        iss=iss+1
        do lstruct2=istruct1(lstruct1-1)+1,istruct1(lstruct1)

         b_lay=.false.
         lay=lstruct2
      
          call mapsub(iss)
          chilay(lay-1)=cmplx(re_chilay,ai_chilay)*unit_chi
          vkd(lay-1)=vector_k*thicklay
          b_absorber=b_absorber.or.b_vfr2.or.b_thicklay
      
          isubthe=1
          call get_theory(isubthe,info)
          if(info.gt.0) return      
          i=rep_grp
          laystr(2*lay-1)=i
          laystr(2*lay)=10*(rep_grp-float(i)+.01)
          roughlay(lay)=roughness
          b_sites(lay)=.false.
      
         iss=iss+1
         do lstruct3=istruct2(lstruct2-1)+1,istruct2(lstruct2)
          b_polisite(lstruct3)=c3_prp(lstruct3).eq.'plrs'
          if(b_polisite(lstruct3)) b_polabsorber=.true.

          b_sites(lay)=.true.
      
          call mapsub(iss)

          b_scatarr=b_scatarr.or.b_vsstrf(1)
          sftr=vsstrf(2)
          wi(lstruct3)=sftr*uthick_w
c         write(6,'(a,2g8.2)')'*absorber**relthick,sftr=',relthick,sftr
      
           wi(lstruct3)=sftr*uthick_A
           if(wi(lstruct3).gt.sing/20..or.sing.gt.0.05)
     &     write(nwr,'(2(a,g8.1),a)')
     &     '*** f*unit_thickness=',wi(lstruct3),' << sin(th)=',
     &     sing,' << 1 ?'

          b_lay=b_lay.or.b_scatarr.or.b_vsstrf(2)
          b_absorber=b_absorber.or.b_lay
          b_false=b_false.or.b_absorber
c          write(6,'(a,l5,2x,f10.3)')' th_mossbauer b_/vsstrf(2)=',
c     &    b_vsstrf(2),vsstrf(2)
          isubthe=0
          call get_theory(isubthe,info)
          if(info.gt.0) return
c          write(6,'(a,i4)')' absorber isubthe=',isubthe
          iss=iss+1
         end do
        end do
       end if  ! lstruct1=2 absorber
      
       if(lstruct1.eq.3) then
c      ----------------------------------------------------------------
c      layer lay=mlay of detector
c      ----------------------------------------------------------------
        lstr1case=3
        b_detector=.true.
        iss=iss+1
        do lstruct2=istruct1(lstruct1-1)+1,istruct1(lstruct1)

         b_lay=.false.
         lay=lstruct2
      
         iss=iss+1
         do lstruct3=istruct2(lstruct2-1)+1,istruct2(lstruct2)

          call mapsub(iss)
          j=vsstrf(1)
          do k=3,j+1
           b_not_sftr=b_not_sftr.or.b_vsstrf(k)
          end do
          b_scatarr=b_scatarr.or.b_not_sftr
      
          sftr=vsstrf(2)
          wi(lstruct3)=sftr*uthick_w
      
          b_lay=b_lay.or.b_scatarr.or.b_vsstrf(2)
          b_false=b_false.or.b_lay
      
          isubthe=0
          call get_theory(isubthe,info)
          if(info.gt.0) return
c         write(6,'(a)') ' back in detector lstruct3 loop'
      
          iss=iss+1
         end do
        end do
       end if  ! lstruct1=3 detector
      end do
      mss=iss

      mlay=lay
c-----------------------------------------------------------------------
c      here the matrix R for the absorber are given :
c      satrace(n)*1 +  (sapp(n)  sapm(n))
c                      (samp(n) -sapp(n))
c
c      calculation of the transmittivity matrix T for all channels n
c      by   T = exp(iR)*rho*exp(-iR+)
c      exp(-2*Sum;lay sattrlay(lay)) is a common factor, which is the
c      only one for an unpolarized sample
      
c-----------------------------------------------------------------------
c      here the matrix R for the layers are given :
c      satrlay(n,lay)*1 +  (sapplay(n,lay)  sapmlay(n,lay))
c                          (samplay(n,lay) -sapplay(n,lay))
c
c      calculation of the transmittivity matrix T for all channels n
c      by   T = exp(iR)*rho*exp(-iR+)
c      exp(-2*Sum;lay sattrilay(lay)) is a common factor, which is the
c      only one for an unpolarized sample
c      if(mstrut1.eq.3) then the last layer (detector) does not move relative
c      to the source. The detector window is treated as an unpolarized absorber.
      
c       write(6,'(a,l5)') ' mossbau b_absorber=',b_absorber
       if(b_absorber) then
         layl=mlay
         if(b_detector) layl=mlay-1
      
           do lay=2,layl
            ly=lay-1
            Cmatrix(1,1,ly)=(0.0,0.0)
            Cmatrix(2,2,ly)=(0.0,0.0)
            Cmatrix(1,2,ly)=(0.0,0.0)
            Cmatrix(2,1,ly)=(0.0,0.0)
           end do
           call optic(b_ew,layl-1,b_sites,laystr,grazing,
     &                Cmatrix,chilay,roughlay,vkd,Rmatrix)
           dd(1)=Rmatrix(1,1)
           dd(4)=Rmatrix(2,2)
           dd(3)=Rmatrix(1,2)
           dd(2)=Rmatrix(2,1)
      
c         trace (dd+*dd*rho) is the intensity
c         bb=cc+
           bb(1)=conjg(dd(1))
           bb(4)=conjg(dd(4))
           bb(2)=conjg(dd(3))
           bb(3)=conjg(dd(2))
           call matprof(bb,dd,aa)
      
c         aa=cc*cc+ is a Hermitian matrix
          baseline=0.5*real(aa(1)+aa(4))
          if(baseline.lt.1.e-20) then
           baseline=1.
           write(nwr,'(2a)') ' electronic reflectivity lt.1.e-20:',
     &       ' insert chi-electronic'
          end if
          array_fr(nstorTH+1)=cmplx(baseline,0.0)
      
c--------------------------------------------------------------------
c        write(6,'(a,2i6)') 'iget=',l3_get(1),l3_get(2)
        do n=-nAS,nAS
          n2=2*abs(n)+1
          if(n.ge.0) n2=n2-1
          n8=4*n2
      
           do lay=2,layl
            ly=lay-1
            issa=istruct2(lay-1)+1
            isse=istruct2(lay)
            if(isse.gt.issa) then
             satraceh=(0.,0.)
             app=cmplx(0.,0.)
             apm=cmplx(0.,0.)
             amp=cmplx(0.,0.)
             do isite=issa,isse
              wisp=wi(isite)/vector_k
              if(b_polisite(isite)) then
               nn=l3_get(isite)+n8
c               if(n.eq.0)write(6,'(a,i6)') 'iget=',l3_get(isite)
               satraceh=satraceh+array_fr(nn+1)*wisp
               app=app+array_fr(nn+2)*wisp
               apm=apm+array_fr(nn+3)*wisp
               amp=amp+array_fr(nn+4)*wisp
              else
               nn=l3_get(isite)+n2
c               if(n.eq.0)write(6,'(a,i6)') 'iget=nn=',l3_get(isite)
               satraceh=satraceh+array_fr(nn+1)*wi(isite)
              end if
             end do     ! isite loop
            else
             wisp=wi(issa)/vector_k
             if(b_polisite(issa)) then
              nn=l3_get(isite)+n8
c              if(n.eq.0)write(6,'(a,i6)') 'iget',l3_get(isite)
             satraceh=array_fr(nn+1)*wisp
              app   =  array_fr(nn+2)*wisp
              apm   =  array_fr(nn+3)*wisp
              amp   =  array_fr(nn+4)*wisp
             else
              nn=l3_get(isite)+n2
c              if(n.eq.0)write(6,'(a,i6)') 'iget=',l3_get(isite)
              satraceh=array_fr(nn)*wisp
             end if
            end if
             Cmatrix(1,1,ly)= satraceh
             Cmatrix(2,2,ly)= app
             Cmatrix(1,2,ly)= apm
             Cmatrix(2,1,ly)= amp
           end do ! lay
           call optic(b_ew,layl-1,b_sites,laystr,grazing,
     &                Cmatrix,chilay,roughlay,vkd,Rmatrix)
           dd(1)=Rmatrix(1,1)
           dd(4)=Rmatrix(2,2)
           dd(3)=Rmatrix(1,2)
           dd(2)=Rmatrix(2,1)
      
c        trace (dd+*dd*rho) is the intensity
c        bb=cc+
           bb(1)=conjg(dd(1))
           bb(4)=conjg(dd(4))
           bb(2)=conjg(dd(3))
           bb(3)=conjg(dd(2))
           call matprof(bb,dd,aa)
      
c        aa=cc*cc+ is a Hermitian matrix
c        aa=1/2*trace(aa)*1 + aP*sv(Pauli)
      
           aTr(n)= 0.5*real(aa(1)+aa(4))-baseline
           aP1(n)=   real(aa(2))
           aP2(n)= -aimag(aa(2))
           aP3(n)= 0.5*real(aa(1)-aa(4))
c         if(n.gt.-6.and.n.lt.6) write(6,'(2(a,i2,a,f15.5))')
c     &    ' aTr(',n,')=',aTr(n),' aP2(',n,')=',aP2(n)
         end do ! n
c         write(6,'(a,i5)') ' mossbau bef nAS=',nAS
c         write(6,'(8f10.3)') (aTr(n),n=0,nAS,32)
      
      
        if(b_polabsorber.and.b_polsource) then
         nabs0=l1_put(mstruct1+1)
c         write(6,'(a,i6)') 'iput=nabs0=',nabs0
         nabs1=nabs0+nAS+1
         nabs2=nabs1+nAS+1
         nabs3=nabs2+nAS+1
c         write(6,'(a,i6)') 'iput=nabs0=',nabs0
         do n=0,nAS
          array_fr(nabs0+n)=cmplx(aTr(n),aTr(-n))
          array_fr(nabs1+n)=cmplx(aP1(n),aP1(-n))
          array_fr(nabs2+n)=cmplx(aP2(n),aP2(-n))
          array_fr(nabs3+n)=cmplx(aP3(n),aP3(-n))
         end do
        else
         nabs0=l1_put(mstruct1+1)
c         write(6,'(a,i6)') '#iput=nabs0=',nabs0
c        write(6,'(a,i5)') ' mossbau iput=nabs3+nAS=',nabs3+nAS
c        write(6,'(8f10.3)') (aTr(n),n=-3,3)
      
         do n=0,nAS
          array_fr(nabs0+n)=cmplx(aTr(n),aTr(-n))
         end do
        end if
c       write(6,'(a,4f15.1)') 'th_mossbauer array_fr(1,2) =',
c    &  (array_fr(iarray_sp-1)),array_fr(iarray_sp)
       else
        if(b_polabsorber.and.b_polsource) then
         nabs0=l1_put(mstruct1+1)
c         write(6,'(a,i6)') 'iget=nabs0=',nabs0
         nabs1=nabs0+nAS+1
         nabs2=nabs1+nAS+1
         nabs3=nabs2+nAS+1
         do n=0,nAS
          aTr(n) = real(array_fr(nabs0+n))
          aTr(-n)=aimag(array_fr(nabs0+n))
          aP1(n) = real(array_fr(nabs1+n))
          aP1(-n)=aimag(array_fr(nabs1+n))
          aP2(n) = real(array_fr(nabs2+n))
          aP2(-n)=aimag(array_fr(nabs2+n))
          aP3(n) = real(array_fr(nabs3+n))
          aP3(-n)=aimag(array_fr(nabs3+n))
         end do
        else
         
         nabs0=l1_put(mstruct1+1)+1
c         write(6,'(a,i6)') 'iget=nabs0=',nabs0
         do n=0,nAS
          aTr(n) = real(array_fr(nabs0+n))
          aTr(-n)=aimag(array_fr(nabs0+n))
         end do
        end if
c        write(6,'(a,i5)') ' mossbau after nAS=',nAS
c        write(6,'(8f10.3)') (aTr(n),n=0,nAS,32)
       end if  ! b_absorber
      
      
c-------------------------------------------------------------
c      b_detector=.true.  detector at rest relative to the source
c-----------------------------------------------------------------------
       if(b_detector) then
        do n=-nSC,nSC
         detector(n)=0.
        end do
        do lstruct3=istruct2(lstruct2-1)+1,istruct2(lstruct2)
         isite=lstruct3
         idt=l3_get(isite)+1
c         write(6,'(a,i6)') 'iget=idt=',idt
         do n=0,nSC
          detector(n)=detector(n)+real(array_fr(idt+n))*wi(isite)
          detector(-n)=detector(-n)+aimag(array_fr(idt+n))*wi(isite)
         end do ! n=0,nSC
        end do  ! lstruct3
        do n=-nSC,nSC
         detector(n)=exp(-2.*detector(n))
        end do  ! n=0,nSC
       end if  ! b_detector
c-------------------------------------------------------------
      
      
      if(.not.b_false) goto 1000
      
      
      lay=1
      issa=istruct2(lay-1)+1
      isse=istruct2(lay)
c      write(6,'(a,8i3)')'istruct2=',(istruct2(isite),isite=0,7)

      do isite=issa,isse
c      sum over all source sites
       isource_sp=l3_get(isite)                 
c       write(6,'(a,2i6)') 'isite,iget=isource_sp=',isite,isource_sp
      
       if(b_source.or.b_absorber) then
      
         if(b_detector) then
c        ----------------------------------------------------------
c        b_detector=.true.  detector at rest relative to the source
c        -----------------------------------------------------------
          do n=0,nSC
          if(b_polisite(isite)) then
           nn=isource_sp+4*n
           sTr(n) =aimag(array_fr(nn+1))*detector(n)
           sTr(-n)=aimag(array_fr(nn+3))*detector(-n)
          else
           nn=isource_sp+2*n
           sTr(n) =aimag(array_fr(nn+1))*detector(n)
           sTr(-n)=aimag(array_fr(nn+2))*detector(-n)
          end if
          end do
          if(b_polabsorber.and.b_polsource) then
           do n=0,nSC
            nn=isource_sp+4*n
            sP1(n)=  real(array_fr(nn+2))*detector(n)
            sP2(n)=-aimag(array_fr(nn+2))*detector(n)
            sP3(n)=  real(array_fr(nn+1))*detector(n)
            sP1(-n)=  real(array_fr(nn+4))*detector(-n)
            sP2(-n)=-aimag(array_fr(nn+4))*detector(-n)
            sP3(-n)=  real(array_fr(nn+3))*detector(-n)
           end do
          end if  ! b_polabsorber.and.b_polsource
      
         else  ! b_detector=.true.
      
c         write(6,'(a,2i8)') '-----sTr,isource_sp,nSC=',isource_sp,nSC
c         write(6,'(a,2f10.5)') '-------sTr(0)=',array_fr(isource_sp+1)
          do n=0,nSC
           if(b_polisite(isite)) then
            nn=isource_sp+4*n
            sTr(n) =aimag(array_fr(nn+1))
            sTr(-n)=aimag(array_fr(nn+3))
           else
            nn=isource_sp+2*n
            sTr(n) =aimag(array_fr(nn+1))
            sTr(-n)=aimag(array_fr(nn+2))
           end if
          end do
      
c         write(6,'(a,2i6)')'mossbau nSC,isource_sp=',nSC,isource_sp
c         write(6,'(8f10.3)') (sTr(n),n=0,64)
      
          if(b_polabsorber.and.b_polsource) then
           do n=0,nSC
            nn=isource_sp+4*n
            sP1(n)=  real(array_fr(nn+2))
            sP2(n)=-aimag(array_fr(nn+2))
            sP3(n)=  real(array_fr(nn+1))
            sP1(-n)=  real(array_fr(nn+4))
            sP2(-n)=-aimag(array_fr(nn+4))
            sP3(-n)=  real(array_fr(nn+3))
           end do
          end if   ! b_polabsorber.and.b_polsource
         end if   !  b_detector
      
         npolSCAS=0
         if (b_polsource.and.b_polabsorber) npolSCAS=1
c        write(6,'(a,4i5)') ' ########npolSCAS,nAS,nSC=',npolSCAS,nAS,nSC
      
         i=2
         if(b_polisite(isite))i=4
         iscn_nr=isource_sp+(nSC+1)*i+1
         iscn_fr=l3_put(isite)
c         write(6,'(a,2i6)') 'isite iput=iscn_fr=',isite,iscn_fr
c         write(6,'(a,4i6)') '---------isource,iscn_nr,iput=iscn_fr=',
c     &       isource_sp,iscn_nr,iscn_fr,isite
      
         if(nAS.gt.nSC) then
          call convolutionAS(iscn_nr,nSC,npolSCAS)
         else
          call convolutionSC(iscn_nr,nAS,npolSCAS)
         end if
         do k=0,km
          array_fr(iyout+k)=array_fr(iyout+k)+yout(k)*wi(isite)
         end do
     
       end if     ! b_source(isite) .or. b_absorber
      end do     ! isite source loop
c     summing up the subspectra
      
      baseline=real(array_fr(nstorTH+1))
c      write(6,'(a,i6,f10.4)')'nstorTH+1,baseline=',nstorTH+1,baseline
c      write(6,'(a,i6)')'mossbau nstorTH+2+km=',nstorTH+2+km
      
      
      b_total=.true.
c     end of calculation of absorber function
      
 1000  continue
      
       return
      end
      
      subroutine convolutionAS_(iscn_nr,nSC,npolSCAS)
      
      include 'comglb.for'
      include 'comthe.for'
      
      integer npolSCAS,iscn_nr,nSC,idumscrd,km,mAS
      parameter (km=256,mAS=4*maxn,idumscrd=maxscrd-9*(2*mAS+1)
     &                                      -2*(km+1))
      real      aP1,aP2,aP3,sP1,sP2,sP3,sTr,aTr,sa,dumscrd
      complex   yout
      common/scrd/sP1(-mAS:mAS),sP2(-mAS:mAS),sP3(-mAS:mAS),
     &            aP1(-mAS:mAS),aP2(-mAS:mAS),aP3(-mAS:mAS),
     &            sTr(-mAS:mAS),aTr(-mAS:mAS),sa(-mAS:mAS),
     &            yout(0:km),dumscrd(idumscrd)
      
c-----------------------------------------------------------------------
c      convolution with the absorber function
c
c     -nAS-------k2--------------0---------k----k2--------nAS
c     -nSC---k2--0--k2---nSC  -nSC---k2--0--k2---nSC
c
      
c     this convolution is calculated with stepwidth srw2
c         write(6,'(a,i8)') '  -conAS--, iscn=',iscn
      
c       do j=-nSC/8,nSC/8
c        write(6,'(i4,8e10.3)') j,(aTr((j-1)*8+i),i=1,8)
c       end do
c       write(6,'(a,2i6)') 'convolutionAS kzlm,nSC=',kzlm,nSC
c       write(6,'(a,i8)') 'convolutionAS iscn_nr=',iscn_nr
c       write(6,'(a,i8)') 'convolutionAS iscn_fr=',iscn_fr
c       write(6,'(a,i8)') 'convolutionAS npolSCAS=',npolSCAS
c       write(6,'(a,2f15.5)')'array_fr(iscn_nr)=',array_fr(iscn_nr)
c      write(6,'(4f10.3)') (sTR(i),i=-2,1)
c      write(6,'(4g15.5)') (cLG(i),i=-2,1)
c       write(6,'(i4,a,2f15.6)')
c     &    (k,' sTr(k),aTr(k)=',sTr(k),aTr(k),k=-5,5)
      
      snorm=3.*real(array_fr(iscn_nr))
c     write(6,'(a,f10.5)') '  snorm =',snorm

      do i=0,2*km,2
       h1=0.
       h2=0.
        do j=-nSC+1,nSC-1,2
        h1=h1+ sTr(j)*aTr(i+j)*2.
        h2=h2+ sTr(j)*aTr(-i+j)*2.
        end do
        do j=-nSC+2,nSC-2,2
        h1=h1+ sTr(j)*aTr(i+j)
        h2=h2+ sTr(j)*aTr(-i+j)
        end do
        h1=h1*2.+ sTr(-nSC)*aTr(-nSC+i)+sTr(nSC)*aTr(nSC+i)
        h2=h2*2.+ sTr(-nSC)*aTr(-nSC-i)+sTr(nSC)*aTr(nSC-i)
      
      if (npolSCAS.eq.1) then
c     product   sP * aP  , Poincare vector of the source sP is already
c     weighted by the intensity sTr
      
        do j=-nSC+1,nSC-1,2
        h1=h1+ (sP1(j)*aP1(i+j)+sP2(j)*aP2(i+j)+sP3(j)*aP3(i+j))*4.
        h2=h2+ (sP1(j)*aP1(-i+j)+sP2(j)*aP2(-i+j)+sP3(j)*aP3(-i+j))*4.
        end do
        do j=-nSC+2,nSC-2,2
        h1=h1+ (sP1(j)*aP1(i+j)+sP2(j)*aP2(i+j)+sP3(j)*aP3(i+j))*2.
        h2=h2+ (sP1(j)*aP1(-i+j)+sP2(j)*aP2(-i+j)+sP3(j)*aP3(-i+j))*2.
        end do
        k=-nSC+i
        h1=h1+ sP1(-nSC)*aP1(k)+sP2(-nSC)*aP2(k)+sP3(-nSC)*aP3(k)
        k=nSC+i
        h1=h1+ sP1(nSC)*aP1(k)+sP2(nSC)*aP2(k)+sP3(nSC)*aP3(k)
        k=-nSC-i
        h2=h2+ sP1(-nSC)*aP1(k)+sP2(-nSC)*aP2(k)+sP3(-nSC)*aP3(k)
        k=nSC-i
        h2=h2+ sP1(nSC)*aP1(k)+sP2(nSC)*aP2(k)+sP3(nSC)*aP3(k)
       end if     ! if polarized- condition
       yout(i/2)=cmplx(h1,h2)/snorm
      end do
      
c       write(6,'(i4,i8,2x,2f15.6)')
c     &          (k,iyout,array_fr(iyout+k),k=-5,5)
      
      return
      end
      
      subroutine convolutionSC(iscn_nr,nAS,npolSCAS)
       include 'comglb.for'
       include 'comthe.for'
      
      integer npolSCAS,iscn_nr,nAS,idumscrd,km,mAS
      parameter (km=256,mAS=4*maxn,idumscrd=maxscrd-9*(2*mAS+1)
     &                                      -2*(km+1))
      real      aP1,aP2,aP3,sP1,sP2,sP3,sTr,aTr,sa,dumscrd
      complex   yout
      common/scrd/sP1(-mAS:mAS),sP2(-mAS:mAS),sP3(-mAS:mAS),
     &            aP1(-mAS:mAS),aP2(-mAS:mAS),aP3(-mAS:mAS),
     &            sTr(-mAS:mAS),aTr(-mAS:mAS),sa(-mAS:mAS),
     &            yout(0:km),dumscrd(idumscrd)

c      write(6,'(a,i4)') 'convolutionSC sTR,aTR,npolSCAS=',npolSCAS
c       write(6,'(a,2i8)') 'convolutionSC nAS=',nAS
c      do j=-nSC/8,nSC/8
c       write(6,'(i4,8e10.3)') j,(sTr((j-1)*8+i),i=1,8)
c      end do
c      do j=-nAS/8,nAS/8
c       write(6,'(i4,8e11.3)') j,(aTr((j-1)*8+i),i=1,8)
c      end do
c       write(6,'(8f10.3)') (aTr(i),i=-nAS,nAS,8),aTr(nAS)
c       nSC=256
c       write(6,'(8f11.3)') (sP3(i)*100,i=-nSC,nSC,16)
      
      iin=iscn_nr
      
      do i=0,2*km,2
       do j=-nAS,nAS
        sa(j)=aTr(j)*sTr(i+j)
       end do
       h1=0.
       do j=-nAS+1,nAS-1,2
        h1=h1+ sa(j)*4.
       end do
       do j=-nAS+2,nAS-2,2
        h1=h1+ sa(j)*2
       end do
       h1=h1+ sa(-nAS)+sa(nAS)
       h2=0.
       do j=-nAS+3,nAS-5,2
        h2=h2+ sa(j)*8.
       end do
       do j=-nAS+2,nAS-4,2
        h2=h2- sa(j)*8.
       end do
       h2=h2-4.*(sa(-nAS)+sa(nAS-2))
     &      +7.*(sa(-nAS+1)+sa(nAS-3))
       hr=h1-h2/30.       

       do j=-nAS,nAS
        sa(j)=aTr(j)*sTr(-i+j)
       end do
       h1=0.
       do j=-nAS+1,nAS-1,2
        h1=h1+ sa(j)*4.
       end do
       do j=-nAS+2,nAS-2,2
        h1=h1+ sa(j)*2
       end do
       h1=h1+ sa(-nAS)+sa(nAS)
       h2=0.
       do j=-nAS+3,nAS-5,2
        h2=h2+ sa(j)*8.
       end do
       do j=-nAS+2,nAS-4,2
        h2=h2- sa(j)*8.
       end do
       h2=h2-4.*(sa(-nAS)+sa(nAS-2))
     &      +7.*(sa(-nAS+1)+sa(nAS-3))
       hi=h1-h2/30.       

       if (npolSCAS.eq.1) then
c       product   aP * sP  , Poincare vector of the source sP is already
c       weighted by the intensity sTr
        do j=-nAS,nAS
         sa(j)=aP1(j)*sP1(i+j)+aP2(j)*sP2(i+j)+aP3(j)*sP3(i+j)
        end do
        h1=0.
        do j=-nAS+1,nAS-1,2
         h1=h1+ sa(j)*4.
        end do
        do j=-nAS+2,nAS-2,2
         h1=h1+ sa(j)*2
        end do
        h1=h1+ sa(-nAS)+sa(nAS)
        h2=0.
        do j=-nAS+3,nAS-5,2
         h2=h2+ sa(j)*8.
        end do
        do j=-nAS+2,nAS-4,2
         h2=h2- sa(j)*8.
        end do
        h2=h2-4.*(sa(-nAS)+sa(nAS-2))
     &       +7.*(sa(-nAS+1)+sa(nAS-3))
        hr=hr+h1-h2/30.       
  
        do j=-nAS,nAS
         sa(j)=aP1(j)*sP1(-i+j)+aP2(j)*sP2(-i+j)+aP3(j)*sP3(-i+j)
        end do
        h1=0.
        do j=-nAS+1,nAS-1,2
         h1=h1+ sa(j)*4.
        end do
        do j=-nAS+2,nAS-2,2
         h1=h1+ sa(j)*2
        end do
        h1=h1+ sa(-nAS)+sa(nAS)
        h2=0.
        do j=-nAS+3,nAS-5,2
         h2=h2+ sa(j)*8.
        end do
        do j=-nAS+2,nAS-4,2
         h2=h2- sa(j)*8.
        end do
        h2=h2-4.*(sa(-nAS)+sa(nAS-2))
     &       +7.*(sa(-nAS+1)+sa(nAS-3))
        hi=hi+h1-h2/30.       
       end if     ! if polarized- condition
       k=i/2
       hr=hr/real(array_fr(iin+k))/3.
       hi=hi/aimag(array_fr(iin+k))/3.
       yout(k)=cmplx(hi,hr)
      end do
c       write(6,'(a,6i6)')'mossbau iin,nAS=',iin,nAS
      return
      end
      
      subroutine convolutionAS(iscn_nr,nSC,npolSCAS)
      
      include 'comglb.for'
      include 'comthe.for'
      
      integer npolSCAS,iscn_nr,nSC,idumscrd,km,mAS
      parameter (km=256,mAS=4*maxn,idumscrd=maxscrd-9*(2*mAS+1)
     &                                      -2*(km+1))
      real      aP1,aP2,aP3,sP1,sP2,sP3,sTr,aTr,sa,dumscrd
      complex   yout
      common/scrd/sP1(-mAS:mAS),sP2(-mAS:mAS),sP3(-mAS:mAS),
     &            aP1(-mAS:mAS),aP2(-mAS:mAS),aP3(-mAS:mAS),
     &            sTr(-mAS:mAS),aTr(-mAS:mAS),sa(-mAS:mAS),
     &            yout(0:km),dumscrd(idumscrd)
      
c-----------------------------------------------------------------------
c      convolution with the absorber function
c
c     -nAS-------k2--------------0---------k----k2--------nAS
c     -nSC---k2--0--k2---nSC  -nSC---k2--0--k2---nSC
c
      
c     this convolution is calculated with stepwidth srw2
c         write(6,'(a,i8)') '  -conAS--, iscn=',iscn
      
c       do j=-nSC/8,nSC/8
c        write(6,'(i4,8e10.3)') j,(aTr((j-1)*8+i),i=1,8)
c       end do
c       write(6,'(a,2i6)') 'convolutionAS kzlm,nSC=',kzlm,nSC
c       write(6,'(a,i8)') 'convolutionAS iscn_nr=',iscn_nr
c       write(6,'(a,i8)') 'convolutionAS iscn_fr=',iscn_fr
c       write(6,'(a,i8)') 'convolutionAS npolSCAS=',npolSCAS
c       write(6,'(a,2f15.5)')'array_fr(iscn_nr)=',array_fr(iscn_nr)
      
      snorm=3.*real(array_fr(iscn_nr))
c     write(6,'(a,f10.5)') '  snorm =',snorm
      
      do i=0,2*km,2

       do j=-nSC,nSC
        sa(j)=sTr(j)*aTr(i+j)
       end do
       h1=0.
       do j=-nSC+1,nSC-1,2
        h1=h1+ sa(j)*4.
       end do
       do j=-nSC+2,nSC-2,2
        h1=h1+ sa(j)*2
       end do
       h1=h1+ sa(-nSC)+sa(nSC)
       h2=0.
       do j=-nSC+3,nSC-5,2
        h2=h2+ sa(j)*8.
       end do
       do j=-nSC+2,nSC-4,2
        h2=h2- sa(j)*8.
       end do
       h2=h2-4.*(sa(-nSC)+sa(nSC-2))
     &      +7.*(sa(-nSC+1)+sa(nSC-3))
       hr=h1-h2/30.       

       do j=-nSC,nSC
        sa(j)=sTr(j)*aTr(-i+j)
       end do
       h1=0.
       do j=-nSC+1,nSC-1,2
        h1=h1+ sa(j)*4.
       end do
       do j=-nSC+2,nSC-2,2
        h1=h1+ sa(j)*2
       end do
       h1=h1+ sa(-nSC)+sa(nSC)
       h2=0.
       do j=-nSC+3,nSC-5,2
        h2=h2+ sa(j)*8.
       end do
       do j=-nSC+2,nSC-4,2
        h2=h2- sa(j)*8.
       end do
       h2=h2-4.*(sa(-nSC)+sa(nSC-2))
     &      +7.*(sa(-nSC+1)+sa(nSC-3))
       hi=h1-h2/30.       

       if (npolSCAS.eq.1) then
c      product   sP * aP  , Poincare vector of the source sP is already
c      weighted by the intensity sTr
        do j=-nSC,nSC
         sa(j)=sP1(j)*aP1(i+j)+sP2(j)*aP2(i+j)+sP3(j)*aP3(i+j)
        end do
        h1=0.
        do j=-nSC+1,nSC-1,2
         h1=h1+ sa(j)*4.
        end do
        do j=-nSC+2,nSC-2,2
         h1=h1+ sa(j)*2
        end do
        h1=h1+ sa(-nSC)+sa(nSC)
        h2=0.
        do j=-nSC+3,nSC-5,2
         h2=h2+ sa(j)*8.
        end do
        do j=-nSC+2,nSC-4,2
         h2=h2- sa(j)*8.
        end do
        h2=h2-4.*(sa(-nSC)+sa(nSC-2))
     &       +7.*(sa(-nSC+1)+sa(nSC-3))
        hr=hr+h1-h2/30.       
  
        do j=-nSC,nSC
         sa(j)=sP1(j)*aP1(-i+j)+sP2(j)*aP2(-i+j)+sP3(j)*aP3(-i+j)
        end do
        h1=0.
        do j=-nSC+1,nSC-1,2
         h1=h1+ sa(j)*4.
        end do
        do j=-nSC+2,nSC-2,2
         h1=h1+ sa(j)*2
        end do
        h1=h1+ sa(-nSC)+sa(nSC)
        h2=0.
        do j=-nSC+3,nSC-5,2
         h2=h2+ sa(j)*8.
        end do
        do j=-nSC+2,nSC-4,2
         h2=h2- sa(j)*8.
        end do
        h2=h2-4.*(sa(-nSC)+sa(nSC-2))
     &       +7.*(sa(-nSC+1)+sa(nSC-3))       
        hi=hi+h1-h2/30.       
       end if     ! if polarized- condition
       k=i/2
       yout(k)=cmplx(hr,hi)/snorm
      end do
      
      return
      end

      FUNCTION BESSI0(X)
      REAL*8 Y,P1,P2,P3,P4,P5,P6,P7,
     *    Q1,Q2,Q3,Q4,Q5,Q6,Q7,Q8,Q9
      DATA P1,P2,P3,P4,P5,P6,P7/1.0D0,3.5156229D0,3.0899424D0,1.2067492D
     *0,
     *    0.2659732D0,0.360768D-1,0.45813D-2/
      DATA Q1,Q2,Q3,Q4,Q5,Q6,Q7,Q8,Q9/0.39894228D0,0.1328592D-1,
     *    0.225319D-2,-0.157565D-2,0.916281D-2,-0.2057706D-1,
     *    0.2635537D-1,-0.1647633D-1,0.392377D-2/
      IF (ABS(X).LT.3.75) THEN
        Y=(X/3.75)**2
        BESSI0=P1+Y*(P2+Y*(P3+Y*(P4+Y*(P5+Y*(P6+Y*P7)))))
      ELSE
        AX=ABS(X)
        Y=3.75/AX
        BESSI0=(EXP(AX)/SQRT(AX))*(Q1+Y*(Q2+Y*(Q3+Y*(Q4
     *      +Y*(Q5+Y*(Q6+Y*(Q7+Y*(Q8+Y*Q9))))))))
      ENDIF
      RETURN
      END

