c     H. Spiering september 2004 Mainz
c     adapted to the beta version
c
      subroutine neutronrock(b_total,info)
      implicit none
      include 'comglb.for'
      include 'comthe.for'
      logical     b_total      
      integer     info,mstruct1,istruct1,istruct2,
     &            l1_get,l2_get,l3_get,l1_put,l2_put,l3_put,
     &            nstorTH,nstorRM,nstorTHyy,istorTH,idum
      character*4 c1_prp,c2_prp,c3_prp,cfill,frthname*64
      common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),
     &              l1_get(0:maxfr1),l2_get(maxfr2),l3_get(maxthss),
     &              l1_put(0:maxfr1),l2_put(maxfr2),l3_put(maxthss),
     &              c1_prp(0:maxfr1),c2_prp(maxfr2),c3_prp(maxthss),
     &              frthname(2),nstorTH,nstorRM,nstorTHyy,idum(5),
     &              istorTH,cfill(23)


      real          acsp,dwba,channels,Q_scale,unit_sclB,unit_sclN,
     &              ch_q,q_beg,q_end,dtheta1,dtheta2,dlambda,
     &              aver_points,dumcs
      common/acstrf/acsp,dwba,channels,Q_scale,unit_sclB,unit_sclN,
     &              ch_q,q_beg,q_end,dtheta1,dtheta2,dlambda,
     &              aver_points,dumcs(icstrf-13)
      
      real          avs,aintensity,background,Pxsi_b,Peta_b,Pzeta_b,
     &              Pxsi_a,Peta_a,Pzeta_a,q_shift,q_min,phi_z,dumvs
      common/avstrf/avs,aintensity,background,Pxsi_b,Peta_b,Pzeta_b,
     &              Pxsi_a,Peta_a,Pzeta_a,q_shift,q_min,phi_z,
     &              dumvs(ivstrf-12)
      logical       b_vs,b_aintensity,b_background,
     &              b_Pxsi_b,b_Peta_b,b_Pzeta_b,
     &              b_Pxsi_a,b_Peta_a,b_Pzeta_a,
     &              b_q_shift,b_q_min,b_phi_z,b_dumvs
      common/bvstrf/b_vs,b_aintensity,b_background,
     &              b_Pxsi_b,b_Peta_b,b_Pzeta_b,
     &              b_Pxsi_a,b_Peta_a,b_Pzeta_a,
     &              b_q_shift,b_q_min,b_phi_z,b_dumvs(ivstrf-12)
      
c     common/vfr1trf/ inc_frac,Hext,theta_He,phi_He
      integer    idumvfr1
      parameter (idumvfr1=ivfr1trf-5)
      real            avfr1,pvfr1,Hext,theta_He,phi_He,dumvfr1
      common/avfr1trf/avfr1,pvfr1,Hext,theta_He,phi_He,dumvfr1(idumvfr1)
      logical         b_vfr1,b_pvfr1,b_Hext,b_theta_He,b_phi_He,
     &                b_dumvfr1
      common/bvfr1trf/b_vfr1,b_pvfr1,b_Hext,b_theta_He,b_phi_He,
     &                b_dumvfr1(idumvfr1)

      real            acfr2,dum,rep_grp,dumcfr2
      common/acfr2trf/acfr2,dum,rep_grp,dumcfr2(icfr2trf-3)

      real            avfr2,thicklay,B_eff,theta_B,phi_B,
     &                ar_scatldens,ai_scatldens,roughness,dumvfr2
      common/avfr2trf/avfr2,thicklay,B_eff,theta_B,phi_B,
     &                ar_scatldens,ai_scatldens,roughness,
     &                dumvfr2(ivfr2trf-8)
      logical         b_vfr2,b_thicklay,b_B_eff,b_theta_B,b_phi_B,
     &                b_ar_scatldens,b_ai_scatldens,b_roughness,
     &                b_dumvfr2
      common/bvfr2trf/b_vfr2,b_thicklay,b_B_eff,b_theta_B,b_phi_B,
     &                b_ar_scatldens,b_ai_scatldens,b_roughness,
     &                b_dumvfr2(ivfr2trf-8)
      
      logical  b_scatl_lay,b_Beff,b_analyser
      
      integer issp,i,nn,lstruct1,lstruct2,
     &        lay,nch_q,nchq,nyout,laystr
C*************************************************************
C
C Variables defined by L. Deak (20.12.2000)      
C
      real      q_scat,rd_q,h,h1,Hext_z,
     &          pi,rad,thicklayer,roughlayer
      real*4    sin_theta_B,cos_theta_B,sin_phi_B,cos_phi_B
      real*4    sin_theta_H,cos_theta_H,sin_phi_H,cos_phi_H
      real*4    sin_B_H,cos_B_H,B_a,B_b,B_c
      logical   b_up,b_down
C
C ************************************************************     
      dimension thicklayer(maxfr2),roughlayer(maxfr2),
     &          laystr(2*maxfr2+2),b_Beff(maxfr2)

      complex aa(4),bb(4),dd(4),rho_a(4),rho_b(4),
     &        K_mag_lay(2,2,maxfr2),scatl_lay,Rmatrix(2,2)
      
      real chrock,chrock2,d_theta1,d_theta2
      dimension chrock(maxn),chrock2(maxn)
c      common/scrd/dumscrd(maxscrd/2)
c      equivalence (dumscrd(1),chrock(1)),(dumscrd(maxn+1),chrock2(1))
      
      logical b_true,b_false,b_scatterer
      
C **** Definitions of structure variables 
C Khaidukov 26.04.2003 & L. Deak 09.10.2002 ***
      integer POINTER,GRP,MAXGRP,GEOSTR(0:2*maxfr2),Kh
      logical b_first
      integer iaver_points
C ****                                       ***     

       iaver_points=aver_points      
       pi=atan(1.)*4.
       rad=pi/180.
c      write(6,'(a)')'synrock ksp_m(0:maxthssp/2)='
c      write(6,'(10i7)')(iarray_sp+ksp_m(i),i=0,maxthssp/4)
c-------------------------------------------------------------------
       b_up  =.false.   ! initialization of '+' beam
       b_down=.false.   !                   '-'
c     write(6,'(3(a,e8.2))')
c    &    ' -- Pxsi_a=',Pxsi_a,' Peta_a=',Peta_a,' Pzeta_a=',Pzeta_a
      
      
      call mapsub(0)
      b_total=b_vs


c---------------------------------------------------------------------------
c     transformation matrix from spherical basis to (sigma,pi)-basis
      
c     orientation of the absorber with respect to the beam
      
      b_analyser=abs(Pxsi_a)+abs(Peta_a)+abs(Pzeta_a).gt.0.001
      if(b_analyser) then
C
C if Pzeta_a > 0. we measure the '+' beam
C if Pzeta_a < 0. we measure the '-' beam
       if(Pzeta_a.gt.0.) b_up  =.true.
       if(Pzeta_a.lt.0.) b_down=.true.
       rho_a(1)=cmplx(1.+Pzeta_a,0.)/2.
       rho_a(3)=cmplx(Pxsi_a,-Peta_a)/2.
       rho_a(2)=cmplx(Pxsi_a,Peta_a)/2.
       rho_a(4)=cmplx(1.-Pzeta_a,0.)/2.
      end if

       rho_b(1)=cmplx(1.+Pzeta_b,0.)/2.
       rho_b(3)=cmplx(Pxsi_b,-Peta_b)/2.
       rho_b(2)=cmplx(Pxsi_b,Peta_b)/2.
       rho_b(4)=cmplx(1.-Pzeta_b,0.)/2.

       nch_q=2*istorTH
       rd_q=(q_end-q_beg)/float(nch_q-1)

c      write(6,'(a,g15.5)')'neutronrok rd_q=',rd_q
c      write(6,'(a)')'++++++++++++++++++++++++++++++++++++'


      issp=1
      lstruct1=1
c       write(6,'(a,12i6)')'lstruct1 issp,ksp_m(issp)=',
c     & lstruct1,issp,ksp_m(issp)
      
       call mapsub(issp)
c      common/avfr1trf/avfr1,pvfr1,Hext
       b_false=b_false.or.b_vfr1
       b_true=b_true.and.b_vfr1
       b_total=b_total.or.b_pvfr1
     
       Hext_z=Hext*unit_sclB      
      
      
       issp=issp+1
       do lstruct2=istruct1(lstruct1-1)+1,istruct1(lstruct1)
c      ------------------------------------------------------------
c      layer lay1,2 ... mlay of scatterer
c      ---------------------------------------------------------------
c        write(6,'(a,12i6)')'lstruct2 issp,ksp_m(issp)=',
c     &  lstruct2,issp,ksp_m(issp)

        lay=lstruct2
        call mapsub(issp)
c       common/acfr2trf/ repeat_group
c       common/avfr2trf/ thicklay,B_eff,theta_B,phi_B,
c                      ar_scatldens,ai_scatldens,roughness


        thicklayer(lay)=thicklay

        scatl_lay=cmplx(ar_scatldens,ai_scatldens)*unit_sclN
 
        b_scatl_lay=b_vfr2.or.b_thicklay
        b_scatterer=b_scatl_lay
c       write(6,'(a,l5)') '1------b_scatterer=',b_scatterer
        b_Beff(lay)=abs(B_eff*unit_sclB).gt.1.0e-6
        i=rep_grp
        laystr(2*lay-1)=i
        laystr(2*lay)=10*(rep_grp-float(i)+.01)
        roughlayer(lay)=roughness
        
C       hs=h*sin(theta_B*rad)
C************************************************************************
C
C transformation of B_eff from the sample system to the neutron system
C
C***********************************************************************

         h=B_eff*unit_sclB
         sin_theta_B=sin(theta_B*rad)
         cos_theta_B=cos(theta_B*rad)
         sin_phi_B  =sin(phi_B*rad)
         cos_phi_B  =cos(phi_B*rad)
C
        if(theta_He*rad.lt.1.e-8)then
         B_a=sin_theta_B*cos_phi_B
         B_b=sin_theta_B*sin_phi_B
         B_c=cos_theta_B
C        write(*,'(a)')'Mintarendszer ...'
C        write(*,*)B_a,B_b,B_c,B_a**2+B_b**2+B_c**2
        else
C        write(*,'(a)')'Trafo ...'
         sin_theta_H =sin(theta_He*rad)
         cos_theta_H =cos(theta_He*rad)
         sin_phi_H   =sin(phi_He*rad)
         cos_phi_H   =cos(phi_He*rad)

         sin_B_H =sin((phi_B-phi_He)*rad)
         cos_B_H =cos((phi_B-phi_He)*rad)
c        write(6,'(3f15.3)')phi_B,phi_He,cos_B_H

         B_a =-sin_theta_B*sin_theta_H*sin_B_H
         B_b = sin_theta_H*(sin_theta_B*cos_theta_H*cos_B_H+
     &         cos_theta_B*sin_theta_H)
         B_c = sin_theta_B*sin_theta_H*cos_B_H+
     &         cos_theta_B*cos_theta_H
c           write(*,'(3f15.3)')B_a,B_b,B_c
        endif        
         K_mag_lay(1,1,lay)=cmplx( h*B_c,0.0)-scatl_lay
         K_mag_lay(2,2,lay)=cmplx(-h*B_c,0.0)-scatl_lay
         K_mag_lay(1,2,lay)=cmplx(h*B_a,-h*B_b)
         K_mag_lay(2,1,lay)=conjg(K_mag_lay(1,2,lay))
c        write(6,'(3e15.5)')h*cos(theta_B*rad),real(scatl_lay),
c     &     real(K_mag_lay(1,1,lay))


C*****************************************************************

        issp=issp+1
       end do

       laystr(2*lay+2)=-1
       laystr(2*lay+1)=0
      
c      write(6,'(a,20i3)') 'laystr(1..lay)=',(laystr(i),i=1,2*lay)
       b_total=b_total.or.b_scatterer
       if(.not.b_total) return

c      write(6,'(a,l5)') ' ---------------b_scatterer,b_total=', b_total
c-----------------------------------------------------------------------
c     here the matrix R for the layers are given :
c     satrlay(n,lay)*1 +  (sapplay(n,lay)  sapmlay(n,lay))
c                         (samplay(n,lay) -sapplay(n,lay))
c
c     calculation of the transmittivity matrix T for all channels n
c     by   T = exp(iR)*rho*exp(-iR+)
      
      
c      if(.not.b_total) goto 1000

c----------------------------------------------------------------
C      ****************************************************************
C      We reconstarct the layer strucrure from the laystr variabale. 
c      GEOSTR(GRP) is the number of layers in group GRP.
c     Khaidukov Yu. 26.04.2003 & L. Deak, 09.10.2002                *** 
       GRP         =0
       GEOSTR(GRP) =0
       MAXGRP      =0
C       
	 b_first     =.true.
       POINTER=1
       do Kh=2,2*lay,2
        if(b_first)then
         if(GRP.eq.laystr(Kh))then
          GEOSTR(2*GRP)   =GEOSTR(2*GRP)+1
         else
          POINTER         =POINTER+GEOSTR(2*GRP)
          GRP             =GRP+1
          MAXGRP          =GRP
          GEOSTR(2*GRP)   =1
          GEOSTR(2*GRP-1) =laystr(Kh-1)
         end if
C
C    
          if(thicklayer(Kh/2).lt.0.) then
           b_first         =.false.
          thicklayer(Kh/2)      =1.e30
          GEOSTR(2*GRP-1) =1
         end if ! VKD < 0
        end if  ! b_first
       end do
C      ******************************************************************


c      if(b_scatterer) then
       do nchq=1,nch_q
        q_scat=q_beg+rd_q*(nchq-1)
c       write(6,'(a,i3,a,f10.5)') 'neutronrock nchq=',nchq,q_scat

     
     
        call n_optics(maxfr2,lay,b_Beff,MAXGRP,GEOSTR,q_scat,Hext_z,
     &              K_mag_lay,thicklayer,roughlayer,b_up,b_down,Rmatrix)

C        call n_optics(maxfr2,lay,b_Beff,laystr,q_scat,Hext_z,
C     &              K_mag_lay,thicklayer,roughlayer,b_up,b_down,Rmatrix)

        nn=nstorRM+(nchq-1)*4
        array_fr(nn+1)=Rmatrix(1,1)
        array_fr(nn+3)=Rmatrix(1,2)
        array_fr(nn+2)=Rmatrix(2,1)
        array_fr(nn+4)=Rmatrix(2,2)
c       write(6,'(8g15.5)') Rmatrix(1,1),Rmatrix(2,2)
       end do  ! loop over q_values   
c      end if
c      write(6,'(a)')' neutronrock do nchq=1,nch_q'

      do nchq=1,nch_q
       nn=nstorRM+4*(nchq-1)
       do i=1,4
        dd(i)=array_fr(nn+i)
       end do
c       write(6,'(8g15.5)') (dd(i),i=1,4)
c      trace (dd+*dd*rho) is the intensity
c      bb=cc+
       bb(1)=conjg(dd(1))
       bb(4)=conjg(dd(4))
       bb(2)=conjg(dd(3))
       bb(3)=conjg(dd(2))
       call matprof(dd,rho_b,aa)
       call matprof(aa,bb,dd)
       if(b_analyser) then
        call matprof(dd,rho_a,bb)
        h1=real(bb(1)+bb(4))
       else
        h1=real(dd(1)+dd(4))
       end if
       chrock(nchq)=h1
      end do  ! loop over q_values
c      write(6,'(8g14.5)') (chrock(i),i=1,nch_q,4)
c--------------------------------------------------------
      d_theta1=dtheta1/1000.0
      d_theta2=dtheta2/1000.0
      call integration(q_beg,q_end,nch_q,chrock,chrock2,iaver_points,
     &                                d_theta1,d_theta2,dlambda)

c      write(6,'(8g14.5)') (chrock(i),i=1,nch_q,4)
c      sum=0.
c      do nchq=1,nch_q
c       sum=sum+chrock(nchq)
c      end do

      nyout=nch_q/2
      do i=1,nyout
c       array_fr(nstorTH+i)=cmplx(chrock(i),chrock(nyout+i))/sum
       array_fr(nstorTH+i)=cmplx(chrock(i),chrock(nyout+i))
      end do
c      write(6,'(8f10.5)' ) (chrock(i)*100./sum,i=1,nch_q)
c     write(6,'(a)')' end of neutronrocking'
      
c     end of calculation of absorber function
 1000 continue
      return
      end
C************************************************************************************************
      
      subroutine integration(q_beg,q_end,nch_q,chrock,chrock2,
     &                         aver_points,dtheta1,dtheta2,dlambda)
      implicit none
!Input
      integer nch_q
      real q_beg,q_end,dtheta1,dtheta2,dlambda,chrock
      dimension chrock(nch_q)

!other variables
      integer j,aver_points,pnts_forw,pnts_back,i
      real dQ,chrock2,div_factor,Qj,Qi,tmp_var,resfunc
	dimension chrock2(nch_q)
! Body of the subroutine

      dQ=6.28*sqrt(dtheta1*dtheta1+dtheta2*dtheta2+dlambda*dlambda)
      IF (nch_q.GT.1.and.dQ.GT.0) then  
	pnts_forw=(aver_points-1)*0.5 !Points for averaging forward and 
 	pnts_back=aver_points-pnts_forw-1  !backward  
 
      do j=1,nch_q !loop over channels

      Qj=q_beg+((q_end-q_beg)*(j-1)/(nch_q-1))
  	chrock2(j)=0
       div_factor=0.0

			DO i=j-pnts_back,j+pnts_forw
      	      IF (i.GT.0.and.j+pnts_forw.LE.nch_q) THEN
                  Qi=q_beg+((q_end-q_beg)*(i-1)/(nch_q-1))
	            tmp_var=-((Qi-Qj)**2)/(2.0*dQ*dQ)
	            resfunc=exp(tmp_var)/(2.50663*dQ) !/sqrt(2*pi)*dQ
	    		chrock2(j)=chrock2(j)+chrock(i)*resfunc
			   
			    div_factor=div_factor+resfunc
      		    END IF 
              END DO
	   IF (div_factor.EQ.0 ) THEN 
	     chrock2(j)=chrock(j)
	   ELSE
	     chrock2(j)=chrock2(j)/div_factor
	   END IF
      end do ! Loop over all channels
 
            DO j=1,nch_q !loop over channels
            chrock(j)=chrock2(j)
            END DO

      END IF !Number of chanels more than one
      return
      end
      
      
      










