      subroutine th_relaxglobalsad(isubthe,icase,iput,iget,info)
      implicit none
      include 'comglb.for'
      include 'comthe.for'

c     sad= source,absorber,detector : lstr1case=1,2,3  (comthe.for) 
      
      integer isubthe,icase,iput,iget,info,istr,dstr,idex,
     &        idum,nLG,nAS,nSC,nsampling,ak8,sk8,nRL
      real    srw8
      parameter (istr=38+4*(maxfr1+maxfr2)+3*maxthss+16)
      common/struct/dstr(istr),idum(2),                      !13.9.05 
     &              nLG,nAS,nSC,nsampling,ak8,sk8,srw8,nRL,idex(7)    

      integer     mAS,idumscrd
      parameter  (mAS=2*maxn,idumscrd=maxscrd-4*(mAS+1))
      real        sTr,yyr,dumscrd
      common/scrd/sTr(-mAS:mAS+1),yyr(-mAS:mAS+1),dumscrd(idumscrd)
      
      real      ym0,ym1,yp1,yp2,as,bs,cs,hr,hi
      integer   i,i1,j,n,ni,sk2
      logical   b_pc

      real          avm,dumvm
      common/avmaps/avm(10),dumvm(ivstrf-10)
      real          c1,dumc
      common/acmaps/c1,dumc(ivstrf-1)
 
      if(isubthe.lt.0) then
       theoryname='1x1_ref_index_dynamic_sad'
c      if(ak2.gt.sk2) then
c       nAS=sk2+ak2+ib2
c       nSC=sk2+ib2
c      else
c       nSC=sk2+ak2+ib2
c       nAS=ak2+ib2
c      end if
       if(-isubthe.eq.1) then
        c1=2*(nSC+1)+1
        if(nSC-nAS.gt.0) c1=c1+(nSC-nAS)/2  ! source norm array
       end if
       if(-isubthe.eq.2) c1=2*(nAS+1)
       if(-isubthe.eq.3) c1=2*(nSC+1)
       return
      end if

c     storage use nst2_8 for 4 complex numbers of r_ik
       idex(1)=icase      
       goto(100,200,100),lstr1case
c-------------------------------------------------------------
      
 100   continue
c      source,detector

c      srw=4.0*srw8
c      half srw for convolution
c      calculation with 4*srw and interpolation for the slow subroutines
c      nRL half number of channels

       if(icase.eq.1) then
        nRL=nSC/4
       else
        nRL=nSC
       end if 
       call get_theory(isubthe,info)

       b_pc=isubthe.gt.0
       if(.not.b_pc) then
        isubthe=-abs(isubthe)
        return
       end if

      
       i1=iget+1
       if(icase.eq.1)then 
        do n=0,nRL+1
         yyr(n)=real(array_fr(i1+n))
         yyr(-n)=aimag(array_fr(i1+n))
        end do
        do n=-nRL,nRL-1
c        h=f(yyr(n/4-1),yyr(n/4),yyr(n/4+1))
         ym0=yyr(n) 
         yp2=yyr(n+2)-ym0
         yp1=yyr(n+1)-ym0
         ym1=yyr(n-1)-ym0
         
         as=(yp2-3.0*yp1-ym1)/24.0
         bs=(ym1+yp1)/8.0
         cs=-(yp2-6.0*yp1+2.0*ym1)/24.0

         sTr(4*n)=ym0
         sTr(4*n+1)=ym0+     as+    bs+    cs
         sTr(4*n+2)=ym0+ 8.0*as+4.0*bs+2.0*cs
         sTr(4*n+3)=ym0+27.0*as+9.0*bs+3.0*cs
        end do       ! n loop
        sTr(4*nRL)=yyr(nRL)
       else
        do n=0,nRL
         sTr(n)=real(array_fr(i1+n))
         sTr(-n)=aimag(array_fr(i1+n))
        end do
       end if
       do n=0,nSC
        ni=iput+2*n
        array_fr(ni+1)=cmplx(0.0,sTr(n))
        array_fr(ni+2)=cmplx(0.0,sTr(-n))
       end do       ! n loop
c       write(6,'(8f10.3)') (sTr(n),n=0,64)
      
c       The sum of the Lorentz-Gauss curves of the jge lines
c       have to be normalized to 1 for each subspectrum of the source
c       iscpi=iscpr+2*nSC+1
      
      
        ni=iput+2*(nSC+1)+1
        if(nAS.lt.nSC) then
         sk2=nSC-nAS
         do i=0,sk2,2
          hr=0.
          hi=0.
          do j=-nAS+1,nAS-1,2
           hr=hr+ sTr(i+j)*2
          end do
          do j=-nAS+2,nAS-2,2
           hr=hr+ sTr(i+j)
          end do
          hr=hr*2.+sTr(-nAS+i)+sTr(nAS+i)
      
          do j=-nAS+1,nAS-1,2
           hi=hi+ sTr(-i+j)*2
          end do
          do j=-nAS+2,nAS-2,2
           hi=hi+ sTr(-i+j)
          end do
          hi=hi*2.+sTr(-nAS-i)+sTr(nAS-i)
          array_fr(ni+i/2)=cmplx(hr,hi)/3.
         end do
c       write(6,'(a,4i5)')'theomoss nAS,NSC,sk2=',nAS,NSC,sk2
c       write(6,'(8f10.3)') (array_fr(iscn+i),i=0,sk2,16)
        else
         hr=0.
         do n=-nSC+1,nSC-1,2
          hr=hr+ sTr(n)*2
         end do
         do n=-nSC+2,nSC-2,2
          hr=hr+sTr(n)
         end do
         hr=hr*2.+ sTr(-nSC)+sTr(nSC)
         array_fr(ni)=cmplx(hr/3.,0.0)
c        write(6,'(a,i6,a,2f15.8)') '----th=',ni,' hr/3.=',hr/3.
c        write(6,'(a,i6,2f15.8)') 'isource_sp snorm:i=',
c    &      isource_sp,array_fr(isource_sp+1)
        end if
        goto 400
c----------------------------------------------------------
 200    continue
c       absorber
c       srw=4.0*srw8
c       half srw for convolution
c       calculation with 4*srw and interpolation for the slow subroutines
c       nRL half number of channels
c       write(6,'(a,2i4)') 'th_mossrelax avmap 1 '
c       write(6,'(10f10.2)')avm

        if(icase.eq.1) then
         nRL=nAS/4
        else
         nRL=nAS
        end if 
        call get_theory(isubthe,info)
c       write(6,'(a,2i4)') 'th_mossrelax avmap 2 '
c       write(6,'(10f10.2)')avm

       b_pc=isubthe.gt.0
       if(.not.b_pc) then
        isubthe=-abs(isubthe)
        return
       end if

      
       i1=iget+1
       if(icase.eq.1) then
        do n=0,nRL+1
         yyr(n)=real(array_fr(i1+n))
         yyr(-n)=aimag(array_fr(i1+n))
        end do
c        write(6,'(a)') 'yyr='
c        write(6,'(8f10.3)')(yyr(i),i=-nRL,nRL)
        do n=-nRL,nRL-1
c        h=f(yyr(n/4-1),yyr(n/4),yyr(n/4+1))
         ym0=yyr(n) 
         yp2=yyr(n+2)-ym0
         yp1=yyr(n+1)-ym0
         ym1=yyr(n-1)-ym0
         
         as=(yp2-3.0*yp1-ym1)/24.0
         bs=(ym1+yp1)/8.0
         cs=-(yp2-6.0*yp1+2.0*ym1)/24.0

         sTr(4*n)=ym0
         sTr(4*n+1)=ym0+     as+    bs+    cs
         sTr(4*n+2)=ym0+ 8.0*as+4.0*bs+2.0*cs
         sTr(4*n+3)=ym0+27.0*as+9.0*bs+3.0*cs
c        write(6,'(i4,4f12.4)')4*n,ym0,sTr(4*n+1),sTr(4*n+2),sTr(4*n+3)
        end do       ! n loop
        sTr(4*nRL)=yyr(nRL)
       else
        do n=0,nRL
         sTr(n)=real(array_fr(i1+n))
         sTr(-n)=aimag(array_fr(i1+n))
        end do
       end if
       do n=0,nAS
        ni=iput+2*n
        array_fr(ni+1)=cmplx(0.0,sTr(n))
        array_fr(ni+2)=cmplx(0.0,sTr(-n))
       end do       ! n loop
      

c       write(6,'(a,2i6)') ' theory3 - absorber,iput=',iput,nAS
      
 400   continue
c        write(6,'(8f10.3)') (sTr(n)*1000.0,n=0,64)

        return
        end
      subroutine th_relaxspinhalfsad(isubthe,icase,iput,iget,info)
      implicit none
      include 'comglb.for'
      include 'comthe.for'

c     sad= source,absorber,detector 
      
      integer isubthe,icase,iput,iget,info,istr,dstr,idex,
     &        idum,nLG,nAS,nSC,nsampling,ak8,sk8,nRL
      real    srw8
      parameter (istr=38+4*(maxfr1+maxfr2)+3*maxthss+16)           
      common/struct/dstr(istr),idum(2),                            !13.9.05 
     &              nLG,nAS,nSC,nsampling,ak8,sk8,srw8,nRL,idex(7)      

      logical         b_vfr1trf
      common/bvfr1trf/b_vfr1trf(ivfr1trf)
      
      real          avm,a_Lwidth,a_iso,a_h0,a_dq,a_eta,a_gml,a_p,dumvssp
c     &             ax,ay,az,gx,gy,gz
c     &             dl,eod,cube,fort,AL,BE,GA
      common/avmaps/avm,a_Lwidth,a_iso,a_h0,a_dq,a_eta,a_gml,a_p(7),
     &              dumvssp(ivstrf-14)
      logical       b_vm,b_Lwidth,b_matrix,
     &              b_iso,b_h0,b_dq,b_eta,b_gml,b_p,b_dumvssp
      common/bvmaps/b_vm,b_Lwidth,b_iso,b_h0,b_dq,b_eta,b_gml,b_p(7),
     &              b_dumvssp(ivstrf-14)
      
      real          c1,gamnat,e_xsi,aiset,aisym,temperature,dumc
      common/acmaps/c1,gamnat,e_xsi,aiset,aisym,temperature,
     &              dumc(icstrf-6)
      logical       b_c1,b_dumc,b_pc
      common/bcmaps/b_c1,b_dumc(icstrf-1)      
c     if one of the  constants changed the value all logical are .true.
c     nuclear parameters are not used. Problem is solved only for iron57.

c--------------------------------------------------------------------
      real*8 dq,eta,gml,ax,ay,az,a_hyp,orf,
     *       dl,eod,cube,fort,AL,BE,GA,te,dl21,dl31,dl32,rom,
     &       gx3(3),gy3(3),gz3(3),ax3(3),ay3(3),az3(3),
     &       eq3(3),qx3(3),qy3(3),qz3(3),eta3(3),
     *       crys(3,3),ct(3,3),cti(3,3),cl(3,3),cli(3,3),
     &       cr(3),cri(3),aw(3),bw(3),cw(3)
      real*8 dtheta,dphi,zero,one,two,three,pt5,
     &       pi,pi2,gwidth,w,exp21,exp31,
     &       vxx,vxy,vxz,vyz,vyy,vzz,qxx,qyy,qzz

c--------------------------------------------------------------------
      integer    mAS,isym,iset,nm,nm2,idumscrd,iepk
      parameter (nm=48,nm2=96,mAS=2*maxn,
     &            idumscrd=maxscrd-2*(mAS+1)-2*3072-13*256
     &                     -nm*nm*2*6-256-5*nm*2-2*nm2*nm2-7*nm2)
      real sTr,theta,phi,weight,pwr,pwi,wrs,wis,h,h1,h2,dumscrd
      real*8 hf,r,t,u,tl,ul,epk1,epk2,epk3,epk4,epk55,
     &       h11,h22,h33,wr,wi
      complex*16 d,dsum,vl1,vl2,vl3,vl4,vl5,vl6,
     &                  vr1,vr2,vr3,vr4,vr5,vr6,pw,hc,z
      common/scrd/sTr(-mAS:mAS+1),theta(3072),phi(3072),
     &           d(8,8),dsum(8,8),wr(nm),wi(nm),
     &           pwr(nm),pwi(nm),wrs(nm),wis(nm),pw(nm),
     &           vl1(8,8),vl2(8,8),vl3(8,8),vl4(8,8),
     &           vl5(8,8),vl6(8,8),vr1(8,8),vr2(8,8),
     &           vr3(8,8),vr4(8,8),vr5(8,8),vr6(8,8),
     &           hf(nm,nm),r(nm,nm),t(nm,nm),u(nm,nm),
     &           tl(nm,nm),ul(nm,nm),epk1(nm),epk2(nm),
     &           epk3(nm),epk4(nm2),epk55(nm2,nm2),iepk(nm2),
     &           dumscrd(idumscrd)

      integer    nop,npoints,ipoint,i,i1,j,j1,k,l,n
      parameter( zero=0.d0, one=1.d0, two=2.d0,three=3.d0,pt5=0.5d0)
      real dw

      if(isubthe.lt.0) then
       theoryname='spin_half_refindex_dynamic'
c      if(ak2.gt.sk2) then
c       nAS=sk2+ak2+ib2
c       nSC=sk2+ib2
c      else
c       nSC=sk2+ak2+ib2
c       nAS=ak2+ib2
c      end if
c       D2 symmetry 6, D3 symmetry 4 out of 48 
       iset=3
       npoints=6*2**(iset+1) 
       if(icase.eq.1) then
        n=1+npoints+16*2*npoints       ! storage for relaxation matrices
       else
        n=1+npoints+48*2*npoints       ! storage for relaxation matrices
       end if                               ! and theta,phi
       if(-isubthe.eq.1) then
        c1=2*(nSC+1)+3+n
        if(nSC-nAS.gt.0) c1=c1+(nSC-nAS)/2  ! source norm array
       end if
       if(-isubthe.eq.2) c1=2*(nAS+1)+2+n
       if(-isubthe.eq.3) c1=2*(nSC+1)+2+n
       return
      end if

c      write(6,'(a,6f12.3)')' acmaps=',c1,aiset,aisym,temperature,gamnat
      
       b_pc=b_vm
       if(.not.b_pc) then
        isubthe=-abs(isubthe)
        return
       end if

c       write(6,'(a,2i5)') 'th_mossrelax avmaps:: nRL=',nRL
c       write(6,'(10f10.2)')avm,a_Lwidth,a_iso,a_h0,a_dq,a_eta,a_gml,a_p

      isym=aisym
      iset=aiset
      nop=nRL+1
      if(idex(1).eq.2) then
       dw=4.0*srw8
      else
       dw=16.0*srw8
      end if
c      write(6,'(a,i4,2f12.3)')'th-mossrelax nop,dw=',nop,dw
c     write(6,'(a,4i4)')'th-mossrelax  isym,iset=',isym,iset

      b_matrix=b_h0.or.b_dq.or.b_eta.or.b_gml
      do k=1,7
       b_matrix=b_matrix.or.b_p(k)
      end do


c      subroutine sphere(iset,isym,iOM,tetah,phih)
c      parameter (niset=128*24)
c      dimension wh4(8),wh8(16),wh16(32),wh32(64),wh64(128),wh128(256),
c     &          eh(3,128),tetah(niset),phih(niset),hmat(3,3)

c     symmetry of the hamiltonian (subgroup of O)
c      data  nd4/1,5,8/                          ! D4 (C4 || z-axis)
c      data  nd2/1,2,5,8,17,18/                  ! D2
c      data  nc2/1,2,3,4,5,7,8,13,17,18,19,22/   ! C2 (z-axis)
c      data  nd3/1,2,3,4/                        ! D3 (C3 || {111}=z-axis)  
c      data nc2y/1,2,3,4,5,7,8,10,13,14,15,16/   ! c2 (y-axis)
      
c     Directions  whi(teta,phi)  for the integration
c     over the sphere.
c     Optimized values are calculated by K. Knese and H. Spiering

c     definition of isym (spezified by the calling routine):
c     C4 || z-axis                     C3 || z-axis
c     cubic    isym=11                 cubic     isym=21
c     D4       isym=12                 D3             22
c     D2            13                 C2             23
c     C2            14                 C1             24
c     C1            15                

c     iOM  (i-Omega) number of points, equal weights  dOM=1./iOM

c     np: number of points on 1/48 sphere,  np=2**(iset+1)
c       iset=3
c       npoints=6*2**(iset+1) 
c       n=1+npoints+16*2*npoints       ! storage for relaxation matrices

      i1=iput+1+nop+1
      if(b_c1) then
       if (isym.gt.0) then
        call sphere(iset,isym,npoints,theta,phi) 
c       write(6,'(8f10.4)')(theta(i),phi(i),i=1,npoints)
        if(npoints.gt.96) then
c        i=npoints/2**(iset+1)
         i=96*2**(iset+1)/npoints/2
         iset=-1
         do while(i.gt.0)
          i=i/2
          iset=iset+1
         end do
         call sphere(iset,isym,npoints,theta,phi) 
         write(nwr,'(a,i2)') '**warning** iset is reduced to ',iset
        end if
       else
        npoints=1
        theta(1)=0.0
        phi(1)=0.0
       end if
       weight=dw/6.28318/npoints
c       write(6,'(a,2i6,g12.5)') 'theomoss3 i1,npoints,weight=',
c     &                i1,npoints,weight
       array_fr(i1) =cmplx(float(npoints),weight)
       do ipoint=1,npoints
        array_fr(i1+ipoint) =cmplx(theta(ipoint),phi(ipoint))
       end do
      else
       npoints=real(array_fr(i1))
       weight=aimag(array_fr(i1))
c       write(6,'(a,2i6)') 'theomoss3 i1,npoints=',i1,npoints
c       write(6,'(8f10.4)')(array_fr(i1+i),i=1,npoints)
       do ipoint=1,npoints
        theta(ipoint)=real(array_fr(i1+ipoint))
        phi(ipoint)=aimag(array_fr(i1+ipoint))
       end do
      end if 

       a_hyp= dble(a_h0)        ! hyperfine splitting, mm/s
       dq= dble(a_dq)           ! quadrupole splitting, mm/s
       eta=dble(a_eta)          ! quadrupole assymetry
       gml=dble(a_gml)          ! relaxation rate, mm/s (*11.625 MHz)
       gwidth=pt5*dble(gamnat*(1.0+a_Lwidth))    ! linewidth, mm/s

       pi    = 3.14159265358979324
       pi2=  pt5*pi     

c       write(6,'(a,5g10.3)')'a_hyp,dq,eta,gml,gwidth=',
c     &                       a_hyp,dq,eta,gml,gwidth
       do i=-nop,nop
        sTr(i)=0.0
       end do


      if(b_matrix) then
       goto (100,100,200),icase

 100   continue        ! S=1/2 Kramers doublet
       if(icase.eq.1) then
       do i=1,3
        gx3(i)=zero
        gy3(i)=zero
        gz3(i)=zero
        aw(i)=zero
        bw(i)=zero
        cw(i)=zero
       end do
        ax= dble(a_p(1))         ! A-tensor
        ay= dble(a_p(2)) 
        az= dble(a_p(3)) 
        gx3(1)=dble(a_p(4))      ! g-tensor
        gy3(1)=dble(a_p(5)) 
        gz3(1)=dble(a_p(6))

c       write(6,'(a,6g12.5)')'ax,ay,az,gx,gy,gz=',
c     &                       ax,ay,az,gx3(1),gy3(1),gz3(1)
c       CALCULATION OF THE QUADRUPOLE TENSOR
        qzz=dq*pt5/dsqrt(one+eta**2/three)
        qxx=pt5*qzz*(eta-one)                                      
        qyy=-qxx-qzz                                               

       else
c       CALCULATE CRYSTAL FIELD HAMILTONIAN, GRIFFITH
        dl=dble(a_p(1))
        rom=dble(a_p(2)) 
        call split(dl,rom,crys)
        n=3
        call diag(crys,ct,cti,cl,cli,
     &          n,hf,r,wr,wi,t,u,tl,ul,
     &          epk1,epk2,epk3,epk4,epk55,iepk)

c        write(6,'(/,a)')'t'
c        write(6,'(16g8.2)')((t(i,k),k=1,n),i=1,n)      
c        write(6,'(/,a)')'u'
c        write(6,'(16g8.2)')((u(i,k),k=1,n),i=1,n)      

        do i=1,3
         cr(i)=wr(i)
         cri(i)=wi(i)
        end do
        call  sort(cr,cri,ct,cti,dl21,dl31,dl32)
 
        orf=1.d0
        call tensor(ct,orf,gx3,gy3,gz3,ax3,ay3,az3,qx3,qy3,qz3,eta3)
        do i=1,3
         eq3(i)=dq*pt5/sqrt(qz3(i)**2+(qx3(i)-qy3(i))**2/three)
         qx3(i)=qx3(i)*eq3(i)
         qy3(i)=qy3(i)*eq3(i)
         qz3(i)=qz3(i)*eq3(i)
        enddo
        ax=ax3(1)
        ay=ay3(1)
        az=az3(1)
        qzz=qz3(1)
        qxx=qx3(1)
        qyy=-qxx-qzz                                               
       end if
c       write(6,'(a,6g12.5)')'ax,ay,az,gx,gy,gz=',
c     &                       ax,ay,az,gx3(1),gy3(1),gz3(1)

c      THIS SUBROUTINE CALCULATES Q-TENSOR IN  THE CASE OF PAS ROTATION
c      VS. MOLECULAR SYSTEM. THE ROTATION ANGLES ALFA, BETA,GAMMA SHOULD 
c      BE GIVEN THEN IN THE INPUT FILE
      
c      alfa=zero    !Euler angles 
c      beta=zero
c      gamma=zero

       call tens(qxx,qyy,qzz,zero,zero,zero,
     *                    vxx,vyy,vzz,vxy,vxz,vyz)  

c       write(6,*) 'vii',vxx,vyy,vzz,vxy,vxz,vyz

c      POWDER AVERAGING 

       i1=iput+1+nop+1+npoints
       do ipoint=1,npoints                               
c        write(6,'(a,2f10.4)')'theta,phi=',theta(ipoint),phi(ipoint)
        j1=i1+(ipoint-1)*32


c       CALCULATION OF THE INTENSITY MATRIX OF NUCLEAR TRANSITIONS   

c       EXTERNAL MAGNETIC FIELD IS PERPENDICULAR TO THE GAMMA-BEAM
c       two direction for the average in the plane 

        dtheta=dble(theta(ipoint))+pi2
        dphi=dble(phi(ipoint))
        call dddd(dtheta,dphi,d)
        do i=1,8
         do k=1,8
          dsum(i,k)=d(i,k)
         end do
        end do

        dtheta=pi2
        dphi=dble(phi(ipoint))+pi2
        call dddd(dtheta,dphi,d)
        do i=1,8
         do k=1,8
          dsum(i,k)=dsum(i,k)+d(i,k)
         end do
        end do
        dtheta=dble(theta(ipoint))
        dphi=dble(phi(ipoint))

        n=16
c ------------------------------------------------------
        call relax(dtheta,dphi,gx3,gy3,gz3,ax,ay,az,a_hyp,
     &             aw,bw,cw,vxx,vyy,vzz,vxy,vxz,vyz,gml,
     &             n,hf,r,wr,wi,t,u,tl,ul,
     &             epk1,epk2,epk3,epk4,epk55,iepk,
     &             vl1,vl2,vl3,vl4,vl5,vl6,
     &             vr1,vr2,vr3,vr4,vr5,vr6)
c -----------------------------        

c        write(6,'(a)')'((vl1(i,k)),k=1,8),i=1,8)' 
c        write(6,'(8g10.2)')((dreal(vl1(i,k)),k=1,8),i=1,8) 
c        write(6,'(8g10.2)')((dimag(vl1(i,k)),k=1,8),i=1,8) 
     
c        write(6,'(a)')'((vr2(i,k)),k=1,8),i=1,8)' 
c        write(6,'(8g10.2)')((dreal(vl2(i,k)),k=1,8),i=1,8) 
c        write(6,'(8g10.2)')((dimag(vl2(i,k)),k=1,8),i=1,8) 

        do i=1,8
         z=zero
         do k=1,8
          hc=zero
          do l=1,8
           hc=hc+dsum(k,l)*vr1(l,i)
          end do
          z=z+hc*vl1(i,k)
         end do
         pw(i)=z*0.75d0
        end do

        do i=1,8
         z=zero
         do k=1,8
          hc=zero
          do l=1,8
           hc=hc+dsum(k,l)*vr2(l,i)
          end do
          z=z+hc*vl2(i,k)
         end do
         pw(i+8)=z*0.75d0
        end do
        
c        z=(0.,0.)
c        do k=1,16
c         z=z+pw(k)
c        end do

c        write(6,'(a,2g12.5)') ' wr,wi='
c        write(6,'(8g10.2)')(wr(k),k=1,n) 
c        write(6,'(8g10.2)')(wi(k),k=1,n) 
c        write(6,'(a,2g10.3)')' pw=',z
c        write(6,'(8g10.2)')(dreal(pw(i)),i=1,n)
c        write(6,'(8g10.2)')(dimag(pw(i)),i=1,n)

c        CALCULATION OF THE SPECTRUM ITSELF
        do j=1,n
         wrs(j)=sngl(wr(j))
         wis(j)=sngl(wi(j))
         pwr(j)=sngl(dreal(pw(j)))
         pwi(j)=sngl(dimag(pw(j)))
        end do

        do i=1,n
         array_fr(j1+i)=cmplx(wrs(i),wis(i))
        end do
        j=j1+n
        do i=1,n
         array_fr(j+i)=cmplx(pwr(i),pwi(i))
        end do

        do i=-nop,nop
         w=dw*float(i)-a_iso
         h=0.0
         do j=1,n
          h1=w-wrs(j)
          h2=gwidth-wis(j)
          h=h+(pwr(j)*h2-pwi(j)*h1)/(h1**2+h2**2)
         end do
         sTr(i)=sTr(i)+h*weight
        end do

       end do   ! ipoint
       goto 300

 200   continue        ! S=5/2 3 Kramers doublets

       dl  = dble(a_p(1))        !D
       eod = dble(a_p(2))        !E/D
       cube= dble(a_p(3))         !a
       fort= dble(a_p(4))         !F
       AL  = dble(a_p(5))       !
       BE  = dble(a_p(6))       ! EULER ANGLES
       GA  = dble(a_p(7))       !
       rom   = eod*dl

C      CALCULATION OF THE ZERO-FIELD HAMILTONIAN
       call splith(dl,rom,cube,fort,crys)

       n=3
       call diag(crys,ct,cti,cl,cli,
     &          n,hf,r,wr,wi,t,u,tl,ul,
     &          epk1,epk2,epk3,epk4,epk55,iepk)
      
       do i=1,3
        cr(i)=wr(i)
        cri(i)=wi(i)
       end do
 
C      ORDERING OF THE ZERO-FIELD DOUBLETS IN ASCENDING ORDER 
C      AND CALCULATION OF THE ENERGY INTERVALS BETWEEN THE DOUBLETS 

       call  sort(cr,cri,ct,cti,dl21,dl31,dl32)	
c      write(6,*)'E(1),E(2),E(3)'
c      write(6,*) cri(1),cri(2),cri(3) 
c      write(6,*)'dl21,dl31,dl32'
c      write(6,*)dl21,dl31,dl32 

       do i=1,3
        gx3(i)=zero
        gy3(i)=zero
        gz3(i)=zero
        aw(i)=zero
        bw(i)=zero
        cw(i)=zero
       end do

C      CALCULATION OF THE G-TENSORS OF ALL KRAMERS DOUBLETS
       call tenshs(cti,gx3,gy3,gz3,aw,bw,cw)

c      write(6,*)'gx3,gy3,gz3'
c      do i=1,3
c      write(6,*) i,abs(gx3(i)),abs(gy3(i)),abs(gz3(i))
c      enddo

C      BOLTZMANN POPULATION    
       te=dble(0.695*temperature)
       exp21=exp(-dl21/te)
       exp31=exp(-dl31/te)
       h11=1.d0/(1.d0+exp21+exp31)
       h22=exp21*h11
       h33=exp31*h11

c      CALCULATION OF THE QUADRUPOLE TENSOR

       qzz=dq*pt5/dsqrt(one+eta**2/three)
       qxx=pt5*qzz*(eta-one)                                      
       qyy=-qxx-qzz                                               

c      THIS SUBROUTINE CALCULATES Q-TENSOR IN  THE CASE OF PAS ROTATION
c      VS. MOLECULAR SYSTEM. THE ROTATION ANGLES ALFA, BETA,GAMMA SHOULD 
c      BE GIVEN THEN IN THE INPUT FILE
      
       call tens(qxx,qyy,qzz,AL,BE,GA,
     *                    vxx,vyy,vzz,vxy,vxz,vyz)  
c      write(nout,*) 'vii',vxx,vyy,vzz,vxy,vxz,vyz


c      POWDER AVERAGING 

       i1=iput+1+nop+1+npoints
       do ipoint=1,npoints                               
c        write(6,'(a,2f10.4)')'theta,phi=',theta(ipoint),phi(ipoint)
        j1=i1+(ipoint-1)*96


c       CALCULATION OF THE INTENSITY MATRIX OF NUCLEAR TRANSITIONS   

c       EXTERNAL MAGNETIC FIELD IS PERPENDICULAR TO THE GAMMA-BEAM
c       two direction for the average in the plane 
        dtheta=dble(theta(ipoint))+pi2
        dphi=dble(phi(ipoint))
        call dddd(dtheta,dphi,d)
        do i=1,8
         do k=1,8
          dsum(i,k)=d(i,k)
         end do
        end do

        dtheta=pi2
        dphi=dble(phi(ipoint))+pi2
        call dddd(dtheta,dphi,d)
        do i=1,8
         do k=1,8
          dsum(i,k)=dsum(i,k)+d(i,k)
         end do
        end do

        dtheta=dble(theta(ipoint))
        dphi=dble(phi(ipoint))
        n=48
c ------------------------------------------------------
        call relax(dtheta,dphi,gx3,gy3,gz3,h11,h22,h33,a_hyp,
     &             aw,bw,cw,vxx,vyy,vzz,vxy,vxz,vyz,gml,
     &             n,hf,r,wr,wi,t,u,tl,ul,
     &             epk1,epk2,epk3,epk4,epk55,iepk,
     &             vl1,vl2,vl3,vl4,vl5,vl6,
     &             vr1,vr2,vr3,vr4,vr5,vr6)
c -----------------------------        

        do i=1,8
         z=zero
         do k=1,8
          hc=zero
          do l=1,8
           hc=hc+dsum(k,l)*vr1(l,i)
          end do
          z=z+hc*vl1(i,k)
         end do
         pw(i)=z*0.75d0
        end do

        do i=1,8
         z=zero
         do k=1,8
          hc=zero
          do l=1,8
           hc=hc+dsum(k,l)*vr2(l,i)
          end do
          z=z+hc*vl2(i,k)
         end do
         pw(i+8)=z*0.75d0
        end do

        do i=1,8
         z=zero
         do k=1,8
          hc=zero
          do l=1,8
           hc=hc+dsum(k,l)*vr3(l,i)
          end do
          z=z+hc*vl3(i,k)
         end do
         pw(i+16)=z*0.75d0
        end do

        do i=1,8
         z=zero
         do k=1,8
          hc=zero
          do l=1,8
           hc=hc+dsum(k,l)*vr4(l,i)
          end do
          z=z+hc*vl4(i,k)
         end do
         pw(i+24)=z*0.75d0
        end do

        do i=1,8
         z=zero
         do k=1,8
          hc=zero
          do l=1,8
           hc=hc+dsum(k,l)*vr5(l,i)
          end do
          z=z+hc*vl5(i,k)
         end do
         pw(i+32)=z*0.75d0
        end do

        do i=1,8
         z=zero
         do k=1,8
          hc=zero
          do l=1,8
           hc=hc+dsum(k,l)*vr6(l,i)
          end do
          z=z+hc*vl6(i,k)
         end do
         pw(i+40)=z*0.75d0
        end do

c        hc=(0.0,0.0)
c        do k=1,n
c         hc=hc+pw(k)
c        end do
c        write(6,'(a,2g12.5)') ' sum pw=',hc
c        write(6,'(8g10.2)')(real(pw(k)),k=1,48) 
c        write(6,'(8g10.2)')(dimag(pw(k)),k=1,48) 

c       CALCULATION OF THE SPECTRUM ITSELF
        do j=1,n
         wrs(j)=sngl(wr(j))
         wis(j)=sngl(wi(j))
         pwr(j)=sngl(dreal(pw(j)))
         pwi(j)=sngl(dimag(pw(j)))
        end do

        do i=1,n
         array_fr(j1+i)=cmplx(wrs(i),wis(i))
        end do
        j=j1+n
        do i=1,n
         array_fr(j+i)=cmplx(pwr(i),pwi(i))
        end do

        do i=-nop,nop
         w=dw*float(i)-a_iso
         h=0.0
         do j=1,n
          h1=w-wrs(j)
          h2=gwidth-wis(j)
          h=h+(pwr(j)*h2-pwi(j)*h1)/(h1**2+h2**2)
         end do
         sTr(i)=sTr(i)+h*weight
        end do

       end do  ! ipoint loop
 300   continue

      else   
c      take aa,bb,pwi,wrs,weight from array_fr

       do i=-nop,nop
        sTr(i)=0.0
       end do
       if(icase.eq.1) n=16
       if(icase.eq.2) n=48
        
       i1=iput+1+nop+1+npoints
       do ipoint=1,npoints
        j1=i1+(ipoint-1)*2*n
        do i=1,n
         wrs(i)=real(array_fr(j1+i))
         wis(i)=aimag(array_fr(j1+i))
        end do
        j=j1+n
        do i=1,n
         pwr(i)=real(array_fr(j+i))
         pwi(i)=aimag(array_fr(j+i))
        end do
        do i=-nop,nop
         w=dw*float(i)-a_iso
         h=0.0
         do j=1,n
          h1=w-wrs(j)
          h2=gwidth-wis(j)
          h=h+(pwr(j)*h2-pwi(j)*h1)/(h1**2+h2**2)
         end do
         sTr(i)=sTr(i)+h*weight
        end do

       end do   ! ipoint loop
      end if

c      h=0.0
c      do i=-nop,nop
c       h=h+sTr(i)
c      end do
c      write(6,'(i5,a,f12.4)') nop,'Sum sTr=',h
c      write(6,'(8f10.5)')(sTr(i),i=-nop,nop)

c-----------------------------------------------------------------
      i1=iput+1
      do n=0,nop
       array_fr(i1+n)=cmplx(sTr(n),sTr(-n))
      end do

      return     
      end





      subroutine  dddd(theta,phi,d)
      implicit real*8 (a-h,o-z)

      real*8 al(8,8),alt(8,8),theta
      complex*16 qj(3,3),dd(8,8),db(8,8),d(8,8),z1

      data zero /0.d0/,one /1.d0/,two /2.d0/,pt5 /0.5d0/

      st=dsin(theta)
      ct=dcos(theta)
      sq2=dsqrt(2.0d0)

      do 255 i=1,3
      do 255 j=1,3
 255  qj(i,j)=zero

      qj(1,1)=(one+ct**2)*pt5
      qj(3,3)=qj(1,1) 
      qj(2,3)=-st*ct/sq2*dcmplx(dcos(phi),dsin(phi))
      qj(1,2)=-qj(2,3)
      qj(2,2)=st**2
      qj(1,3)=st**2*pt5*dcmplx(dcos(two*phi),dsin(two*phi))

      do 25 i=2,3
      do 25 j=1,2
   25 qj(i,j)= dconjg(qj(j,i))

      do 13  i=1,8
      do 13 j=1,8
  13  dd(i,j)=zero	

      do 14 j1=1,4
      do 14 i1=1,2
      n1=j1-i1+1
      if(n1.eq.0.or.n1.eq.4) go to 14
      e1=j1-2.5
      k1=8-4*(i1-1)-(j1-1)
      do 15 j2=1,4
      do 15 i2=1,2
      n2=j2-i2+1
      if(n2.eq.0.or.n2.eq.4) go to 15
      e2=j2-2.5
      k2=8-4*(i2-1)-(j2-1)
      dd(k1,k2)=pp(e1,n1)*pp(e2,n2)*qj(n1,n2)
   15 continue
   14 continue

      do 16 i=1,8
      do 16 j=1,8
      al(i,j)=zero
      alt(i,j)=zero
   16 continue

      al(1,1)=one
      al(2,8)=one
      al(3,2)=one
      al(4,7)=one
      al(5,3)=one
      al(6,6)=one
      al(7,4)=one
      al(8,5)=one

      do 17 i=1,8
      do 17 j=1,8
      alt(i,j)=al(j,i)
   17 continue

      do 81 i=1,8
      do 81 j=1,8
      z1=zero
      do 82 k=1,8
   82 z1=z1+dd(i,k)*alt(k,j)
   81 db(i,j)=z1

      do 83 i=1,8
      do 83 j=1,8
      z1=zero
      do 84 k=1,8
   84 z1=z1+al(i,k)*db(k,j)
      d(i,j)=z1

   83 continue
      return
      end

* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * 

      subroutine hyperr(nr,hyp,rel,gx,gy,gz,ax,ay,az,a_hyp,
     *                  qx,qy,qz,qxy,qxz,qyz,tetm,phim)

      implicit real*8 (a-h,o-z)
      real*8 hyp(8,8),rel(8,8)

      data zero /0.d0/,two /2.d0/, three /3.d0/

       ag=0.180448d0 
       ae=-0.10307d0
       h0=a_hyp*0.25d0/ag

      stm=dsin(tetm)
      ctm=dcos(tetm)
      spm=dsin(phim)
      cpm=dcos(phim)

      gxx=gx*stm*cpm
      gyy=gy*stm*spm
      gzz=gz*ctm

      g2=gzz**2 + gxx**2 +gyy**2
      sqr=dsqrt(g2)
      
      h0g=h0/sqr
      if(nr.eq.2) h0g=-h0g
      hz=h0g*gzz*az
      hy=h0g*gyy*ay
      hx=h0g*gxx*ax

      sq3=dsqrt(three)
      sq3r=1.d0/sq3
      sq3r2=two*sq3r

      do 1 i=1,8
      do 1 j=1,8
      hyp(i,j)=zero
      rel(i,j)=zero
   1  continue

      ae3=three*ae
      qz2=two*qz

      hyp(1,1)=hz*(ae3-ag)+qz
      hyp(2,2)=-hyp(1,1)+qz2
      hyp(3,3)=hz*(ae-ag)-qz
      hyp(4,4)=-hyp(3,3)-qz2
      hyp(5,5)=hz*(-ae-ag)-qz
      hyp(6,6)=-hyp(5,5)-qz2
      hyp(7,7)=hz*(-ae3-ag)+qz
      hyp(8,8)=-hyp(7,7)+qz2
      
      h3x=sq3*ae*hx
      h2x=two*ae*hx
      hgx=hx*ag

      h3y=sq3*ae*hy
      h2y=two*ae*hy
      hgy=hy*ag
      qxz32=qxz*sq3r2
      qxmy3=sq3r*(qx-qy)
      qyz32=qyz*sq3r2
      qxy32=sq3r2*qxy
  
      hyp(1,3)= h3x+qxz32
      hyp(3,1)= hyp(1,3)
      hyp(1,5)= qxmy3
      hyp(5,1)= hyp(1,5)
      hyp(1,8)= -hgx
      hyp(8,1)= -hgx
      hyp(2,4)= h3x-qxz32
      hyp(4,2)= hyp(2,4)
      hyp(2,6)= qxmy3
      hyp(6,2)= hyp(2,6)
      hyp(2,7)= -hgx
      hyp(7,2)= -hgx
      hyp(3,5)= h2x
      hyp(5,3)= h2x
      hyp(3,7)= qxmy3 
      hyp(7,3)= hyp(3,7)
      hyp(3,6)= -hgx
      hyp(6,3)= -hgx
      hyp(5,4)= -hgx
      hyp(4,5)= -hgx 
      hyp(4,6)= h2x
      hyp(6,4)= h2x
      hyp(4,8)= qxmy3
      hyp(8,4)= hyp(4,8)
      hyp(5,7)= h3x-qxz32
      hyp(7,5)= hyp(5,7)
      hyp(6,8)= h3x+qxz32
      hyp(8,6)= hyp(6,8)


      rel(1,3)=-h3y-qyz32
      rel(3,1)=-rel(1,3)
      rel(1,5)=-qxy32
      rel(5,1)=-rel(1,5)
      rel(1,8)=-hgy
      rel(8,1)= hgy
      rel(2,4)= h3y-qyz32
      rel(4,2)=-rel(2,4)
      rel(2,6)= qxy32
      rel(6,2)=-rel(2,6)
      rel(2,7)= hgy
      rel(7,2)=-hgy
      rel(3,5)=-h2y
      rel(5,3)= h2y
      rel(3,7)=-qxy32 
      rel(7,3)=-rel(3,7)
      rel(3,6)=-hgy
      rel(6,3)= hgy
      rel(4,5)= hgy     
      rel(5,4)=-hgy
      rel(4,6)= h2y
      rel(6,4)=-h2y
      rel(4,8)= qxy32
      rel(8,4)=-rel(4,8)
      rel(5,7)=-h3y+qyz32
      rel(7,5)=-rel(5,7) 
      rel(6,8)= h3y+qyz32
      rel(8,6)=-rel(6,8)

      return
      end

* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
      function pp(e,n)
      implicit real*8 (a-h, o-z)
      data two /2.d0/
      fe=two
      fn=two
      if(dabs(e).gt.0.6d0) fe=6.d0
      if(n.eq.2) fn=1.d0
      pp=(-1)**n*dsqrt(fe/fn/12.d0)
      return
      end
*********************************************************
*                                                       *
      SUBROUTINE tens(QXX,QYY,QZZ,ALPHA,BETA,GAMMA,              
     1               VXX,VYY,VZZ,VXY,VXZ,VYZ)            
*                                                       *
*********************************************************
C        
      IMPLICIT REAL*8 (A-H,O-Z)                                  
C    ***                                                         
C    ***  PURPOSE                                                
C    ***  SET UP TENSOR COMPONENTS OF A REAL SYMMETRIC TENSOR     
C    ***                                                          
C    ***  INPUT PARAMETERS                                       
C    ***  QXX,QYY,QZZ=MAIN COMPONENTS OF THE TENSOR              
C    ***  ALPHA,BETA,GAMMA=EULER ANGLES OF THE PRINCIPAL AXES SYSTEM  
C    ***                                                        
C    ***  OUTPUT PARAMETERS                                      
C    ***  VXX,VYY,VZZ,VXY,VXZ,VYZ=TENSOR COMPONENTS              
C    ***                                                          

      pi    = 3.14159265358979324

      H0=pi/180.d0
      H7=ALPHA*H0                                                
      H8=BETA*H0                                                
      H9=GAMMA*H0                                                
      H1=DSIN(H7)                                               
      H2=DCOS(H7)                                               
      H3=DSIN(H8)                                               
      H4=DCOS(H8)                                                
      H5=DSIN(H9)                                                
      H6=DCOS(H9)                                               
      TV33=H4                                                    
      TV31=H3*H2                                                 
      TV32=H3*H1                                                 
      TV13=-H6*H3                                                
      TV23=H5*H3                                                 
      TV11=H2*H4*H6-H1*H5                                       
      TV12=H1*H4*H6+H2*H5                                       
      TV21=-H2*H4*H5-H1*H6                                      
      TV22=-H1*H4*H5+H2*H6                                       
C    ***  REMARK  TVIJ IS THE J-TH COMPONENT OF THE I-TH PRINCIPAL AXIS
      H1=QXX*TV11                                                
      H2=QYY*TV21                                                
      H3=QZZ*TV31                                               
      H4=QXX*TV12                                               
      H5=QYY*TV22                                               
      H6=QZZ*TV32                                                
      VXX=TV11*H1+TV21*H2+TV31*H3                               
      VXY=TV12*H1+TV22*H2+TV32*H3                                  
      VXZ=TV13*H1+TV23*H2+TV33*H3                                  
      VYY=TV12*H4+TV22*H5+TV32*H6                                 
      VYZ=TV13*H4+TV23*H5+TV33*H6                                  
      VZZ=QXX+QYY+QZZ-VXX-VYY                                    
      RETURN                                                     
      END                                         
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
***************************************************

      subroutine splith(dl,rom,cube,fort,crso)
      implicit real*8 (a-h,o-z)
      common/sq/sq2,sq3,sq5,sq10,o3
      real*8 crso(3,3)

      data one /1.d0/,two /2.d0/,three /3.d0/,pt5 /0.5d0/

      sq2=dsqrt(two)
      sq3=dsqrt(three)
      sq5=dsqrt(5.d0) 
      sq10=sq2*sq5

      o3=one/three

      do 1 i=1,3
      do 1 j=1,3
 1    crso(i,j)=0.d0
 
      crso(1,1)=10.d0*o3*dl + pt5*cube + o3*fort
      crso(1,2)=sq10*rom
      crso(1,3)=pt5*sq5*cube
      crso(2,1)=crso(1,2)
      crso(2,2)=-8.d0*o3*dl + cube + two*o3*fort
      crso(2,3)=three*sq2*rom
      crso(3,1)=crso(1,3)
      crso(3,2)=crso(2,3)
      crso(3,3)=-two*o3*dl -1.5d0*cube - fort

      return
      end

***************************************************
      subroutine tenshs(cts,gx,gy,gz,a,b,c)
      implicit real*8 (a-h,o-z)
      common/sq/sq2,sq3,sq5,sq10,o3
      real*8 cts(3,3),gx(3),gy(3),gz(3),a(3),b(3),c(3)

       data two /2.d0/,three /3.d0/,four/4.d0/ 

      gj=two

      sq5t=two*sq5
      fsq2=four*sq2

      do  i=1,3

      a(i)=cts(1,i)
      b(i)=cts(2,i)
      c(i)=cts(3,i)

      ai2=a(i)**2
      bi2=b(i)**2
      ci2=c(i)**2
      aici=a(i)*c(i)
      bici=b(i)*c(i)

      gx(i)=gj*(three*bi2+sq5t*aici
     &      +fsq2*bici)
      gy(i)=gj*(-1)**(i+1)*(three*bi2+sq5t*aici
     &      -fsq2*bici)
      gz(i)=(-1)**(i+1)*gj*(5.d0*ai2+bi2-three*ci2)
      enddo

      return
      end

***************************************************

      subroutine relsl(relr,gx,gy,gz,a,b,c,tetm,phim)
      implicit real*8 (a-h,o-z)
      common/sq/sq2,sq3,sq5,sq10,o3
      real*8 a(3),b(3),c(3),gx(3),gy(3),gz(3),gzr(3),gxr(3),gyr(3),
     *gr(3),sq(3),r1(3,3),r2(3,3),r3(3,3),r4(3,3),relr(6,6)

      complex*16 relax(6,6),gpl(3),gmn(3), rpp(3,3),rpm(3,3)

      data zero /0.d0/,two /2.d0/

      st=dsin(tetm)
      ct=dcos(tetm)
      sp=dsin(phim)
      cp=dcos(phim)

c      write(6,'(a)')'gx,gy,gz'
c      write(6,'(3g12.4)')(gx(j),j=1,3)
c      write(6,'(6g12.4)')(gy(j),j=1,3)
c      write(6,'(6g12.4)')(gz(j),j=1,3)
c      write(6,'(6g12.4)') st,ct,sp,cp

      do 11 i=1,6
      do 11 j=1,6
      relr(i,j)=zero
 11   relax(i,j)=zero

      do 1 i=1,3
 
      gr(i)=sqrt(gz(i)**2*ct**2 + (gx(i)**2*cp**2
     *+gy(i)**2*sp**2)*st**2)
      hh=gr(i)+gz(i)*ct
      if(hh.le.0.d0) then
       gzr(i)=0.0d0
       gxr(i)=0.0d0
       gyr(i)=0.0d0
c       write(6,'(a,6g12.4)')'gr(i),sq(i)=',gr(i),sq(i),hh
      else    
       sq(i)=dsqrt(two*gr(i)*(gr(i)+gz(i)*ct))

       gzr(i)=(gr(i)+gz(i)*ct)/sq(i)
       gxr(i)=gx(i)*st*cp/sq(i)
       gyr(i)=gy(i)*st*sp/sq(i)
      end if
      gpl(i)=dcmplx(gxr(i),gyr(i))
      gmn(i)=dcmplx(gxr(i),-gyr(i)) 
 1    continue

      do 2 i=1,3

      ai2=a(i)**2
      bi2=b(i)**2
      ci2=c(i)**2
      aibi=a(i)*b(i)
      aici=a(i)*c(i)
      bici=b(i)*c(i)   

      do 2 j=1,3

      aj2=a(j)**2
      bj2=b(j)**2
      cj2=c(j)**2
      ajbj=a(j)*b(j)
      ajcj=a(j)*c(j)
      bjcj=b(j)*c(j) 

      r1(i,j)=40.d0*ai2*aj2 + 48.d0*bi2*bj2+
     *184.d0*o3*ci2*cj2 + 160.d0*aibi*ajbj+
     *400.d0*o3*aici*ajcj + 352.d0*o3*bici*bjcj-
     *40.d0*o3*(ai2*bj2+aj2*bi2)-
     *24.d0*(bi2*cj2+bj2*ci2)-
     *16.d0*sq5*(aibi*bjcj+ ajbj*bici)
     
      r2(i,j)=40.d0*ai2*aj2 + 48.d0*bi2*bj2+
     *184.d0*o3*ci2*cj2 + 400.d0*o3*aibi*ajbj+
     *400.d0*o3*aici*ajcj+208.d0*o3*bici*bjcj-
     *16.d0*sq5*(bi2*ajcj+bj2*aici)

      r3(i,j)=80.d0*o3*(two*aici*ajcj-ai2*cj2-aj2*ci2) +
     *32.d0*o3*(two*bici*bjcj-bi2*cj2-bj2*ci2)

      r4(i,j)=32.d0*o3*sq10*(ci2*ajbj+cj2*aibi-
     *aici*bjcj-ajcj*bici)

      rpp(i,j)=gzr(i)**2*(gzr(j)**2*r1(i,j)+gpl(j)*gmn(j)*r3(i,j))+
     *gzr(i)*gpl(i)*(gzr(j)*gmn(j)*r2(i,j)+gzr(j)*gpl(j)*r4(i,j))+
     *gzr(i)*gmn(i)*(gzr(j)*gmn(j)*r4(i,j)+gzr(j)*gpl(j)*r2(i,j))+
     *gmn(i)*gpl(i)*(gzr(j)**2*r3(i,j)+gmn(j)*gpl(j)*r1(i,j))

      rpm(i,j)=gzr(i)**2*(gzr(j)**2*r3(i,j)+gpl(j)*gmn(j)*r1(i,j))-
     *gzr(i)*gpl(i)*(gzr(j)*gmn(j)*r2(i,j)+gzr(j)*gpl(j)*r4(i,j))-
     *gzr(i)*gmn(i)*(gzr(j)*gmn(j)*r4(i,j)+gzr(j)*gpl(j)*r2(i,j))+
     *gmn(i)*gpl(i)*(gzr(j)**2*r1(i,j)+gmn(j)*gpl(j)*r3(i,j))

 2    continue
      do 3 i=1,5,2
      do 3 j=1,5,2
      ni=int((i-1)/2)+1
      nj=int((j-1)/2)+1

 3    relax(i,j)=rpp(ni,nj)

      do 4 i=2,6,2
      do 4 j=2,6,2
      ni=int((i-1)/2)+1
      nj=int((j-1)/2)+1
 4    relax(i,j)=rpp(ni,nj)

      do 6 i=2,6,2
      do 6 j=1,5,2
      ni=int((i-1)/2)+1
      nj=int((j-1)/2)+1
 6    relax(i,j)=rpm(ni,nj)

      do 7 i=1,5,2
      do 7 j=2,6,2
      ni=int((i-1)/2)+1
      nj=int((j-1)/2)+1
 7    relax(i,j)=rpm(ni,nj)

      relnom=-147.d0/8.d0/767.d0

      do 5 i=1,6
      do 5 j=1,6
 5    relr(i,j)=relnom*dreal(relax(i,j))

      return
      end
**************************************************

       subroutine sort(e,es,vor,vsort,delt21,delt31,delt32)		
        implicit real*8 (a-h,o-z)
	
	integer index(3)
	real*8 e(3),es(3),vor(3,3),vsort(3,3)
	IF(e(1) .LT. e(2)) THEN
	        IF(e(1) .LT. e(3)) then 		
		index(1)=1
		       if(e(2) .lt. e(3)) then
			index(2)=2
			index(3)=3
			else  
			index(2)=3
			index(3)=2
			endif
	        else  
	        index(1)=3
	        index(2)=1
		index(3)=2
	       endif
	ELSE IF (e(2) .LT. e(3) ) THEN 
		index(1)=2
		if(e(1) .lt. e(3)) then
		index(2)=1
		index(3)=3
		else
		index(2)=3
		index(3)=1
		endif
	else 
	index(1)=3
	index(2)=2
	index(3)=1	
	endif

        do 1 i=1,3
        j=index(i)
        es(i)=e(j)
        do 1 k=1,3
        vsort(k,i)=vor(k,j)
 1      continue

        delt21=es(2)-es(1)
        delt31=es(3)-es(1)
        delt32=es(3)-es(2)        
	return	
	end


       subroutine  relax(dtheta,dphi,gx3,gy3,gz3,h11,h22,h33,a_hyp,
     &             aw,bw,cw,vxx,vyy,vzz,vxy,vxz,vyz,gml,
     &             n,hf,r,wr,wi,t,u,tl,ul,
     &             epk1,epk2,epk3,epk4,epk55,iepk,
     &             vl1,vl2,vl3,vl4,vl5,vl6,
     &             vr1,vr2,vr3,vr4,vr5,vr6)
	implicit none
        integer    iepk,n,n2,i,j,k,l,id,ik,nd,nr,
     &             iki,ikj,in,ini,inj
        real*8     dtheta,dphi,gx3(3),gy3(3),gz3(3),h11,h22,h33,a_hyp,
     &             aw(3),bw(3),cw(3),vxx,vyy,vzz,vxy,vxz,vyz,gml,
     &             gx,gy,gz,ax,ay,az,
     &             relr(6,6),hyp(8,8),rel(8,8)
        complex*16 vl1(8,8),vl2(8,8),vl3(8,8),vl4(8,8),
     &             vl5(8,8),vl6(8,8),vr1(8,8),vr2(8,8),
     &             vr3(8,8),vr4(8,8),vr5(8,8),vr6(8,8)
c     &             unit(48,48),hmat(48,48),hc,hhc
	real*8     hf(n,n),r(n,n),wr(n),wi(n),
     &             t(n,n),u(n,n),tl(n,n),ul(n,n),
     &             epk1,epk2,epk3,epk4,epk55
C


c       INITIALIZATION OF THE HYPERFINE MATRIX
c        write(6,'(8g12.5)')dtheta,dphi,h11,h22,h33,a_hyp       
c        write(6,'(8g12.5)')gx3,gy3
c        write(6,'(8g12.5)')gz3,aw        
c        write(6,'(8g12.5)')bw,cw       
c        write(6,'(8g12.5)')vxx,vyy,vzz,vxy,vxz,vyz,gml
        nd=n*n
        call zeroar(nd,hf)
        call zeroar(nd,r)

c       CALCULATION OF THE HYPERFINE INTERACTION  MATRIX
        id=n/8
        if(id.eq.2) then
         ax=h11
         ay=h22
         az=h33
         gx=gx3(1)
         gy=gy3(1)
         gz=gz3(1)
c        write(6,'(8g12.5)')gx,gy,gz,ax,ay,az        
c        write(6,'(8g12.5)')
         do  id=1,2
          call hyperr(id,hyp,rel,gx,gy,gz,ax,ay,az,a_hyp,
     *            vxx,vyy,vzz,vxy,vxz,vyz,dtheta,dphi)

          ik=8*(id-1)
          do i=1,8
           do j=1,8
            k=i+ik
            l=j+ik
            hf(k,l)=hyp(i,j)
            r(k,l)=rel(i,j)
           end do
          end do
c        write(6,'(/,a)')'hyp'
c        write(6,'(16g8.2)')((hyp(i,k),k=1,8),i=1,8)
c        write(6,'(/,a)')'rel'
c        write(6,'(16g8.2)')((rel(i,k),k=1,8),i=1,8)
         end do    ! id=2

c        RELAXATION IN ITS MOST PRIMITIVE FORM
         do i=1,8
          j=i+8
          r(i,j)=gml
          r(j,i)=gml
          r(i,i)=-gml
          r(j,j)=-gml
         end do
        else if(id.eq.6) then

         do id=1,6
          nd=int((id-1)/2)+1
          nr=(2+id-2*nd)
          gx=gx3(nd)
          gy=gy3(nd)
          gz=gz3(nd)
          ax=gx*0.5d0
          ay=gy*0.5d0
          az=gz*0.5d0

          call hyperr(nr,hyp,rel,gx,gy,gz,ax,ay,az,a_hyp,
     &                vxx,vyy,vzz,vxy,vxz,vyz,dtheta,dphi)

          ik=8*(id-1)
          do i=1,8
           do j=1,8
            k=i+ik
            l=j+ik
            hf(k,l)=hyp(i,j)
            r(k,l)=rel(i,j)
           end do
          end do
         end do    ! id=1,6
c        RELAXATION between Kramers doublets
         call relsl(relr,gx3,gy3,gz3,aw,bw,cw,dtheta,dphi)

         do  i=1,6
          iki=8*(i-1)
          do j=1,6
           ikj=8*(j-1)
           do in=1,8
            ini=in+iki
            inj=in+ikj
            r(ini,inj)=relr(i,j)*gml
           end do
          end do 
         end do
        end if        ! id

c       CALCULATION OF THE EIGENVALUES AND EIGENVECTORS
c        do i=1,n
c         do k=1,n
c          hmat(i,k)=dcmplx(hf(i,k),r(i,k))
c         end do
c        end do
c        write(6,'(/,a)')'hf'
c        write(6,'(16g8.2)')((hf(i,k),k=1,n),i=1,n)
c        write(6,'(/,a)')'r'
c        write(6,'(16g8.2)')((r(i,k),k=1,n),i=1,n)
c        write(6,'(/,a)')'t'
c        write(6,'(16g8.2)')((t(i,k),k=1,n),i=1,n)
c         write(6,'(/,a)')'wr,wi'
c         write(6,'(8g12.4)')(wr(k),k=1,n)
c         write(6,'(8g12.4)')(wi(k),k=1,n)
         n2=2*n
         call allvec (n,hf,r,wr,wi,t,u,tl,ul,
     &               epk1,epk2,epk3,n2,epk4,epk55,iepk)

c        write(6,'(/,a)')'vr*vl'
c        do i=1,n
c         do k=1,n
c           hc=(0.,0.)        
c           do j=1,n
c            hc=hc+dcmplx(tl(i,j),ul(i,j))*dcmplx(t(j,k),u(j,k))
c           end do
c          unit(i,k)=hc
c         end do
c        end do
c        write(6,'(16g9.2)')((unit(i,k),k=1,n),i=1,n)

c        write(6,'(/,a)')'diag vl*hmat*vr'
c        do i=1,n
c         do k=1,n
c          hhc=(0.0,0.0)
c          do l=1,n
c           hc=(0.,0.)        
c           do j=1,n
c            hc=hc+hmat(l,j)*dcmplx(t(j,k),u(j,k))
c           end do
c           hhc=hhc+dcmplx(tl(i,l),ul(i,l))*hc 
c          end do
c          unit(i,k)=hhc
c         end do
c        end do
c        write(6,'(16g8.2)')(real(unit(i,i)),i=1,n)
c        write(6,'(/,a)')' tl'
c        write(6,'(8g12.4)')((tl(i,k),k=1,n),i=1,n)
c        write(6,'(/,a)')' ul'
c        write(6,'(16g8.2)')((ul(i,k),k=1,n),i=1,n)

       id=n/8
       if(id.eq.2) then
        do  i=1,8
         do  j=1,8
          vl1(i,j)=dcmplx(tl(i,j),ul(i,j))+
     &             dcmplx(tl(i,j+8),ul(i,j+8))
          vl2(i,j)=dcmplx(tl(i+8,j),ul(i+8,j))+
     &             dcmplx(tl(i+8,j+8),ul(i+8,j+8))
         end do
        end do     
        do  i=1,8
         do  j=1,8
          vr1(i,j)=dcmplx(t(i,j),u(i,j))+
     &             dcmplx(t(i+8,j),u(i+8,j))
          vr2(i,j)=dcmplx(t(i,j+8),u(i,j+8))+
     &             dcmplx(t(i+8,j+8),u(i+8,j+8))
         end do
        end do 
       else if(id.eq.6) then
        do  i=1,8
         do  j=1,8
          vl1(i,j)=dcmplx(tl(i,j),ul(i,j))+
     &             dcmplx(tl(i,j+8),ul(i,j+8))+
     &             dcmplx(tl(i,j+16),ul(i,j+16))+
     &             dcmplx(tl(i,j+24),ul(i,j+24))+
     &             dcmplx(tl(i,j+32),ul(i,j+32))+
     &             dcmplx(tl(i,j+40),ul(i,j+40))
          vl2(i,j)=dcmplx(tl(i+8,j),ul(i+8,j))+
     &             dcmplx(tl(i+8,j+8),ul(i+8,j+8))+
     &             dcmplx(tl(i+8,j+16),ul(i+8,j+16))+
     &             dcmplx(tl(i+8,j+24),ul(i+8,j+24))+
     &             dcmplx(tl(i+8,j+32),ul(i+8,j+32))+
     &             dcmplx(tl(i+8,j+40),ul(i+8,j+40))
          vl3(i,j)=dcmplx(tl(i+16,j),ul(i+16,j))+
     &             dcmplx(tl(i+16,j+8),ul(i+16,j+8))+
     &             dcmplx(tl(i+16,j+16),ul(i+16,j+16))+
     &             dcmplx(tl(i+16,j+24),ul(i+16,j+24))+
     &             dcmplx(tl(i+16,j+32),ul(i+16,j+32))+
     &             dcmplx(tl(i+16,j+40),ul(i+16,j+40))
          vl4(i,j)=dcmplx(tl(i+24,j),ul(i+24,j))+
     &             dcmplx(tl(i+24,j+8),ul(i+24,j+8))+
     &             dcmplx(tl(i+24,j+16),ul(i+24,j+16))+
     &             dcmplx(tl(i+24,j+24),ul(i+24,j+24))+
     &             dcmplx(tl(i+24,j+32),ul(i+24,j+32))+
     &             dcmplx(tl(i+24,j+40),ul(i+24,j+40))
          vl5(i,j)=dcmplx(tl(i+32,j),ul(i+32,j))+
     &             dcmplx(tl(i+32,j+8),ul(i+32,j+8))+
     &             dcmplx(tl(i+32,j+16),ul(i+32,j+16))+
     &             dcmplx(tl(i+32,j+24),ul(i+32,j+24))+
     &             dcmplx(tl(i+32,j+32),ul(i+32,j+32))+
     &             dcmplx(tl(i+32,j+40),ul(i+32,j+40))
          vl6(i,j)=dcmplx(tl(i+40,j),ul(i+40,j))+
     &             dcmplx(tl(i+40,j+8),ul(i+40,j+8))+
     &             dcmplx(tl(i+40,j+16),ul(i+40,j+16))+
     &             dcmplx(tl(i+40,j+24),ul(i+40,j+24))+
     &             dcmplx(tl(i+40,j+32),ul(i+40,j+32))+
     &             dcmplx(tl(i+40,j+40),ul(i+40,j+40))
         end do
        end do     

        do  i=1,8
         do  j=1,8
         vr1(i,j)=(dcmplx(t(i,j),u(i,j))+
     &             dcmplx(t(i+8,j),u(i+8,j)))*h11+
     &            (dcmplx(t(i+16,j),u(i+16,j))+
     &             dcmplx(t(i+24,j),u(i+24,j)))*h22+
     &            (dcmplx(t(i+32,j),u(i+32,j))+
     &             dcmplx(t(i+40,j),u(i+40,j)))*h33
         vr2(i,j)=(dcmplx(t(i,j+8),u(i,j+8))+
     &             dcmplx(t(i+8,j+8),u(i+8,j+8)))*h11+
     &            (dcmplx(t(i+16,j+8),u(i+16,j+8))+
     &             dcmplx(t(i+24,j+8),u(i+24,j+8)))*h22+
     &            (dcmplx(t(i+32,j+8),u(i+32,j+8))+
     &             dcmplx(t(i+40,j+8),u(i+40,j+8)))*h33
         vr3(i,j)=(dcmplx(t(i,j+16),u(i,j+16))+
     &             dcmplx(t(i+8,j+16),u(i+8,j+16)))*h11+
     &            (dcmplx(t(i+16,j+16),u(i+16,j+16))+
     &             dcmplx(t(i+24,j+16),u(i+24,j+16)))*h22+
     &            (dcmplx(t(i+32,j+16),u(i+32,j+16))+
     &             dcmplx(t(i+40,j+16),u(i+40,j+16)))*h33
         vr4(i,j)=(dcmplx(t(i,j+24),u(i,j+24))+
     &             dcmplx(t(i+8,j+24),u(i+8,j+24)))*h11+
     &            (dcmplx(t(i+16,j+24),u(i+16,j+24))+
     &             dcmplx(t(i+24,j+24),u(i+24,j+24)))*h22+
     &            (dcmplx(t(i+32,j+24),u(i+32,j+24))+
     &             dcmplx(t(i+40,j+24),u(i+40,j+24)))*h33
         vr5(i,j)=(dcmplx(t(i,j+32),u(i,j+32))+
     &             dcmplx(t(i+8,j+32),u(i+8,j+32)))*h11+
     &            (dcmplx(t(i+16,j+32),u(i+16,j+32))+
     &             dcmplx(t(i+24,j+32),u(i+24,j+32)))*h22+
     &            (dcmplx(t(i+32,j+32),u(i+32,j+32))+
     &             dcmplx(t(i+40,j+32),u(i+40,j+32)))*h22
         vr6(i,j)=(dcmplx(t(i,j+40),u(i,j+40))+
     &             dcmplx(t(i+8,j+40),u(i+8,j+40)))*h11+
     &            (dcmplx(t(i+16,j+40),u(i+16,j+40))+
     &             dcmplx(t(i+24,j+40),u(i+24,j+40)))*h22+
     &            (dcmplx(t(i+32,j+40),u(i+32,j+40))+
     &             dcmplx(t(i+40,j+40),u(i+40,j+40)))*h33
         end do
        end do     


       end if    
       return
       end

      subroutine diag(crys,ct,cti,cl,cli,
     &          n,hf,r,wr,wi,t,u,tl,ul,
     &          epk1,epk2,epk3,epk4,epk55,iepk)
      
	implicit none
        integer    iepk,n,n2,i,j
        real*8     crys(3,3),ct(3,3),cti(3,3),cl(3,3),cli(3,3)
	real*8     hf(n,n),r(n,n),wr(n),wi(n),
     &             t(n,n),u(n,n),tl(n,n),ul(n,n),
     &             epk1,epk2,epk3,epk4,epk55

      do i=1,3
       do j=1,3
        hf(i,j)=crys(i,j)
         r(i,j)=0.0d0
       end do
      end do

C      CALCULATION OF THE ZERO-FIELD SPLITTING
       n2=2*n
       call allvec (n,hf,r,wr,wi,t,u,tl,ul,
     &               epk1,epk2,epk3,n2,epk4,epk55,iepk)
       
      do i=1,3
       do j=1,3
        ct(i,j)=t(i,j)
        cti(i,j)=u(i,j)
        cl(i,j)=tl(i,j)
        cli(i,j)=ul(i,j)
       end do
      end do
      
      return
      end  

      subroutine split(dl,rom,crso)
      implicit real*8 (a-h,o-z)
      real*8 crso(3,3)
      data zero /0.d0/,one /1.d0/,two /2.d0/,pt5 /0.5d0/

      sq2=dsqrt(two)

      do  i=1,3
      do  j=1,3
      crso(i,j)=zero
      enddo
      enddo
       
      crso(1,1)=-pt5
      crso(1,2)=-one/sq2 
      crso(1,3)=pt5*rom
      crso(2,1)=crso(1,2)
      crso(2,2)=dl
      crso(3,1)=crso(1,3)
      crso(3,3)=pt5

      return
      end

* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * 

      subroutine tensor(cu,orf,gx,gy,gz,ax,ay,az,qx,qy,qz,etq)
      implicit real*8 (a-h,o-z)

      real*8 cu(3,3),gx(3),gy(3),gz(3),ax(3),ay(3),az(3),
     *qx(3),qy(3),qz(3),etq(3)
 
      data one /1.d0/,two /2.d0/,four /4.d0/

      sq2=dsqrt(two)

      cof=0.35d0
      s=one/7.d0
      sk=cof+s
      s3=3.d0*s
      s21=two*s

      do  i=1,3

      ap=cu(1,i)
      bp=cu(2,i)
      cp=cu(3,i)

      a=bp
      b=(ap+cp)/sq2
      c=(ap-cp)/sq2

      qa=a**2
      qb=b**2
      qc=c**2

      gx(i)= two*(qa-qb+qc+two*a*c*orf)
      gy(i)= two*(qa+qb-qc+two*a*b*orf)
      gz(i)= two*(qa-qb-qc-two*b*c*orf)


     
      ax(i)= four*a*c-sk*( qa-qb+qc)+s3*(one-two*b*(a+c))
      ay(i)= four*a*b-sk*( qa+qb-qc)+s3*(one-two*c*(a+b))
      az(i)=-four*b*c+sk*(-qa+qb+qc)-s3*(one-two*a*(b+c))

      qx(i)= s21*(qa-two*qb+qc)
      qy(i)= s21*(qa+qb-two*qc)
      qz(i)= s21*(-two*qa+qb+qc)

      etq(i)=(qx(i)-qy(i))/qz(i)

      enddo

      return
      end


      subroutine th_relaxtwostatesad(isubthe,icase,iput,iget,info)
      implicit none
      include 'comglb.for'
      include 'comthe.for'

c     sad= source,absorber,detector 
      
      integer isubthe,icase,iput,iget,info,istr,dstr,idex,
     &        idum,nLG,nAS,nSC,nsampling,ak8,sk8,nRL
      real    srw8
      parameter (istr=38+4*(maxfr1+maxfr2)+3*maxthss+16)           
      common/struct/dstr(istr),idum(2),                            !13.9.05 
     &              nLG,nAS,nSC,nsampling,ak8,sk8,srw8,nRL,idex(7)      
      real            avfr1,dfr1,B_ext,dumfr1
      common/avfr1trf/avfr1,dfr1,B_ext,dumfr1(ivfr1trf-3)
      logical         b_vfr1trf
      common/bvfr1trf/b_vfr1trf(ivfr1trf)
      real            acfr2,unufr2,temperature,dumfr2
      common/acfr2trf/acfr2,unufr2(4),temperature,dumfr2(ivfr2trf-6)

      real          avm,a_iso,hz1,hz2,dq,t_rate,popmom,forMofT,ai0,
     &              dumvssp
      common/avmaps/avm,a_iso,hz1,hz2,dq,t_rate,popmom,forMofT,ai0,
     &              dumvssp(ivstrf-9)
      logical       b_vm,b_dumvssp
      common/bvmaps/b_vm,b_dumvssp(ivstrf-1)
      
      real          c1,gamnat,e_xsi,cTms,ajg,aje,amueg,amuee,QgdQe,
     &              E2dM1,e1m1,Treference,dumc
      common/acmaps/c1,gamnat,e_xsi,cTms,ajg,aje,amueg,amuee,QgdQe,
     &              E2dM1,e1m1,Treference,dumc(icstrf-12)
      logical       b_c1,b_dumc,b_pc
      common/bcmaps/b_c1,b_dumc(icstrf-1)      
c     if one of the  constants changed the value all logical are .true.
c     nuclear parameters are not used. Problem is solved only for iron57.

c--------------------------------------------------------------------
      integer     mAS,idumscrd
      parameter  (mAS=2*maxn,idumscrd=maxscrd-4*(mAS+1))
      real        sTr,yyr,dumscrd
      common/scrd/sTr(-mAS:mAS+1),yyr(-mAS:mAS+1),dumscrd(idumscrd)
      integer nop,je,jg,me,mg,n,i1
      real h,ug,ue,de1,de2,qh,qe,qg,ra11,ra22,ai,gam,
     &     pi12,pi21,dw,clebsch,popr,B_T,dipole_T,hz1_T,hz2_T,fT
      complex*8 a11,a22,aint,denom

      if(isubthe.lt.0) then
       theoryname='two_state_refindex_dynamic_pert'
       c1=2*(nSC+1)+3
       if(nSC-nAS.gt.0) c1=c1+(nSC-nAS)/2  ! source norm array
       return
      end if
c      write(6,'(a,6f12.3)')' acmaps=',c1,aiset,aisym,temperature,gamnat
      
       b_pc=b_vm.or.b_vfr1trf(1)
       if(.not.b_pc) then
        isubthe=-abs(isubthe)
        return
       end if

       if(icase.eq.1)then
        popr=popmom 
        hz1_T=hz1
        hz2_T=hz2
       else
        if(temperature.le.0.) then
         info=1
         infotext(1)=' '
         infotext(2)='temperature has zero value (not included)'
         infotext(3)='set up: include constant temperature for  ... [y]'  
         infotext(3)=' '
         return
        end if
        fT=1.0+forMofT*
     &      (1.0-((temperature-Treference)/(300-Treference))**2)
        hz1_T=hz1*fT
        hz2_T=hz2*fT
        dipole_T=(hz1_T+hz2_T)/2.0
        popr=exp(2.*popmom*(B_ext+dipole_T)/temperature)
c        write(6,'(a,6f12.4)')'fT, popr,t_rate,H1,2=',fT,popr,t_rate,
c     &               hz1_T+B_ext,hz2_T+B_ext
       end if
c       0.0467 *B[kG]cm**-1 ; 0.695*T cm**-1 ; 2.24^=10**4 mu-Bohr*1kG/300K

       nop=nRL+1
       ug=amueg/ajg/cTms/2.
       ue=amuee/aje/cTms/2.
       jg=2.*ajg+0.001
       je=2.*aje+0.001
       gam=popr/(1.0+popr)     !     gam=pop1, 1-gam=pop2
       pi12=(1.-gam)*t_rate    !     t_rate=pi12+pi21
       pi21=gam*t_rate
c       write(6,'(a,2f10.3)')' pi12,pi21=',pi12,pi21
c        write(6,'(a,8f12.4)')'fT, popr,t_rate,H1,2=',fT,popr,t_rate,
c     &               hz1_T+B_ext,hz2_T+B_ext,pi12,pi21
       dq=0.
       qe=dq/4.
       qg=QgdQe*qe
       qh=-qg*jg*(jg+2)+qe*je*(je+2)                
       ra11=gamnat/2.+pi12
       ra22=gamnat/2.+pi21

       if(idex(1).eq.2) then
        dw=4.0*srw8
       else
        dw=16.0*srw8
       end if

       do n=-nop,nop
        sTr(n)=0.0
       end do
c      (am+bm=cm)       
       do mg=-jg,jg,2
        do me=-je,je,2
         if(mg-me.eq.0) then         
          ai=clebsch(1.0,0.,
     &           ajg,float(mg)/2.,aje,float(me)/2.)**2*ai0
c         write(6,'(a,2i3,2x,f10.3)')'0 mg,me, ai=',mg,me, ai
         else if(abs(me-mg).eq.2) then
          ai= clebsch(1.0,float(me-mg)/2.,
     &           ajg,float(mg)/2.,aje,float(me)/2.)**2
c         write(6,'(a,2i3,2x,f10.3)')'2 mg,me, ai=',mg,me, ai
         else if(abs(me-mg).gt.2) then        
          ai=0.
         end if
         if(ai.gt.0) then
          h=qh+3.*(qg*mg**2-qe*me**2)+a_iso
          de1=(ug*mg-ue*me)*(hz1_T+B_ext)+h
          de2=(ug*mg-ue*me)*(hz2_T+B_ext)+h
          do n=-nop,nop
           a11=cmplx(ra11,-n*dw-de1)
           a22=cmplx(ra22,-n*dw-de2)
           denom=a11*a22-cmplx(pi12*pi21,0.)
           aint=gam*(a22+cmplx(pi12,0.))+(1.-gam)*(a11+cmplx(pi21,0.))
           sTr(n)=sTr(n)+real(aint/denom)*ai   
          end do
         end if
        end do
       end do
       h=0.
       do n=-nop+1,nop-1,2
        h=h+ sTr(n)*2
       end do
       do n=-nop+2,nop-2,2
        h=h+sTr(n)
       end do
       h=h*2.+ sTr(-nop)+sTr(nop)
       h=h/3.*dw

       i1=iput+1
       do n=0,nop
        array_fr(i1+n)=cmplx(sTr(n),sTr(-n))/h
       end do
c       write(6,'(8f10.3)')(sTr(n),n=-nop,nop,8)
       return
       end 
