c     Jg Je arbitrary spin
c     synchrotron source
c
      subroutine moss_strob(b_total,info)
      implicit none
      include 'comglb.for'
      include 'comthe.for'
   
      logical    b_total
      integer    info,ifrth,iaddr,idex,mstruct1,istruct1,istruct2,
     &           l1_get,l2_get,l3_get,l1_put,l2_put,l3_put,
     &           nstorTH,nstorTH1,nstorTHyy,idum1,nCP,nCC,
     &           iflag_basis,l_Poincare,idum2,idum3,nTH,nsampling,
     &           ak8,idum4
      real        srw8
      character*4 c1_prp,c2_prp,c3_prp,frthname*64
      common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),     !13.9.05 
     &              l1_get(0:maxfr1),l2_get(maxfr2),l3_get(maxthss),
     &              l1_put(0:maxfr1),l2_put(maxfr2),l3_put(maxthss),
     &              c1_prp(0:maxfr1),c2_prp(maxfr2),c3_prp(maxthss),
     &              frthname(2),nstorTH,nstorTH1,nstorTHyy,iaddr(5),
     &              idum1,nCP,nCC,ifrth(5),                   
     &              iflag_basis,l_Poincare,idum2,idum3,nTH,nsampling,
     &              ak8,idum4,srw8,idex(7)

c     a large array(1:maxn*256) is used in order to store information of the
c     theory for each data set. This storage ensures that during 
c     simultanious fitting of different data sets by the same theory
c     calculations are preserved which are not needed to be recalculated 
c     for each iteration  
c     
c     c1_prp(0:maxfr1),c2_prp(maxfr2),c3_prp(maxthss) stores the property
c     polarized ci_prp()(1:1)='T', non polarized ci_prp()(1:1)='F',
c     li_get,li_put denote the pointer on array_fr 
c     li_get points to the result of the subroutines called by 
c     get_theory(isubthe,info)
c     li_put points to an array area requestet in framexx.
c     results calculated by this main routine are stored here
c     li belongs to the loop index lstructi. 
c     l1_put(lstruct1) is the pointer for storage defined in framexx 
c     lstruct1.gt.0.and.(lstruct2+lstruct3).eq.0
c     l2_put(lstruct2) :lstruct2.gt.0.and.lstruct3.eq.0
c     l3_put(lstruct3) :lstruct3.gt.0
c
c     convention: the first number is stored on li_get+1, li_put+1 

c     !!! the 2nd variable in all common blocks of variables is 
c         an  intensity, which is used to calculate subsets (incoherent
c         parts, subspectra, ...) 

      real          acsp,wavelength,uthick_w,uthick_A,
     &              unitchi,channels,v_range,
     &              th_channels,th_sampling,drive_mode,channels_vmax,
     &              Tbunch,flag_basis,flag_phase,strob_order,dumcs
      common/acstrf/acsp,wavelength,uthick_w,uthick_A,
     &              unitchi,channels,v_range,
     &              th_channels,th_sampling,drive_mode,channels_vmax,
     &              Tbunch,flag_basis,flag_phase,strob_order,
     &              dumcs(icstrf-15)  

      logical b_cs,b_dumc
      common/bcstrf/b_cs,b_dumc(icstrf-1) 

      real    avsp,dum1,base,dum2,v_max,
     &        channel_v0,v_max2,channel_v02,v_max3,channel_v03,geo,       
     &        ang_shift,Pxsi,Peta,Pzeta,graz_angle,dumv     
      common/avstrf/avsp,dum1,base,dum2,v_max,
     &        channel_v0,v_max2,channel_v02,v_max3,channel_v03,geo,       
     &        ang_shift,Pxsi,Peta,Pzeta,graz_angle,dumv(ivstrf-16)     
      logical b_vs,b_dum1,b_base,b_dum2,b_v_max,b_channel_v0,
     &        b_v_max2,b_vphase2,b_v_max3,b_vphase3,b_geo,
     &        b_ang_shift,b_Pxsi,b_Peta,b_Pzeta,b_graz_angle,b_dumv
      common/bvstrf/b_vs,b_dum1,b_base,b_dum2,b_v_max,b_channel_v0,
     &        b_v_max2,b_vphase2,b_v_max3,b_vphase3,b_geo,b_ang_shift,
     &        b_Pxsi,b_Peta,b_Pzeta,b_graz_angle,b_dumv(ivstrf-16)



      real            cfr1trf
      common/acfr1trf/cfr1trf(ivfr1trf)
      real            avfr1,pvfr1,HextA,thetaHeA,phiHeA,
     &                phiA,thetaA,psiA,dumvfr1
      common/avfr1trf/avfr1,pvfr1,HextA,thetaHeA,phiHeA,
     &                phiA,thetaA,psiA,dumvfr1(ivfr1trf-7)
      logical         b_avfr1,b_pvfr1,b_HextA,b_thetaHeA,b_phiHeA,
     &                b_phiA,b_thetaA,b_psiA,b_dumvfr1
      common/bvfr1trf/b_avfr1,b_pvfr1,b_HextA,b_thetaHeA,b_phiHeA,
     &                b_phiA,b_thetaA,b_psiA,b_dumvfr1(ivfr1trf-7)

      real            acfr2,rep_grp,dumcfr2
      common/acfr2trf/acfr2,rep_grp,dumcfr2(icfr2trf-2)
      logical         b_cfr2,b_rep_grp,b_dumcfr2
      common/bcfr2trf/b_cfr2,b_rep_grp,b_dumcfr2(icfr2trf-2)

      real            avfr2,thicklay,re_chilay,ai_chilay,roughness,
     &                dumvfr2
      common/avfr2trf/avfr2,thicklay,re_chilay,ai_chilay,roughness,
     &                dumvfr2(ivfr2trf-5)
      logical         b_vfr2,b_thicklay,b_re_chilay,b_ai_chilay,
     &                b_roughness,b_dumvfr2
      common/bvfr2trf/b_vfr2,b_thicklay,b_re_chilay,b_ai_chilay,
     &                b_roughness,b_dumvfr2(ivfr2trf-5)

      real             vsstrf,sftr
      common/avsstrf/ vsstrf(ivsstrf)
      logical          b_vsstrf,b_sftr
      common/bvsstrf/ b_vsstrf(ivsstrf)

      logical  b_chilay,b_lay,b_absorber,b_ew,
     &         b_isgt1,b_sites,b_chilaynz

      real      winc,wi,vkd
      integer   l1_pos,l1p,l2p,l3p
      dimension winc(maxfr1),wi(maxthss),l1_pos(maxfr1),l1p(maxfr1),
     &          l2p(maxfr2),vkd(maxfr2),b_sites(maxfr2),
     &          b_chilay(maxfr2),b_chilaynz(maxfr2)

      integer iss,ipos,lstruct1,lstruct2,lstruct3,isubthe,icase,
     &        iset,is_a,is_e,j_s,n_vm,n_er,n_v,n_s,n_ch,
     &        i,j,ji,n,nn,j1,j2,j3,j4,i4,nomega,nstrob_order,
     &        k,l,ll,lav,lay,mlay,layb,laye,isctp,iflag_phase,
     &        iposlay,npos,lays,mlays,laysites,laystr

      real pi,rad,grazing,vector_k,sing,thicklayer,roughlay,sqrt2,eta
      dimension thicklayer(maxfr2),roughlay(maxfr2),
     &          iposlay(maxfr2),
     &          laystr(2*maxfr2),laysites(maxfr2)

      complex hc,hcc,hcp,hcm,hc1,hci,hc0,app,apm,amp,R_oo,
     &        swin,swinp,swinm,satraceh,trace,carray,
     &        aam(4,maxfr2),aa(4),bb(4),dd(4),cc(4),rho(4),satrexp,
     &        Cmatrix(2,2,maxfr2),chilay(maxfr2),
     &        Rmatrix(2,2),trv(2,2),TSPCA(2,2),sph(2,2)
      real    h0,h1,h2,hp,hm,yth,yth0,dumscrd,start,finish

      integer mAL,idumscrd
      parameter (mAL=8*(2*maxn+1),
     &           idumscrd=maxscrd-2-4*maxn-2*mAL-2-8*maxn)
      common/scrd/carray(mAL),yth(-maxn:maxn),yth0(-maxn:maxn),
     &            trace(-2*maxn:2*maxn),dumscrd(idumscrd)

c      integer mFF,mFF1,mAL,mth2,mth4
c      parameter (mFF=16*maxn,mFF1=2*mFF+1,
c     &            mth2=2*maxn+2,mth4=4*maxn+4,mAL=8*(2*maxn+1))
c      complex carray,th0,trace,dumscrd
c      real yth,yth0
c      dimension carray(mAL),th0(maxn),trace(-2*maxn:2*maxn),
c     &          yth(-maxn:maxn),yth0(-maxn:maxn)
c      common/scrd/dumscrd(maxscrd/2)
c      equivalence (dumscrd(1),th0(1)),(dumscrd(mth2),yth(-maxn)),
c     &                                (dumscrd(mth4),yth0(-maxn))
c      equivalence (dumscrd(1),carray(1))

      logical b_reference
C **** Definitions of structure variables L. Deak 09.10.2002 ***
      integer POINTER,GRP,MAXGRP,GEOSTR(0:2*maxfr2)
      logical b_first,b_frcn,b_frcr,b_frci
C ****                                                       ***     
      b_total=b_cs
c     icase=1   ! forward forward scattering geometry
c     icase=20   ! grazing incidence
c-------------------------------------------------------------------
c      write(6,'(a,2i4)')' th_strobmoss ifrcase,flag_phase=',
c     &                     ifrcase,flag_phase
      call cpu_time(start)

      iflag_phase=flag_phase
      b_frcn=iflag_phase.eq.0
      b_frcr=iflag_phase.eq.1
      b_frci=iflag_phase.eq.-1

      call mapsub(0)
      isubthe=1
      call get_theory(isubthe,info)
      b_total=b_total.or.(isubthe.gt.0) 


      b_reference=.false.
c      write(6,'(a,2L4)')' moss_strob b_cs,b_total=',b_cs,b_total

      hc1=cmplx(1.,0.)
      hci=cmplx(0.,1.)
      hc0=cmplx(0.,0.)

      nstrob_order=strob_order
      srw8=v_max/float(nTH)/8.
      nomega=wavelength/Tbunch*100./srw8/nsampling                 !13.9.05
c     write(6,'(a,i5)')' moss_strob nstrob_order=',nstrob_order
      srw8=abs(srw8)
      ak8=v_range/srw8

      pi=atan(1.)*4.
      rad=pi/180.
      vector_k=2.0*pi/wavelength    ! /Angstroem

c     write(6,'(a,3f10.2)') ' Poincare =', Pxsi,Peta, Pzeta
c      (11 12))     fortran  ( 1 3 )
c      (21 22)               ( 2 4 )    
c                       effi ( 1 3 )  
c                            ( 4 2 ) 
c     !!!!! 2x2 matrices on array_fr use always effi notation !!!!  
c     Fortran notation 
      rho(1)=cmplx(1.+Pzeta,0.)/2.
      rho(3)=cmplx(Pxsi,-Peta)/2.
      rho(2)=cmplx(Pxsi,Peta)/2.
      rho(4)=cmplx(1.-Pzeta,0.)/2.
c       write(6,'(a,8f8.2)') ' rho=', (rho(k),k=1,4)
c---------------------------------------------------------------
       iflag_basis=flag_basis
       if(iflag_basis.eq.0) then
c      linear polarization basis
       sqrt2=1./sqrt(2.)
       TSPCA(1,1)=cmplx( sqrt2,0.)
       TSPCA(1,2)=cmplx(-sqrt2,0.)
       TSPCA(2,1)=cmplx(0.,-sqrt2)
       TSPCA(2,2)=cmplx(0.,-sqrt2)

       sph(1,1)=rho(1)
       sph(1,2)=rho(3)
       sph(2,1)=rho(2)
       sph(2,2)=rho(4)
       do i=1,2
       do k=1,2
        hc=(0.,0.)
        do j=1,2
        do l=1,2
         hc=hc+TSPCA(i,l)*sph(l,j)*conjg(TSPCA(k,j))
        end do
        end do
        trv(i,k)=hc
       end do
       end do
       rho(1)=trv(1,1)
       rho(3)=trv(1,2)
       rho(2)=trv(2,1)
       rho(4)=trv(2,2)
       end if
c--------------------------------------------------------------
      lstruct1=0
      iss=1
 1000 continue
      b_absorber=.false.

      lstruct1=lstruct1+1
      if(lstruct1.gt.mstruct1) goto 2500
c      different devices have differen values for l_Poincare !!
       icase=1
       l_Poincare=1                              ! reference absorber
       if(lstruct1.ge.2.and.ifrcase.eq.2) then
        icase=2                      !  stroboscopic reflection spectrum
        l_Poincare=0    ! optic is called       
       end if

       l1p(lstruct1)=2
       if(c1_prp(lstruct1)(1:1).eq.'T') l1p(lstruct1)=8
       l1_pos(lstruct1)=l1_put(lstruct1)    ! 0..2*nCC*4

       call mapsub(iss)

       isubthe=1                      ! frame
       call get_theory(isubthe,info)
       b_total= b_total.or.(isubthe.gt.0)     

       b_absorber=b_absorber.or.b_avfr1.or.b_pvfr1
       
       winc(lstruct1)=pvfr1
c      write(6,'(a,i4,a,g12.4)')'moss_strob case=',icase,
c    &     ' graz_angle=',graz_angle

       if(icase.eq.2) then
        b_absorber=b_absorber.or.b_graz_angle.or.b_ang_shift
        grazing=0.001*(graz_angle+ang_shift)
c       thetaA=(pi/2.-grazing)/rad  new transformationmn
        sing=sin(grazing)
       end if

       iss=iss+1
       layb=istruct1(lstruct1-1)
       laye=istruct1(lstruct1)
       do lstruct2=istruct1(lstruct1-1)+1,istruct1(lstruct1)
c      ------------------------------------------------------------
c      layer lay1,2 ... mlay of  absorber
c      ---------------------------------------------------------------
c      The Lorentz curve of the absorber in npq is 1 at resonance so that
c      for a singl line the exponent at resonance is just -teff (effective
c      thickness). areaLor ~ pi*ga/2 ( area -+ infinity), ga/2=hga/2/srw8,
c      normalizes ( to area 1) the Lorentz curve.
c
c      Sums of absorber curves at the positions Eagd.
c
c      ----0--------------------------naLG
c       naLG--------------------------0-------------        srw8
c        nCC------------0------------nCC                    srw
c       write(6,'(a,12i6)')'lstruct2 iss,i_adds(iss)=',
c    &  lstruct2,iss,i_adds(iss)
        lay=lstruct2-layb

        call mapsub(iss)
c        write(6,'(a,5g12.4)')' synmos r,i_chi,roughness,thicklay=',
c     &        re_chilay,ai_chilay,roughness,thicklay

        thicklayer(lay)=thicklay
        b_absorber=b_absorber.or.b_vfr2.or.b_thicklay
        isubthe=1                      ! frame
        call get_theory(isubthe,info)
        b_total= b_total.or.(isubthe.gt.0).or.b_absorber    

        if(icase.eq.2) then
         if(abs(re_chilay)+abs(ai_chilay).gt.1.0e-10) then
          chilay(lay)=cmplx(re_chilay,ai_chilay)*unitchi
          b_chilaynz(lay)=.true.
         else
          chilay(lay)=(0.,0.)
          b_chilaynz(lay)=.false.
         end if
         b_chilay(lay)=b_vfr2.or.b_thicklay
         i=rep_grp
         laystr(2*lay-1)=i
         laystr(2*lay)=10*(rep_grp-float(i)+.01)
         roughlay(lay)=roughness
        end if

c       polarized layer
        l2p(lstruct2)=2
        if(c2_prp(lstruct2)(1:1).eq.'T') l2p(lstruct2)=8

        b_isgt1=.false.
        if(istruct2(lstruct2)-istruct2(lstruct2-1).gt.1)then
         b_isgt1=.true.
c        if more than one site within layer lstruct2
c        than the sum of the site amplitudes times wi is stored
c        at l2_put(lstruct2)
c        (if one site the amplitudes at l3_get(lstruct3) are taken 
c         and multiplied by wi)  

         iposlay(lay)=l2_put(lstruct2) 
         do i=1,l2p(lstruct2)*(nCC+1)
          carray(i)=(0.,0.)
         end do
        end if

        b_sites(lay)=.false.
        b_lay=.false.
        iss=iss+1
        do lstruct3=istruct2(lstruct2-1)+1,istruct2(lstruct2)
         iset=lstruct3
         l3p=2
         if(c3_prp(lstruct3)(1:1).eq.'T') l3p=8
         
         iset=lstruct3
         b_sites(lay)=.true.

         call mapsub(iss)
         sftr=vsstrf(2) 
         b_sftr= b_vsstrf(2)

         wi(iset)=sftr*uthick_w
         if(ifrcase.eq.2.and.lstruct1.gt.1)wi(iset)=sftr*uthick_A


c         write(6,'(a,i4,5g10.3)')
c     &   'moss_strob lay,wi(iset),sftr,uthick_w,uthick_A=',
c     &    lay,wi(iset),sftr,uthick_w,uthick_A

         if(icase.eq.2) then
          if(b_vsstrf(1).and.enwr(6).eq.'nynn') then
           if(wi(iset).gt.sing/20..or.sing.gt.0.05)
     &     write(nwr,'(2(a,g8.1),a)')
     &     '** f*unit_thickness=',wi(iset),' << sin(th)=',sing,' << 1 ?'
          end if
         end if

         isubthe=0
         call get_theory(isubthe,info)
         b_lay=b_lay.or.b_sftr.or.b_vsstrf(1)
         b_absorber=b_absorber.or.b_lay.or.(isubthe.gt.0)
                  

         if(b_isgt1) then
          isctp=l3_get(lstruct3)
c         three possibilities l2p=l3p=8, 2, and l2p=8,l3p=2
c         !! the first two cases have different array sizes 

          if(l2p(lstruct2).eq.l3p) then
           do n=0,nCC
            nn=isctp+l2p(lstruct2)*n
            ll=l2p(lstruct2)*n
             do k=1,l2p(lstruct2)
             carray(ll+k)=carray(ll+k)+ array_fr(nn+k)*wi(iset)
             end do
           end do
          else !  if(l2p(lstruct2).eq.4*l3p) then
           do n=0,nCC
            nn=isctp+l3p*n
            ll=l2p(lstruct2)*n
            hc=array_fr(nn+1)*wi(iset)
            carray(ll+1)=carray(ll+1)+ hc
            carray(ll+4)=carray(ll+4)+ hc
            hc=array_fr(nn+2)*wi(iset)
            carray(ll+5)=carray(ll+5)+ hc
            carray(ll+8)=carray(ll+8)+ hc
           end do
          end if
         else
          iposlay(lay)=l3_get(lstruct3)
c           write(6,'(a,i2,a2,i8)')
c     &       'moss_strob iposlay(',lay,')=',iposlay(lay)
          do n=0,4
           nn=iposlay(lay)+n*8
c          write(6,'(a2,2i6,10f9.4)')'n=',n,nn,(array_fr(nn+j),j=1,4)
          end do
         end if
c        write(6,'(a)') 'moss_strob  carray(1..)='
c        write(6,'(8f12.4)') (carray(i)*1000,i=1,8)

         iss=iss+1
        end do     ! lstruct3

        if(b_isgt1.and.b_lay) then
         do i=1,l2p(lstruct2)*(nCC+1)
          array_fr(iposlay(lay)+i)=carray(i)
         end do
        end if

       end do  ! lstruct2
       mlay=lay
       laystr(2*lay+2)=-1
       laystr(2*lay+1)=0

c      write(6,'(a,l5)')'moss_strob -> 2000 b_absorber=',b_absorber
      b_total=b_total.or.b_absorber
      if(lstruct1.eq.1) b_reference=b_absorber
      if(.not.b_absorber) goto 2000

c-----------------------------------------------------------------------
c     here the matrix R for the layers are given :
c     satrlay(n,lay)*1 +  (sapplay(n,lay)  sap(n,lay))
c                         (samplay(n,lay) -sapplay(n,lay))
c
c     calculation of the transmittivity matrix T for all channels n
c     by   T = exp(iR)*rho*exp(-iR+)


      do lstruct2=layb+1,laye
       lay=lstruct2-layb
       is_a=istruct2(lstruct2-1)+1
       is_e=istruct2(lstruct2)
c       if(is_e.ge.is_a)
c     &  write(6,'(a,i4,2g10.3)')'synmos lay,wi(is_a),thicklayer',
c     &   lay,wi(is_a),thicklayer(lay)
      end do

      do k=1,mlay
       laysites(k)=0
      end do
      if(icase.eq.1) then
       mlays=0
       do lstruct2=layb+1,laye
        lay=lstruct2-layb
        is_a=istruct2(lstruct2-1)+1
        is_e=istruct2(lstruct2)
        if(b_sites(lay)) then
         mlays=mlays+1
         l2p(mlays)=l2p(lay)
         iposlay(mlays)=iposlay(lay)
         if(is_e.gt.is_a) thicklayer(mlays)=thicklayer(lay)
         if(is_e.eq.is_a)
     &           thicklayer(mlays)=thicklayer(lay)*wi(is_a)
c         write(6,'(a,i4,2f10.3)')'synmos lay,wi(is_a),thicklayer',
c     &   lay,wi(is_a),thicklayer(lay)
        end if
       end do
      else
       mlays=mlay-1
       do lstruct2=layb+1,laye
        lay=lstruct2-layb
        is_a=istruct2(lstruct2-1)+1
        is_e=istruct2(lstruct2)
        vkd(lay)=vector_k*thicklayer(lay)
        if(is_e.lt.is_a) then
c         write(6,'(i4,a,2i4)') lay,'=lay ### is_a,is_e=',is_a,is_e
         thicklayer(lay)=0.
        else
         if(is_e.gt.is_a) thicklayer(lay)=1./vector_k
         if(is_e.eq.is_a) thicklayer(lay)=wi(is_a)/vector_k
        end if
       end do
      end if


       if(icase.eq.2) then
C       ********************************************************************
C       We reconstruct the layer strucrure from the laystr variabale. 
c       ELEMENT(GRP) is the number of layers in group GRP.
c        *** L. Deak, 09.10.2002    *** 
        GRP         =0
        GEOSTR(GRP) =0
        MAXGRP      =0
C
        b_first     =.true.
        POINTER=1
        do lay=2,2*mlay,2
         if(b_first)then
          if(GRP.eq.laystr(lay))then
           GEOSTR(2*GRP)   =GEOSTR(2*GRP)+1
          else
           POINTER         =POINTER+GEOSTR(2*GRP)
           GRP             =GRP+1
           MAXGRP          =GRP
           GEOSTR(2*GRP)   =1
           GEOSTR(2*GRP-1) =laystr(lay-1)
          end if

          if(vkd(lay/2).lt.0.) then
           b_first         =.false.
           vkd(lay/2)      =1.e30
           GEOSTR(2*GRP-1) =1
          end if ! VKD < 0
         end if  ! b_first
        end do
C       ***********************************************************************
c       write(6,'(a,10i8)')'moss_strob iposlay(1.)=',(iposlay(i),i=1,mlays)c
c       do lstruct2=layb+1,laye
c        lay=lstruct2-layb
c        write(6,'(i4,2x,L3,a,2g12.4,2(a,g12.4))')
c     & lay,b_sites(lay),' chilay=',chilay(lay)/unitchi,' vkd=',vkd(lay),
c     & ' thicklayer(lay)=',thicklayer(lay)
c       end do
c       write(6,'(20i4)')(GEOSTR(i),i=1,20)

          b_ew=.false.
        do lay=1,mlay
         Cmatrix(1,1,lay)=hc0
         Cmatrix(2,2,lay)=hc0
         Cmatrix(1,2,lay)=hc0
         Cmatrix(2,1,lay)=hc0
        end do
        call optic(b_ew,mlay,b_sites,MAXGRP,GEOSTR,grazing,
     &                Cmatrix,chilay,roughlay,vkd,Rmatrix)
        R_oo=Rmatrix(1,1)
        array_fr(nstorTH1+2)=R_oo
       else
        R_oo=hc1
        array_fr(nstorTH1+1)=R_oo
       end if


       ipos=l1_pos(lstruct1)

c      construction of the input for general optics program
c      here the matrix R for the layers are given :
c      satrlay(n,lay)*1 +  (sapplay(n,lay)  sapmlay(n,lay))
c                          (samplay(n,lay) -sapplay(n,lay))
       if(mlay.eq.1) then
        if(icase.eq.1) then
         if(l1p(lstruct1).eq.8) then
          do n=-nCC,nCC
           npos=8*abs(n)
           if(n.lt.0)npos=npos+4
           nn=iposlay(1)+npos
           satraceh=array_fr(nn+1)*thicklayer(1)
           app=array_fr(nn+2)*thicklayer(1)
           apm=array_fr(nn+3)*thicklayer(1)
           amp=array_fr(nn+4)*thicklayer(1)
           call expo_22(app,apm,amp,dd)
           satrexp=exp(satraceh*hci)
c          multiplication of the matrices exp(iR(mlay))*...*exp(iR(1))
c          laystr(rep,grp,rep,grp,.....)
c          dd Fortran mode   
           nn=(nCC+n)*4
           array_fr(ipos+nn+1)=dd(1)*satrexp
           array_fr(ipos+nn+4)=dd(2)*satrexp
           array_fr(ipos+nn+3)=dd(3)*satrexp
           array_fr(ipos+nn+2)=dd(4)*satrexp
          end do
c           if(abs(n).lt.5)write(6,'(a2,i3,i8,8f12.4)')
c     &                  '##',n,nn,array_fr(ipos+nn+1)

c          write(6,'(a,2i8)')'moss_strob ipos,ipos+8*nCC=',
c     &        ipos,ipos+8*nCC 
         else ! if non polarized
          
          do n=-nCC,0
           nn=iposlay(1)-2*n+1
c           if(abs(n).lt.5)write(6,'(a2,i3,i8,8f12.4)')
c     &                  '##',n,nn,array_fr(nn+1)
           satraceh=array_fr(nn+1)*thicklayer(1)
           carray(nCC+n+1)=exp(satraceh*hci)
          end do
          do n=1,nCC
           nn=iposlay(1)+2*n
           satraceh=array_fr(nn+1)*thicklayer(1)
           carray(nCC+n+1)=exp(satraceh*hci)
          end do
          do nn=0,2*nCC
           array_fr(ipos+nn+1)=carray(nn+1)
          end do
c          write(6,'(a,2i8)')'moss_strob ipos,ipos+2*nCC=',
c     &        ipos,ipos+2*nCC 

         end if  ! polarized
        else if(icase.eq.2) then
c        multilayer can only be caculated with the full polarization
c        matrix; only 2x2 matrix theories are connected to be called
          b_ew=.false.
         do n=-nCC,nCC
          npos=8*abs(n)
          if(n.lt.0)npos=npos+4

          nn=iposlay(1)+npos
          Cmatrix(1,1,1)= array_fr(nn+1)*thicklayer(1)
          Cmatrix(2,2,1)= array_fr(nn+2)*thicklayer(1)
          Cmatrix(1,2,1)= array_fr(nn+3)*thicklayer(1)
          Cmatrix(2,1,1)= array_fr(nn+4)*thicklayer(1)
 
          call optic(b_ew,mlay,b_sites,MAXGRP,GEOSTR,grazing,
     &                Cmatrix,chilay,roughlay,vkd,Rmatrix)

          nn=(nCC+n)*4
          carray(nn+1)=Rmatrix(1,1)
          carray(nn+3)=Rmatrix(1,2)
          carray(nn+2)=Rmatrix(2,1)
          carray(nn+4)=Rmatrix(2,2)
         end do 
         do nn=0,8*nCC,4
          array_fr(ipos+nn+1)=carray(nn+1)
          array_fr(ipos+nn+4)=carray(nn+2)
          array_fr(ipos+nn+3)=carray(nn+3)
          array_fr(ipos+nn+2)=carray(nn+4)
         end do
c           if(abs(n).lt.5)write(6,'(a2,i3,i8,8f12.4)')
c     &                  '##',n,nn,array_fr(ipos+nn+1)
        end if ! icase.eq.2

       else    ! mlay > 1

        if(icase.eq.1) then
c        different layers may polarized or non polarized.
c        if l1p(lstruct1)=2 then all layers are non polarized
c        the dd matrix of a non polarized scatterer is the unit matrix
c        (dd(1)=(1,0),dd(2)=(0,0),dd(3)=(0,0),dd(4)=(1,0))
         lav=0
         do lays=1,mlays
          lav=lav+l2p(lays)
         end do
         lav=lav/mlays
 
         if(l1p(lstruct1).eq.lav) then 
          if(l1p(lstruct1).eq.2)then
           do n=-nCC,nCC
            npos=2*abs(n)
            if(n.lt.0)npos=npos+1
            satraceh=cmplx(0.,0.)
            do lays=1,mlays
             nn=iposlay(lays)+npos
             satraceh=satraceh+array_fr(nn+1)*thicklayer(lays)
            end do   ! lays=1,mlays
            satrexp=exp(satraceh*hci)
c           multiplication of the matrices exp(iR(mlay))*...*exp(iR(1))
c           laystr(rep,grp,rep,grp,.....)
            nn=(nCC+n)
            array_fr(ipos+nn+1)=satrexp
           end do
          else if(l1p(lstruct1).eq.8) then
           do n=-nCC,nCC
            npos=8*abs(n)
            if(n.lt.0)npos=npos+4
    
            satraceh=cmplx(0.,0.)
            do lays=1,mlays
             nn=iposlay(lays)+npos
             satraceh=satraceh+array_fr(nn+1)*thicklayer(lays)
             app=array_fr(nn+2)*thicklayer(lays)
             apm=array_fr(nn+3)*thicklayer(lays)
             amp=array_fr(nn+4)*thicklayer(lays)
             call expo_22(app,apm,amp,dd)
             do k=1,4
              aam(k,lays)=dd(k)
              end do
            end do   ! lays=1,mlays
            satrexp=exp(satraceh*hci)
c           multiplication of the matrices exp(iR(mlay))*...*exp(iR(1))
c           laystr(rep,grp,rep,grp,.....)
   
            if(mlays.gt.1) then
             do k=1,4
              dd(k)=aam(k,mlays)
             end do
   
             do lays=mlays-1,1,-1
              do k=1,4
               aa(k)=dd(k)
               bb(k)=aam(k,lays)
              end do
              call matprof(aa,bb,dd)
             end do
            end if
   
            nn=(nCC+n)*4
            array_fr(ipos+nn+1)=dd(1)*satrexp
            array_fr(ipos+nn+4)=dd(2)*satrexp
            array_fr(ipos+nn+3)=dd(3)*satrexp
            array_fr(ipos+nn+2)=dd(4)*satrexp
           end do
          end if ! l1p(lstruct1)=l .eq.8
         else     ! if l1p(lstruct1).ne.l
c         at least one of l2p(lays) is equal 2 
          do n=-nCC,nCC
   
           satraceh=cmplx(0.,0.)
           do lays=1,mlays
            npos=l2p(lays)*abs(n)
            if(n.lt.0)npos=npos+l2p(lays)/2
            nn=iposlay(lays)+npos
            satraceh=satraceh+array_fr(nn+1)*thicklayer(lays)
            if(l2p(lays).eq.8) then
             app=array_fr(nn+2)*thicklayer(lays)
             apm=array_fr(nn+3)*thicklayer(lays)
             amp=array_fr(nn+4)*thicklayer(lays)
             call expo_22(app,apm,amp,dd)
             do k=1,4
              aam(k,lays)=dd(k)
             end do
            else
             dd(1)=(1.0,0.0)
             dd(2)=(0.0,0.0)
             dd(3)=(0.0,0.0)
             dd(4)=(1.0,0.0)
            end if
           end do   ! lays=1,mlays
           satrexp=exp(satraceh*hci)
c          multiplication of the matrices exp(iR(mlay))*...*exp(iR(1))
c          laystr(rep,grp,rep,grp,.....)
  
           if(mlays.gt.1) then
            do k=1,4
             dd(k)=aam(k,mlays)
            end do
   
            do lays=mlays-1,1,-1
             do k=1,4
              aa(k)=dd(k)
              bb(k)=aam(k,lays)
             end do
             call matprof(aa,bb,dd)
            end do
           end if
   
           nn=(nCC+n)*4
           array_fr(ipos+nn+1)=dd(1)*satrexp
           array_fr(ipos+nn+4)=dd(2)*satrexp
           array_fr(ipos+nn+3)=dd(3)*satrexp
           array_fr(ipos+nn+2)=dd(4)*satrexp
          end do
         end if  ! l1p(lstruct1)#l=8
        else if(icase.eq.2) then
  
         do n=-nCC,nCC
          npos=8*abs(n)
          if(n.lt.0)npos=npos+4
   
           do lay=1,mlay
           if(b_sites(lay)) then
            nn=iposlay(lay)+npos
            Cmatrix(1,1,lay)= array_fr(nn+1)*thicklayer(lay)
            Cmatrix(2,2,lay)= array_fr(nn+2)*thicklayer(lay)
            Cmatrix(1,2,lay)= array_fr(nn+3)*thicklayer(lay)
            Cmatrix(2,1,lay)= array_fr(nn+4)*thicklayer(lay)
c            if(abs(n).lt.2)write(6,'(2x,i8,2x,8g13.6)')lay,
c     &               Cmatrix(1,1,lay),Cmatrix(1,1,lay),thicklayer(lay)
           end if
          end do   ! lay=1,mlay

          b_ew=.false.

          call optic(b_ew,mlay,b_sites,MAXGRP,GEOSTR,grazing,
     &                Cmatrix,chilay,roughlay,vkd,Rmatrix)

          nn=(nCC+n)*4
          array_fr(ipos+nn+1)=Rmatrix(1,1)
          array_fr(ipos+nn+3)=Rmatrix(1,2)
          array_fr(ipos+nn+4)=Rmatrix(2,1)
          array_fr(ipos+nn+2)=Rmatrix(2,2)
c          if(abs(n).lt.5)
c     &      write(6,'(2x,i8,2x,8g13.6)')nn,Rmatrix
         end do 

        end if ! icase.eq.2
       end if  ! mlay.eq.1



 2000 continue
c      write(6,'(a,2i6)')'synmos lstruct1,mstruct1=',lstruct1,mstruct1
      if(mstruct1.ge.2) goto 1000
   
c     address of reference absorber
c     ipos_mstruct1(1)+n, n=1,...,4*(2*nCC+1)

 2500 continue
      if(.not.b_total) return

      j_s=8/nsampling
      n_vm=nTH*j_s
      n_er=ak8/8*j_s          
c      write(6,'(a,8i6)')' l1_put(1),l1_put(2),nCC,n_er,n_vm,nomega=',
c     &  l1_put(1),l1_put(2),nCC,n_er,n_vm,nomega

      do n_s=0,nstrob_order
        swin=array_fr(l1_get(0)+1+abs(n_s))
c        write(6,'(i5,2x,2f10.3)')n_s,swin
      end do

      R_oo=array_fr(nstorTH1+icase)
c      write(6,'(a,2f10.3)')'moss_strob R_oo=',R_oo      
c       write(6,'(a,L4)')'moss_strob  b_reference=',b_reference      
c      write(6,'(a,5i8)')'moss_strob l1_pos(1..=',l1_pos(1),l1_pos(2)      
c       write(6,'(a,5i8)')'moss_strob l1p(1,2),icase=',l1p(1),l1p(2),icase     
c      write(6,'(a,5i8)')'moss_strob nstrob_order,n_vm,j_s,nCC,nomega=',
c     &                             nstrob_order,n_vm,j_s,nCC,nomega 
     

      eta=1./6.
      if(b_reference) then
       if(icase.eq.2) then
      
        if(l1p(1).eq.2) then
         do n_v=-n_vm,n_vm,j_s
          k=n_v/j_s
          h0=0.
          hp=0.
          hm=0.
          hc=(0.,0.)
          do n_s=0,nstrob_order
           swin=array_fr(l1_get(0)+1+abs(n_s))
           if(n_s.eq.0) swin=swin/2. 
           swinp=swin*exp(-hci*2.*pi*n_s*eta)
           swinm=swin*exp(hci*2.*pi*n_s*eta)
           h1=real(conjg(swin)*swin)
           if(h1.gt.1.e-3)then
c           integration of Int;(-n_ch,n_ch)       
c           n_ch=n_er+n_vm+n_s*nomega/2
           
            j1=l1_pos(1)+(nCC+n_v+n_s*nomega/2) 
            j3=l1_pos(1)+(nCC+n_v-n_s*nomega/2) 
     
            n_ch=n_er+n_vm+n_s*nomega/2

            do i=-n_ch,n_ch
             aa(1)=array_fr(j1+i+1)*R_oo-R_oo
             cc(1)=conjg(R_oo*array_fr(j3+i+1)-R_oo) 
             trace(i)=cc(1)*aa(1)
            end do  ! nch
            hcc=hc0
            do i=-n_ch+1,n_ch-1,2
             hcc=hcc+trace(i)*2.
            end do
            do i=-n_ch+2,n_ch-2,2
             hcc=hcc+trace(i)
            end do
            hcc=(hcc*2.0+trace(-n_ch)+trace(n_ch))/3.0

            h0=h0+real(hcc*swin)*2.
            hp=hp+real(hcc*swinp)*2.
            hm=hm+real(hcc*swinm)*2.
           end if   ! abs(swin) >0.001
          end do 

          if(b_frcn) then
           yth0(k)=h0
          else if(b_frcr) then
           yth0(k)=0.5*(hp+hm)-h0
          else if(b_frci) then
           yth0(k)=0.5*(hp-hm)
          end if
         end do
         j1=nstorTH+(nTH+1)+1
c         write(6,'(a,2i8)') 'nstorTH,nTH=',nstorTH,nTH
         do i=0,nTH
          array_fr(j1+i)=cmplx(yth0(i),yth0(-i))
         end do
        else if(l1p(1).eq.8) then

         do n_v=-n_vm,n_vm,j_s
          k=n_v/j_s
          h0=0.
          hp=0.
          hm=0.
          do n_s=0,nstrob_order
           swin=array_fr(l1_get(0)+1+abs(n_s))
           if(n_s.eq.0) swin=swin/2. 
           swinp=swin*exp(-hci*2.*pi*n_s*eta)
           swinm=swin*exp(hci*2.*pi*n_s*eta)
            h1=real(conjg(swin)*swin)
            if(h1.gt.1.e-3)then
      
            j1=l1_pos(1)+4*(nCC+n_v+n_s*nomega/2) 
            j3=l1_pos(1)+4*(nCC+n_v-n_s*nomega/2) 
      
            n_ch=n_er+n_vm+n_s*nomega/2
            hcc=hc0
            do i=-n_ch,n_ch
             i4=4*i
             j=j1+i4
   
             aa(1)=array_fr(j+1)*R_oo-R_oo     
             aa(2)=array_fr(j+4)*R_oo       
             aa(3)=array_fr(j+3)*R_oo       
             aa(4)=array_fr(j+2)*R_oo-R_oo       
       
             j=j3+i4
             cc(1)=conjg(R_oo*array_fr(j+1)-R_oo)     
             cc(2)=conjg(R_oo*array_fr(j+3))      
             cc(3)=conjg(R_oo*array_fr(j+4))      
             cc(4)=conjg(R_oo*array_fr(j+2)-R_oo)      
     
             call matprof(cc,aa,bb)
             call matprof(bb,rho,aa)
             hcc=hcc+aa(1)+aa(4)
            end do  ! nch
            h0=h0+real(hcc*swin)*2.
            hp=hp+real(hcc*swinp)*2.
            hm=hm+real(hcc*swinm)*2.
           end if   ! abs(swin) >0.001
          end do
          if(b_frcn) then
           yth0(k)=h0
          else if(b_frcr) then
           yth0(k)=0.5*(hp+hm)-h0
          else if(b_frci) then
           yth0(k)=0.5*(hp-hm)
          end if
         end do
         j1=nstorTH+(nTH+1)+1
         do i=0,nTH
          array_fr(j1+i)=cmplx(yth0(i),yth0(-i))
         end do
        end if
       else if(icase.eq.1) then
        if(l1p(1).eq.2) then
c        both unpolarized
         do n_v=-n_vm,n_vm,j_s
          k=n_v/j_s
          hc=hc0
          hcp=hc0
          hcm=hc0
          do n_s=0,nstrob_order
           swin=array_fr(l1_get(0)+1+abs(n_s))
           if(n_s.eq.0) swin=swin/2. 
           swinp=swin*exp(-hci*2.*pi*n_s*eta)
           swinm=swin*exp(hci*2.*pi*n_s*eta)
           h1=real(conjg(swin)*swin)
           if(h1.gt.1.e-3)then
c           integration of Int;(-n_ch,n_ch)       
c           n_ch=n_er+n_vm+n_s*nomega/2
           
            j1=l1_pos(1)+(nCC+n_v+n_s*nomega/2) 
            j3=l1_pos(1)+(nCC+n_v-n_s*nomega/2) 

            n_ch=n_er+n_vm+n_s*nomega/2
            hcc=hc0
            do i=-n_ch,n_ch
             aa(1)=array_fr(j1+i+1)-R_oo
             cc(1)=conjg(array_fr(j3+i+1)-R_oo)
             hcc=hcc+cc(1)*aa(1)
            end do  ! nch
            h0=h0+real(hcc*swin)*2.
            hp=hp+real(hcc*swinp)*2.
            hm=hm+real(hcc*swinm)*2.
           end if   ! abs(swin) >0.001
          end do   ! n_s
          if(b_frcn) then
           yth0(k)=h0
          else if(b_frcr) then
           yth0(k)=0.5*(hp+hm)-h0
          else if(b_frci) then
           yth0(k)=0.5*(hp-hm)
          end if
         end do
         j1=nstorTH+(nTH+1)+1
         do i=0,nTH
          array_fr(j1+i)=cmplx(yth0(i),yth0(-i))
         end do
        else if(l1p(1).eq.8) then
         j1=l1_pos(1)+1
         j2=l1_pos(2)+1
   
         do n_v=-n_vm,n_vm,j_s
          k=n_v/j_s
          hc=hc0
          hcp=hc0
          hcm=hc0
          do n_s=0,nstrob_order
           swin=array_fr(l1_get(0)+1+abs(n_s))
           if(n_s.eq.0) swin=swin/2.
           swinp=swin*exp(-hci*2.*pi*n_s*eta)
           swinm=swin*exp(hci*2.*pi*n_s*eta)
           h1=real(conjg(swin)*swin)
           if(h1.gt.1.e-3)then
   
            j1=l1_pos(1)+4*(nCC+n_v+n_s*nomega/2) 
            j3=l1_pos(1)+4*(nCC+n_v-n_s*nomega/2) 
            n_ch=n_er+n_vm+n_s*nomega/2
            hcc=hc0
            do i=-n_ch,n_ch
             i4=4*i
             j=j1+i4
             aa(1)=array_fr(j+1)-(1.0,0.0)*R_oo    
             aa(2)=array_fr(j+4)-(1.0,0.0)*R_oo 
             aa(3)=array_fr(j+3)-(1.0,0.0)*R_oo 
             aa(4)=array_fr(j+2)-(1.0,0.0)*R_oo 
    
             j=j3+i4
             cc(1)=conjg(R_oo*(array_fr(j+1)-(1.0,0.0)))     
             cc(2)=conjg(R_oo*(array_fr(j+3)-(1.0,0.0)))
             cc(3)=conjg(R_oo*(array_fr(j+4)-(1.0,0.0)))
             cc(4)=conjg(R_oo*(array_fr(j+2)-(1.0,0.0)))
     
             call matprof(cc,aa,bb)
             trace(i)=bb(1)*rho(1)+bb(3)*rho(2)+bb(2)*rho(3)+
     &                                          bb(4)*rho(4)
            end do  ! nch
            hcc=hc0
            do i=-n_ch+1,n_ch-1,2
             hcc=hcc+trace(i)*2.
            end do
            do i=-n_ch+2,n_ch-2,2
             hcc=hcc+trace(i)
            end do
            hcc=(hcc*2.0+trace(-n_ch)+trace(n_ch))/3.0
            h0=h0+real(hcc*swin)*2.
            hp=hp+real(hcc*swinp)*2.
            hm=hm+real(hcc*swinm)*2.
           end if   ! abs(swin) >0.001
          end do   ! n_s
          if(b_frcn) then
           yth0(k)=h0
          else if(b_frcr) then
           yth0(k)=0.5*(hp+hm)-h0
          else if(b_frci) then
           yth0(k)=0.5*(hp-hm)
          end if
         end do
         j1=nstorTH+(nTH+1)+1
         do i=0,nTH
          array_fr(j1+i)=cmplx(yth0(i),yth0(-i))
         end do
        end if    ! l1p(1).eq.8 
       end if     ! icase=1
      else
       j1=nstorTH+(nTH+1)+1
       do i=0,nTH
        yth0(i)=real(array_fr(j1+i))
        yth0(-i)=aimag(array_fr(j1+i))
       end do
      end if    ! b-reference
           
      if(l1p(1)+l1p(2).eq.16) then
c       write(6,'(a)') ' l1p(1)+l1p(2).eq.16'
       do n_v=-n_vm,n_vm,j_s
        k=n_v/j_s
        hc=hc0
        hcp=hc0
        hcm=hc0
        do n_s=-nstrob_order,nstrob_order
         swin=array_fr(l1_get(0)+1+abs(n_s))
         if(n_s.lt.0) swin=conjg(swin)
         swinp=swin*exp(-hci*2.*pi*n_s*eta)
         swinm=swin*exp(hci*2.*pi*n_s*eta)
         h1=real(conjg(swin)*swin)
         if(h1.gt.1.e-3)then
c         write(6,'(I4,2F12.5)')n_s,abs(swin)
c         integration of Int;(-n_ch,n_ch)       
c          n_ch=n_er+n_vm+n_s*nomega/2
          
          j1=l1_pos(1)+4*(nCC+n_v+n_s*nomega/2) 
          j2=l1_pos(2)+4*(nCC+n_s*nomega/2) 
    
          j3=l1_pos(1)+4*(nCC+n_v-n_s*nomega/2) 
          j4=l1_pos(2)+4*(nCC-n_s*nomega/2) 
    
          n_ch=n_er+n_vm+n_s*nomega/2
          do i=-n_ch,n_ch
           i4=4*i
           j=j1+i4
           bb(1)=array_fr(j+1)     
           bb(2)=array_fr(j+4)      
           bb(3)=array_fr(j+3)      
           bb(4)=array_fr(j+2)      
           j=j2+i4
           dd(1)=array_fr(j+1)      
           dd(2)=array_fr(j+4)      
           dd(3)=array_fr(j+3)      
           dd(4)=array_fr(j+2)      
    
           call matprof(bb,dd,aa)
           aa(1)=aa(1)-R_oo
           aa(4)=aa(4)-R_oo
     
           j=j3+i4
           bb(1)=conjg(array_fr(j+1))     
           bb(2)=conjg(array_fr(j+3))      
           bb(3)=conjg(array_fr(j+4))      
           bb(4)=conjg(array_fr(j+2))      
     
           j=j4+i4
           dd(1)=conjg(array_fr(j+1))      
           dd(2)=conjg(array_fr(j+3))      
           dd(3)=conjg(array_fr(j+4))      
           dd(4)=conjg(array_fr(j+2))      
     
           call matprof(dd,bb,cc)
           cc(1)=cc(1)-conjg(R_oo)
           cc(4)=cc(4)-conjg(R_oo)
           call matprof(cc,aa,bb)
           trace(i)=bb(1)*rho(1)+bb(3)*rho(2)+bb(2)*rho(3)+bb(4)*rho(4)
          end do  ! nch
          hcc=hc0
          do i=-n_ch+1,n_ch-1,2
           hcc=hcc+trace(i)*2.
          end do
          do i=-n_ch+2,n_ch-2,2
           hcc=hcc+trace(i)
          end do
          hcc=(hcc*2.0+trace(-n_ch)+trace(n_ch))/3.0
          hc=hc+hcc*swin
          hcp=hcp+hcc*swinp
          hcm=hcm+hcc*swinm
         end if   ! abs(swin) >0.001
        end do   ! n_s
        if(b_frcn) then
         yth(k)=real(hc)
        else if(b_frcr) then
         yth(k)=real(0.5*(hcp+hcm)-hc)
        else if(b_frci) then
         yth(k)=real(0.5*(hcp-hcm))
        end if
       end do
  
      else if(l1p(1)+l1p(2).eq.4) then
c         write(6,'(a)') 'l1p(1)+l1p(2).eq.4'
  
c      both unpolarized
       do n_v=-n_vm,n_vm,j_s
        k=n_v/j_s
        hc=hc0
        hcp=hc0
        hcm=hc0
        do n_s=-nstrob_order,nstrob_order
         swin=array_fr(l1_get(0)+1+abs(n_s))
         if(n_s.lt.0) swin=conjg(swin)
         swinp=swin*exp(-hci*2.*pi*n_s*eta)
         swinm=swin*exp(hci*2.*pi*n_s*eta)
         h1=real(conjg(swin)*swin)
         if(h1.gt.1.e-3)then
c         write(6,'(I4,2F12.5)')n_s,abs(swin)
c         integration of Int;(-n_ch,n_ch)       
c          n_ch=n_er+n_vm+n_s*nomega/2
          
          j1=l1_pos(1)+(nCC+n_v+n_s*nomega/2) 
          j2=l1_pos(2)+(nCC+n_s*nomega/2) 
   
          j3=l1_pos(1)+(nCC+n_v-n_s*nomega/2) 
          j4=l1_pos(2)+(nCC-n_s*nomega/2) 
    
          n_ch=n_er+n_vm+n_s*nomega/2
          hcc=hc0
          do i=-n_ch,n_ch
           j=j1+i
           bb(1)=array_fr(j+1)     
           j=j2+i
           dd(1)=array_fr(j+1)      
           aa(1)=bb(1)*dd(1)-R_oo
           j=j3+i
           bb(1)=conjg(array_fr(j+1))     
           j=j4+i
           dd(1)=conjg(array_fr(j+1))      
           cc(1)=dd(1)*bb(1)-conjg(R_oo)
           hcc=hcc+cc(1)*aa(1)
          end do  ! nch
          hc=hc+hcc*swin
          hcp=hcp+hcc*swinp
          hcm=hcm+hcc*swinm
         end if   ! abs(swin) >0.001
        end do   ! n_s
        if(b_frcn) then
         yth(k)=real(hc)
        else if(b_frcr) then
         yth(k)=real(0.5*(hcp+hcm)-hc)
        else if(b_frci) then
         yth(k)=real(0.5*(hcp-hcm))
        end if
       end do

      else if(l1p(1)+l1p(2).eq.10) then
c       write(6,'(a)') 'l1p(1)+l1p(2).eq.10'

       j1=l1_pos(1)+1
       j2=l1_pos(2)+1
    
       do n_v=-n_vm,n_vm,j_s
        k=n_v/j_s
        hc=hc0
        hcp=hc0
        hcm=hc0        
        do n_s=-nstrob_order,nstrob_order

         swin=array_fr(l1_get(0)+1+abs(n_s))
         if(n_s.lt.0) swin=conjg(swin)
         swinp=swin*exp(-hci*2.*pi*n_s*eta)
         swinm=swin*exp(hci*2.*pi*n_s*eta)
         h1=real(conjg(swin)*swin)
         if(h1.gt.1.e-3)then
          n_ch=n_er+n_vm+n_s*nomega/2

          hcc=hc0
          if(l1p(1).eq.2)then    
           j1=l1_pos(1)+(nCC+n_v+n_s*nomega/2) 
           j2=l1_pos(2)+4*(nCC+n_s*nomega/2) 
           j3=l1_pos(1)+(nCC+n_v-n_s*nomega/2) 
           j4=l1_pos(2)+4*(nCC-n_s*nomega/2) 
           do i=-n_ch,n_ch
            i4=4*i
            j=j2+i4
            ji=j1+i+1
            aa(1)=array_fr(j+1)*array_fr(ji)-R_oo       
            aa(2)=array_fr(j+4)*array_fr(ji)       
            aa(3)=array_fr(j+3)*array_fr(ji)       
            aa(4)=array_fr(j+2)*array_fr(ji)-R_oo       

            j=j4+i4
            ji=j3+i+1
            cc(1)=conjg(array_fr(j+1)*array_fr(ji)-R_oo)     
            cc(2)=conjg(array_fr(j+3)*array_fr(ji))     
            cc(3)=conjg(array_fr(j+4)*array_fr(ji))     
            cc(4)=conjg(array_fr(j+2)*array_fr(ji)-R_oo)     

            call matprof(cc,aa,bb)
            trace(i)=bb(1)*rho(1)+bb(3)*rho(2)+bb(2)*rho(3)+bb(4)*rho(4)
           end do  ! nch
          else
           j1=l1_pos(1)+4*(nCC+n_v+n_s*nomega/2) 
           j2=l1_pos(2)+(nCC+n_s*nomega/2) 
           j3=l1_pos(1)+4*(nCC+n_v-n_s*nomega/2) 
           j4=l1_pos(2)+(nCC-n_s*nomega/2) 
           do i=-n_ch,n_ch
            i4=4*i
            j =j1+i4
            ji=j2+i+1
            aa(1)=array_fr(j+1)*array_fr(ji)-R_oo     
            aa(2)=array_fr(j+4)*array_fr(ji)      
            aa(3)=array_fr(j+3)*array_fr(ji)      
            aa(4)=array_fr(j+2)*array_fr(ji)-R_oo      
    
            j =j3+i4
            ji=j4+i+1
            cc(1)=conjg(array_fr(ji)*array_fr(j+1)-R_oo)     
            cc(2)=conjg(array_fr(ji)*array_fr(j+3))      
            cc(3)=conjg(array_fr(ji)*array_fr(j+4))      
            cc(4)=conjg(array_fr(ji)*array_fr(j+2)-R_oo)      
     
            call matprof(cc,aa,bb)
            trace(i)=bb(1)*rho(1)+bb(3)*rho(2)+bb(2)*rho(3)+bb(4)*rho(4)
           end do  ! nch
          end if
          hcc=hc0
          do i=-n_ch+1,n_ch-1,2
           hcc=hcc+trace(i)*2.
          end do
          do i=-n_ch+2,n_ch-2,2
           hcc=hcc+trace(i)
          end do
          hcc=(hcc*2.0+trace(-n_ch)+trace(n_ch))/3.0
          hc=hc+hcc*swin
          hcp=hcp+hcc*swinp
          hcm=hcm+hcc*swinm
         end if   ! abs(swin) >0.001
        end do   ! n_s

        if(b_frcn) then
         yth(k)=real(hc)
        else if(b_frcr) then
         yth(k)=real(0.5*(hcp+hcm)-hc)
        else if(b_frci) then
         yth(k)=real(0.5*(hcp-hcm))
        end if
       end do
      end if
      call cpu_time(finish)
      if(enwr(16).eq.'time')
     &    print '(" runtime = ",f15.3," seconds.")',finish-start

 
c        open(unit=8,file='ch8.dat'
c     &            ,status='unknown'
c     &            ,access='sequential'
c     &            ,form='formatted')
c        do j=-nTH,nTH
c         write(8,'(i8,2f15.5)')j,yth(j),yth0(j)
c        end do
c        close(unit=8)
   
      h1=0.
      do j=-nTH+1,nTH-1,2
       h1=h1+(yth(j)-yth0(j))*4
      end do
      do j=-nTH+2,nTH-2,2
       h1=h1+(yth(j)-yth0(j))*2
      end do
      h1=h1+yth(-nTH)+yth(nTH)-yth0(-nTH)-yth0(nTH)
      h1=h1/3./(2*nTH+1)
   
      j1=nstorTH+1
c      if(icase.eq.1) then
c      do i=0,nTH
c       array_fr(j1+i)=cmplx(yth(i)-yth0(i)*h1,yth(-i)-yth0(-i)*h1)
c      end do
c      else
       do i=0,nTH
        array_fr(j1+i)=cmplx(yth(i)/(yth0(i)+h1),
     &                       yth(-i)/(yth0(-i)+h1))
c      array_fr(j1+i)=cmplx(yth(i),yth(-i))*100
       end do
c      end if 

c      j1=nstorTH+1
c      write(6,'(i3,i7,2f15.5)')(i,j1+i,array_fr(j1+i),i=0,n_vm/j_s,16)
c        write(6,'(a,8f8.2)') ' rho=', (rho(k),k=1,2)
c        write(6,'(a,8f8.2)') '    =', (rho(k),k=3,4)
            
      return
      end
     
