c     H. Spiering January,1999 Mainz
c     Jg Je arbitrary spin
c     synchrotron source
c     5.06.05
      subroutine synrocking(b_total,info)
      implicit none
      include 'comglb.for'
      include 'comthe.for'

      logical     b_total
      integer     info,ifrth,iaddr,idex,mstruct1,istruct1,istruct2,
     &            l1_get,l2_get,l3_get,l1_put,l2_put,l3_put,
     &            nstorTH,nstorTH1,nstorTHyy,nstorSI,nTH1,nCP,nCC,nsrw,
     &            iflag_basis,l_trans,nLG,nTH,ith_channels,nsampling,
     &            ak8,nomega,nstrob_order,jt0_ch,iT_max,nvch,
     &            nhyperfine
      real        srw8
      character*4 c1_prp,c2_prp,c3_prp,frthname*64
      common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),     !13.9.05 
     &              l1_get(0:maxfr1),l2_get(maxfr2),l3_get(maxthss),
     &              l1_put(0:maxfr1),l2_put(maxfr2),l3_put(maxthss),
     &              c1_prp(0:maxfr1),c2_prp(maxfr2),c3_prp(maxthss),
     &              frthname(2),nstorTH,nstorTH1,nstorTHyy,nstorSI,
     &              iaddr(4),nTH1,nCP,nCC,nsrw,ifrth(4),                   
     &              iflag_basis,l_trans,nLG,nTH,ith_channels,nsampling,
     &              ak8,nomega,srw8,nstrob_order,jt0_ch,iT_max,nvch,
     &              nhyperfine,idex(2)

      real          acsp,wavelength,uthick_A,
     &              unitchi,dum6,
     &              ch_angle,graz_beg,graz_end,dumcsp
      common/acstrf/acsp,wavelength,uthick_A,
     &              unitchi,dum6(6),ch_angle,graz_beg,graz_end,
     &              dumcsp(icstrf-8)

      real          avs,counts,background,Pxsi,Peta,Pzeta,
     &              ang_shift,graz_min,phi_z,detekt_eff,
     &              counts_bunch,dumvsp
      common/avstrf/avs,counts,background,Pxsi,Peta,Pzeta,
     &              ang_shift,graz_min,phi_z,detekt_eff,
     &              counts_bunch,dumvsp(ivstrf-12)

      logical       b_vs,b_counts,b_background,b_Pxsi,b_Peta,b_Pzeta,
     &              b_ang_shift,b_graz_min,b_phi_z,
     &              b_detekt_eff,b_counts_bunch,b_dumvsp
      common/bvstrf/b_vs,b_counts,b_background,b_Pxsi,b_Peta,b_Pzeta,
     &              b_ang_shift,b_graz_min,b_phi_z,
     &              b_detekt_eff,b_counts_bunch,b_dumvsp(ivstrf-11)
 
      real            avfr1,pvfr1,dum1,phiA,thetaA,dvfr1
      common/avfr1trf/avfr1,pvfr1,dum1(3),phiA,thetaA,dvfr1(ivfr1trf-7)
      logical         b_avfr1,b_pvfr1,b_dum1,b_vfr1
      common/bvfr1trf/b_avfr1,b_pvfr1,b_dum1(3),b_vfr1(ivfr1trf-5)

      real            acfr2,rep_grp,dumcfr2
      common/acfr2trf/acfr2,rep_grp,dumcfr2(icfr2trf-2)

      real            avfr2,thicklay,re_chilay,ai_chilay,roughness,
     &                dumvfr2
      common/avfr2trf/avfr2,thicklay,re_chilay,ai_chilay,roughness,
     &                dumvfr2(ivfr2trf-5)
      logical         b_vfr2,b_thicklay,b_re_chilay,b_ai_chilay,
     &                b_roughness,b_dumvfr2
      common/bvfr2trf/b_vfr2,b_thicklay,b_re_chilay,b_ai_chilay,
     &                b_roughness,b_dumvfr2(ivfr2trf-5)

      real            vsstrf,sftr
      common/avsstrf/ vsstrf(ivsstrf)
      logical         b_vsstrf
      common/bvsstrf/ b_vsstrf(ivsstrf)

      logical  b_chilay,b_lay,b_absorber,
     &         b_isgt1,b_sites,b_chilaynz

      real      winc,wi,vkd
      dimension winc(maxfr1),wi(maxthss),vkd(maxfr2),
     &          b_sites(maxfr2),
     &          b_chilay(maxfr2),b_chilaynz(maxfr2)

      integer lstruct1,lstruct2,lstruct3,nt,isubthe,
     &        iset,is_a,is_e,inc_pos,iss,
     &        i,i4,jj,j,j1,j3,n,nn,n_s,k,ll,nb_ch,ne_ch,
     &        lay,mlay,nch_angle,nchan,nyout,nst16,
     &        ipos_mstruct1,iposlay,npos,mlays,laysites,laystr,chT0

      real    pi,rad,grazing,rd_theta,vector_k,h1,h2,
     &        sing,h,sum,thicklayer,roughlay

      dimension thicklayer(maxfr2),roughlay(maxfr2),
     &          ipos_mstruct1(maxfr1),iposlay(maxfr2),
     &          laystr(2*maxfr2+2),laysites(maxfr2)

      complex hc,hc1,hcc,hci,hc0,swin,
     &        aa(4),bb(4),cc(4),dd(4),rho(4),R_oo,
     &        Cmatrix(2,2,maxfr2),chilay(maxfr2),
     &        Rmatrix(2,2)


      integer   mAL,mFF,ichall,ichstr,iall,neg,isamp,
     &          ij,mcht,icht,ii,ka,k0,k1,k2,idumscrd
      real      yth,chrock,fn,qn,dn,grazmin,dumi,dumscrd,trc,
     &          ap0,ap1,ap2,bp0,bp1,bp2,cp0,cp1,cp2,dx1,dx2,dx3,hhoff,
     &          ap,bp,cp,det,x0,x1,x2,hh,hhstr,swinr,swini,start,finish
      complex   carray,POC,pocfi,trace

      parameter (mAL=8*(2*maxn+1),mFF=16*maxn,
     &           idumscrd=maxscrd-4-12*maxn-2*mAL-2*mFF-3*32-12*96-
     &           -9-18*maxn-4*maxn)
      common/scrd/ichall(0:maxn*2),ichstr(0:maxn),
     &            carray(mAL),POC(mFF),dumi(0:4*maxn),
     &            yth(0:4*maxn),chrock(maxn),fn(0:31),dn(0:31),qn(0:31),
     &            ap0(0:95),ap1(0:95),ap2(0:95),
     &            bp0(0:95),bp1(0:95),bp2(0:95),
     &            cp0(0:95),cp1(0:95),cp2(0:95),
     &            dx1(0:95),dx2(0:95),dx3(0:95),
     &            pocfi(4,-maxn:maxn),trc(-maxn:maxn),
     &            trace(1:2*maxn),dumscrd(idumscrd)

      logical b_bunchinf,b_ew,b_fo
C **** Definitions of structure variables L. Deak 09.10.2002 ***
      integer POINTER,GRP,MAXGRP,GEOSTR(0:2*maxfr2)
      logical b_first
C ****                                                       ***     
      b_bunchinf=.false.
      b_ew=.false.
c      write(6,'(a,L5,2g12.4)')'b_counts_bunch,counts_bunch=',
c     &                           b_counts_bunch,counts_bunch
c      write(6,'(a,3L5,2g12.4)')' b_vs,b_counts,b_graz_min=',
c     &                    b_vs,b_counts,b_graz_min,counts,graz_min
c------------------------------------------------------------------
c-------------------------------------------------------------------

      call cpu_time(start)

      call mapsub(0)
      b_absorber=b_vs
      b_total=b_vs

c     calculation of non equidistant energy points
       call channels_adjust(nvch,nhyperfine,nstrob_order,nomega,
     &                          iall)

c      the routine calculates channels needed for a nonequidistant
c      channel numbers for all later shifts +- nomega in the stoboscopic 
c      integration
c----------------------------------------------------------------------
c       nvch=0 
c       iall=nTH
c       do i=0,iall
c        ichall(i)=i
c       end do
c       ichall(nTH+1)=-1
c       write(6,'(a,i5)') ' th_synrock nTH=',nTH
c----------------------------------------------------------------------

      isubthe=1
      call get_theory(isubthe,info)
      b_total= b_total.or.(isubthe.gt.0) 
      hc1=cmplx(1.,0.)
      hci=cmplx(0.,1.)
      hc0=cmplx(0.,0.)

c     write(6,'(a,2i4)')' th_synrock ifrcase=',ifrcase 

c     thfrcase(1)='time differential transmission spectrum(11)   v=100'
c     thfrcase(2)='time differential reflection spectrum(21)     v=100'
c     thfrcase(3)='time integral - rocking curve-Fourier(22)     v=100'
c     thfrcase(4)='time integral - rocking curve(24)        v=100'
c     thfrcase(5)='time integral - rocking curve_fi(25)        v=100'
c     thfrcase(6)='prompt - rocking curve(23)     v=100'
c     thfrcase(7)='time integral - offspecular(31)          v=001'

      if(ifrcase.eq.24.or.ifrcase.eq.25) then
       do n_s=0,nstrob_order
        swin=array_fr(l1_get(0)+1+abs(n_s))

c        write(6,'(i5,2x,2f10.3)')n_s,swin
       end do
      end if

c-------------------------------------------------------------------

c     write(6,'(3(a,e8.2))')
c    &    ' synmos-- Pxsi=',Pxsi,' Peta=',Peta,' Pzeta=',Pzeta

       pi=atan(1.)*4.
       rad=pi/180.
c      transformation matrix from spherical basis to (sigma,pi)-basis

      vector_k=2.0*pi/wavelength    ! /Angstroem
      grazmin=graz_min*0.001
c---------------------------------------------------------------------------
c     transformation matrix from spherical basis to (sigma,pi)-basis
c     orientation of the absorber with respect to the beam

        rho(1)=cmplx(1.+Pzeta,0.)/2.
        rho(3)=cmplx(Pxsi,-Peta)/2.
        rho(2)=cmplx(Pxsi,Peta)/2.
        rho(4)=cmplx(1.-Pzeta,0.)/2.
c       write(6,'(a,8f8.2)') ' rho=', (rho(k),k=1,4)
c       (1 3)     fortran definition
c       (2 4)

      lstruct1=0
      iss=1
 1000 continue
       if(ifrcase.eq.23) b_absorber=
     &                 b_absorber.or.b_detekt_eff.or.b_counts_bunch

      lstruct1=lstruct1+1
      if(lstruct1.gt.mstruct1) goto 2500
      inc_pos=l1_put(lstruct1)
      ipos_mstruct1(lstruct1)=inc_pos

c       write(6,'(a,i1,a2,i8)')
c     &         'synmos l1_put(',lstruct1,')=',l1_put(lstruct1)  

       call mapsub(iss)

c      b_fo change of external field and scatterer orientation
       b_fo=b_phi_z
       do i=1,3
        b_fo=b_fo.or.b_dum1(i)
       end do

       winc(lstruct1)=pvfr1
       b_total=b_total.or.b_pvfr1.or.b_fo

       nch_angle=ch_angle
       rd_theta=(graz_end-graz_beg)/(ch_angle-1.)
c      write(6,'(a,g15.5)')'1synrock rd_theta=',rd_theta

       thetaA=(graz_end-graz_beg)/2.
       sing=sin(0.001*thetaA)
       thetaA=0.001*thetaA/rad !  hyperfine fields - fix

       iss=iss+1
       do lstruct2=istruct1(lstruct1-1)+1,istruct1(lstruct1)
c      ------------------------------------------------------------
c      layer lay1,2 ... mlay of  absorber
c      ---------------------------------------------------------------
c      The Lorentz curve of the absorber in npq is 1 at resonance so that
c      for a singl line the exponent at resonance is just -teff (effective
c      thickness). areaLor ~ pi*ga/2 ( area -+ infinity), ga/2=hga/2/srw8,
c      normalizes ( to area 1) the Lorentz curve.
c
c      Sums of absorber curves at the positions Eagd.
c
c      ----0--------------------------naLG
c       naLG--------------------------0-------------        srw8
c        nTH------------0------------nTH                    srw

        lay=lstruct2

        call mapsub(iss)
c       external field and scatterer orientation written on fr2
c       th_22nuclear routines take the field from common/avfr2trf
c       mapsub overwrites common/.vfr2trf, therefore
        do i=1,3
         dumvfr2(1+i)=dum1(i)
         b_dumvfr2(1+i)=b_dum1(i)
        end do
        dumvfr2(5)=phi_z
        dumvfr2(6)=thetaA
        b_dumvfr2(5)=b_phi_z
        b_dumvfr2(6)=.false.
c       end of transfer       


        thicklayer(lay)=thicklay
        if(abs(re_chilay)+abs(ai_chilay).gt.1.0e-10) then
         chilay(lay)=cmplx(re_chilay,ai_chilay)*unitchi
         b_chilaynz(lay)=.true.
        else
         chilay(lay)=(0.,0.)
         b_chilaynz(lay)=.false.
        end if
        b_chilay(lay)=b_vfr2.or.b_thicklay
        b_absorber=b_absorber.or.b_chilay(lay)
c       write(6,'(a,l5)') '1------b_absorber=', b_absorber

        i=rep_grp
        laystr(2*lay-1)=i
        laystr(2*lay)=10*(rep_grp-float(i)+.01)
        roughlay(lay)=roughness*vector_k

        b_isgt1=.false.
        if(istruct2(lstruct2)-istruct2(lstruct2-1)-1.gt.0)then
         b_isgt1=.true.
         iposlay(lay)=l2_put(lstruct2)
         do i=1,8*(nTH+1)
          carray(i)=(0.,0.)
         end do
        end if

        b_sites(lay)=.false.
        b_lay=.false.
        iss=iss+1
        do lstruct3=istruct2(lstruct2-1)+1,istruct2(lstruct2)

         iset=lstruct3
         b_sites(lay)=.true.

         call mapsub(iss)

         b_lay=b_vsstrf(2).or.b_fo
c        write(6,'(a,l5)') '2------b_absorber=', b_absorber
c         write(6,'(a,2i4)') 'synrock lay,iset=',lay,iset

         sftr=vsstrf(2)
         wi(iset)=sftr*uthick_A
 
         if(b_vsstrf(1)) then
          if((wi(iset).gt.sing/20..or.sing.gt.0.05).and.
     &       (ifrcase.eq.22.or.ifrcase.eq.24.or.ifrcase.eq.25))
     &     write(nwr,'(2(a,g8.1),a)')
     &     '** f*unit_thickness=',wi(iset),' << sin(th)=',sing,' << 1 ?'
         end if


         if(ifrcase.eq.22.or.ifrcase.eq.24.or.ifrcase.eq.25) then
          isubthe=0
          call get_theory(isubthe,info)
          b_lay=b_lay.or.(isubthe.gt.0)
         end if
         b_absorber=b_absorber.or.b_lay

         if(b_isgt1) then
          i=l3_get(lstruct3)
          do n=0,nTH
           ll=8*n
           nn=i+ll
            do k=1,8
            carray(ll+k)=carray(ll+k)+ array_fr(nn+k)*wi(iset)
            end do
          end do
         else
          iposlay(lay)=l3_get(lstruct3)
         end if

         iss=iss+1
        end do

        if(b_isgt1.and.b_lay) then
         ll=iposlay(lay)
         do i=1,8*(nTH+1)
          array_fr(ll+i)=carray(i)
         end do
        end if

       end do
       mlay=lay
       laystr(2*lay+2)=-1
       laystr(2*lay+1)=0
       b_total=b_total.or.b_absorber

c      write(6,'(a)')'++++++++++++++synrock++++++++++++++++++++++'
c      write(6,'(a,20i3)') 'laystr(1..lay)=',(laystr(i),i=1,2*lay)
c-----------------------------------------------------------------------
c     here the matrix R for the layers are given :
c     satrlay(n,lay)*1 +  (sapplay(n,lay)  sapmlay(n,lay))
c                         (samplay(n,lay) -sapplay(n,lay))
c
c     calculation of the transmittivity matrix T for all channels n
c     by   T = exp(iR)*rho*exp(-iR+)


      if(.not.(b_total.or.b_graz_min)) goto 1000

      do k=1,mlay
       laysites(k)=0
      end do
      mlays=0
      do lay=1,mlay
       is_a=istruct2(lay-1)+1
       is_e=istruct2(lay)
c      write(6,'(a,2i4)') 'synrock is_a,is_e=',is_a,is_e
       vkd(lay)=vector_k*thicklayer(lay)
c       write(6,'(a,f15.5)') 'synrock vkd(lay)=',vkd(lay)
       if(is_e.lt.is_a) then
        thicklayer(lay)=0.
       else
        if(is_e.gt.is_a) thicklayer(lay)=1./vector_k
        if(is_e.eq.is_a) thicklayer(lay)=wi(is_a)/vector_k
       end if
c       write(6,'(a,g15.5,2i6,L5)') 'thickl,lay,iposlay(lay)=',
c     &   thicklayer(lay)*1.e6,lay,iposlay(lay),b_sites(lay)
      end do

C      ****************************************************************
C      We reconstarct the layerstrucrure from the laystr variable. 
c      GEOSTR(GRP) is the number of layers in group GRP.
c      L. Deak, 09.10.2002                                                     *** 
       GRP         =0
       GEOSTR(GRP) =0
       MAXGRP      =0
C
       b_first     =.true.
       POINTER=1
       do lay=2,2*mlay,2
        if(b_first)then
         if(GRP.eq.laystr(lay))then
          GEOSTR(2*GRP)   =GEOSTR(2*GRP)+1
         else
          POINTER         =POINTER+GEOSTR(2*GRP)
          GRP             =GRP+1
          MAXGRP          =GRP
          GEOSTR(2*GRP)   =1
          GEOSTR(2*GRP-1) =laystr(lay-1)
         end if
C
         if(vkd(lay/2).lt.0.) then
          b_first         =.false.
          vkd(lay/2)      =1.e30
          GEOSTR(2*GRP-1) =1
         end if ! VKD < 0
        end if  ! b_first
       end do
C      ******************************************************************
c      write(6,'(a,l5)')'4 synrock b_total=',b_total

c------------------------------ifrcase=22--------------------------------
      if(ifrcase.eq.22) then
c      only b_graz_min=.true.
       if(.not.b_total) goto 800

       do nchan=1,nch_angle
c       grazing=0.001*15
c       rd_theta=(graz_end-graz_beg)/(ch_angle-1.)
        grazing=0.001*(graz_beg+rd_theta*(nchan-1))
c        write(6,'(a,i3,a,4f10.5)') 'synrock nchan=',nchan,
c     &    ' grazing=',grazing,graz_beg,rd_theta
  
C       ******************************************************************     
C       L.Deak 09.10.2002
C 
         do lay=1,mlay
          if(b_sites(lay)) then
           Cmatrix(1,1,lay)= hc0 
           Cmatrix(2,2,lay)= hc0
           Cmatrix(1,2,lay)= hc0
           Cmatrix(2,1,lay)= hc0
          end if
         end do
  
         call optic(b_ew,mlay,b_sites,MAXGRP,GEOSTR,grazing,
     &                Cmatrix,chilay,roughlay,vkd,Rmatrix)
         R_oo=Rmatrix(1,1)
c         write(6,'(a,4g15.5)') 'synrock  R_oo=', R_oo  
c        *********************************************************************
   
         do n=-nTH,nTH-1
c        do n=-1,1
   
c        construction of the input for general optics program
c        here the matrix R for the ylayers are given :
c        satrlay(n,lay)*1 +  (sapplay(n,lay)  sapmlay(n,lay))
c                           (samplay(n,lay) -sapplay(n,lay))
         npos=8*abs(n)
         if(n.lt.0)npos=npos+4
c          effi (1 3)  to fortran  ( 1 3 )
c               (4 2)              ( 2 4 )   
         do lay=1,mlay
          if(b_sites(lay)) then
           nn=iposlay(lay)+npos
           Cmatrix(1,1,lay)= array_fr(nn+1)*thicklayer(lay)
           Cmatrix(2,2,lay)= array_fr(nn+2)*thicklayer(lay)
           Cmatrix(1,2,lay)= array_fr(nn+3)*thicklayer(lay)
           Cmatrix(2,1,lay)= array_fr(nn+4)*thicklayer(lay)
          end if
         end do   ! lay=1,mlay
    
c         if(n.lt.1.and.n.gt.-1)
c     &      write(6,'(a,i4,4e15.5,/,20x,4e15.5)')
c     &     'synrock Cmatrix=',n,Cmatrix(1,1,1),Cmatrix(2,2,1)
c     &       Cmatrix(2,1,1),Cmatrix(2,2,1)
    
    
         call optic(b_ew,mlay,b_sites,MAXGRP,GEOSTR,grazing,
     &                Cmatrix,chilay,roughlay,vkd,Rmatrix)
c        Fortran notation    
         nn=(nTH+n)*4
         POC(nn+1)=Rmatrix(1,1)-R_oo
         POC(nn+2)=Rmatrix(2,1)
         POC(nn+3)=Rmatrix(1,2)
         POC(nn+4)=Rmatrix(2,2)-R_oo
        end do     ! n=-nTH,nTH
    
c        write(6,'(a,i5)') 'nTH=',nTH

c       do n=1,30,9
c        write(6,'(8f10.5)')(POC(n+i)*1000,i=1,4)
c       end do
        nn=2*nTH
c       write(6,'(a)') ' synrock bef Fourier POC'
c        write(6,'(6g12.3)') (POC(i),i=1,nn,32)
c       call fourier4(POC,nn,mFF,-1)
        call fourier4r(nn)
  
c        write(6,'(a)') ' synrock after Fourier POC'
c        write(6,'(8f10.3)') (POC(i),i=1,nn,64)
  
        do n=1,nTH
c        trace (dd+*dd*rho) is the intensity
c        bb=cc+
         jj=4*(n-1)
         do i=1,4
          dd(i)=POC(jj+i)
         end do
c         if(n.eq.1) write(6,'(8f10.3)') (dd(i),i=1,4)
c        if(n.eq.2) write(6,'(8f10.3)') (dd(i),i=1,4)
         bb(1)=conjg(dd(1))
         bb(4)=conjg(dd(4))
         bb(2)=conjg(dd(3))
         bb(3)=conjg(dd(2))
         call matprof(bb,dd,aa)
         call matprof(aa,rho,bb)
c        aa=cc*cc+ is a Hermitian matrix
         h1=real(bb(1)+bb(4))
         jj=4*(nTH+n-1)
         do i=1,4
          dd(i)=POC(jj+i)
         end do
         bb(1)=conjg(dd(1))
         bb(4)=conjg(dd(4))
         bb(2)=conjg(dd(3))
         bb(3)=conjg(dd(2))
         call matprof(bb,dd,aa)
         call matprof(aa,rho,bb)
         h2=real(bb(1)+bb(4))
         yth(n)=h1
         yth(n+nTH)=h2
        end do ! n
c        write(6,'(8g12.3)')( yth(j),j=1,nTH,16)
        if(b_bunchinf) then
         do k=1,2*nTH
          dumi(k)=0.0
          do j=k,2*nTH
           dumi(k)=dumi(k)+yth(j)
          end do
         end do
         do k=1,2*nTH
           yth(k)=dumi(k)
         end do
c         write(6,'(a)')
c         write(6,'(8g12.3)')( yth(j),j=1,nTH,16)
         if(iT_max.gt.0) then
          nt  =nTH*2
          chT0=jt0_ch*2
          do k=1,iT_max
           nt  =nt/2
           chT0=chT0/2
          end do
         else
          nt  =2*nTH
          chT0=jt0_ch*2
         end if
        else
         if(iT_max.gt.0) then
          nt=nTH*2
          chT0=jt0_ch*2
          do k=1,iT_max
           nt  =nt/2
           chT0=chT0/2
           do j=1,nt
            yth(j)=yth(j)+yth(j+nt)
           end do
          end do
         else
          nt=2*nTH
          chT0=jt0_ch*2
         end if
        end if
   
c        integration of yth from nt0 - nth
        sum =0.
C For the SPRING8 experiment the symmetrical time window should be used
C original:  do j=2*jt0_ch,nt
C        write(*,*)chT0,nt-chT0,nt
        do j=chT0,nt-chT0
         sum=sum+yth(j)
        end do
   
        chrock(nchan)=sum
   
c       write(6,'(a,i3,a2,3i5,g15.5,)')
c     &    ' synrock jt0_ch,iT_max,nth,chrock(',nchan,')=',
c     &    jt0_ch,iT_max,nth,sum
       end do  ! loop over angles by nch_angle
c       write(6,'(8g10.5)') (chrock(i), i=1,nch_angle)
       nn=2*nstorTH1
       do i=1,nch_angle
        real_fr(nn+i)=chrock(i)
       end do
c------------------------------ifrcase=24--------------------------------
      else if(ifrcase.eq.24) then
c      only b_graz_min=.true.
       if(.not.b_total) goto 800
       isamp=8/nsampling
       if(enwr(16).eq.'omeg') write(nwr,'(2(a,i4),a,f6.2,a,f8.4)')
     & ' nomega=',nomega,'    nTH=',nTH,'   v_nTH=',
     &  srw8*nsampling*(ith_channels+nstrob_order*nomega+1.5),
     &  '    dv=',srw8*nsampling
       do nchan=1,nch_angle
c       grazing=0.001*15
c       rd_theta=(graz_end-graz_beg)/(ch_angle-1.)
        grazing=0.001*(graz_beg+rd_theta*(nchan-1))
c        write(6,'(a,i3,a,4f10.5)') 'synrock nchan=',nchan,
c     &    ' grazing=',grazing,graz_beg,rd_theta
  
C       ******************************************************************     
C       L.Deak 09.10.2002
C 
         do lay=1,mlay
          if(b_sites(lay)) then
           Cmatrix(1,1,lay)= hc0 
           Cmatrix(2,2,lay)= hc0
           Cmatrix(1,2,lay)= hc0
           Cmatrix(2,1,lay)= hc0
          end if
         end do
  
         call optic(b_ew,mlay,b_sites,MAXGRP,GEOSTR,grazing,
     &                Cmatrix,chilay,roughlay,vkd,Rmatrix)
         R_oo=Rmatrix(1,1)
c         write(6,'(a,4g15.5)') 'synrock  R_oo=', Rmatrix(1,1)  
c        *********************************************************************
   
         do n=-nTH,nTH
c        do n=-1,1
   
c        construction of the input for general optics program
c        here the matrix R for the ylayers are given :
c        satrlay(n,lay)*1 +  (sapplay(n,lay)  sapmlay(n,lay))
c                           (samplay(n,lay) -sapplay(n,lay))
         npos=8*abs(n)
         if(n.lt.0)npos=npos+4
c          effi (1 3)  to fortran  ( 1 3 )
c               (4 2)              ( 2 4 )   
         do lay=1,mlay
          if(b_sites(lay)) then
           nn=iposlay(lay)+npos
           Cmatrix(1,1,lay)= array_fr(nn+1)*thicklayer(lay)
           Cmatrix(2,2,lay)= array_fr(nn+2)*thicklayer(lay)
           Cmatrix(1,2,lay)= array_fr(nn+3)*thicklayer(lay)
           Cmatrix(2,1,lay)= array_fr(nn+4)*thicklayer(lay)
          end if
         end do   ! lay=1,mlay
    
c         if(n.lt.1.and.n.gt.-1)
c           write(6,'(a,i4,4e15.5,/,20x,4e15.5)')
c     &     'synrock Cmatrix=',n,Cmatrix(1,1,3),Cmatrix(2,2,3)
c     &       Cmatrix(2,1,3),Cmatrix(2,2,3)
    
    
         call optic(b_ew,mlay,b_sites,MAXGRP,GEOSTR,grazing,
     &                Cmatrix,chilay,roughlay,vkd,Rmatrix)
    
c        Fortran notation
         nn=(nTH+n)*4
         POC(nn+1)=Rmatrix(1,1)-R_oo
         POC(nn+3)=Rmatrix(1,2)
         POC(nn+2)=Rmatrix(2,1)
         POC(nn+4)=Rmatrix(2,2)-R_oo
        end do     ! n=-nTH,nTH


          hh=0.
          do n_s=0,nstrob_order
           swin=array_fr(l1_get(0)+1+abs(n_s))
           if(n_s.eq.0) swin=swin/2.0
           h1=real(conjg(swin)*swin)
           if(h1.gt.1.e-3)then
      
            j1=4*(n_s*nomega/2) 
            j3=4*(-n_s*nomega/2) 
            nb_ch=((nstrob_order*2-n_s)*nomega/2)*isamp
            ne_ch=((nstrob_order*2+n_s)*nomega/2+2*ith_channels)*isamp

            do i=nb_ch,ne_ch
             i4=4*i
             j=j1+i4
             aa(1)=POC(j+1)     
             aa(2)=POC(j+2)      
             aa(3)=POC(j+3)      
             aa(4)=POC(j+4)    
       
             j=j3+i4
             cc(1)=conjg(POC(j+1))     
             cc(3)=conjg(POC(j+2))      
             cc(2)=conjg(POC(j+3))      
             cc(4)=conjg(POC(j+4))      
     
             call matprof(cc,aa,bb)
             trace(i)=bb(1)*rho(1)+bb(3)*rho(2)+bb(2)*rho(3)+
     &                                          bb(4)*rho(4)            
c             call matprof(bb,rho,aa)
c             hcc=hcc+aa(1)+aa(4)
            end do  ! nch
            hcc=hc0
            do i=nb_ch+1,ne_ch-1,2
             hcc=hcc+trace(i)*2
            end do
            do i=nb_ch+2,ne_ch-2,2
             hcc=hcc+trace(i)
            end do
            hcc=(hcc*2.0+trace(ne_ch)+trace(ne_ch))/3.0
            hh=hh+2.0*real(hcc*swin)
           end if   ! abs(swin) >0.001
          end do   ! n_s
          chrock(nchan)=hh
       end do  ! loop over angles by nch_angle
c       write(6,'(8g10.5)') (chrock(i), i=1,nch_angle)
       nn=2*nstorTH1
       do i=1,nch_angle
        real_fr(nn+i)=chrock(i)
       end do
c------------------------------ifrcase=25--------------------------------
      else if(ifrcase.eq.25) then
c      only b_graz_min=.true.
       if(.not.b_total) goto 800

       do nchan=1,nch_angle
        grazing=0.001*(graz_beg+rd_theta*(nchan-1))
  
C       ******************************************************************     
C       L.Deak 09.10.2002
C 
         do lay=1,mlay
          if(b_sites(lay)) then
           Cmatrix(1,1,lay)= hc0 
           Cmatrix(2,2,lay)= hc0
           Cmatrix(1,2,lay)= hc0
           Cmatrix(2,1,lay)= hc0
          end if
         end do
  
         call optic(b_ew,mlay,b_sites,MAXGRP,GEOSTR,grazing,
     &                Cmatrix,chilay,roughlay,vkd,Rmatrix)
         R_oo=Rmatrix(1,1)
c         write(6,'(a,4g15.5)') 'synrock  R_oo=', Rmatrix(1,1)  
c        *********************************************************************
   
c         do n=-nTH,nTH
c        do n=-1,1
   
c        construction of the input for general optics program
c        here the matrix R for the ylayers are given :
c        satrlay(n,lay)*1 +  (sapplay(n,lay)  sapmlay(n,lay))
c                           (samplay(n,lay) -sapplay(n,lay))
c         npos=8*abs(n)
c         if(n.lt.0)npos=npos+4

c          write(6,'(a,2i6)')' iall=',iall
c          write(6,'(a,3i6)')' nomega,nTH=',nomega,nTH,nsampling 
        do ka=0,iall
         n=ichall(ka)
         do neg=-1,1,2     
          npos=8*n+(1-neg)*2
c        (11 12)    effi (1 3)     fortran  ( 1 3 )
c        (21 22)         (4 2)              ( 2 4 )   
          do lay=1,mlay
           if(b_sites(lay)) then
            nn=iposlay(lay)+npos
            Cmatrix(1,1,lay)= array_fr(nn+1)*thicklayer(lay)
            Cmatrix(2,2,lay)= array_fr(nn+2)*thicklayer(lay)
            Cmatrix(1,2,lay)= array_fr(nn+3)*thicklayer(lay)
            Cmatrix(2,1,lay)= array_fr(nn+4)*thicklayer(lay)
           end if
          end do   ! lay=1,mlay
    
c         if(n.lt.iall)
c     &      write(6,'(a,i4,4e15.5)')
c     &     'synrock Cmatrix=',n,Cmatrix(1,1,3),Cmatrix(2,2,3)
c     &       Cmatrix(2,1,3),Cmatrix(2,2,3)
    
    
          call optic(b_ew,mlay,b_sites,MAXGRP,GEOSTR,grazing,
     &                 Cmatrix,chilay,roughlay,vkd,Rmatrix)
c         Fortran notation
          i=neg*n 
          pocfi(1,i)=Rmatrix(1,1)-R_oo 
          pocfi(3,i)=Rmatrix(1,2)      
          pocfi(2,i)=Rmatrix(2,1)      
          pocfi(4,i)=Rmatrix(2,2)-R_oo 

         end do
        end do     ! n=-nTH,nTH
c           write(6,'(8f12.4)')( pocfi(1,i)*1000,i=-nTH,0,16)
c           write(6,'(8f12.4)')( pocfi(2,i)*1000,i=-nTH,0,16)
c           write(6,'(8f12.4)')( pocfi(3,i)*1000,i=-nTH,0,16)
c           write(6,'(8f12.4)')( pocfi(4,i)*1000,i=-nTH,0,16)
c          read(5,'(a)')
        hhstr=0.
        hhoff=0.
        DO n_s=0,nstrob_order   
         swinr=real(array_fr(l1_get(0)+1+abs(n_s)))
         swini=aimag(array_fr(l1_get(0)+1+abs(n_s)))
         if(n_s.eq.0) swinr=swinr/2.0
         if(abs(swinr)+abs(swini).gt.0.001)then

          ij=n_s*nomega/2
          mcht=ij+nhyperfine
          do i=0,mcht
           ichstr(i)=i
          end do        
          do i=1,nvch
           ichstr(mcht+i)=mcht+i*(i+1)/2
          end do
          icht=mcht+nvch

          DO ka=0,icht
           ii=ichstr(ka)

           i=ii+ij
           aa(1)=pocfi(1,i)     
           aa(2)=pocfi(2,i)  
           aa(3)=pocfi(3,i)  
           aa(4)=pocfi(4,i)

           j=ii-ij
           cc(1)=conjg(pocfi(1,j))     
           cc(3)=conjg(pocfi(2,j))      
           cc(2)=conjg(pocfi(3,j))      
           cc(4)=conjg(pocfi(4,j))      
           call matprof(cc,aa,bb)     
c          trace(bb*rho)
           hc=bb(1)*rho(1)+bb(3)*rho(2)+bb(2)*rho(3)+bb(4)*rho(4)            
           trc(ii)=swinr*real(hc)-swini*aimag(hc)
          END DO 

          DO ka=1,icht
           ii=-ichstr(ka)

           i=ii+ij
           aa(1)=pocfi(1,i)     
           aa(2)=pocfi(2,i)  
           aa(3)=pocfi(3,i)  
           aa(4)=pocfi(4,i)

           j=ii-ij
           cc(1)=conjg(pocfi(1,j))     
           cc(3)=conjg(pocfi(2,j))      
           cc(2)=conjg(pocfi(3,j))      
           cc(4)=conjg(pocfi(4,j))      
           call matprof(cc,aa,bb)     
c          trace(bb*rho)
           hc=bb(1)*rho(1)+bb(3)*rho(2)+bb(2)*rho(3)+bb(4)*rho(4)            
           trc(ii)=swinr*real(hc)-swini*aimag(hc)
          END DO 

c          write(6,'(8f12.4)')(trc(i)*1000,i=-icht,icht,8)
c          read(5,'(a)')
          hh=0.
          do i=-mcht+1,mcht-1,2
           hh=hh+trc(i)*2
          end do
          do i=-mcht+2,mcht-2,2
           hh=hh+trc(i)
          end do
          hh=(hh*2.0+trc(-mcht)+trc(mcht))/3.0
          h1=hh
c         if(mcht.ne.iall)then          
          do i=0,nvch
           x0 =-ichstr(icht-i+2)        ! -ichstr(icht-i+2)=+ichstr(-icht+i-2)
           x1 =-ichstr(icht-i+1)
           x2 =-ichstr(icht-i)
           ap0(i)= (x1-x2)
           ap1(i)=-(x0-x2)
           ap2(i)= (x0-x1)
           bp0(i)=-(x1**2-x2**2)
           bp1(i)= (x0**2-x2**2)
           bp2(i)=-(x0**2-x1**2)
           cp0(i)= (x1-x2)*x1*x2
           cp1(i)=-(x0-x2)*x0*x2
           cp2(i)= (x0-x1)*x0*x1
         
           det=x0**2*ap0(i)+x0*bp0(i)+cp0(i)
           dx3(i)=(x2**3-x0**3)/3./det
           dx2(i)=-bp1(i)/2./det 
           dx1(i)=ap1(i)/det    
          end do              
         
          do i=2,nvch,2
           k0 =-(icht-i+2)        
           k1 =-(icht-i+1)
           k2 =-(icht-i)
           ap= trc(k0)*ap0(i)+trc(k1)*ap1(i)+trc(k2)*ap2(i)
           bp= trc(k0)*bp0(i)+trc(k1)*bp1(i)+trc(k2)*bp2(i)
           cp= trc(k0)*cp0(i)+trc(k1)*cp1(i)+trc(k2)*cp2(i)
           hh=hh+ap*dx3(i)+bp*dx2(i)+cp*dx1(i)
          end do
           
          do i=0,nvch-2
           x0 =ichstr(i+mcht)
           x1 =ichstr(i+mcht+1)
           x2 =ichstr(i+mcht+2)
           ap0(i)= (x1-x2)
           ap1(i)=-(x0-x2)
           ap2(i)= (x0-x1)
           bp0(i)=-(x1**2-x2**2)
           bp1(i)= (x0**2-x2**2)
           bp2(i)=-(x0**2-x1**2)
           cp0(i)= (x1-x2)*x1*x2
           cp1(i)=-(x0-x2)*x0*x2
           cp2(i)= (x0-x1)*x0*x1
         
           det=x0**2*ap0(i)+x0*bp0(i)+cp0(i)
           dx3(i)=(x2**3-x0**3)/3./det
           dx2(i)=-bp1(i)/2./det 
           dx1(i)=ap1(i)/det    
          end do              
         
          do i=0,nvch-2,2
           k0=(mcht+i) 
           k1=(mcht+i+1) 
           k2=(mcht+i+2) 
           ap= trc(k0)*ap0(i)+trc(k1)*ap1(i)+trc(k2)*ap2(i)
           bp= trc(k0)*bp0(i)+trc(k1)*bp1(i)+trc(k2)*bp2(i)
           cp= trc(k0)*cp0(i)+trc(k1)*cp1(i)+trc(k2)*cp2(i)
           hh=hh+ap*dx3(i)+bp*dx2(i)+cp*dx1(i)
          end do
          hhoff=hhoff+hh-h1
          hhstr=hhstr+hh
         end if ! swin >> 0.001
        END DO    ! nstrob=0,nstrob_order
c        write(6,'(f10.3,a,2f15.5)')grazing*1000,' hhstr,hhoff=',
c     &                                            hhstr,hhoff/hhstr
        chrock(nchan)=hhstr*2.0
       end do  ! loop over angles by nch_angle
c       write(6,'(8g10.5)') (chrock(i), i=1,nch_angle)
       nn=2*nstorTH1
       do i=1,nch_angle
        real_fr(nn+i)=chrock(i)
       end do
c-----------------------------ifrcase=23---------------------------
      else if(ifrcase.eq.23) then
c      write(6,'(a)') ' synrock roughlay'
c      write(6,'(8f10.2)') (roughlay(i),i=1,mlay)
c      write(6,'(20i5)') (laystr(i),i=1,2*mlay)
c      write(6,'(8f10.2)') (chilay(i),i=1,mlay)
c      write(6,'(6e12.4)') (vkd(i),i=1,mlay)
c      write(6,'(20L3)') (b_sites(i),i=1,mlay)
c      write(6,'(f12.6)') graz_min
       do i=1,mlay
        Cmatrix(1,1,i)=(0.0,0.0)
        Cmatrix(1,2,i)=(0.0,0.0)
        Cmatrix(2,1,i)=(0.0,0.0)
        Cmatrix(2,2,i)=(0.0,0.0)
       end do

       do nchan=1,nch_angle
        grazing=0.001*(graz_beg+rd_theta*(nchan-1))
c        if(nchan.lt.5)write(6,'(a,f15.5)')'synrock grazing=',grazing

        call optic(b_ew,mlay,b_sites,MAXGRP,GEOSTR,grazing,
     &                Cmatrix,chilay,roughlay,vkd,Rmatrix)

c       trace (dd+*dd*rho) is the intensity
c       bb=cc+
        dd(1)=Rmatrix(1,1)
        dd(3)=Rmatrix(1,2)
        dd(2)=Rmatrix(2,1)
        dd(4)=Rmatrix(2,2)

c       if(nchan.lt.20)write(6,'(8f10.5)') (dd(i),i=1,4)
        bb(1)=conjg(dd(1))
        bb(4)=conjg(dd(4))
        bb(2)=conjg(dd(3))
        bb(3)=conjg(dd(2))
        call matprof(bb,dd,aa)
        call matprof(aa,rho,bb)
c       aa=cc*cc+ is a Hermitian matrix
        h1=real(bb(1)+bb(4))

        if(grazing.lt.grazmin) then
         h1=h1*sin(grazing)/sin(grazmin)
        end if
        chrock(nchan)=h1
       end do  ! loop over angles by nch_angle
c       write(6,'(6g12.5)') (chrock(i),i=1,100)

       do j=1,nch_angle
        chrock(j)=chrock(j)*counts_bunch
       end do
c       chrock(1)=counts_bunch
c       write(6,'(a,2f10.3,L5)') 'prompt counts_bunch,det.,b_det.=',
c     &   counts_bunch,detekt_eff,b_detekt_eff

       qn(0)=1
       nst16=nstorTH1+nch_angle/2
       if(b_detekt_eff) then
        fn(0)=1
        dn(0)=1
        do i=1,30
         dn(i)=dn(i-1)*(1.0-detekt_eff)
        end do
        do i=1,30
         fn(i)=fn(i-1)*float(i)
        end do
        do i=1,30
         dn(i)=(1.0-dn(i))/fn(i)
        end do
        do i=1,15
         array_fr(nst16+i)=cmplx(dn(i),dn(i+15))
        end do
       else
        do i=1,30
         dn(i)=(1.0-dn(i))/fn(i)
        end do
        do i=1,15
         dn(i)=real(array_fr(nst16+i))
         dn(i+15)=aimag(array_fr(nst16+i))
        end do
       end if
       if(b_counts_bunch) then
        do i=1,30
         qn(i)=qn(i-1)*counts_bunch
        end do
        k=0
        h=1
        do while(h.gt.1.0e-4.and.k.le.29)
         k=k+1
         h=qn(k)/fn(k)/counts_bunch
c        write(6,'(a,i2,a2,g15.5,)') 'prompt qn(k)/fn(',k,')=',h
        end do

        array_fr(nst16+16)=cmplx(float(k-1),0.0)
       else
        k=real(array_fr(nst16+16))
       end if
       do j=1,nch_angle
        do i=1,k
         qn(i)=qn(i-1)*chrock(j)
        end do
        h=0
        do i=1,k
         h=h+dn(i)*qn(i)
        end do
        chrock(j)=h*exp(-chrock(j))
       end do

       goto 900

      end if ! ifrcase

 800  continue
c     write(6,'(8g10.5)') (chrock(i)*100,i=1,100)
      nn=2*nstorTH1
      do nchan=1,nch_angle
       chrock(nchan)=real_fr(nn+nchan)
      end do

      do nchan=1,nch_angle
       grazing=0.001*(graz_beg+rd_theta*(nchan-1))
       if(grazing.lt.grazmin) then
        chrock(nchan)=chrock(nchan)*sin(grazing)/sin(grazmin)
       end if
      end do
      b_total=.true.
 
 900  sum=0.
      do nchan=1,nch_angle
       sum=sum+chrock(nchan)
      end do

      nn=nstorTH*2
      if(mstruct1.gt.1) nn=inc_pos*2
      do i=1,nch_angle
       real_fr(nn+i)=chrock(i)/sum
      end do
      call cpu_time(finish)
      print '(" runtime = ",f15.3," seconds.")',finish-start
c      write(6,'(8f10.5)') (chrock(i)*100./sum,i=1,100)
c      write(6,'(a,i6)')' end of synrocking nstorTH=',nn

c     end of calculation of absorber function
c     end of calculation for incoherent par
 2000 continue
c      write(6,'(a,2i6)')'synrock lstruct1,mstruct1=',lstruct1,mstruct1
      if(mstruct1.gt.1) goto 1000

      if(.not.b_total) return

 2500 continue
      if(mstruct1.gt.1) then
c      summation of incoherent parts mstruct1
       if(nyout.gt.512) nyout=512
       nyout=nch_angle/2
       do i=1,nyout
        array_fr(nstorTH+i)=cmplx(0.,0.)
       end do
       do k=1,mstruct1
        nn=ipos_mstruct1(k)
c       write(6,'(a,i6,2i4,2i8,f10.3)')
c     &    'nstorTH,k,nthchannel,iarray_sp,ipos_mstruct1(k),winc(k)=',
c     &        nstorTH,k,n,iarray_sp,nn,winc(k)
c       write(6,'(8f10.4)')(array_fr(nn+i)*100,i=1,16)
        do i=1,nyout
         array_fr(nstorTH+i)=
     &       array_fr(nstorTH+i)+array_fr(nn+i)*winc(k)
        end do
       end do
      end if

      return
      end












