      subroutine thstr_22indexmoss(l_jth,cmch,property)
c     n_ik(E) refraction index (static) for
c     Mossbauer transmission and   Mossbauer resonance reflection theories
c     level 3 theory
      
      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'
      
      character ch132*132,property*132,chth*8,cmch*4
      logical b_return

      chth='th'//property(1:6)

      if(enwr(14)(1:1).eq.'y') write(nwr,'(2(a,a8),a,i2,a,/,a)')
     & ' cmch=',cmch,' thstruct:',chth,' l_jth=',l_jth,
     & ' subr= thstr_22index  nameth_as=',nameth_as(:40)

       b_return=cmch.eq.'name'
      if(b_return) 
     & property='2x2 refraction index (sad)'                                   !name
      if(cmch.eq.'prop') then
       if(l_jth.eq.1) then 
        property=
     & 'prop=2x2_ref_index_static_sad   plrs,1  nc_v_a_the=4,4,t'
       end if
       b_return=.true.
      end if
      
c     names of this routine
      mthchild=1    ! <=(max_nth
      nameth(1)='2x2 refraction index (static,sad)'
c      nameth(2)=' '
      if(b_return) return 
      
      
      if(l_jth.eq.0) then
c      asking for the number (mthchild) of theories fitting to ntheory
       mthparent=5     ! <=max_nth
       ntheory(1)='Mossbauer transmission_vA_3'
       ntheory(2)='Mossbauer transmission_vB_3'
       ntheory(3)='Mossbauer reemission_vA_3'
       ntheory(4)='Mossbauer reemission_vB_3'
       ntheory(5)='Mossbauer transmission_vC_3'
c      ntheory(6)='Mossbauer resonance reflection_3'
       do k= 1,mthparent
        if(nameth_as.eq.ntheory(k)) l_jth=mthchild
       end do
       return
      end if
      
      if(cmch.eq.'hdbk') then
       nstruct='handbook=nucleus.hdb'//
     & ' list=3 seq=2  chth='//chth  
       return
      end if

      if(cmch.eq.'copa') then

       k=1
       do while(strco(k)(:5).ne.'#beg#')
        k=k+1
       end do
       j=k-1
       jb=k
       strco(j+1)='flag_SAMP               1    1 '
                 ! discrete (1) , continuous(0) LG-curves
       strco(j+2)='flag_Voigt              2    0'
                 ! LG-convolution (1) , Voigt profile (0)
       j=j+2            
       strco(j+1)='#end#  2   seq1'
       strco(j+2)='#beg#'
       do k=jb,j
        ch132=strco(k)
        call stringlength(ch132,l)
        strco(k)=ch132(:l)//'/'//chth
       end do

       k=1
       do while(strtm(k,1)(:5).ne.'#beg#')
c        write(6,'(i4,a,a)')k,' strtm(k,1)=',strtm(k,1) 
        k=k+1
       end do
       jm=k-1
       jmb=jm+1
       k=1
       do while(strth(k,1)(:5).ne.' ')
        k=k+1
       end do
       jh=k-1
        
c                     123456789012345678901234567      
       strtm(jm+1,1)='t_eff                   ,#i 1 1'
       strtm(jm+1,2)='effective thickness by the f-factor at the site'
       strth(jh+1,1)='mg/cm2xf         , 1.0  0.0 0.0  0.1'
       strth(jh+1,2)='mg/cm2xf                1     1  '
        
       strtm(jm+2,1)='position                , 1 1'
       strtm(jm+2,2)='position of the spectrum'
       strth(jh+2,1)='is_shift         , 0.0  0.0 0.0  0.1'
       strth(jh+2,2)='is_shift                2    1  '
        
       strtm(jm+3,1)='broadening              ,# 2 2'
       strtm(jm+3,2)='broadening of the lines of the spectrum'
       strth(jh+3,1)='G_width          , 0.0  0.0 0.0  0.1'
       strth(jh+4,1)='L_width          , 0.0  0.0 0.0  0.1'
       strth(jh+3,2)='G_width                 3      1 0 '
       strth(jh+4,2)='L_width                 4      0 1 '
       jm=jm+3
       jh=jh+4
        
       strtm(jm+1,1)='#end#  4 '
       strtm(jm+2,1)='#beg#'
       
        
       do k=jmb,jm
        ch132=strtm(k,1)
        call stringlength(ch132,l)
        strtm(k,1)=ch132(:l)//'/'//chth
       end do
      end if
      return
      end


      subroutine thstr_22indexfmoss(l_jth,cmch,property)
c     n_ik(E) refraction index (static) for
c     Mossbauer transmission , powder, anisotropic f-factor
c     level 3 theory
      
      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'
      
      character ch132*132,property*132,chth*8,cmch*4
      logical b_return

      chth='th'//property(1:6)

      if(enwr(14)(1:1).eq.'y') write(nwr,'(2(a,a8),a,i2,a,/,a)')
     & ' cmch=',cmch,' thstruct:',chth,' l_jth=',l_jth,
     & ' subr= thstr_22indexft  nameth_as=',nameth_as(:40)

       b_return=cmch.eq.'name'
      if(b_return) 
     & property='2x2 refraction index_f (sad)'               
      if(cmch.eq.'prop') then
       if(l_jth.eq.1) then
        property=
     & 'prop=2x2_ref_index_static_sad plrs,1  nc_v_a_the=4,4,t'
       else if(l_jth.eq.2) then
        property=
     & 'prop=2x2_ref_index_static_sad  plrs,1  nc_v_a_the=4,4,t'
       end if
       b_return=.true.
      end if
      
c     names of this routine
      mthchild=1    ! <=(max_nth
      nameth(1)='2x2 refraction index (static,f_anisotrop,sad)'
c      nameth(3)=' '
      if(b_return) return
      
      
      if(l_jth.eq.0) then
c      asking for the number (mthchild) of theories fitting to ntheory
       mthparent=3     ! <=max_nth
       ntheory(1)='Mossbauer transmission_vB_3'
       ntheory(2)='Mossbauer reemission_vB_3'
       ntheory(3)='Mossbauer transmission_vC_3'
       do k= 1,mthparent
        if(nameth_as.eq.ntheory(k)) l_jth=mthchild
       end do
       return
      end if

      if(cmch.eq.'hdbk') then
       nstruct='handbook=nucleus.hdb'//
     & ' list=3 seq=2  chth='//chth  
       return
      end if


      if(cmch.eq.'copa') then

       k=1
       do while(strco(k)(:5).ne.'#beg#')
        k=k+1
       end do
       j=k-1
       jb=k
       strco(j+1)='flag_SAMP               1    1 '
                 ! discrete (1) , continuous(0) LG-curves
       strco(j+2)='flag_Voigt              2    0'
                 ! LG-convolution (1) , Voigt profile (0)
       j=j+2            
       strco(j+1)='#end#  2   seq1'
       strco(j+2)='#beg#'
       do k=jb,j
        ch132=strco(k)
        call stringlength(ch132,l)
        strco(k)=ch132(:l)//'/'//chth
       end do

       k=1
       do while(strtm(k,1)(:5).ne.'#beg#')
c        write(6,'(i4,a,a)')k,' strtm(k,1)=',strtm(k,1) 
        k=k+1
       end do
       jm=k-1
       jmb=jm+1
       k=1
       do while(strth(k,1)(:5).ne.' ')
        k=k+1
       end do
       jh=k-1
c                     123456789012345678901234567      
       strtm(jm+1,1)='t_eff                   ,#i 1 1'
       strtm(jm+1,2)='effective thickness by the f-factor at the site'
       strth(jh+1,1)='mg/cm2xf         , 1.0  0.0 0.0  0.1'
       strth(jh+1,2)='mg/cm2xf                 1     1  '
        
       strtm(jm+2,1)='position                , 1 1'
       strtm(jm+2,2)='position of the spectrum'
       strth(jh+2,1)='is_shift         , 0.0  0.0 0.0  0.1'
       strth(jh+2,2)='is_shift                 2    1  '
        
       strtm(jm+3,1)='broadening              ,# 2 2'
       strtm(jm+3,2)='broadening of the lines of the spectrum'
       strth(jh+3,1)='G_width          , 0.0  0.0 0.0  0.1'
       strth(jh+4,1)='L_width          , 0.0  0.0 0.0  0.1'
       strth(jh+3,2)='G_width                  3      1 0 '
       strth(jh+4,2)='L_width                  4      0 1 '
       jm=jm+3
       jh=jh+4
        
       strtm(jm+1,1)='#end#  4 '
       strtm(jm+2,1)='#beg#'
       
        
       do k=jmb,jm
        ch132=strtm(k,1)
        call stringlength(ch132,l)
        strtm(k,1)=ch132(:l)//'/'//chth
       end do
      end if


      return
      end

      subroutine thstr_22indexMB(l_jth,cmch,property)
c     n_ik(E) refraction index (static) for
c     Mossbauer transmission , powder, anisotropic f-factor
c     level 3 theory
      
      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'
      
      character ch132*132,property*132,chth*8,cmch*4
      logical b_return

      chth='th'//property(1:6)

      if(enwr(14)(1:1).eq.'y') write(nwr,'(2(a,a8),a,i2,a,/,a)')
     & ' cmch=',cmch,' thstruct:',chth,' l_jth=',l_jth,
     & ' subr= thstr_22indexft  nameth_as=',nameth_as(:40)

       b_return=cmch.eq.'name'
      if(b_return) 
     & property='2x2 refraction index MB'                                 !name
      if(cmch.eq.'prop') then
c       if(l_jth.eq.1) then
        property=
     & 'prop=2x2_ref_index_static_sad plrs,1  nc_v_a_the=4,4,t'
c       end if
       b_return=.true.
      end if
      
c     names of this routine
      mthchild=2    ! <=(max_nth
      nameth(1)='2x2 refraction index (static,sad)'
      nameth(2)='2x2 refraction index (f,texture,spinham)'
c      nameth(3)=' '
      if(b_return) return
      
      
      if(l_jth.eq.0) then
c      asking for the number (mthchild) of theories fitting to ntheory
       mthparent=1     ! <=max_nth
       ntheory(1)='Mossbauer transmission_vD_3'
       do k= 1,mthparent
        if(nameth_as.eq.ntheory(k)) l_jth=mthchild
       end do
       return
      end if

      if(cmch.eq.'hdbk') then
       nstruct='handbook=nucleus.hdb'//
     & ' list=3 seq=2  chth='//chth  
       return
      end if


      if(cmch.eq.'copa') then

       k=1
       do while(strco(k)(:5).ne.'#beg#')
        k=k+1
       end do
       j=k-1
       jb=k
       strco(j+1)='flag_SAMP               1    1 '
                 ! discrete (1) , continuous(0) LG-curves
       strco(j+2)='flag_Voigt              2    0'
                 ! LG-convolution (1) , Voigt profile (0)
       j=j+2            
       strco(j+1)='#end#  2   seq1'
       strco(j+2)='#beg#'
       do k=jb,j
        ch132=strco(k)
        call stringlength(ch132,l)
        strco(k)=ch132(:l)//'/'//chth
       end do

       k=1
       do while(strtm(k,1)(:5).ne.'#beg#')
c        write(6,'(i4,a,a)')k,' strtm(k,1)=',strtm(k,1) 
        k=k+1
       end do
       jm=k-1
       jmb=jm+1
       k=1
       do while(strth(k,1)(:5).ne.' ')
        k=k+1
       end do
       jh=k-1
c                     123456789012345678901234567      
       strtm(jm+1,1)='t_eff                   ,#i 1 1'
       strtm(jm+1,2)='effective thickness by the f-factor at the site'
       strth(jh+1,1)='mg/cm2xf         , 1.0  0.0 0.0  0.1'
       strth(jh+1,2)='mg/cm2xf                 1     1  '
        
       strtm(jm+2,1)='position                , 1 1'
       strtm(jm+2,2)='position of the spectrum'
       strth(jh+2,1)='is_shift         , 0.0  0.0 0.0  0.1'
       strth(jh+2,2)='is_shift                 2    1  '
        
       strtm(jm+3,1)='broadening              ,# 2 2'
       strtm(jm+3,2)='broadening of the lines of the spectrum'
       strth(jh+3,1)='G_width          , 0.0  0.0 0.0  0.1'
       strth(jh+4,1)='L_width          , 0.0  0.0 0.0  0.1'
       strth(jh+3,2)='G_width                  3      1 0 '
       strth(jh+4,2)='L_width                  4      0 1 '
       jm=jm+3
       jh=jh+4
        
       strtm(jm+1,1)='#end#  4 '
       strtm(jm+2,1)='#beg#'
       
        
       do k=jmb,jm
        ch132=strtm(k,1)
        call stringlength(ch132,l)
        strtm(k,1)=ch132(:l)//'/'//chth
       end do
      end if


      return
      end


      subroutine thstr_22indexrefl(l_jth,cmch,property)

c     n_ik(E) refraction index (static) for
c     Mossbauer transmission and   Mossbauer resonance reflection theories
c     level 3 theory

      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'

      character ch132*132,property*132,chth*8,cmch*4
      logical b_return

      chth='th'//property(1:6)


      if(enwr(14)(1:1).eq.'y') write(nwr,'(2(a,a8),a,i2,a,/,a)')
     & ' cmch=',cmch,' thstruct:',chth,' l_jth=',l_jth,
     & ' subr= thstr_22index  nameth_as=',nameth_as(:40)

      b_return=cmch.eq.'name'
      if(b_return)
     & property='2x2 refraction index reflection'                                  !name

      if(cmch.eq.'prop') then
       if(l_jth.eq.1) then
        property=
     &   'prop=2x2_refraction_index_static   plrs,1  nc_v_a_the=4,4,t'
       end if
       b_return=.true.
      end if

c     names of this routine
      mthchild=1    ! <=(maxnth
      nameth(1)='2x2 refraction index (static)'
c      nameth(2)=' '
      if(b_return) return

      if(l_jth.eq.0) then
c      asking for the number (mthchild) of theories fitting to ntheory
       mthparent=5     ! <=maxnth
       ntheory(1)='stroboscopic reflection spectrum_3'
       ntheory(2)='time differential reflection spectrum_3'
       ntheory(3)='time integral - rocking curve-Fourier_3'
       ntheory(4)='time integral - rocking curve_3'
       ntheory(5)='time integral - rocking curve_fi_3'
       do k= 1,mthparent
        if(nameth_as.eq.ntheory(k)) l_jth=mthchild
       end do
       return
      end if


      if(cmch.eq.'hdbk') then
       nstruct='handbook=nucleus.hdb'//
     & ' list=3 seq=2  chth='//chth  
       return
      end if

      if(cmch.eq.'copa') then
       if(l_jth.eq.1) then
        k=1
        do while(strco(k)(:5).ne.'#beg#')
         k=k+1
        end do
        j=k-1
        jb=k
        strco(j+1)='flag_SAMP               1     0 '
                 ! discrete (1) , continuous(0) LG-curves
        strco(j+2)='flag_Voigt              2    #n   0 '
        j=j+2            
        strco(j+1)='#end#  2   seq1'
c       comment on the 2 instead of 1 (flag_Voigt is omitted):
c       flag_Voigt is still in use in the Mossbauer=> the position
c       of constants in the .par file are the same as in Mossbauer.
        strco(j+2)='#beg#'
        do k=jb,j
         ch132=strco(k)
         call stringlength(ch132,l)
         strco(k)=ch132(:l)//'/'//chth
        end do
       end if
       k=1
       do while(strtm(k,1)(:5).ne.'#beg#')
c        write(6,'(i4,a,a)')k,' strtm(k,1)=',strtm(k,1) 
        k=k+1
       end do
       jm=k-1
       jmb=jm+1
       k=1
       do while(strth(k,1)(:5).ne.' ')
        k=k+1
       end do
       jh=k-1
        
c                     123456789012345678901234567 
            
       strtm(jm+1,1)='A_thickness             ,#i 1 1'
       strtm(jm+1,2)='effective thickness by the f-factor at the site'
       strth(jh+1,1)='Axf             , 1.0  0.0 0.0  0.1'
       strth(jh+1,2)='Axf                     1     1  '

       strtm(jm+2,1)='position                , 1 1'
       strtm(jm+2,2)='position of the spectrum'
       strth(jh+2,1)='is_shift         , 0.0  0.0 0.0  0.1'
       strth(jh+2,2)='is_shift                2    1  '

       strtm(jm+3,1)='broadening              ,# 2 2'
       strtm(jm+3,2)='broadening of the lines of the spectrum'
       strth(jh+3,1)='G_width          , 0.0  0.0 0.0  0.1'
       strth(jh+4,1)='L_width          , 0.0  0.0 0.0  0.1'
       strth(jh+3,2)='G_width                 3      1 0 '
       strth(jh+4,2)='L_width                 4      0 1 '
       jm=jm+3
       jh=jh+4       

       strtm(jm+1,1)='#end#  4 '
       strtm(jm+2,1)='#beg#'
       
        
       do k=jmb,jm
        ch132=strtm(k,1) 
        call stringlength(ch132,l)
        strtm(k,1)=ch132(:l)//'/'//chth
       end do
      end if

      return
      end

      subroutine thstr_22indexreflnosampl(l_jth,cmch,property)

c     n_ik(E) refraction index (static) for
c     level 3 theory
c     the routine "2x2_refraction_index_static" is called by case=2
c     flag_sampl=0 and flag_Voigt=1  == aLORGAUS() is called   
c     aLORGAUS() does not store on array_fr()
  
      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'

      character ch132*132,property*132,chth*8,cmch*4
      logical b_return

      chth='th'//property(1:6)


      if(enwr(14)(1:1).eq.'y') write(nwr,'(2(a,a8),a,i2,a,/,a)')
     & ' cmch=',cmch,' thstruct:',chth,' l_jth=',l_jth,
     & ' subr= thstr_22index  nameth_as=',nameth_as(:40)

      b_return=cmch.eq.'name'
      if(b_return)
     & property='2x2 refraction index offspec' 
      if(cmch.eq.'prop') then
       if(l_jth.eq.1) then
        property=
     &   'prop=2x2_refraction_index_static   plrs,2  nc_v_a_the=4,4,t'
c                name                             case          
c                                                1 constant from nucleus.hdb
       end if
       b_return=.true.
      end if

c     names of this routine
      mthchild=1    ! <=(maxnth
      nameth(1)='2x2 refraction index (static)'
c      nameth(2)=' '
      if(b_return) return

      if(l_jth.eq.0) then
c      asking for the number (mthchild) of theories fitting to ntheory
       mthparent=1     ! <=maxnth
       ntheory(1)='time integral - offspecular_3'
       do k= 1,mthparent
        if(nameth_as.eq.ntheory(k)) l_jth=mthchild
       end do
       return
      end if


      if(cmch.eq.'hdbk') then
       nstruct='handbook=nucleus.hdb'//
     & ' list=3 seq=2  chth='//chth  
       return
      end if

      if(cmch.eq.'copa') then

       k=1
       do while(strco(k)(:5).ne.'#beg#')
        k=k+1
       end do
       j=k-1
       jb=k
       strco(j+1)='flag_SAMP               1    #n   0 '
                 ! discrete (1) , continuous(0) LG-curves
       strco(j+2)='flag_Voigt              2    #n   0 '
       j=j+2            
       strco(j+1)='#end#  2   seq1'
c      comment on the 2 instead of 0 (flags_ are omitted):
c      flags are in use in Mossbauer, etc => the position
c      of constants in the .par file are in the same order as
c      in Mossbauer, etc.
       strco(j+2)='#beg#'
       do k=jb,j
        ch132=strco(k)
        call stringlength(ch132,l)
        strco(k)=ch132(:l)//'/'//chth
       end do

       k=1
       do while(strtm(k,1)(:5).ne.'#beg#')
c        write(6,'(i4,a,a)')k,' strtm(k,1)=',strtm(k,1) 
        k=k+1
       end do
       jm=k-1
       jmb=jm+1
       k=1
       do while(strth(k,1)(:5).ne.' ')
        k=k+1
       end do
       jh=k-1
        
c                     123456789012345678901234567 
            
       strtm(jm+1,1)='A_thickness             ,#i 1 1'
       strtm(jm+1,2)='effective thickness by the f-factor at the site'
       strth(jh+1,1)='Axf             , 1.0  0.0 0.0  0.1'
       strth(jh+1,2)='Axf                     1     1  '

       strtm(jm+2,1)='position                , 1 1'
       strtm(jm+2,2)='position of the spectrum'
       strth(jh+2,1)='is_shift         , 0.0  0.0 0.0  0.1'
       strth(jh+2,2)='is_shift                2    1  '

       strtm(jm+3,1)='broadening              ,# 2 2'
       strtm(jm+3,2)='broadening of the lines of the spectrum'
       strth(jh+3,1)='G_width          , 0.0  0.0 0.0  0.1'
       strth(jh+4,1)='L_width          , 0.0  0.0 0.0  0.1'
       strth(jh+3,2)='G_width                 3      1 0 '
       strth(jh+4,2)='L_width                 4      0 1 '
       jm=jm+3
       jh=jh+4       

       strtm(jm+1,1)='#end#  4 '
       strtm(jm+2,1)='#beg#'
       
        
       do k=jmb,jm
        ch132=strtm(k,1) 
        call stringlength(ch132,l)
        strtm(k,1)=ch132(:l)//'/'//chth
       end do
      end if

      return
      end

      subroutine thstr_22indextrm(l_jth,cmch,property)

c     n_ik(E) refraction index (static) for
c     Mossbauer transmission and   Mossbauer resonance reflection theories
c     level 3 theory

      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'

      character ch132*132,property*132,chth*8,cmch*4
      logical b_return

      chth='th'//property(1:6)


      if(enwr(14)(1:1).eq.'y') write(nwr,'(2(a,a8),a,i2,a,/,a)')
     & ' cmch=',cmch,' thstruct:',chth,' l_jth=',l_jth,
     & ' subr= thstr_22index  nameth_as=',nameth_as(:40)

      b_return=cmch.eq.'name'
      if(b_return)
     & property='2x2 refraction index transmission'                                  !name

      if(cmch.eq.'prop') then
       if(l_jth.eq.1) then
        property=
     &   'prop=2x2_refraction_index_static   plrs,1  nc_v_a_the=4,4,t'
       else
        property=' '
       end if
       b_return=.true.
      end if

c     names of this routine
      mthchild=1    ! <=(maxnth
      nameth(1)='2x2 refraction index (static)'
c      nameth(2)=' '
      if(b_return) return

      if(l_jth.eq.0) then
c      asking for the number (mthchild) of theories fitting to ntheory
       mthparent=2     ! <=maxnth
       ntheory(1)='stroboscopic transmission spectrum_3'
       ntheory(2)='time differential transmission spectrum_3'
       do k= 1,mthparent
        if(nameth_as.eq.ntheory(k)) l_jth=mthchild
       end do
       return
      end if


      if(cmch.eq.'hdbk') then
       nstruct='handbook=nucleus.hdb'//
     & ' list=3 seq=2  chth='//chth  
       return
      end if

      if(cmch.eq.'copa') then

       k=1
       do while(strco(k)(:5).ne.'#beg#')
        k=k+1
       end do
       j=k-1
       jb=k
       strco(j+1)='flag_SAMP               1    0 '
                 ! discrete (1) , continuous(0) LG-curves
       strco(j+2)='flag_Voigt              2    #n   0 '
       j=j+2            
       strco(j+1)='#end#  2   seq1'
c      comment on the 2 instead of 1 (flag_Voigt is omitted):
c      flag_Voigt is still in use in Mossbauer,etc. => the position
c      of constants in the .par file are in the same order as 
c      in Mossbauer,etc.
       strco(j+2)='#beg#'
       do k=jb,j
        ch132=strco(k)
        call stringlength(ch132,l)
        strco(k)=ch132(:l)//'/'//chth
       end do

       k=1
       do while(strtm(k,1)(:5).ne.'#beg#')
c        write(6,'(i4,a,a)')k,' strtm(k,1)=',strtm(k,1) 
        k=k+1
       end do
       jm=k-1
       jmb=jm+1
       k=1
       do while(strth(k,1)(:5).ne.' ')
        k=k+1
       end do
       jh=k-1
        
c                     123456789012345678901234567 
            
       strtm(jm+1,1)='t_eff                    ,#i 1 1'
       strtm(jm+1,2)='effective thickness by the f-factor at the site'
       strth(jh+1,1)='mg/cm2xf         , 1.0  0.0 0.0  0.1'
       strth(jh+1,2)='mg/cm2xf                1     1  '

       strtm(jm+2,1)='position                , 1 1'
       strtm(jm+2,2)='position of the spectrum'
       strth(jh+2,1)='is_shift         , 0.0  0.0 0.0  0.1'
       strth(jh+2,2)='is_shift                2    1  '

       strtm(jm+3,1)='broadening              ,# 2 2'
       strtm(jm+3,2)='broadening of the lines of the spectrum'
       strth(jh+3,1)='G_width          , 0.0  0.0 0.0  0.1'
       strth(jh+4,1)='L_width          , 0.0  0.0 0.0  0.1'
       strth(jh+3,2)='G_width                 3      1 0 '
       strth(jh+4,2)='L_width                 4      0 1 '
       jm=jm+3
       jh=jh+4       

       strtm(jm+1,1)='#end#  4 '
       strtm(jm+2,1)='#beg#'
       
        
       do k=jmb,jm
        ch132=strtm(k,1)
        call stringlength(ch132,l)
        strtm(k,1)=ch132(:l)//'/'//chth
       end do
      end if

      return
      end

