       subroutine thstr_hyperfield(l_jth,cmch,property)

c     hyperfine parameters of H,EFG
c     case 1 values set (no calculation)
c     case 2 g-tensor, A-tensor and EFG,
c     theory spin_Hamiltonian_H(T)_Deq calculates from g,A-tensors 
c     and temperature T the thermal average of S, so that H=A<S> 

      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'

      character ch132*132,property*132,chth*8,cmch*4
      logical b_return

      chth='th'//property(1:6)

      if(enwr(14)(3:3).eq.'y') write(nwr,'(2(a,a8),a,i2,a,/,a)')
     & ' cmch=',cmch,' thstruct:',chth,' l_jth=',l_jth,
     & ' subr= thstr_hdeqf nameth_as=',nameth_as(:40)
 

      b_return=cmch.eq.'name'
      if(b_return)
     & property='spin_Hamiltonian one field'                           
      if(cmch.eq.'prop') then
       if(l_jth.eq.1) then
        property=
     & 'prop=spin_Hamiltonian_H(T)_Deq plrs,1  nc_v_a_the=0,8'
       else if(l_jth.eq.2) then
        property=
     & 'prop=spin_Hamiltonian_H(T)_Deq plrs,2  nc_v_a_the=0,17'
       else if(l_jth.eq.3) then
        property=
     & 'prop=spin_Hamiltonian_H(T)_Deq  plrs,3  nc_v_a_the=0,11'
       end if
       b_return=.true.
      end if

c     name of this routine
      mthchild=3      ! <=max_nth
      nameth(1)='DEQ-tensor,H-field values'            !  in S_C      
      nameth(2)='spin Hamiltonian S=1/2'               !  in S_C      
      nameth(3)='T2g(S=1/2) spin Hamiltonian'          !  in S_C      

      if(b_return) return

      if(l_jth.eq.0) then
c      asking for the number (mthchild) of theories fitting to ntheory
       mthparent=1     ! <=max_nth
       ntheory(1)='DEQ spin Hamiltonian'
       do k= 1,mthparent
        if(nameth_as.eq.ntheory(k)) l_jth=mthchild
       end do
       return
      end if

      if(cmch.eq.'hdbk')  return

      if(cmch.eq.'copa') then


c      common/avsstrf/avss,sftr,aisom,w_Gauss,w_Lorentz,
c                      dsx2,sx2eta,sx2phi,sx2theta,sx2psi,

c      &1     /avmaps/  DEq,eta,phiE,thetaE,psiE,aH,thetaH,phiH,

c      &2     /avmaps/  DEq,eta,phiE,thetaE,psiE,
c                       gav,ga,geta,phi_g,theta_g,psi_g,
c                       Aav,A_a,A_eta,phi_A,theta_A,psi_A
c      &3     /avmaps/  Deq,Aav,Hc_kappa,cov_k,phi_t2g,theta_t2g


       k=1
       do while(strtm(k,1)(:5).ne.'#beg#')
        k=k+1
       end do
       jm=k-1
       jmb=k
       k=1
       do while(strth(k,1)(:5).ne.' ')
        k=k+1
       end do
       jh=k-1

       if(l_jth.eq.1)then
        strtm(jm+1,1)='EFG                     ,# 2 2'
        strtm(jm+1,2)='electric field gradient tensor at crystal site'
        strth(jh+1,1)='EFG              , 0.0  0.0 0.0  0.1'
        strth(jh+2,1)='eta              , 0.0  0.0 0.0  0.1'
        strth(jh+1,2)='EFG                      1     1 0 '
        strth(jh+2,2)='eta                      2     0 1 '
        jm=jm+1
        jh=jh+2
      
        strtm(jm+1,1)='orient_EFG               # 3 3'
        strtm(jm+1,2)='Euler angle of the EFG in the crystal system'
        strth(jh+1,1)='phiE            , 0.0  0.0 0.0  1.0'
        strth(jh+2,1)='thetaE          , 0.0 0.0 0.0   1.0'
        strth(jh+3,1)='psiE            , 0.0 0.0 0.0   1.0 '
        strth(jh+1,2)='phiE                    3   1 0 0'
        strth(jh+2,2)='thetaE                  4   0 1 0'
        strth(jh+3,2)='psiE                    5   0 0 1'
        jm=jm+1
        jh=jh+3

        strtm(jm+1,1)='H_internal              ,# 3 3'
        strtm(jm+1,2)='internal magnetic field at crystal site'
        strth(jh+1,1)='Hi               , 333.0  0.0 0.0  1.0'
        strth(jh+2,1)='thetaH           , 0.0 0.0 0.0   1.0'
        strth(jh+3,1)='phiH             , 0.0 0.0 0.0   1.0 '
        strth(jh+1,2)='Hi                       6    1 0 0  '
        strth(jh+2,2)='thetaH                   7    0 1 0 '
        strth(jh+3,2)='phiH                     8    0 0 1'
        jm=jm+1
        jh=jh+3

        strtm(jm+1,1)='#end#  8'
        strtm(jm+2,1)='#beg#'
       else if(l_jth.eq.2)then

        strtm(jm+1,1)='EFG                     ,# 2 2'
        strtm(jm+1,2)='electric field gradient tensor at crystal site'
        strth(jh+1,1)='EFG              , 0.0  0.0 0.0  0.1'
        strth(jh+2,1)='eta              , 0.0  0.0 0.0  0.1'
        strth(jh+1,2)='EFG                      1     1 0 '
        strth(jh+2,2)='eta                      2     0 1 '
        jm=jm+1
        jh=jh+2
      
        strtm(jm+1,1)='orient_EFG               # 3 3'
        strtm(jm+1,2)='Euler angle of the EFG in the crystal system'
        strth(jh+1,1)='phiE            , 0.0  0.0 0.0  1.0'
        strth(jh+2,1)='thetaE          , 0.0 0.0 0.0   1.0'
        strth(jh+3,1)='psiE            , 0.0 0.0 0.0   1.0 '
        strth(jh+1,2)='phiE                    3   1 0 0'
        strth(jh+2,2)='thetaE                  4   0 1 0'
        strth(jh+3,2)='psiE                    5   0 0 1'
        jm=jm+1
        jh=jh+3

        strtm(jm+1,1)='g-tensor                 # 3 3'
        strtm(jm+1,2)='g-tensor in the crystal system'
        strth(jh+1,1)='gav               , 2.0  0.0 0.0  0.1'
        strth(jh+2,1)='g_a               , 0.0 0.0 0.0   0.1'
        strth(jh+3,1)='g_eta             , 0.0 0.0 0.0   0.05 '
        strth(jh+1,2)='gav                      6   1 0 0'
        strth(jh+2,2)='g_a                      7   0 1 0'
        strth(jh+3,2)='g_eta                    8   0 0 1'
        jm=jm+1
        jh=jh+3
        strtm(jm+1,1)='orient_g               # 3 3'
        strtm(jm+1,2)=
     &       'Euler angle of the g-tensor in the crystal system'
        strth(jh+1,1)='phi_g            , 0.0  0.0 0.0  1.0'
        strth(jh+2,1)='theta_g          , 0.0 0.0 0.0   1.0'
        strth(jh+3,1)='psi_g            , 0.0 0.0 0.0   1.0 '
        strth(jh+1,2)='phi_g                    9   1 0 0'
        strth(jh+2,2)='theta_g                  10  0 1 0'
        strth(jh+3,2)='psi_g                    11  0 0 1'
        jm=jm+1
        jh=jh+3
   
        strtm(jm+1,1)='A-tensor               # 3 3'
        strtm(jm+1,2)='A-tensor in the crystal system'
        strth(jh+1,1)='Aav               , 200.0  0.0 0.0  0.1'
        strth(jh+2,1)='A_a               , 0.0 0.0 0.0   0.1'
        strth(jh+3,1)='A_eta             , 0.0 0.0 0.0   0.05 '
        strth(jh+1,2)='Aav                      12   1 0 0'
        strth(jh+2,2)='A_a                      13   0 1 0'
        strth(jh+3,2)='A_eta                    14   0 0 1'
        jm=jm+1
        jh=jh+3
        strtm(jm+1,1)='orient_A               # 3 3'
        strtm(jm+1,2)=
     &        'Euler angle of the A-tensor in the crystal system'
        strth(jh+1,1)='phi_A            , 0.0  0.0 0.0  1.0'
        strth(jh+2,1)='theta_A          , 0.0 0.0 0.0   1.0'
        strth(jh+3,1)='psi_A            , 0.0 0.0 0.0   1.0 '
        strth(jh+1,2)='phi_A                    15   1 0 0'
        strth(jh+2,2)='theta_A                  16  0 1 0'
        strth(jh+3,2)='psi_A                    17  0 0 1'
        jm=jm+1
        jh=jh+3
        strtm(jm+1,1)='#end#  17'
        strtm(jm+2,1)='#beg#'
       else if(l_jth.eq.3)then

        strtm(jm+1,1)='V-A-strength            # 2 2'
        strtm(jm+1,2)='stenght of EFg and A-tensor'
        strth(jh+1,1)='Deq               , 0.0  0.0 0.0  0.1'
        strth(jh+2,1)='Aav               , 200.0 0.0 0.0   1.0'
        strth(jh+1,2)='Deq                      1   1 0 '
        strth(jh+2,2)='Aav                      2   0 1 '
        jm=jm+1
        jh=jh+2

        strtm(jm+1,1)='covalenz                # 2 2'
        strtm(jm+1,2)='covalenz factors kappa,k of the t2g state'
        strth(jh+1,1)='Hc_kappa          , 0.35  0.0 0.0  0.03'
        strth(jh+2,1)='cov_k             , 0.785 0.0 0.0  0.03'
        strth(jh+1,2)='Hc_kappa                 3   1 0 '
        strth(jh+2,2)='cov_k                    4   0 1 '
        jm=jm+1
        jh=jh+2
   
        strtm(jm+1,1)='t2g_function               # 2 2'
        strtm(jm+1,2)='two angle describe the 1-electron t2g states'
        strth(jh+1,1)='phi_t2g            , 45.0  0.0 0.0  1.0'
        strth(jh+2,1)='theta_t2g          , 54.74 0.0 0.0   1.0'
        strth(jh+1,2)='phi_t2g                   5  1 0 '
        strth(jh+2,2)='theta_t2g                 6  0 1 '
        jm=jm+1
        jh=jh+2
        strtm(jm+1,1)='orient_PAS               # 3 3'
        strtm(jm+1,2)=
     &       'Euler angle of the PAS in the crystal system'
        strth(jh+1,1)='phi_t            , 0.0  0.0 0.0  1.0'
        strth(jh+2,1)='theta_t          , 0.0 0.0 0.0   1.0'
        strth(jh+3,1)='psi_t            , 0.0 0.0 0.0   1.0 '
        strth(jh+1,2)='phi_t                    9   1 0 0'
        strth(jh+2,2)='theta_t                  10   0 1 0'
        strth(jh+3,2)='psi_t                    11   0 0 1'
        jm=jm+1

        strtm(jm+1,1)='#end#  11'
        strtm(jm+2,1)='#beg#'
       end if

       do k=jmb,jm
        ch132=strtm(k,1)
        call stringlength(ch132,l)
        strtm(k,1)=ch132(:l)//'/'//chth
       end do
      end if    ! cmch.eq.'copa'

      return
      end

       subroutine thstr_hyperfield2(l_jth,cmch,property)
c     hyperfine parameters of H1,H2, ,EFG
c     g-tensor, A-tensor 
c     theory two_hyperfine_fields calculates from g,A-tensors 
c     two S expectation values so that H1=A<S1> H2=A<S2> of
c     energy levels E1 and E2.
      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'

      character ch132*132,property*132,chth*8,cmch*4
      logical b_return

      chth='th'//property(1:6)

      if(enwr(14)(3:3).eq.'y') write(nwr,'(2(a,a8),a,i2,a,/,a)')
     & ' cmch=',cmch,' thstruct:',chth,' l_jth=',l_jth,
     & ' subr= thstr_hdeqf nameth_as=',nameth_as(:40)
 

      b_return=cmch.eq.'name'
      if(b_return)
     & property='spin_Hamiltonian two fields'                           
      if(cmch.eq.'prop') then
       if(l_jth.eq.1) then
        property=
     & 'prop=spin_Hamiltonian_H(T)_Deq plrs,1  nc_v_a_the=0,17,t'
       else if(l_jth.eq.3) then
        property=
     & 'prop=spin_Hamiltonian_H(T)_Deq  plrs,2  nc_v_a_the=0,6,t'
       end if
       b_return=.true.
      end if

c     name of this routine
      mthchild=2      ! <=max_nth
      nameth(2)='Kramers doublet slow relaxation'       !  in S_C      
      nameth(3)='T2g(S=1/2) spin-Ham slow relaxation'   !  in S_C      
      if(b_return) return

      if(l_jth.eq.0) then
c      asking for the number (mthchild) of theories fitting to ntheory
       mthparent=1     ! <=max_nth
       ntheory(1)='DEQ spin Hamiltonian, 2 hyp_fields'
       do k= 1,mthparent
        if(nameth_as.eq.ntheory(k)) l_jth=mthchild
       end do
       return
      end if

      if(cmch.eq.'hdbk')  return

      if(cmch.eq.'copa') then


c      common/avsstrf/avss,sftr,aisom,w_Gauss,w_Lorentz,
c                      dsx2,sx2eta,sx2phi,sx2theta,sx2psi,

c      &1     /avmaps/  DEq,eta,phiE,thetaE,psiE,aH,thetaH,phiH,

c      &2     /avmaps/  DEq,eta,phiE,thetaE,psiE,
c                       gav,ga,geta,phi_g,theta_g,psi_g,
c                       Aav,A_a,A_eta,phi_A,theta_A,psi_A
c      &3     /avmaps/  Deq,Aav,Hc_kappa,cov_k,phi_t2g,theta_t2g


       k=1
       do while(strtm(k,1)(:5).ne.'#beg#')
        k=k+1
       end do
       jm=k-1
       jmb=k
       k=1
       do while(strth(k,1)(:5).ne.' ')
        k=k+1
       end do
       jh=k-1

       if(l_jth.eq.1)then

        strtm(jm+1,1)='EFG                     ,# 2 2'
        strtm(jm+1,2)='electric field gradient tensor at crystal site'
        strth(jh+1,1)='EFG              , 0.0  0.0 0.0  0.1'
        strth(jh+2,1)='eta              , 0.0  0.0 0.0  0.1'
        strth(jh+1,2)='EFG                      1     1 0 '
        strth(jh+2,2)='eta                      2     0 1 '
        jm=jm+1
        jh=jh+2
      
        strtm(jm+1,1)='orient_EFG               # 3 3'
        strtm(jm+1,2)='Euler angle of the EFG in the crystal system'
        strth(jh+1,1)='phiE            , 0.0  0.0 0.0  1.0'
        strth(jh+2,1)='thetaE          , 0.0 0.0 0.0   1.0'
        strth(jh+3,1)='psiE            , 0.0 0.0 0.0   1.0 '
        strth(jh+1,2)='phiE                    3   1 0 0'
        strth(jh+2,2)='thetaE                  4   0 1 0'
        strth(jh+3,2)='psiE                    5   0 0 1'
        jm=jm+1
        jh=jh+3

        strtm(jm+1,1)='g-tensor                 # 3 3'
        strtm(jm+1,2)='g-tensor in the crystal system'
        strth(jh+1,1)='gav               , 2.0  0.0 0.0  0.1'
        strth(jh+2,1)='g_a               , 0.0 0.0 0.0   0.1'
        strth(jh+3,1)='g_eta             , 0.0 0.0 0.0   0.05 '
        strth(jh+1,2)='gav                    6   1 0 0'
        strth(jh+2,2)='g_a                    7   0 1 0'
        strth(jh+3,2)='g_eta                  8   0 0 1'
        jm=jm+1
        jh=jh+3
        strtm(jm+1,1)='orient_g               # 3 3'
        strtm(jm+1,2)=
     &       'Euler angle of the g-tensor in the crystal system'
        strth(jh+1,1)='phi_g            , 0.0  0.0 0.0  1.0'
        strth(jh+2,1)='theta_g          , 0.0 0.0 0.0   1.0'
        strth(jh+3,1)='psi_g            , 0.0 0.0 0.0   1.0 '
        strth(jh+1,2)='phi_g                    9   1 0 0'
        strth(jh+2,2)='theta_g                  10  0 1 0'
        strth(jh+3,2)='psi_g                    11  0 0 1'
        jm=jm+1
        jh=jh+3
   
        strtm(jm+1,1)='A-tensor               # 3 3'
        strtm(jm+1,2)='A-tensor in the crystal system'
        strth(jh+1,1)='Aav               , 2.0  0.0 0.0  0.1'
        strth(jh+2,1)='A_a               , 0.0 0.0 0.0   0.1'
        strth(jh+3,1)='A_eta             , 0.0 0.0 0.0   0.05 '
        strth(jh+1,2)='Aav                    12   1 0 0'
        strth(jh+2,2)='A_a                    13   0 1 0'
        strth(jh+3,2)='A_eta                  14   0 0 1'
        jm=jm+1
        jh=jh+3
        strtm(jm+1,1)='orient_g               # 3 3'
        strtm(jm+1,2)=
     &        'Euler angle of the g-tensor in the crystal system'
        strth(jh+1,1)='phi_A            , 0.0  0.0 0.0  1.0'
        strth(jh+2,1)='theta_A          , 0.0 0.0 0.0   1.0'
        strth(jh+3,1)='psi_A            , 0.0 0.0 0.0   1.0 '
        strth(jh+1,2)='phi_A                    15   1 0 0'
        strth(jh+2,2)='theta_A                  16  0 1 0'
        strth(jh+3,2)='psi_A                    17  0 0 1'
        jm=jm+1
        jh=jh+3
        strtm(jm+1,1)='#end#  17'
        strtm(jm+2,1)='#beg#'
       else if(l_jth.eq.2)then

        strtm(jm+1,1)='V-A-strength            # 2 2'
        strtm(jm+1,2)='stenght of EFg and A-tensor'
        strth(jh+1,1)='Deq               , 0.0  0.0 0.0  0.1'
        strth(jh+2,1)='Aav               , 0.0 0.0 0.0   1.0'
        strth(jh+1,2)='Deq                    1   1 0 '
        strth(jh+2,2)='Aav                    2   0 1 '
        jm=jm+1
        jh=jh+2

        strtm(jm+1,1)='covalenz                # 2 2'
        strtm(jm+1,2)='covalenz factors kappa,k of the t2g state'
        strth(jh+1,1)='Hc_kapp a         , 0.35  0.0 0.0  0.03'
        strth(jh+2,1)='cov_k             , 0.785 0.0 0.0  0.03'
        strth(jh+1,2)='Hc_kappa                3   1 0 '
        strth(jh+2,2)='cov_k                   4   0 1 '
        jm=jm+1
        jh=jh+2
   
        strtm(jm+1,1)='t2g_function               # 2 2'
        strtm(jm+1,2)='two angle describe the 1-electron t2g states'
        strth(jh+1,1)='phi_t2g            , 45.0  0.0 0.0  1.0'
        strth(jh+2,1)='theta_t2g          , 54.74 0.0 0.0   1.0'
        strth(jh+1,2)='phi_t2g                     5  1 0 '
        strth(jh+2,2)='theta_t2g                   6  0 1 '
        jm=jm+1
        jh=jh+2
        strtm(jm+1,1)='#end#  6'
        strtm(jm+2,1)='#beg#'
       end if

       do k=jmb,jm
        ch132=strtm(k,1)
        call stringlength(ch132,l)
        strtm(k,1)=ch132(:l)//'/'//chth
       end do
      end if    ! cmch.eq.'copa'

      return
      end




